/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
/*
*
* Script de DDL e DML
*
* Versao 2.04.8
*
* Fabio Bertoldi - 20160217
*
*/

----------------
-- Ticket #23551
----------------

ALTER TABLE stn.despesa_pessoal ADD COLUMN valor_pessoal_ativo         NUMERIC (14,2);
ALTER TABLE stn.despesa_pessoal ADD COLUMN valor_pessoal_inativo       NUMERIC (14,2);
ALTER TABLE stn.despesa_pessoal ADD COLUMN valor_terceirizacao         NUMERIC (14,2);
ALTER TABLE stn.despesa_pessoal ADD COLUMN valor_indenizacoes          NUMERIC (14,2);
ALTER TABLE stn.despesa_pessoal ADD COLUMN valor_decisao_judicial      NUMERIC (14,2);
ALTER TABLE stn.despesa_pessoal ADD COLUMN valor_exercicios_anteriores NUMERIC (14,2);
ALTER TABLE stn.despesa_pessoal ADD COLUMN valor_inativos_pensionistas NUMERIC (14,2);


----------------
-- Ticket #23550
----------------

ALTER TABLE stn.receita_corrente_liquida ADD COLUMN valor_receita_tributaria       NUMERIC(14,2);
ALTER TABLE stn.receita_corrente_liquida ADD COLUMN valor_receita_contribuicoes    NUMERIC(14,2);
ALTER TABLE stn.receita_corrente_liquida ADD COLUMN valor_receita_patrimonial      NUMERIC(14,2);
ALTER TABLE stn.receita_corrente_liquida ADD COLUMN valor_receita_agropecuaria     NUMERIC(14,2);
ALTER TABLE stn.receita_corrente_liquida ADD COLUMN valor_receita_industrial       NUMERIC(14,2);
ALTER TABLE stn.receita_corrente_liquida ADD COLUMN valor_receita_servicos         NUMERIC(14,2);
ALTER TABLE stn.receita_corrente_liquida ADD COLUMN valor_transferencias_correntes NUMERIC(14,2);
ALTER TABLE stn.receita_corrente_liquida ADD COLUMN valor_outras_receitas          NUMERIC(14,2);
ALTER TABLE stn.receita_corrente_liquida ADD COLUMN valor_contrib_plano_sss        NUMERIC(14,2);
ALTER TABLE stn.receita_corrente_liquida ADD COLUMN valor_compensacao_financeira   NUMERIC(14,2);
ALTER TABLE stn.receita_corrente_liquida ADD COLUMN valor_deducao_fundeb           NUMERIC(14,2);


----------------
-- Ticket #23574
----------------

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
VALUES
     ( 3101
     , 451
     , 'FMManterCronogramaExecucaoMensalDesembolso.php'
     , 'manter'
     , 51
     , ''
     , 'Cronograma de Execução Mensal de Desembolso'
     , TRUE
     );

CREATE TABLE tcemg.grupos_despesa(
    cod_grupo     INTEGER         NOT NULL,
    descricao     VARCHAR(50)     NOT NULL,
    CONSTRAINT pk_grupos_despesa  PRIMARY KEY (cod_grupo)
);
GRANT ALL ON tcemg.grupos_despesa TO urbem;

INSERT INTO tcemg.grupos_despesa VALUES (1, 'Pessoal e Encargos Sociais');
INSERT INTO tcemg.grupos_despesa VALUES (2, 'Juros e Encargos Dívida'   );
INSERT INTO tcemg.grupos_despesa VALUES (3, 'Outras Despesas Correntes' );
INSERT INTO tcemg.grupos_despesa VALUES (4, 'Investimento'              );
INSERT INTO tcemg.grupos_despesa VALUES (5, 'Inversão Financeira'       );
INSERT INTO tcemg.grupos_despesa VALUES (6, 'Amortização da Divida'     );

CREATE TABLE tcemg.cronograma_execucao_mensal_desembolso (
    cod_grupo       INTEGER             NOT NULL,
    periodo         INTEGER             NOT NULL,
    cod_entidade    INTEGER             NOT NULL,
    exercicio       CHAR(4)             NOT NULL,
    num_unidade     INTEGER             NOT NULL,
    num_orgao       INTEGER             NOT NULL,
    valor           NUMERIC(14,2)               ,
    CONSTRAINT pk_cronograma_execucao_mensal_desembolso     PRIMARY KEY (cod_grupo, periodo, cod_entidade, exercicio, num_unidade, num_orgao),
    CONSTRAINT fk_cronograma_execucao_mensal_desembolso_1   FOREIGN KEY                                       (cod_grupo)
                                                            REFERENCES tcemg.grupos_despesa                   (cod_grupo),
    CONSTRAINT fk_cronograma_execucao_mensal_desembolso_2   FOREIGN KEY               (exercicio, num_unidade, num_orgao)
                                                            REFERENCES tcemg.uniorcam (exercicio, num_unidade, num_orgao)
);
GRANT ALL ON tcemg.cronograma_execucao_mensal_desembolso TO urbem;


----------------
-- Ticket #23491
----------------

ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN publicacao_relatorio_lrf            INTEGER;
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN dt_publicacao_relatorio_lrf         DATE;
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN bimestre                            INTEGER;
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN meta_bimestral                      INTEGER;
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN medida_adotada                      TEXT;
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN cont_op_credito                     INTEGER;
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN desc_cont_op_credito                TEXT;
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN realiz_op_credito                   INTEGER;
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN tipo_realiz_op_credito_capta        INTEGER;
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN tipo_realiz_op_credito_receb        INTEGER;
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN tipo_realiz_op_credito_assun_dir    INTEGER;
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN tipo_realiz_op_credito_assun_obg    INTEGER;


----------------
-- Ticket #23486
----------------

INSERT
  INTO tcemg.contrato_modalidade_licitacao
     ( cod_modalidade_licitacao
     , descricao
     ) 
VALUES
     ( 8
     , 'Licitação realizada por consórcio público'
     );


----------------
-- Ticket #23595
----------------

ALTER TABLE tcmgo.plano_contas_tcmgo ALTER COLUMN titulo TYPE VARCHAR(150);

CREATE OR REPLACE FUNCTION manutencao() RETURNS VOID AS $$
DECLARE

BEGIN
    PERFORM 1
       FROM tcmgo.plano_contas_tcmgo
      WHERE exercicio  = '2016'
          ;
    IF NOT FOUND THEN
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (   1,'2016','1.0.0.0.0.00.00','ATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (   2,'2016','1.1.0.0.0.00.00','ATIVO CIRCULANTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (   3,'2016','1.1.1.0.0.00.00','CAIXA E EQUIVALENTES DE CAIXA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (   4,'2016','1.1.1.1.0.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (   5,'2016','1.1.1.1.1.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (   6,'2016','1.1.1.1.1.01.00','CAIXA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (   7,'2016','1.1.1.1.1.02.00','CONTA ÚNICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (   8,'2016','1.1.1.1.1.06.00','CONTA ÚNICA RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (   9,'2016','1.1.1.1.1.06.01','BANCOS CONTA MOVIMENTO - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  10,'2016','1.1.1.1.1.06.02','BANCOS CONTA MOVIMENTO - PLANO FINANCEIRO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  11,'2016','1.1.1.1.1.06.03','BANCOS CONTA MOVIMENTO - PLANO PREVIDENCIÁRIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  12,'2016','1.1.1.1.1.06.04','BANCOS CONTA MOVIMENTO - TAXA DE ADMINISTRAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  13,'2016','1.1.1.1.1.19.00','BANCOS CONTA MOVIMENTO - DEMAIS CONTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  14,'2016','1.1.1.1.1.30.00','REDE BANCARIA - ARRECADAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  15,'2016','1.1.1.1.1.50.00','APLICAÇÕES FINANCEIRAS DE LIQUIDEZ IMEDIATA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  16,'2016','1.1.1.1.1.50.01','TÍTULOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  17,'2016','1.1.1.1.1.50.02','POUPANÇA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  18,'2016','1.1.1.1.1.50.03','FUNDOS DE INVESTIMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  19,'2016','1.1.1.1.1.50.04','CDB','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  20,'2016','1.1.1.1.1.50.99','OUTRAS APLICAÇÕES FINANCEIRAS DE LIQUIDEZ IMEDIATA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  21,'2016','1.1.1.1.2.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  22,'2016','1.1.1.1.2.06.00','CONTA ÚNICA RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  23,'2016','1.1.1.1.2.06.01','BANCOS CONTA MOVIMENTO - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  24,'2016','1.1.1.1.2.06.02','BANCOS CONTA MOVIMENTO - PLANO FINANCEIRO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  25,'2016','1.1.1.1.2.06.03','BANCOS CONTA MOVIMENTO - PLANO PREVIDENCIÁRIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  26,'2016','1.1.1.1.2.06.04','BANCOS CONTA MOVIMENTO - TAXA DE ADMINISTRAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  27,'2016','1.1.1.2.0.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  28,'2016','1.1.1.2.1.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  29,'2016','1.1.1.2.1.01.00','CAIXA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  30,'2016','1.1.1.2.1.02.00','BANCOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  31,'2016','1.1.1.2.1.03.00','APLICAÇÕES FINANCEIRAS DE LIQUIDEZ IMEDIATA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  32,'2016','1.1.2.0.0.00.00','CRÉDITOS A CURTO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  33,'2016','1.1.2.1.0.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  34,'2016','1.1.2.1.1.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  35,'2016','1.1.2.1.1.01.00','IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  36,'2016','1.1.2.1.1.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  37,'2016','1.1.2.1.1.01.02','IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  38,'2016','1.1.2.1.1.01.03','ITCMD','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  39,'2016','1.1.2.1.1.01.04','ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  40,'2016','1.1.2.1.1.01.05','IPTU','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  41,'2016','1.1.2.1.1.01.06','ITBI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  42,'2016','1.1.2.1.1.01.07','ISS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  43,'2016','1.1.2.1.1.01.08','ITR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  44,'2016','1.1.2.1.1.01.99','OUTROS IMPOSTOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  45,'2016','1.1.2.1.1.02.00','TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  46,'2016','1.1.2.1.1.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  47,'2016','1.1.2.1.1.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  48,'2016','1.1.2.1.1.03.00','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  49,'2016','1.1.2.1.1.03.01','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  50,'2016','1.1.2.1.1.04.00','DEMAIS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  51,'2016','1.1.2.1.1.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  52,'2016','1.1.2.1.1.05.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  53,'2016','1.1.2.1.1.05.01','CONTRIBUIÇÕES DO RPPS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  54,'2016','1.1.2.1.1.05.02','CONTRIBUIÇÕES DO RGPS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  55,'2016','1.1.2.1.1.05.99','OUTRAS CONTRIBUIÇÕES PREVIDENCIÁRIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  56,'2016','1.1.2.1.1.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  57,'2016','1.1.2.1.1.71.00','CRÉDITOS PREVIDENCIÁRIOS PARCELADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  58,'2016','1.1.2.1.2.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  59,'2016','1.1.2.1.2.01.00','IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  60,'2016','1.1.2.1.2.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  61,'2016','1.1.2.1.2.01.02','IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  62,'2016','1.1.2.1.2.01.03','ITCMD','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  63,'2016','1.1.2.1.2.01.04','ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  64,'2016','1.1.2.1.2.01.05','IPTU','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  65,'2016','1.1.2.1.2.01.06','ITBI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  66,'2016','1.1.2.1.2.01.07','ISS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  67,'2016','1.1.2.1.2.01.08','ITR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  68,'2016','1.1.2.1.2.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  69,'2016','1.1.2.1.2.02.00','TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  70,'2016','1.1.2.1.2.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  71,'2016','1.1.2.1.2.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  72,'2016','1.1.2.1.2.03.00','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  73,'2016','1.1.2.1.2.03.01','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  74,'2016','1.1.2.1.2.04.00','DEMAIS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  75,'2016','1.1.2.1.2.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  76,'2016','1.1.2.1.2.05.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  77,'2016','1.1.2.1.2.05.01','CONTRIBUIÇÕES DO RPPS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  78,'2016','1.1.2.1.2.05.02','CONTRIBUIÇÕES DO RGPS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  79,'2016','1.1.2.1.2.05.99','OUTRAS CONTRIBUIÇÕES PREVIDENCIÁRIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  80,'2016','1.1.2.1.2.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  81,'2016','1.1.2.1.2.71.00','CRÉDITOS PREVIDENCIÁRIOS PARCELADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  82,'2016','1.1.2.1.3.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  83,'2016','1.1.2.1.3.01.00','IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  84,'2016','1.1.2.1.3.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  85,'2016','1.1.2.1.3.01.02','IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  86,'2016','1.1.2.1.3.01.03','ITCMD','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  87,'2016','1.1.2.1.3.01.04','ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  88,'2016','1.1.2.1.3.01.05','IPTU','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  89,'2016','1.1.2.1.3.01.06','ITBI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  90,'2016','1.1.2.1.3.01.07','ISS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  91,'2016','1.1.2.1.3.01.08','ITR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  92,'2016','1.1.2.1.3.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  93,'2016','1.1.2.1.3.02.00','TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  94,'2016','1.1.2.1.3.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  95,'2016','1.1.2.1.3.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  96,'2016','1.1.2.1.3.03.00','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  97,'2016','1.1.2.1.3.03.01','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  98,'2016','1.1.2.1.3.04.00','DEMAIS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (  99,'2016','1.1.2.1.3.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 100,'2016','1.1.2.1.3.05.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 101,'2016','1.1.2.1.3.05.01','CONTRIBUIÇÕES DO RPPS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 102,'2016','1.1.2.1.3.05.02','CONTRIBUIÇÕES DO RGPS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 103,'2016','1.1.2.1.3.05.99','OUTRAS CONTRIBUIÇÕES PREVIDENCIÁRIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 104,'2016','1.1.2.1.3.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 105,'2016','1.1.2.1.3.71.00','CRÉDITOS PREVIDENCIÁRIOS PARCELADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 106,'2016','1.1.2.1.4.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 107,'2016','1.1.2.1.4.01.00','IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 108,'2016','1.1.2.1.4.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 109,'2016','1.1.2.1.4.01.02','IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 110,'2016','1.1.2.1.4.01.03','ITCMD','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 111,'2016','1.1.2.1.4.01.04','ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 112,'2016','1.1.2.1.4.01.05','IPTU','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 113,'2016','1.1.2.1.4.01.06','ITBI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 114,'2016','1.1.2.1.4.01.07','ISS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 115,'2016','1.1.2.1.4.01.08','ITR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 116,'2016','1.1.2.1.4.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 117,'2016','1.1.2.1.4.02.00','TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 118,'2016','1.1.2.1.4.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 119,'2016','1.1.2.1.4.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 120,'2016','1.1.2.1.4.03.00','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 121,'2016','1.1.2.1.4.03.01','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 122,'2016','1.1.2.1.4.04.00','DEMAIS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 123,'2016','1.1.2.1.4.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 124,'2016','1.1.2.1.4.05.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 125,'2016','1.1.2.1.4.05.01','CONTRIBUIÇÕES DO RPPS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 126,'2016','1.1.2.1.4.05.99','OUTRAS CONTRIBUIÇÕES PREVIDENCIÁRIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 127,'2016','1.1.2.1.4.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 128,'2016','1.1.2.1.4.71.00','CRÉDITOS PREVIDENCIÁRIOS PARCELADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 129,'2016','1.1.2.1.5.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 130,'2016','1.1.2.1.5.01.00','IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 131,'2016','1.1.2.1.5.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 132,'2016','1.1.2.1.5.01.02','IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 133,'2016','1.1.2.1.5.01.03','ITCMD','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 134,'2016','1.1.2.1.5.01.04','ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 135,'2016','1.1.2.1.5.01.05','IPTU','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 136,'2016','1.1.2.1.5.01.06','ITBI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 137,'2016','1.1.2.1.5.01.07','ISS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 138,'2016','1.1.2.1.5.01.08','ITR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 139,'2016','1.1.2.1.5.01.99','OUTROS CRÉDITOS TRIBUTÁRIOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 140,'2016','1.1.2.1.5.02.00','TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 141,'2016','1.1.2.1.5.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 142,'2016','1.1.2.1.5.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 143,'2016','1.1.2.1.5.03.00','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 144,'2016','1.1.2.1.5.03.01','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 145,'2016','1.1.2.1.5.04.00','DEMAIS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 146,'2016','1.1.2.1.5.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 147,'2016','1.1.2.1.5.05.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 148,'2016','1.1.2.1.5.05.01','CONTRIBUIÇÕES DO RPPS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 149,'2016','1.1.2.1.5.05.99','OUTRAS CONTRIBUIÇÕES PREVIDENCIÁRIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 150,'2016','1.1.2.1.5.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 151,'2016','1.1.2.1.5.71.00','CRÉDITOS PREVIDENCIÁRIOS PARCELADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 152,'2016','1.1.2.2.0.00.00','CLIENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 153,'2016','1.1.2.2.1.00.00','CLIENTES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 154,'2016','1.1.2.2.1.01.00','FATURAS/DUPLICATAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 155,'2016','1.1.2.2.1.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 156,'2016','1.1.2.2.2.00.00','CLIENTES - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 157,'2016','1.1.2.2.2.01.00','FATURAS/DUPLICATAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 158,'2016','1.1.2.2.2.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 159,'2016','1.1.2.2.3.00.00','CLIENTES - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 160,'2016','1.1.2.2.3.01.00','FATURAS/DUPLICATAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 161,'2016','1.1.2.2.3.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 162,'2016','1.1.2.2.4.00.00','CLIENTES - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 163,'2016','1.1.2.2.4.01.00','FATURAS/DUPLICATAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 164,'2016','1.1.2.2.4.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 165,'2016','1.1.2.2.5.00.00','CLIENTES - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 166,'2016','1.1.2.2.5.01.00','FATURAS/DUPLICATAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 167,'2016','1.1.2.2.5.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 168,'2016','1.1.2.3.0.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 169,'2016','1.1.2.3.1.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 170,'2016','1.1.2.3.1.01.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS DE INSTITUIÇÕES PRIVADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 171,'2016','1.1.2.3.1.02.00','CRÉDITOS DE CONSÓRCIOS PÚBLICOS DECORRENTES DE CONTRATO DE RATEIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 172,'2016','1.1.2.3.3.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 173,'2016','1.1.2.3.3.01.00','CRÉDITOS DECORRENTES DA PARTICIPAÇÃO NAS RECEITAS DA UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 174,'2016','1.1.2.3.3.01.01','COTA-PARTE DO FPE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 175,'2016','1.1.2.3.3.01.02','COTA-PARTE DO FPM','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 176,'2016','1.1.2.3.3.01.03','COTA-PARTE DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 177,'2016','1.1.2.3.3.01.04','COTA-PARTE DO IPI - ESTADOS EXPORTADORES DE PRODUTOS INDUSTRIALIZADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 178,'2016','1.1.2.3.3.01.05','COTA-PARTE DA CIDE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 179,'2016','1.1.2.3.3.02.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS PELA EXPLORAÇÃO DE RECURSOS NATURAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 180,'2016','1.1.2.3.3.02.01','COTA-PARTE DA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECUROS HÍDRICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 181,'2016','1.1.2.3.3.02.02','COTA-PARTE CA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECURSOS MINERAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 182,'2016','1.1.2.3.3.02.03','COTA-PARTE DO VALOR DO PETRÓLEO BRUTO DE PRODUÇÃO NACIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 183,'2016','1.1.2.3.3.03.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIA DO SUS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 184,'2016','1.1.2.3.3.04.00','CRÉDITOS DECORRENTES DO FNAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 185,'2016','1.1.2.3.3.05.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIA DO FNDE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 186,'2016','1.1.2.3.3.05.01','COTA-PARTE DO SALÁRIO-EDUCAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 187,'2016','1.1.2.3.3.06.00','CRÉDITOS DECORRENTES DAS TRANSFERÊNCIAS DO ICMS - DESONERAÇÃO - LC 87/96','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 188,'2016','1.1.2.3.3.06.01','TRANSFERÊNCIA FINANCEIRA DO ICMS - DESONERAÇÃO - LC 87/96','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 189,'2016','1.1.2.3.3.07.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS MULTIGOVERNAMENTAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 190,'2016','1.1.2.3.3.07.01','FUNDEB','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 191,'2016','1.1.2.3.3.08.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS DE CONVÊNIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 192,'2016','1.1.2.3.3.09.00','CRÉDITOS DECORRENTES DE OUTRAS TRANSFERÊNCIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 193,'2016','1.1.2.3.4.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 194,'2016','1.1.2.3.4.01.00','CRÉDITOS DECORRENTES DA PARTICIPAÇÃO NAS RECEITAS DOS ESTADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 195,'2016','1.1.2.3.4.01.01','COTA-PARTE DO ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 196,'2016','1.1.2.3.4.01.02','COTA-PARTE DO IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 197,'2016','1.1.2.3.5.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 198,'2016','1.1.2.4.0.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 199,'2016','1.1.2.4.1.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 200,'2016','1.1.2.4.1.01.00','EMPRÉSTIMOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 201,'2016','1.1.2.4.1.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 202,'2016','1.1.2.4.1.02.00','FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 203,'2016','1.1.2.4.1.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 204,'2016','1.1.2.4.1.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 205,'2016','1.1.2.4.1.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 206,'2016','1.1.2.4.1.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 207,'2016','1.1.2.4.1.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 208,'2016','1.1.2.4.1.07.01','EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 209,'2016','1.1.2.4.1.07.02','FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 210,'2016','1.1.2.4.1.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 211,'2016','1.1.2.4.1.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 212,'2016','1.1.2.4.2.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 213,'2016','1.1.2.4.2.01.00','EMPRÉSTIMOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 214,'2016','1.1.2.4.2.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 215,'2016','1.1.2.4.2.02.00','FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 216,'2016','1.1.2.4.2.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 217,'2016','1.1.2.4.2.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 218,'2016','1.1.2.4.2.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 219,'2016','1.1.2.4.2.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 220,'2016','1.1.2.4.2.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 221,'2016','1.1.2.4.2.07.01','EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 222,'2016','1.1.2.4.2.07.02','FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 223,'2016','1.1.2.4.2.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 224,'2016','1.1.2.4.2.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 225,'2016','1.1.2.4.3.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 226,'2016','1.1.2.4.3.01.00','EMPRÉSTIMOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 227,'2016','1.1.2.4.3.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 228,'2016','1.1.2.4.3.02.00','FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 229,'2016','1.1.2.4.3.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 230,'2016','1.1.2.4.3.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 231,'2016','1.1.2.4.3.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 232,'2016','1.1.2.4.3.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 233,'2016','1.1.2.4.3.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 234,'2016','1.1.2.4.3.07.01','EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 235,'2016','1.1.2.4.3.07.02','FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 236,'2016','1.1.2.4.3.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 237,'2016','1.1.2.4.3.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 238,'2016','1.1.2.4.4.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 239,'2016','1.1.2.4.4.01.00','EMPRÉSTIMOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 240,'2016','1.1.2.4.4.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 241,'2016','1.1.2.4.4.02.00','FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 242,'2016','1.1.2.4.4.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 243,'2016','1.1.2.4.4.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 244,'2016','1.1.2.4.4.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 245,'2016','1.1.2.4.4.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 246,'2016','1.1.2.4.4.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 247,'2016','1.1.2.4.4.07.01','EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 248,'2016','1.1.2.4.4.07.02','FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 249,'2016','1.1.2.4.4.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 250,'2016','1.1.2.4.4.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 251,'2016','1.1.2.4.4.08.00','PROGRAMA DE REESTRUTURAÇÃO FISCAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 252,'2016','1.1.2.4.4.08.01','PROGRAMA DE REESTRUTURAÇÃO FISCAL - CRÉDITOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 253,'2016','1.1.2.4.4.08.02','JUROS E ENCARGOS A RECEBER - PROGRAMA DE REESTRUTURAÇÃO FISCAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 254,'2016','1.1.2.4.5.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 255,'2016','1.1.2.4.5.01.00','EMPRÉSTIMOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 256,'2016','1.1.2.4.5.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 257,'2016','1.1.2.4.5.02.00','FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 258,'2016','1.1.2.4.5.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 259,'2016','1.1.2.4.5.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 260,'2016','1.1.2.4.5.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 261,'2016','1.1.2.4.5.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 262,'2016','1.1.2.4.5.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 263,'2016','1.1.2.4.5.07.01','EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 264,'2016','1.1.2.4.5.07.02','FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 265,'2016','1.1.2.4.5.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 266,'2016','1.1.2.4.5.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 267,'2016','1.1.2.4.5.08.00','PROGRAMA DE REESTRUTURAÇÃO FISCAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 268,'2016','1.1.2.4.5.08.01','PROGRAMA DE REESTRUTURAÇÃO FISCAL - CRÉDITOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 269,'2016','1.1.2.4.5.08.02','JUROS E ENCARGOS A RECEBER - PROGRAMA DE REESTRUTURAÇÃO FISCAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 270,'2016','1.1.2.5.0.00.00','DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 271,'2016','1.1.2.5.1.00.00','DÍVIDA ATIVA TRIBUTÁRIA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 272,'2016','1.1.2.5.1.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 273,'2016','1.1.2.5.1.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 274,'2016','1.1.2.5.1.01.02','DÍVIDA ATIVA DO IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 275,'2016','1.1.2.5.1.01.03','DÍVIDA ATIVA DO ITCMD','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 276,'2016','1.1.2.5.1.01.04','DÍVIDA ATIVA DO ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 277,'2016','1.1.2.5.1.01.05','DÍVIDA ATIVA DO IPTU','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 278,'2016','1.1.2.5.1.01.06','DÍVIDA ATIVA DO ITBI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 279,'2016','1.1.2.5.1.01.07','DÍVIDA ATIVA DO ISS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 280,'2016','1.1.2.5.1.01.08','DÍVIDA ATIVA DO ITR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 281,'2016','1.1.2.5.1.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 282,'2016','1.1.2.5.1.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 283,'2016','1.1.2.5.1.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 284,'2016','1.1.2.5.1.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 285,'2016','1.1.2.5.1.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 286,'2016','1.1.2.5.1.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 287,'2016','1.1.2.5.1.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 288,'2016','1.1.2.5.1.05.00','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 289,'2016','1.1.2.5.1.06.00','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 290,'2016','1.1.2.5.1.99.00','DEMAIS DÍVIDAS ATIVAS TRIBUTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 291,'2016','1.1.2.5.2.00.00','DÍVIDA ATIVA TRIBUTÁRIA - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 292,'2016','1.1.2.5.2.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 293,'2016','1.1.2.5.2.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 294,'2016','1.1.2.5.2.01.02','DÍVIDA ATIVA DO IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 295,'2016','1.1.2.5.2.01.03','DÍVIDA ATIVA DO ITCMD','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 296,'2016','1.1.2.5.2.01.04','DÍVIDA ATIVA DO ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 297,'2016','1.1.2.5.2.01.05','DÍVIDA ATIVA DO IPTU','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 298,'2016','1.1.2.5.2.01.06','DÍVIDA ATIVA DO ITBI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 299,'2016','1.1.2.5.2.01.07','DÍVIDA ATIVA DO ISS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 300,'2016','1.1.2.5.2.01.08','DÍVIDA ATIVA DO ITR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 301,'2016','1.1.2.5.2.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 302,'2016','1.1.2.5.2.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 303,'2016','1.1.2.5.2.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 304,'2016','1.1.2.5.2.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 305,'2016','1.1.2.5.2.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 306,'2016','1.1.2.5.2.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 307,'2016','1.1.2.5.2.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 308,'2016','1.1.2.5.2.99.00','DEMAIS DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 309,'2016','1.1.2.5.3.00.00','DÍVIDA ATIVA TRIBUTÁRIA - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 310,'2016','1.1.2.5.3.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 311,'2016','1.1.2.5.3.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 312,'2016','1.1.2.5.3.01.02','DÍVIDA ATIVA DO IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 313,'2016','1.1.2.5.3.01.03','DÍVIDA ATIVA DO ITCMD','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 314,'2016','1.1.2.5.3.01.04','DÍVIDA ATIVA DO ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 315,'2016','1.1.2.5.3.01.05','DÍVIDA ATIVA DO IPTU','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 316,'2016','1.1.2.5.3.01.06','DÍVIDA ATIVA DO ITBI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 317,'2016','1.1.2.5.3.01.07','DÍVIDA ATIVA DO ISS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 318,'2016','1.1.2.5.3.01.08','DÍVIDA ATIVA DO ITR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 319,'2016','1.1.2.5.3.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 320,'2016','1.1.2.5.3.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 321,'2016','1.1.2.5.3.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 322,'2016','1.1.2.5.3.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 323,'2016','1.1.2.5.3.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 324,'2016','1.1.2.5.3.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 325,'2016','1.1.2.5.3.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 326,'2016','1.1.2.5.3.99.00','DEMAIS DÍVIDAS ATIVAS TRIBUTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 327,'2016','1.1.2.5.4.00.00','DÍVIDA ATIVA TRIBUTÁRIA - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 328,'2016','1.1.2.5.4.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 329,'2016','1.1.2.5.4.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 330,'2016','1.1.2.5.4.01.02','DÍVIDA ATIVA DO IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 331,'2016','1.1.2.5.4.01.03','DÍVIDA ATIVA DO ITCMD','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 332,'2016','1.1.2.5.4.01.04','DÍVIDA ATIVA DO ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 333,'2016','1.1.2.5.4.01.05','DÍVIDA ATIVA DO IPTU','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 334,'2016','1.1.2.5.4.01.06','DÍVIDA ATIVA DO ITBI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 335,'2016','1.1.2.5.4.01.07','DÍVIDA ATIVA DO ISS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 336,'2016','1.1.2.5.4.01.08','DÍVIDA ATIVA DO ITR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 337,'2016','1.1.2.5.4.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 338,'2016','1.1.2.5.4.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 339,'2016','1.1.2.5.4.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 340,'2016','1.1.2.5.4.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 341,'2016','1.1.2.5.4.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 342,'2016','1.1.2.5.4.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 343,'2016','1.1.2.5.4.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 344,'2016','1.1.2.5.4.99.00','DEMAIS DÍVIDAS ATIVAS TRIBUTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 345,'2016','1.1.2.5.5.00.00','DÍVIDA ATIVA TRIBUTÁRIA - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 346,'2016','1.1.2.5.5.01.00','DÍVIDA ATIVA TRIBUTÁRIA DOS IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 347,'2016','1.1.2.5.5.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 348,'2016','1.1.2.5.5.01.02','DÍVIDA ATIVA DO IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 349,'2016','1.1.2.5.5.01.03','DÍVIDA ATIVA DO ITCMD','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 350,'2016','1.1.2.5.5.01.04','DÍVIDA ATIVA DO ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 351,'2016','1.1.2.5.5.01.05','DÍVIDA ATIVA DO IPTU','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 352,'2016','1.1.2.5.5.01.06','DÍVIDA ATIVA DO ITBI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 353,'2016','1.1.2.5.5.01.07','DÍVIDA ATIVA DO ISS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 354,'2016','1.1.2.5.5.01.08','DÍVIDA ATIVA DO ITR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 355,'2016','1.1.2.5.5.02.00','DÍVIDA ATIVA TRIBUTÁRIA DAS TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 356,'2016','1.1.2.5.5.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 357,'2016','1.1.2.5.5.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 358,'2016','1.1.2.5.5.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 359,'2016','1.1.2.5.5.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 360,'2016','1.1.2.5.5.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 361,'2016','1.1.2.5.5.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 362,'2016','1.1.2.5.5.99.00','DEMAIS DÍVIDAS ATIVAS TRIBUTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 363,'2016','1.1.2.6.0.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 364,'2016','1.1.2.6.1.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA  - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 365,'2016','1.1.2.6.1.01.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 366,'2016','1.1.2.6.2.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA  - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 367,'2016','1.1.2.6.2.01.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 368,'2016','1.1.2.6.3.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA  - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 369,'2016','1.1.2.6.3.01.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 370,'2016','1.1.2.6.4.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA  - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 371,'2016','1.1.2.6.4.01.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 372,'2016','1.1.2.6.5.00.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA  - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 373,'2016','1.1.2.6.5.01.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 374,'2016','1.1.2.9.0.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 375,'2016','1.1.2.9.1.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 376,'2016','1.1.2.9.1.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 377,'2016','1.1.2.9.1.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 378,'2016','1.1.2.9.1.01.02','(-) PERDAS ESTIMADAS EM TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 379,'2016','1.1.2.9.1.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 380,'2016','1.1.2.9.1.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 381,'2016','1.1.2.9.1.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 382,'2016','1.1.2.9.1.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 383,'2016','1.1.2.9.1.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 384,'2016','1.1.2.9.1.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 385,'2016','1.1.2.9.1.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 386,'2016','1.1.2.9.1.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 387,'2016','1.1.2.9.1.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 388,'2016','1.1.2.9.1.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 389,'2016','1.1.2.9.1.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 390,'2016','1.1.2.9.1.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 391,'2016','1.1.2.9.1.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 392,'2016','1.1.2.9.1.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 393,'2016','1.1.2.9.2.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 394,'2016','1.1.2.9.2.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 395,'2016','1.1.2.9.2.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 396,'2016','1.1.2.9.2.01.02','(-) PERDAS ESTIMADAS EM TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 397,'2016','1.1.2.9.2.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 398,'2016','1.1.2.9.2.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 399,'2016','1.1.2.9.2.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 400,'2016','1.1.2.9.2.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 401,'2016','1.1.2.9.2.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 402,'2016','1.1.2.9.2.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 403,'2016','1.1.2.9.2.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 404,'2016','1.1.2.9.2.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 405,'2016','1.1.2.9.2.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 406,'2016','1.1.2.9.2.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 407,'2016','1.1.2.9.2.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 408,'2016','1.1.2.9.2.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 409,'2016','1.1.2.9.2.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 410,'2016','1.1.2.9.2.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 411,'2016','1.1.2.9.3.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 412,'2016','1.1.2.9.3.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 413,'2016','1.1.2.9.3.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 414,'2016','1.1.2.9.3.01.02','(-) PERDAS ESTIMADAS EM TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 415,'2016','1.1.2.9.3.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 416,'2016','1.1.2.9.3.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 417,'2016','1.1.2.9.3.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 418,'2016','1.1.2.9.3.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 419,'2016','1.1.2.9.3.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 420,'2016','1.1.2.9.3.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 421,'2016','1.1.2.9.3.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 422,'2016','1.1.2.9.3.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 423,'2016','1.1.2.9.3.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 424,'2016','1.1.2.9.3.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 425,'2016','1.1.2.9.3.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 426,'2016','1.1.2.9.3.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 427,'2016','1.1.2.9.3.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 428,'2016','1.1.2.9.3.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 429,'2016','1.1.2.9.4.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 430,'2016','1.1.2.9.4.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 431,'2016','1.1.2.9.4.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 432,'2016','1.1.2.9.4.01.02','(-) PERDAS ESTIMADAS EM TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 433,'2016','1.1.2.9.4.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 434,'2016','1.1.2.9.4.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 435,'2016','1.1.2.9.4.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 436,'2016','1.1.2.9.4.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 437,'2016','1.1.2.9.4.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 438,'2016','1.1.2.9.4.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 439,'2016','1.1.2.9.4.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 440,'2016','1.1.2.9.4.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 441,'2016','1.1.2.9.4.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 442,'2016','1.1.2.9.4.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 443,'2016','1.1.2.9.4.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 444,'2016','1.1.2.9.4.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 445,'2016','1.1.2.9.4.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 446,'2016','1.1.2.9.4.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 447,'2016','1.1.2.9.5.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 448,'2016','1.1.2.9.5.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 449,'2016','1.1.2.9.5.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 450,'2016','1.1.2.9.5.01.02','(-) PERDAS ESTIMADAS EM TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 451,'2016','1.1.2.9.5.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 452,'2016','1.1.2.9.5.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 453,'2016','1.1.2.9.5.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 454,'2016','1.1.2.9.5.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 455,'2016','1.1.2.9.5.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 456,'2016','1.1.2.9.5.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 457,'2016','1.1.2.9.5.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 458,'2016','1.1.2.9.5.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 459,'2016','1.1.2.9.5.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 460,'2016','1.1.2.9.5.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 461,'2016','1.1.2.9.5.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 462,'2016','1.1.2.9.5.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 463,'2016','1.1.2.9.5.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 464,'2016','1.1.2.9.5.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 465,'2016','1.1.3.0.0.00.00','DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 466,'2016','1.1.3.1.0.00.00','ADIANTAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 467,'2016','1.1.3.1.1.00.00','ADIANTAMENTOS CONCEDIDOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 468,'2016','1.1.3.1.1.01.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 469,'2016','1.1.3.1.1.01.01','SALÁRIOS E ORDENADOS - ADIANTAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 470,'2016','1.1.3.1.1.01.02','13  SALÁRIO - ADIANTAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 471,'2016','1.1.3.1.1.01.03','FÉRIAS - ADIANTAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 472,'2016','1.1.3.1.1.01.04','1/3 DE FÉRIAS - ADIANTAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 473,'2016','1.1.3.1.1.01.05','VIAGENS - ADIANTAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 474,'2016','1.1.3.1.1.01.99','OUTROS ADIANTAMENTOS A PESSOAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 475,'2016','1.1.3.1.1.02.00','SUPRIMENTO DE FUNDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 476,'2016','1.1.3.1.1.03.00','ADIANTAMENTOS DE TRANSFERÊNCIAS VOLUNTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 477,'2016','1.1.3.1.1.04.00','ADIANTAMENTO A FORNECEDORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 478,'2016','1.1.3.1.1.99.00','ADIANTAMENTOS DIVERSOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 479,'2016','1.1.3.2.0.00.00','TRIBUTOS A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 480,'2016','1.1.3.2.1.00.00','TRIBUTOS A RECUPERAR/COMPENSAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 481,'2016','1.1.3.2.1.01.00','IPI A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 482,'2016','1.1.3.2.1.02.00','ICMS A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 483,'2016','1.1.3.2.1.03.00','ICMS DIFERIDO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 484,'2016','1.1.3.2.1.04.00','IRRF A  COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 485,'2016','1.1.3.2.1.05.00','IR E CSLL A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 486,'2016','1.1.3.2.1.06.00','IR E CSLL DIFERIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 487,'2016','1.1.3.2.1.07.00','ISS A  COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 488,'2016','1.1.3.2.1.08.00','IPVA A  COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 489,'2016','1.1.3.2.1.09.00','IPTU A  COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 490,'2016','1.1.3.2.1.10.00','ITR A  COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 491,'2016','1.1.3.2.1.11.00','INSS A  COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 492,'2016','1.1.3.2.1.12.00','COFINS A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 493,'2016','1.1.3.2.1.13.00','PIS/PASEP A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 494,'2016','1.1.3.2.1.14.00','CIP A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 495,'2016','1.1.3.2.1.99.00','OUTROS TRIBUTOS A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 496,'2016','1.1.3.3.0.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 497,'2016','1.1.3.3.1.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 498,'2016','1.1.3.3.1.01.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 499,'2016','1.1.3.4.0.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 500,'2016','1.1.3.4.1.00.00','CRÉDITOS POR DANOS AO PATRIMONIO- CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 501,'2016','1.1.3.4.1.01.00','CRÉDITOS POR DANOS AO PATRIMONIO DECORRENTES DE CRÉDITOS ADMINISTRATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 502,'2016','1.1.3.4.1.02.00','CRÉDITOS POR DANOS AO PATRIMONIO APURADOS EM  TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 503,'2016','1.1.3.4.1.03.00','CRÉDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 504,'2016','1.1.3.5.0.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 505,'2016','1.1.3.5.1.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 506,'2016','1.1.3.5.1.01.00','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 507,'2016','1.1.3.5.1.02.00','DEPÓSITOS JUDICIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 508,'2016','1.1.3.5.1.03.00','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 509,'2016','1.1.3.5.1.04.00','DEPÓSITOS ESPECIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 510,'2016','1.1.3.5.1.05.00','VALORES APREENDIDOS POR DECISÃO JUDICIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 511,'2016','1.1.3.5.1.06.00','DEPÓSITOS TRANSFERIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 512,'2016','1.1.3.5.1.07.00','DEPÓSITOS COMPULSÓRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 513,'2016','1.1.3.5.1.08.00','CONTA ESPECIAL - PRECATÓRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 514,'2016','1.1.3.5.1.99.00','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 515,'2016','1.1.3.8.0.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 516,'2016','1.1.3.8.1.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 517,'2016','1.1.3.8.1.01.00','ALUGUÉIS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 518,'2016','1.1.3.8.1.02.00','CRÉDITOS A RECEBER DECORRENTES DE PERMISSÃO DE USO DE BENS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 519,'2016','1.1.3.8.1.03.00','VALORES A RECUPERAR DECORRENTES DE INDENIZAÇÕES POR SINISTROS PAGOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 520,'2016','1.1.3.8.1.04.00','VALES, TICKETS E BILHETES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 521,'2016','1.1.3.8.1.06.00','VALORES EM TRÂNSITO REALIZÁVEIS A CURTO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 522,'2016','1.1.3.8.1.07.00','CRÉDITOS A RECEBER DECORRENTES DE INFRAÇÕES LEGAIS E CONTRATUAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 523,'2016','1.1.3.8.1.08.00','CRÉDITOS A RECEBER POR REEMBOLSO DE SALÁRIO FAMÍLIA PAGO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 524,'2016','1.1.3.8.1.09.00','CRÉDITOS A RECEBER POR REEMBOLSO DE SALÁRIO MATERNIDADE PAGO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 525,'2016','1.1.3.8.1.10.00','AUXÍLIO NATALIDADE PAGO A RECUPERAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 526,'2016','1.1.3.8.1.11.00','CRÉDITOS A RECEBER POR REEMBOLSO DE AUXÍLIO DOENÇA E ACIDENTES PAGOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 527,'2016','1.1.3.8.1.12.00','CRÉDITOS A RECEBER POR CESSÃO DE PESSOAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 528,'2016','1.1.3.8.1.13.00','CRÉDITOS A RECEBER DECORRENTES DE CESSÃO DE ÁREAS PÚBLICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 529,'2016','1.1.3.8.1.14.00','CRÉDITOS A RECEBER DECORRENTES DE ALIENAÇÃO DE BENS MÓVEIS E IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 530,'2016','1.1.3.8.1.15.00','CRÉDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESA DE TERCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 531,'2016','1.1.3.8.1.16.00','CRÉDITOS A RECEBER POR ACERTO FINANCEIRO COM SERVIDORES E EX-SERVIDORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 532,'2016','1.1.3.8.1.17.00','CRÉDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 533,'2016','1.1.3.8.1.18.00','DIVIDENDOS PROPOSTOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 534,'2016','1.1.3.8.1.20.00','REMUNERAÇÃO DE DEBÊNTURES A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 535,'2016','1.1.3.8.1.27.00','TÍTULOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 536,'2016','1.1.3.8.1.28.00','CREDITOS A RECEBER DE ENTIDADES FEDERAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 537,'2016','1.1.3.8.1.29.00','CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 538,'2016','1.1.3.8.1.31.00','CRÉDITOS A RECEBER DE PARCELAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 539,'2016','1.1.3.8.1.99.00','OUTROS CRÉDITOS A RECEBER E VALORES DE  CURTO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 540,'2016','1.1.3.9.0.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 541,'2016','1.1.3.9.1.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 542,'2016','1.1.3.9.1.03.00','(-) AJUSTE  PARA PERDAS EM CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 543,'2016','1.1.3.9.1.04.00','(-) AJUSTE  PARA PERDAS EM CRÉDITOS POR DANOS AO PATRIMÔNIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 544,'2016','1.1.3.9.1.04.01','(-) AJUSTE  PARA PERDAS EM CRÉDITOS ADMINISTRATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 545,'2016','1.1.3.9.1.04.02','(-) AJUSTE  PARA PERDAS EM CRÉDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 546,'2016','1.1.3.9.1.04.03','(-) AJUSTE  PARA PERDAS EM CRÉDITOS APURADOS EM PROCESSOS JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 547,'2016','1.1.3.9.1.99.00','(-) AJUSTE  PARA PERDAS DE DEMAIS CRÉDITOS E  VALORES A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 548,'2016','1.1.4.0.0.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A CURTO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 549,'2016','1.1.4.1.0.00.00','TÍTULOS E VALORES MOBILIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 550,'2016','1.1.4.1.1.00.00','TÍTULOS E VALORES MOBILIARIOS- CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 551,'2016','1.1.4.1.1.01.00','TÍTULOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 552,'2016','1.1.4.1.1.02.00','AÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 553,'2016','1.1.4.1.1.03.00','DERIVATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 554,'2016','1.1.4.1.1.09.00','APLICAÇÕES EM SEGMENTO DE RENDA FIXA - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 555,'2016','1.1.4.1.1.09.01','TÍTULOS DE RESPONSABILIDADE DO TESOURO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 556,'2016','1.1.4.1.1.09.02','TÍTULOS DE RESPONSABILIDADE DO BANCO CENTRAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 557,'2016','1.1.4.1.1.09.03','DEPÓSITOS DE POUPANÇA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 558,'2016','1.1.4.1.1.09.04','FUNDOS DE INVESTIMENTO EM RENDA FIXA OU REFERENCIADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 559,'2016','1.1.4.1.1.09.05','FUNDOS DE INVESTIMENTO EM RENDA FIXA - CRÉDITO PRIVADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 560,'2016','1.1.4.1.1.09.06','FUNDOS DE INVESTIMENTOS EM RENDA FIXA OU REFERENCIADOS - IMA/IDkA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 561,'2016','1.1.4.1.1.09.07','FUNDOS DE INVESTIMENTOS EM DIREITOS CREDITORIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 562,'2016','1.1.4.1.1.09.08','FUNDOS DE INVESTIMENTOS EM TÍTULOS DO TESOURO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 563,'2016','1.1.4.1.1.09.09','OPERAÇÕES COMPROMISSADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 564,'2016','1.1.4.1.1.09.10','LETRAS IMOBILIÁRIAS GARANTIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 565,'2016','1.1.4.1.1.10.00','APLICAÇÕES EM SEGMENTO DE RENDA VARIAVEL - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 566,'2016','1.1.4.1.1.10.01','FUNDOS DE INVESTIMENTOS REFERENCIADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 567,'2016','1.1.4.1.1.10.02','FUNDOS DE INVESTIMENTO EM AÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 568,'2016','1.1.4.1.1.10.03','FUNDOS DE INVESTIMENTO MULTIMERCADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 569,'2016','1.1.4.1.1.10.04','FUNDOS DE ÍNDICES REFERENCIADOS EM AÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 570,'2016','1.1.4.1.1.10.05','FUNDOS DE INVESTIMENTOS EM PARTICIPAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 571,'2016','1.1.4.1.1.10.06','FUNDOS DE INVESTIMENTOS IMOBILIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 572,'2016','1.1.4.1.1.11.00','APLICAÇÕES EM SEGMENTO IMOBILIARIO - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 573,'2016','1.1.4.1.1.11.01','FUNDOS DE INVESTIMENTO IMOBILIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 574,'2016','1.1.4.1.1.12.00','APLICAÇÕES EM ENQUADRAMENTO - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 575,'2016','1.1.4.1.1.12.01','TITULOS E VALORES EM ENQUADRAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 576,'2016','1.1.4.1.1.13.00','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 577,'2016','1.1.4.1.1.13.01','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 578,'2016','1.1.4.1.1.14.00','APLICAÇÕES COM A TAXA DE ADMINISTRAÇÃO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 579,'2016','1.1.4.1.1.14.01','APLICAÇÕES COM A TAXA DE ADMINISTRAÇÃO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 580,'2016','1.1.4.1.1.15.00','FUNDO DE APLICAÇÕES EM COTAS - RENDA VARIÁVEL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 581,'2016','1.1.4.1.1.99.00','OUTROS TÍTULOS E VALORES MOBILIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 582,'2016','1.1.4.2.0.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 583,'2016','1.1.4.2.1.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS- CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 584,'2016','1.1.4.3.0.00.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 585,'2016','1.1.4.3.1.00.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 586,'2016','1.1.4.9.0.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 587,'2016','1.1.4.9.1.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 588,'2016','1.1.4.9.1.01.00','(-) AJUSTE DE PERDAS COM TÍTULOS E VALORES MOBILIÁRIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 589,'2016','1.1.4.9.1.02.00','(-) AJUSTE DE PERDAS COM APLICAÇÕES TEMPORÁRIAS EM METAIS PRECIOSOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 590,'2016','1.1.5.0.0.00.00','ESTOQUES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 591,'2016','1.1.5.1.0.00.00','MERCADORIAS PARA REVENDA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 592,'2016','1.1.5.1.1.00.00','MERCADORIAS PARA REVENDA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 593,'2016','1.1.5.1.1.01.00','MERCADORIAS PARA VENDA OU REVENDA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 594,'2016','1.1.5.1.1.02.00','MERCADORIAS ESTOQUES REGULATÓRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 595,'2016','1.1.5.1.1.99.00','OUTRAS MERCADORIAS PARA REVENDA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 596,'2016','1.1.5.2.0.00.00','PRODUTOS E SERVIÇOS ACABADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 597,'2016','1.1.5.2.1.00.00','PRODUTOS E SERVIÇOS ACABADOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 598,'2016','1.1.5.2.1.01.00','PRODUTOS ACABADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 599,'2016','1.1.5.2.1.02.00','SERVICOS ACABADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 600,'2016','1.1.5.3.0.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 601,'2016','1.1.5.3.1.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 602,'2016','1.1.5.3.1.01.00','PRODUTOS EM ELABORAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 603,'2016','1.1.5.3.1.02.00','SERVICOS EM ELABORAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 604,'2016','1.1.5.4.0.00.00','MATÉRIAS-PRIMAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 605,'2016','1.1.5.4.1.00.00','MATÉRIAS-PRIMAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 606,'2016','1.1.5.4.1.01.00','MATERIAS-PRIMAS - ARMAZENS PROPRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 607,'2016','1.1.5.4.1.02.00','MATERIAS-PRIMAS - ARMAZENS DE TERCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 608,'2016','1.1.5.5.0.00.00','MATERIAIS EM TRANSITO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 609,'2016','1.1.5.5.1.00.00','MATERIAIS EM TRANSITO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 610,'2016','1.1.5.5.1.01.00','MATERIAL EM TRANSITO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 611,'2016','1.1.5.6.0.00.00','ALMOXARIFADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 612,'2016','1.1.5.6.1.00.00','ALMOXARIFADO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 613,'2016','1.1.5.6.1.01.00','MATERIAL DE CONSUMO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 614,'2016','1.1.5.6.1.02.00','GÊNEROS ALIMENTÍCIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 615,'2016','1.1.5.6.1.03.00','MATERIAIS DE CONSTRUÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 616,'2016','1.1.5.6.1.04.00','AUTOPEÇAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 617,'2016','1.1.5.6.1.05.00','MEDICAMENTOS E MATERIAIS HOSPITALARES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 618,'2016','1.1.5.6.1.06.00','MATERIAIS GRÁFICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 619,'2016','1.1.5.6.1.07.00','MATERIAL DE EXPEDIENTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 620,'2016','1.1.5.6.1.08.00','MATERIAIS A CLASSIFICAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 621,'2016','1.1.5.6.1.09.00','ESTOQUE SOBRESSALENTES A ALIENAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 622,'2016','1.1.5.7.0.00.00','ADIANTAMENTOS A FORNECEDORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 623,'2016','1.1.5.7.1.00.00','ADIANTAMENTOS A FORNECEDORES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 624,'2016','1.1.5.8.0.00.00','OUTROS ESTOQUES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 625,'2016','1.1.5.8.1.00.00','OUTROS ESTOQUES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 626,'2016','1.1.5.9.0.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 627,'2016','1.1.5.9.1.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 628,'2016','1.1.5.9.1.01.00','(-) AJUSTE DE PERDAS DE ESTOQUES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 629,'2016','1.1.5.9.1.02.00','(-) AJUSTE DE PERDAS PARA REDUÇÃO AO VALOR DE MERCADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 630,'2016','1.1.9.0.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 631,'2016','1.1.9.1.0.00.00','PRÊMIOS DE SEGUROS A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 632,'2016','1.1.9.1.1.00.00','PRÊMIOS DE SEGUROS A APROPRIAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 633,'2016','1.1.9.2.0.00.00','VPD FINANCEIRAS A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 634,'2016','1.1.9.2.1.00.00','VPD FINANCEIRAS A APROPRIAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 635,'2016','1.1.9.3.0.00.00','ASSINATURAS E ANUIDADES A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 636,'2016','1.1.9.3.1.00.00','ASSINATURAS E ANUIDADES A APROPRIAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 637,'2016','1.1.9.4.0.00.00','ALUGUEIS PAGOS A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 638,'2016','1.1.9.4.1.00.00','ALUGUEIS PAGOS A APROPRIAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 639,'2016','1.1.9.5.0.00.00','TRIBUTOS PAGOS A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 640,'2016','1.1.9.5.1.00.00','TRIBUTOS PAGOS A APROPRIAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 641,'2016','1.1.9.6.0.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 642,'2016','1.1.9.6.1.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 643,'2016','1.1.9.7.0.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 644,'2016','1.1.9.7.1.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 645,'2016','1.1.9.8.0.00.00','DEMAIS VPD A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 646,'2016','1.1.9.8.1.00.00','DEMAIS VPD A APROPRIAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 647,'2016','1.2.0.0.0.00.00','ATIVO NÃO CIRCULANTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 648,'2016','1.2.1.0.0.00.00','ATIVO REALIZÁVEL A LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 649,'2016','1.2.1.1.0.00.00','CRÉDITOS A LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 650,'2016','1.2.1.1.1.00.00','CRÉDITOS A LONGO PRAZO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 651,'2016','1.2.1.1.1.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 652,'2016','1.2.1.1.1.01.01','IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 653,'2016','1.2.1.1.1.01.02','TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 654,'2016','1.2.1.1.1.01.03','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 655,'2016','1.2.1.1.1.01.04','DEMAIS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 656,'2016','1.2.1.1.1.01.05','CONTRIBUIÇÕES PREVIDENCIÁRIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 657,'2016','1.2.1.1.1.01.70','CRÉDITOS TRIBUTÁRIOS PARCELADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 658,'2016','1.2.1.1.1.01.71','CRÉDITOS PREVIDENCIÁRIOS PARCELADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 659,'2016','1.2.1.1.1.02.00','CLIENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 660,'2016','1.2.1.1.1.02.01','FATURAS/DUPLICATAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 661,'2016','1.2.1.1.1.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 662,'2016','1.2.1.1.1.03.01','EMPRÉSTIMOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 663,'2016','1.2.1.1.1.03.02','FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 664,'2016','1.2.1.1.1.03.03','EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 665,'2016','1.2.1.1.1.04.00','DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 666,'2016','1.2.1.1.1.04.01','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 667,'2016','1.2.1.1.1.04.02','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 668,'2016','1.2.1.1.1.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 669,'2016','1.2.1.1.1.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 670,'2016','1.2.1.1.1.99.01','(-) AJUSTE DE PERDAS DE CRÉDITOS TRIBUTÁRIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 671,'2016','1.2.1.1.1.99.02','(-) AJUSTE DE PERDAS DE CLIENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 672,'2016','1.2.1.1.1.99.03','(-) AJUSTE DE PERDAS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 673,'2016','1.2.1.1.1.99.04','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 674,'2016','1.2.1.1.1.99.05','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 675,'2016','1.2.1.1.2.00.00','CRÉDITOS A LONGO PRAZO - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 676,'2016','1.2.1.1.2.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 677,'2016','1.2.1.1.2.02.00','CLIENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 678,'2016','1.2.1.1.2.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 679,'2016','1.2.1.1.2.04.00','DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 680,'2016','1.2.1.1.2.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 681,'2016','1.2.1.1.2.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 682,'2016','1.2.1.1.3.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 683,'2016','1.2.1.1.3.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 684,'2016','1.2.1.1.3.02.00','CLIENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 685,'2016','1.2.1.1.3.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 686,'2016','1.2.1.1.3.04.00','DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 687,'2016','1.2.1.1.3.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 688,'2016','1.2.1.1.3.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 689,'2016','1.2.1.1.4.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 690,'2016','1.2.1.1.4.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 691,'2016','1.2.1.1.4.02.00','CLIENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 692,'2016','1.2.1.1.4.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 693,'2016','1.2.1.1.4.03.01','EMPRÉSTIMOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 694,'2016','1.2.1.1.4.03.02','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 695,'2016','1.2.1.1.4.03.03','FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 696,'2016','1.2.1.1.4.03.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 697,'2016','1.2.1.1.4.03.05','EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 698,'2016','1.2.1.1.4.03.06','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 699,'2016','1.2.1.1.4.03.07','FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 700,'2016','1.2.1.1.4.03.08','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 701,'2016','1.2.1.1.4.03.09','PROGRAMA DE REESTRUTURAÇÃO FISCAL DOS ESTADOS - CRÉDITOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 702,'2016','1.2.1.1.4.03.10','JUROS E ENCARGOS A RECEBER - PROGRAMA DE REESTRUTURAÇÃO FISCAL DOS ESTADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 703,'2016','1.2.1.1.4.04.00','DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 704,'2016','1.2.1.1.4.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 705,'2016','1.2.1.1.4.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 706,'2016','1.2.1.1.5.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 707,'2016','1.2.1.1.5.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 708,'2016','1.2.1.1.5.02.00','CLIENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 709,'2016','1.2.1.1.5.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 710,'2016','1.2.1.1.5.03.01','EMPRÉSTIMOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 711,'2016','1.2.1.1.5.03.02','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 712,'2016','1.2.1.1.5.03.03','FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 713,'2016','1.2.1.1.5.03.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 714,'2016','1.2.1.1.5.03.05','EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 715,'2016','1.2.1.1.5.03.06','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 716,'2016','1.2.1.1.5.03.07','FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 717,'2016','1.2.1.1.5.03.08','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 718,'2016','1.2.1.1.5.03.09','PROGRAMA DE REESTRUTURAÇÃO FISCAL DOS MUNICÍPIOS - CRÉDITOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 719,'2016','1.2.1.1.5.03.10','JUROS E ENCARGOS A RECEBER - PROGRAMA DE REESTRUTURAÇÃO FISCAL DOS MUNICÍPIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 720,'2016','1.2.1.1.5.04.00','DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 721,'2016','1.2.1.1.5.05.00','DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 722,'2016','1.2.1.1.5.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 723,'2016','1.2.1.2.0.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 724,'2016','1.2.1.2.1.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 725,'2016','1.2.1.2.1.01.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 726,'2016','1.2.1.2.1.01.01','ADIANTAMENTOS CONCEDIDOS A PESSOAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 727,'2016','1.2.1.2.1.01.99','ADIANTAMENTOS DIVERSOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 728,'2016','1.2.1.2.1.02.00','TRIBUTOS A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 729,'2016','1.2.1.2.1.02.01','IPI A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 730,'2016','1.2.1.2.1.02.02','ICMS A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 731,'2016','1.2.1.2.1.02.03','ICMS DIFERIDO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 732,'2016','1.2.1.2.1.02.04','IRRF A  COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 733,'2016','1.2.1.2.1.02.05','IR E CSLL A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 734,'2016','1.2.1.2.1.02.06','IR E CSLL DIFERIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 735,'2016','1.2.1.2.1.02.07','ISS A  COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 736,'2016','1.2.1.2.1.02.08','IPVA A  COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 737,'2016','1.2.1.2.1.02.09','IPTU A  COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 738,'2016','1.2.1.2.1.02.10','ITR A  COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 739,'2016','1.2.1.2.1.02.11','INSS A  COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 740,'2016','1.2.1.2.1.02.12','COFINS A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 741,'2016','1.2.1.2.1.02.13','PIS/PASEP A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 742,'2016','1.2.1.2.1.02.14','CIP A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 743,'2016','1.2.1.2.1.02.99','OUTROS TRIBUTOS A RECUPERAR/COMPENSAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 744,'2016','1.2.1.2.1.03.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 745,'2016','1.2.1.2.1.04.00','CRÉDITOS POR DANOS AO PATRIMÔNIO PROVENIENTES DE CRÉDITOS ADMINISTRATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 746,'2016','1.2.1.2.1.04.01','CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 747,'2016','1.2.1.2.1.04.02','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 748,'2016','1.2.1.2.1.04.03','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 749,'2016','1.2.1.2.1.04.04','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 750,'2016','1.2.1.2.1.04.05','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 751,'2016','1.2.1.2.1.04.06','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 752,'2016','1.2.1.2.1.04.07','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 753,'2016','1.2.1.2.1.04.08','CREDITOS A RECEBER POR USO INDEVIDO DE COTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 754,'2016','1.2.1.2.1.04.09','CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 755,'2016','1.2.1.2.1.04.10','CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 756,'2016','1.2.1.2.1.04.99','OUTROS CREDITOS ADMINISTRATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 757,'2016','1.2.1.2.1.05.00','CRÉDITOS POR DANOS AO PATRIMÔNIO APURADOS EM TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 758,'2016','1.2.1.2.1.05.01','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 759,'2016','1.2.1.2.1.05.02','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL  - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 760,'2016','1.2.1.2.1.05.03','CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS  - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 761,'2016','1.2.1.2.1.05.04','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVICOS - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 762,'2016','1.2.1.2.1.05.05','CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 763,'2016','1.2.1.2.1.05.06','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO  - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 764,'2016','1.2.1.2.1.05.07','CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS  - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 765,'2016','1.2.1.2.1.05.08','CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVAÇÃO  - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 766,'2016','1.2.1.2.1.05.09','CREDITOS  A RECEBER DECORRENTES DE FALTA DE LICITAÇÃO  - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 767,'2016','1.2.1.2.1.05.10','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 768,'2016','1.2.1.2.1.05.11','CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGAÇÕES PECUNIARIAS  - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 769,'2016','1.2.1.2.1.05.12','CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS  - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 770,'2016','1.2.1.2.1.05.13','CREDITOS  A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE   - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 771,'2016','1.2.1.2.1.05.14','CREDITOS A RECEBER POR USO INDEVIDO DE COTA - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 772,'2016','1.2.1.2.1.05.15','CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL - TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 773,'2016','1.2.1.2.1.05.99','OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 774,'2016','1.2.1.2.1.06.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 775,'2016','1.2.1.2.1.06.01','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 776,'2016','1.2.1.2.1.06.02','DEPÓSITOS JUDICIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 777,'2016','1.2.1.2.1.06.03','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 778,'2016','1.2.1.2.1.06.04','DEPÓSITOS ESPECIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 779,'2016','1.2.1.2.1.06.05','VALORES APREENDIDOS POR DECISÃO JUDICIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 780,'2016','1.2.1.2.1.06.06','DEPÓSITOS TRANSFERIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 781,'2016','1.2.1.2.1.06.07','DEPÓSITOS COMPULSÓRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 782,'2016','1.2.1.2.1.06.99','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 783,'2016','1.2.1.2.1.98.00','OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 784,'2016','1.2.1.2.1.98.01','CRÉDITOS A RECEBER DE ENTIDADES FEDERAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 785,'2016','1.2.1.2.1.98.02','CRÉDITOS A RECEBER POR CESSÃO DE CRÉDITOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 786,'2016','1.2.1.2.1.98.03','CRÉDITOS ORIUNDOS DE CONCESSÕES DE DIREITOS DE USO E DE EXPLORAÇÃO DE BENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 787,'2016','1.2.1.2.1.98.04','CRÉDITOS A RECEBER DE DEVEDORES DE CONVÊNIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 788,'2016','1.2.1.2.1.98.05','CRÉDITOS A RECEBER DECORRENTES DE ALIENAÇÃO DE BENS MÓVEIS E IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 789,'2016','1.2.1.2.1.98.06','CRÉDITOS A RECEBER POR ACERTO FINANCEIRO COM SERVIDOR E EX-SERVIDOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 790,'2016','1.2.1.2.1.98.07','CRÉDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 791,'2016','1.2.1.2.1.98.08','INDENIZAÇÕES A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 792,'2016','1.2.1.2.1.98.99','OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 793,'2016','1.2.1.2.1.99.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 794,'2016','1.2.1.2.1.99.01','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA - DEMAIS CRÉDITOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 795,'2016','1.2.1.2.1.99.02','(-) AJUSTE DE PERDAS DE CRÉDITOS ADMINISTRATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 796,'2016','1.2.1.2.1.99.03','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 797,'2016','1.2.1.2.1.99.07','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA - DEMAIS CRÉDITOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 798,'2016','1.2.1.2.1.99.98','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 799,'2016','1.2.1.3.0.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 800,'2016','1.2.1.3.1.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 801,'2016','1.2.1.3.1.01.00','TÍTULOS E VALORES MOBILIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 802,'2016','1.2.1.3.1.01.01','TÍTULOS PÚBLICOS - MERCADO ABERTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 803,'2016','1.2.1.3.1.01.02','AÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 804,'2016','1.2.1.3.1.01.03','FUNDO DE APLICAÇÕES EM COTAS - RENDA VARIÁVEL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 805,'2016','1.2.1.3.1.01.99','OUTROS TÍTULOS E VALORES MOBILIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 806,'2016','1.2.1.3.1.02.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 807,'2016','1.2.1.3.1.02.01','APLICAÇÃO TEMPORÁRIA EM OURO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 808,'2016','1.2.1.3.1.02.02','APLICAÇÃO TEMPORÁRIA EM OUTROS METAIS PRECIOSOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 809,'2016','1.2.1.3.1.03.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 810,'2016','1.2.1.3.1.99.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 811,'2016','1.2.1.3.1.99.01','(-) AJUSTE DE PERDAS COM TITULOS E VALORES MOBILIARIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 812,'2016','1.2.1.3.1.99.02','(-) AJUSTE DE PERDAS COM APLICAÇÕES TEMPORARIAS EM METAIS PRECIOSOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 813,'2016','1.2.1.3.1.99.03','(-) AJUSTE DE PERDAS COM APLICAÇÕES EM SEGMENTO DE IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 814,'2016','1.2.1.4.0.00.00','ESTOQUES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 815,'2016','1.2.1.4.1.00.00','ESTOQUES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 816,'2016','1.2.1.4.1.01.00','MERCADORIAS PARA REVENDA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 817,'2016','1.2.1.4.1.02.00','PRODUTOS E SERVIÇOS ACABADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 818,'2016','1.2.1.4.1.03.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 819,'2016','1.2.1.4.1.04.00','MATÉRIAS-PRIMAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 820,'2016','1.2.1.4.1.05.00','MATÉRIAIS EM TRANSITO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 821,'2016','1.2.1.4.1.06.00','ALMOXARIFADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 822,'2016','1.2.1.4.1.07.00','ADIANTAMENTOS A FORNECEDORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 823,'2016','1.2.1.4.1.98.00','OUTROS ESTOQUES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 824,'2016','1.2.1.4.1.99.00','(-) AJUSTE DE PERDAS DE ESTOQUES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 825,'2016','1.2.1.9.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 826,'2016','1.2.1.9.1.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 827,'2016','1.2.1.9.1.01.00','PRÊMIOS DE SEGUROS A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 828,'2016','1.2.1.9.1.02.00','VPD FINANCEIRAS A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 829,'2016','1.2.1.9.1.03.00','ASSINATURAS E ANUIDADES A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 830,'2016','1.2.1.9.1.04.00','ALUGUEIS PAGOS A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 831,'2016','1.2.1.9.1.05.00','TRIBUTOS PAGOS A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 832,'2016','1.2.1.9.1.06.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 833,'2016','1.2.1.9.1.07.00','BENEFÍCIOS A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 834,'2016','1.2.1.9.1.99.00','DEMAIS VPD A APROPRIAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 835,'2016','1.2.2.0.0.00.00','INVESTIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 836,'2016','1.2.2.1.0.00.00','PARTICIPAÇÕES PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 837,'2016','1.2.2.1.1.00.00','PARTICIPAÇÕES PERMANENTES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 838,'2016','1.2.2.1.1.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 839,'2016','1.2.2.1.1.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 840,'2016','1.2.2.1.1.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 841,'2016','1.2.2.1.1.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 842,'2016','1.2.2.1.1.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 843,'2016','1.2.2.1.1.01.05','ÁGIO SOBRE OS INVESTIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 844,'2016','1.2.2.1.1.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 845,'2016','1.2.2.1.1.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 846,'2016','1.2.2.1.1.01.08','PARTICIPAÇÃO EM FUNDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 847,'2016','1.2.2.1.1.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 848,'2016','1.2.2.1.1.01.95','OUTRAS PARTICIPAÇÕES - MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 849,'2016','1.2.2.1.1.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 850,'2016','1.2.2.1.1.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 851,'2016','1.2.2.1.1.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 852,'2016','1.2.2.1.1.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 853,'2016','1.2.2.1.1.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 854,'2016','1.2.2.1.1.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 855,'2016','1.2.2.1.1.02.03','PARTICIPAÇÃO EM FUNDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 856,'2016','1.2.2.1.1.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 857,'2016','1.2.2.1.1.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 858,'2016','1.2.2.1.1.02.99','OUTRAS PARTICIPAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 859,'2016','1.2.2.1.2.00.00','PARTICIPAÇÕES PERMANENTES - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 860,'2016','1.2.2.1.2.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 861,'2016','1.2.2.1.2.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 862,'2016','1.2.2.1.2.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 863,'2016','1.2.2.1.2.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 864,'2016','1.2.2.1.2.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 865,'2016','1.2.2.1.2.01.05','ÁGIO SOBRE OS INVESTIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 866,'2016','1.2.2.1.2.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 867,'2016','1.2.2.1.2.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 868,'2016','1.2.2.1.2.01.08','PARTICIPAÇÃO EM FUNDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 869,'2016','1.2.2.1.2.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 870,'2016','1.2.2.1.2.01.95','OUTRAS PARTICIPAÇÕES - MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 871,'2016','1.2.2.1.2.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 872,'2016','1.2.2.1.2.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 873,'2016','1.2.2.1.2.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 874,'2016','1.2.2.1.2.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 875,'2016','1.2.2.1.2.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 876,'2016','1.2.2.1.2.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 877,'2016','1.2.2.1.2.02.03','PARTICIPAÇÃO EM FUNDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 878,'2016','1.2.2.1.2.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 879,'2016','1.2.2.1.2.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 880,'2016','1.2.2.1.2.02.99','OUTRAS PARTICIPAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 881,'2016','1.2.2.1.3.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 882,'2016','1.2.2.1.3.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 883,'2016','1.2.2.1.3.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 884,'2016','1.2.2.1.3.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 885,'2016','1.2.2.1.3.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 886,'2016','1.2.2.1.3.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 887,'2016','1.2.2.1.3.01.05','ÁGIO SOBRE OS INVESTIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 888,'2016','1.2.2.1.3.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 889,'2016','1.2.2.1.3.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 890,'2016','1.2.2.1.3.01.08','PARTICIPAÇÃO EM FUNDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 891,'2016','1.2.2.1.3.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 892,'2016','1.2.2.1.3.01.95','OUTRAS PARTICIPAÇÕES - MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 893,'2016','1.2.2.1.3.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 894,'2016','1.2.2.1.3.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 895,'2016','1.2.2.1.3.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 896,'2016','1.2.2.1.3.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 897,'2016','1.2.2.1.3.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 898,'2016','1.2.2.1.3.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 899,'2016','1.2.2.1.3.02.03','PARTICIPAÇÃO EM FUNDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 900,'2016','1.2.2.1.3.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 901,'2016','1.2.2.1.3.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 902,'2016','1.2.2.1.3.02.99','OUTRAS PARTICIPAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 903,'2016','1.2.2.1.4.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 904,'2016','1.2.2.1.4.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 905,'2016','1.2.2.1.4.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 906,'2016','1.2.2.1.4.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 907,'2016','1.2.2.1.4.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 908,'2016','1.2.2.1.4.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 909,'2016','1.2.2.1.4.01.05','ÁGIO SOBRE OS INVESTIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 910,'2016','1.2.2.1.4.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 911,'2016','1.2.2.1.4.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 912,'2016','1.2.2.1.4.01.08','PARTICIPAÇÃO EM FUNDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 913,'2016','1.2.2.1.4.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 914,'2016','1.2.2.1.4.01.95','OUTRAS PARTICIPAÇÕES - MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 915,'2016','1.2.2.1.4.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 916,'2016','1.2.2.1.4.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 917,'2016','1.2.2.1.4.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 918,'2016','1.2.2.1.4.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 919,'2016','1.2.2.1.4.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 920,'2016','1.2.2.1.4.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 921,'2016','1.2.2.1.4.02.03','PARTICIPAÇÃO EM FUNDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 922,'2016','1.2.2.1.4.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 923,'2016','1.2.2.1.4.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 924,'2016','1.2.2.1.4.02.99','OUTRAS PARTICIPAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 925,'2016','1.2.2.1.5.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 926,'2016','1.2.2.1.5.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 927,'2016','1.2.2.1.5.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 928,'2016','1.2.2.1.5.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 929,'2016','1.2.2.1.5.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 930,'2016','1.2.2.1.5.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 931,'2016','1.2.2.1.5.01.05','ÁGIO SOBRE OS INVESTIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 932,'2016','1.2.2.1.5.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 933,'2016','1.2.2.1.5.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 934,'2016','1.2.2.1.5.01.08','PARTICIPAÇÃO EM FUNDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 935,'2016','1.2.2.1.5.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 936,'2016','1.2.2.1.5.01.95','OUTRAS PARTICIPAÇÕES - MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 937,'2016','1.2.2.1.5.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 938,'2016','1.2.2.1.5.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 939,'2016','1.2.2.1.5.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 940,'2016','1.2.2.1.5.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 941,'2016','1.2.2.1.5.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 942,'2016','1.2.2.1.5.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 943,'2016','1.2.2.1.5.02.03','PARTICIPAÇÃO EM FUNDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 944,'2016','1.2.2.1.5.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 945,'2016','1.2.2.1.5.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 946,'2016','1.2.2.1.5.02.99','OUTRAS PARTICICAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 947,'2016','1.2.2.2.0.00.00','PROPRIEDADES PARA INVESTIMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 948,'2016','1.2.2.2.1.00.00','PROPRIEDADES PARA INVESTIMENTO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 949,'2016','1.2.2.2.1.01.00','BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 950,'2016','1.2.2.2.1.01.01','TERRENOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 951,'2016','1.2.2.2.1.01.02','EDIFÍCIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 952,'2016','1.2.2.2.1.02.00','BENS IMOVEIS NÃO DESTINADOS A USO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 953,'2016','1.2.2.2.1.02.01','TERRENOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 954,'2016','1.2.2.2.1.02.02','EDIFÍCIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 955,'2016','1.2.2.2.1.99.00','OUTRAS PROPRIEDADES PARA INVESTIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 956,'2016','1.2.2.3.0.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 957,'2016','1.2.2.3.1.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 958,'2016','1.2.2.3.1.01.00','TITULOS E VALORES MOBILIÁRIOS - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 959,'2016','1.2.2.3.1.01.01','APLICAÇÕES EM ATIVOS EM ENQUADRAMENTO - TÍTULOS E VALORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 960,'2016','1.2.2.3.1.01.02','APLICAÇÕES EM ATIVOS NÃO SUJEITOS À RESOLUÇÃO DO CMN - TÍTULOS E VALORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 961,'2016','1.2.2.3.1.02.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 962,'2016','1.2.2.3.1.02.01','IMÓVEIS - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 963,'2016','1.2.2.7.0.00.00','DEMAIS INVESTIMENTOS PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 964,'2016','1.2.2.7.1.00.00','DEMAIS INVESTIMENTOS PERMANENTES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 965,'2016','1.2.2.7.1.01.00','OBRAS DE ARTE E OUTROS BENS SINGULARES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 966,'2016','1.2.2.7.1.02.00','TÍTULOS E VALORES MOBILIÁRIOS PERMANENTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 967,'2016','1.2.2.7.1.03.00','BENS MOVEIS NÃO DESTINADOS A USO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 968,'2016','1.2.2.7.1.04.00','BENS INTANGIVEIS NÃO DESTINADOS A USO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 969,'2016','1.2.2.7.1.99.00','DEMAIS INVESTIMENTOS PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 970,'2016','1.2.2.8.0.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 971,'2016','1.2.2.8.1.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 972,'2016','1.2.2.8.1.01.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS - CONSOLIDAÇÃO - PROPRIEDADES PARA INVESTIMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 973,'2016','1.2.2.8.1.01.01','(-) DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 974,'2016','1.2.2.8.1.01.02','(-) DEPRECIAÇÃO ACUMULADA DE BENS IMOVEIS NÃO DESTINADOS A USO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 975,'2016','1.2.2.8.1.01.99','(-) DEPRECIAÇÃO ACUMULADA OUTRAS PROPRIEDADES PARA INVESTIMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 976,'2016','1.2.2.9.0.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 977,'2016','1.2.2.9.1.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 978,'2016','1.2.2.9.1.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 979,'2016','1.2.2.9.1.01.01','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 980,'2016','1.2.2.9.1.01.02','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 981,'2016','1.2.2.9.1.02.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 982,'2016','1.2.2.9.1.02.01','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 983,'2016','1.2.2.9.1.02.02','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE BENS IMOVEIS NÃO DESTINADOS A USO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 984,'2016','1.2.2.9.1.03.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 985,'2016','1.2.2.9.1.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 986,'2016','1.2.2.9.2.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 987,'2016','1.2.2.9.2.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 988,'2016','1.2.2.9.2.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 989,'2016','1.2.2.9.3.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 990,'2016','1.2.2.9.3.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 991,'2016','1.2.2.9.3.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 992,'2016','1.2.2.9.4.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 993,'2016','1.2.2.9.4.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 994,'2016','1.2.2.9.4.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 995,'2016','1.2.2.9.5.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 996,'2016','1.2.2.9.5.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 997,'2016','1.2.2.9.5.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 998,'2016','1.2.3.0.0.00.00','IMOBILIZADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES ( 999,'2016','1.2.3.1.0.00.00','BENS MOVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1000,'2016','1.2.3.1.1.00.00','BENS MOVEIS- CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1001,'2016','1.2.3.1.1.01.00','MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1002,'2016','1.2.3.1.1.01.01','APARELHOS DE MEDIÇÃO E ORIENTAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1003,'2016','1.2.3.1.1.01.02','APARELHOS E EQUIPAMENTOS DE COMUNICAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1004,'2016','1.2.3.1.1.01.03','APARELHOS, EQUIPAMENTOS E UTENSÍLIOS MÉDICOS, ODONTOLÓGICOS, LABORATORIAIS E HOSPITALARES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1005,'2016','1.2.3.1.1.01.04','APARELHOS E EQUIPAMENTOS PARA ESPORTES E DIVERSÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1006,'2016','1.2.3.1.1.01.05','EQUIPAMENTO DE PROTEÇÃO, SEGURANÇA E SOCORRO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1007,'2016','1.2.3.1.1.01.06','MÁQUINAS E EQUIPAMENTOS INDUSTRIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1008,'2016','1.2.3.1.1.01.07','MÁQUINAS E EQUIPAMENTOS ENERGÉTICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1009,'2016','1.2.3.1.1.01.08','MÁQUINAS E EQUIPAMENTOS GRÁFICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1010,'2016','1.2.3.1.1.01.09','MÁQUINAS, FERRAMENTAS E UTENSÍLIOS DE OFICINA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1011,'2016','1.2.3.1.1.01.10','EQUIPAMENTOS DE MONTARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1012,'2016','1.2.3.1.1.01.11','EQUIPAMENTOS E MATERIAL SIGILOSO E RESERVADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1013,'2016','1.2.3.1.1.01.12','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS PARA AUTOMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1014,'2016','1.2.3.1.1.01.13','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS MARÍTIMOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1015,'2016','1.2.3.1.1.01.14','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS AERONÁUTICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1016,'2016','1.2.3.1.1.01.15','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS DE PROTEÇÃO AO VOO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1017,'2016','1.2.3.1.1.01.16','EQUIPAMENTOS DE MERGULHO E SALVAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1018,'2016','1.2.3.1.1.01.17','EQUIPAMENTOS DE MANOBRAS E PATRULHAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1019,'2016','1.2.3.1.1.01.18','EQUIPAMENTOS DE PROTEÇÃO E VIGILÂNCIA AMBIENTAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1020,'2016','1.2.3.1.1.01.19','MÁQUINAS, EQUIPAMENTOS E UTENSÍLIOS AGROPECUÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1021,'2016','1.2.3.1.1.01.20','MÁQUINAS, EQUIPAMENTOS E UTENSÍLIOS RODOVIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1022,'2016','1.2.3.1.1.01.21','EQUIPAMENTOS HIDRÁULICOS E ELÉTRICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1023,'2016','1.2.3.1.1.01.99','OUTRAS MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1024,'2016','1.2.3.1.1.02.00','BENS DE INFORMÁTICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1025,'2016','1.2.3.1.1.02.01','EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1026,'2016','1.2.3.1.1.02.02','EQUIPAMENTOS DE TECNOLOGIA DA INFORMAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1027,'2016','1.2.3.1.1.02.03','SISTEMAS APLICATIVOS - SOFTWARES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1028,'2016','1.2.3.1.1.03.00','MÓVEIS E UTENSÍLIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1029,'2016','1.2.3.1.1.03.01','APARELHOS E UTENSÍLIOS DOMÉSTICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1030,'2016','1.2.3.1.1.03.02','MÁQUINAS E UTENSÍLIOS DE ESCRITÓRIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1031,'2016','1.2.3.1.1.03.03','MOBILIÁRIO EM GERAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1032,'2016','1.2.3.1.1.03.04','UTENSÍLIOS EM GERAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1033,'2016','1.2.3.1.1.04.00','MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1034,'2016','1.2.3.1.1.04.01','BANDEIRAS, FLÂMULAS E INSÍGNIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1035,'2016','1.2.3.1.1.04.02','COLEÇÕES E MATERIAIS BIBLIOGRÁFICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1036,'2016','1.2.3.1.1.04.03','DISCOTECAS E FILMOTECAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1037,'2016','1.2.3.1.1.04.04','INSTRUMENTOS MUSICAIS E ARTÍSTICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1038,'2016','1.2.3.1.1.04.05','EQUIPAMENTOS PARA ÁUDIO, VÍDEO E FOTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1039,'2016','1.2.3.1.1.04.06','OBRAS DE ARTE E PEÇAS PARA EXPOSIÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1040,'2016','1.2.3.1.1.04.99','OUTROS MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1041,'2016','1.2.3.1.1.05.00','VEÍCULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1042,'2016','1.2.3.1.1.05.01','VEÍCULOS EM GERAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1043,'2016','1.2.3.1.1.05.02','VEÍCULOS FERROVIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1044,'2016','1.2.3.1.1.05.03','VEÍCULOS DE TRAÇÃO MECÂNICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1045,'2016','1.2.3.1.1.05.04','CARROS DE COMBATE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1046,'2016','1.2.3.1.1.05.05','AERONAVES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1047,'2016','1.2.3.1.1.05.06','EMBARCAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1048,'2016','1.2.3.1.1.06.00','PEÇAS E CONJUNTOS DE REPOSIÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1049,'2016','1.2.3.1.1.07.00','BENS MÓVEIS EM ANDAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1050,'2016','1.2.3.1.1.07.01','BENS MÓVEIS EM ELABORACÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1051,'2016','1.2.3.1.1.07.02','IMPORTAÇÕES EM ANDAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1052,'2016','1.2.3.1.1.07.04','ALMOXARIFADO DE MATERIAIS A SEREM APLICADOS EM BENS EM ANDAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1053,'2016','1.2.3.1.1.08.00','BENS MÓVEIS EM ALMOXARIFADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1054,'2016','1.2.3.1.1.08.01','ESTOQUE INTERNO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1055,'2016','1.2.3.1.1.08.03','BENS MÓVEIS A REPARAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1056,'2016','1.2.3.1.1.08.05','BENS MÓVEIS INSERVÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1057,'2016','1.2.3.1.1.09.00','ARMAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1058,'2016','1.2.3.1.1.10.00','SEMOVENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1059,'2016','1.2.3.1.1.99.00','DEMAIS BENS MÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1060,'2016','1.2.3.1.1.99.01','BENS MÓVEIS A ALIENAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1061,'2016','1.2.3.1.1.99.02','BENS EM PODER DE OUTRA UNIDADE OU TERCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1062,'2016','1.2.3.1.1.99.08','BENS MÓVEIS A CLASSIFICAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1063,'2016','1.2.3.1.1.99.99','OUTROS BENS MÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1064,'2016','1.2.3.2.0.00.00','BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1065,'2016','1.2.3.2.1.00.00','BENS IMOVEIS- CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1066,'2016','1.2.3.2.1.01.00','BENS DE USO ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1067,'2016','1.2.3.2.1.01.01','IMÓVEIS RESIDENCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1068,'2016','1.2.3.2.1.01.02','IMÓVEIS COMERCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1069,'2016','1.2.3.2.1.01.03','EDIFÍCIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1070,'2016','1.2.3.2.1.01.04','TERRENOS/GLEBAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1071,'2016','1.2.3.2.1.01.05','ARMAZÉNS/GALPÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1072,'2016','1.2.3.2.1.01.06','AQUARTELAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1073,'2016','1.2.3.2.1.01.07','AEROPORTOS/ESTAÇÕES/AERÓDROMOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1074,'2016','1.2.3.2.1.01.08','IMÓVEIS DE USO EDUCACIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1075,'2016','1.2.3.2.1.01.09','REPRESAS/AÇUDES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1076,'2016','1.2.3.2.1.01.10','FAZENDAS, PARQUES E RESERVAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1077,'2016','1.2.3.2.1.01.11','IMÓVEIS DE USO RECREATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1078,'2016','1.2.3.2.1.01.12','FARÓIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1079,'2016','1.2.3.2.1.01.13','MUSEUS/PALÁCIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1080,'2016','1.2.3.2.1.01.14','LABORATÓRIOS/OBSERVATÓRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1081,'2016','1.2.3.2.1.01.15','HOSPITAIS E UNIDADES DE SAÚDE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1082,'2016','1.2.3.2.1.01.16','HOTÉIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1083,'2016','1.2.3.2.1.01.17','PRESÍDIOS/DELEGACIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1084,'2016','1.2.3.2.1.01.18','PORTOS/ESTALEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1085,'2016','1.2.3.2.1.01.19','COMPLEXOS/FÁBRICAS/USINAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1086,'2016','1.2.3.2.1.01.20','CEMITÉRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1087,'2016','1.2.3.2.1.01.21','ESTACIONAMENTOS E GARAGENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1088,'2016','1.2.3.2.1.01.22','POSTOS DE FISCALIZAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1089,'2016','1.2.3.2.1.01.98','OUTROS BENS IMÓVEIS DE USO ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1090,'2016','1.2.3.2.1.04.00','BENS DOMINICAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1091,'2016','1.2.3.2.1.04.01','EDIFÍCIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1092,'2016','1.2.3.2.1.04.02','APARTAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1093,'2016','1.2.3.2.1.04.03','ARMAZÉNS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1094,'2016','1.2.3.2.1.04.04','CASAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1095,'2016','1.2.3.2.1.04.05','CEMITÉRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1096,'2016','1.2.3.2.1.04.06','EDIFÍCIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1097,'2016','1.2.3.2.1.04.07','GARAGENS E ESTACIONAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1098,'2016','1.2.3.2.1.04.08','FAZENDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1099,'2016','1.2.3.2.1.04.09','GALPÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1100,'2016','1.2.3.2.1.04.10','GLEBAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1101,'2016','1.2.3.2.1.04.11','LOJAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1102,'2016','1.2.3.2.1.04.12','SALAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1103,'2016','1.2.3.2.1.04.13','TERRENOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1104,'2016','1.2.3.2.1.04.14','LOTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1105,'2016','1.2.3.2.1.04.15','LOTES INDUSTRIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1106,'2016','1.2.3.2.1.04.16','GLEBAS URBANAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1107,'2016','1.2.3.2.1.04.17','GLEBAS URBANIZADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1108,'2016','1.2.3.2.1.04.18','GLEBAS RURAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1109,'2016','1.2.3.2.1.04.99','OUTROS BENS DOMINICAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1110,'2016','1.2.3.2.1.05.00','BENS DE USO COMUM DO POVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1111,'2016','1.2.3.2.1.05.01','RUAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1112,'2016','1.2.3.2.1.05.02','PRAÇAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1113,'2016','1.2.3.2.1.05.03','ESTRADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1114,'2016','1.2.3.2.1.05.04','PONTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1115,'2016','1.2.3.2.1.05.05','VIADUTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1116,'2016','1.2.3.2.1.05.06','SISTEMAS DE ESGOTO E/OU DE ABASTECIMENTO DE ÁGUA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1117,'2016','1.2.3.2.1.05.07','SISTEMAS DE ABASTECIMETNO DE ENERGIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1118,'2016','1.2.3.2.1.05.08','REDES DE TELECOMUNICAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1119,'2016','1.2.3.2.1.05.09','BENS DO PATRIMONIO CULTURAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1120,'2016','1.2.3.2.1.05.99','OUTROS BENS DE USO COMUM DO POVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1121,'2016','1.2.3.2.1.06.00','BENS IMÓVEIS EM ANDAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1122,'2016','1.2.3.2.1.06.01','OBRAS EM ANDAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1123,'2016','1.2.3.2.1.06.05','ESTUDOS E PROJETOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1124,'2016','1.2.3.2.1.07.00','INSTALAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1125,'2016','1.2.3.2.1.08.00','BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1126,'2016','1.2.3.2.1.99.00','DEMAIS BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1127,'2016','1.2.3.2.1.99.01','BENS IMÓVEIS LOCADOS PARA TERCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1128,'2016','1.2.3.2.1.99.02','IMÓVEIS EM PODER DE TERCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1129,'2016','1.2.3.2.1.99.03','MATERIAIS TEMPORARIAMENTE SEPARADOS DE IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1130,'2016','1.2.3.2.1.99.05','BENS IMÓVEIS A CLASSIFICAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1131,'2016','1.2.3.2.1.99.06','BENS IMÓVEIS A ALIENAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1132,'2016','1.2.3.2.1.99.99','OUTROS BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1133,'2016','1.2.3.8.0.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1134,'2016','1.2.3.8.1.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1135,'2016','1.2.3.8.1.01.00','(-) DEPRECIAÇÃO ACUMULADA - BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1136,'2016','1.2.3.8.1.01.01','(-) DEPRECIAÇÃO ACUMULADA DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1137,'2016','1.2.3.8.1.01.02','(-) DEPRECIAÇÃO ACUMULADA DE BENS DE INFORMÁTICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1138,'2016','1.2.3.8.1.01.03','(-) DEPRECIAÇÃO ACUMULADA DE MÓVEIS E UTENSÍLIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1139,'2016','1.2.3.8.1.01.04','(-) DEPRECIAÇÃO ACUMULADA DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1140,'2016','1.2.3.8.1.01.05','(-) DEPRECIAÇÃO ACUMULADA DE VEÍCULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1141,'2016','1.2.3.8.1.01.06','(-) DEPRECIAÇÃO ACUMULADA DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1142,'2016','1.2.3.8.1.01.07','(-) DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ANDAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1143,'2016','1.2.3.8.1.01.08','(-) DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ALMOXARIFADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1144,'2016','1.2.3.8.1.01.09','(-) DEPRECIAÇÃO ACUMULADA DE ARMAMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1145,'2016','1.2.3.8.1.01.10','(-) DEPRECIAÇÃO ACUMULADA DE SEMOVENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1146,'2016','1.2.3.8.1.01.99','(-) DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1147,'2016','1.2.3.8.1.02.00','(-) DEPRECIAÇÃO ACUMULADA - BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1148,'2016','1.2.3.8.1.02.01','(-) DEPRECIAÇÃO ACUMULADA DE BENS DE USO ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1149,'2016','1.2.3.8.1.02.02','(-) DEPRECIAÇÃO ACUMULADA DE BENS DOMINICAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1150,'2016','1.2.3.8.1.02.03','(-) DEPRECIAÇÃO ACUMULADA DE BENS DE USO COMUM DO POVO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1151,'2016','1.2.3.8.1.02.04','(-) DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS EM ANDAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1152,'2016','1.2.3.8.1.02.05','(-) DEPRECIAÇÃO ACUMULADA DE INSTALAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1153,'2016','1.2.3.8.1.02.06','(-) DEPRECIAÇÃO ACUMULADA DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1154,'2016','1.2.3.8.1.02.99','(-) DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1155,'2016','1.2.3.8.1.03.00','(-) EXAUSTÃO ACUMULADA - BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1156,'2016','1.2.3.8.1.04.00','(-) EXAUSTÃO ACUMULADA - BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1157,'2016','1.2.3.8.1.05.00','(-) AMORTIZAÇÃO ACUMULADA - BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1158,'2016','1.2.3.8.1.06.00','(-) AMORTIZAÇÃO ACUMULADA - BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1159,'2016','1.2.3.9.0.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1160,'2016','1.2.3.9.1.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1161,'2016','1.2.3.9.1.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS MOVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1162,'2016','1.2.3.9.1.01.01','(-) REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1163,'2016','1.2.3.9.1.01.02','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE INFORMÁTICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1164,'2016','1.2.3.9.1.01.03','(-) REDUÇÃO A VALOR RECUPERÁVEL DE MÓVEIS E UTENSÍLIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1165,'2016','1.2.3.9.1.01.04','(-) REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1166,'2016','1.2.3.9.1.01.05','(-) REDUÇÃO A VALOR RECUPERÁVEL DE VEÍCULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1167,'2016','1.2.3.9.1.01.06','(-) REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1168,'2016','1.2.3.9.1.01.07','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1169,'2016','1.2.3.9.1.01.08','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ALMOXARIFADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1170,'2016','1.2.3.9.1.01.09','(-) REDUÇÃO A VALOR RECUPERÁVEL DE ARMAMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1171,'2016','1.2.3.9.1.01.10','(-) REDUÇÃO A VALOR RECUPERÁVEL DE SEMOVENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1172,'2016','1.2.3.9.1.01.99','(-) REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1173,'2016','1.2.3.9.1.02.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1174,'2016','1.2.3.9.1.02.01','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1175,'2016','1.2.3.9.1.02.02','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS DOMINICAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1176,'2016','1.2.3.9.1.02.03','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1177,'2016','1.2.3.9.1.02.04','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS EM ANDAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1178,'2016','1.2.3.9.1.02.05','(-) REDUÇÃO A VALOR RECUPERÁVEL DE INSTALAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1179,'2016','1.2.3.9.1.02.06','(-) REDUÇÃO A VALOR RECUPERÁVEL DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1180,'2016','1.2.3.9.1.02.99','(-) REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1181,'2016','1.2.4.0.0.00.00','INTANGÍVEL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1182,'2016','1.2.4.1.0.00.00','SOFTWARES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1183,'2016','1.2.4.1.1.00.00','SOFTWARES- CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1184,'2016','1.2.4.1.1.01.00','SOFTWARES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1185,'2016','1.2.4.1.1.02.00','SOFTWARES EM DESENVOLVIMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1186,'2016','1.2.4.2.0.00.00','MARCAS, DIREITOS E PATENTES INDUSTRIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1187,'2016','1.2.4.2.1.00.00','MARCAS, DIREITOS E PATENTES INDUSTRIAIS- CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1188,'2016','1.2.4.2.1.01.00','MARCAS E PATENTES INDUSTRIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1189,'2016','1.2.4.2.1.02.00','CONCESSÃO DE DIREITO DE USO DE COMUNICAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1190,'2016','1.2.4.2.1.03.00','DIREITOS AUTORAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1191,'2016','1.2.4.2.1.04.00','DIREITOS SOBRE RECURSOS NATURAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1192,'2016','1.2.4.2.1.05.00','ADIANTAMENTO PARA TRANFERÊNCIA DE TECNOLOGIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1193,'2016','1.2.4.2.1.99.00','OUTROS DIREITOS - BENS INTANGÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1194,'2016','1.2.4.3.0.00.00','DIREITO DE USO DE IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1195,'2016','1.2.4.3.1.00.00','DIREITO DE USO DE IMOVEIS- CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1196,'2016','1.2.4.8.0.00.00','(-) AMORTIZAÇÃO ACUMULADA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1197,'2016','1.2.4.8.1.00.00','(-) AMORTIZAÇÃO ACUMULADA- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1198,'2016','1.2.4.8.1.01.00','(-) AMORTIZAÇÃO ACUMULADA - SOFTWARES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1199,'2016','1.2.4.8.1.02.00','(-) AMORTIZAÇÃO ACUMULADA - MARCAS, DIREITOS E PATENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1200,'2016','1.2.4.8.1.03.00','(-) AMORTIZAÇÃO ACUMULADA - DIREITO DE USO DE IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1201,'2016','1.2.4.9.0.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1202,'2016','1.2.4.9.1.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1203,'2016','1.2.4.9.1.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - SOFTWARES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1204,'2016','1.2.4.9.1.02.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - MARCAS, DIREITOS E PATENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1205,'2016','1.2.4.9.1.03.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL-DIREITO DE USO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1206,'2016','1.2.5.0.0.00.00','DIFERIDO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1207,'2016','1.2.5.1.0.00.00','GASTOS DE IMPLANTAÇÃO E PRÉ-OPERACIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1208,'2016','1.2.5.1.1.00.00','GASTOS DE IMPLANTAÇÃO E PRÉ-OPERACIONAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1209,'2016','1.2.5.2.0.00.00','GASTOS DE REORGANIZAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1210,'2016','1.2.5.2.1.00.00','GASTOS DE REORGANIZAÇÃO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1211,'2016','1.2.5.9.0.00.00','(-) AMORTIZAÇÃO ACUMULADA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1212,'2016','1.2.5.9.1.00.00','(-) AMORTIZAÇÃO ACUMULADA - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1213,'2016','1.2.5.9.1.01.00','(-) AMORTIZAÇÃO ACUMULADA - GASTOS DE IMPLANTAÇÃO E PRÉ-OPERACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1214,'2016','1.2.5.9.1.02.00','(-) AMORTIZAÇÃO ACUMULADA - GASTOS DE REORGANIZAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1215,'2016','2.0.0.0.0.00.00','PASSIVO E PATRIMÔNIO LIQUIDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1216,'2016','2.1.0.0.0.00.00','PASSIVO CIRCULANTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1217,'2016','2.1.1.0.0.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1218,'2016','2.1.1.1.0.00.00','PESSOAL A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1219,'2016','2.1.1.1.1.00.00','PESSOAL A PAGAR - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1220,'2016','2.1.1.1.1.01.00','PESSOAL A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1221,'2016','2.1.1.1.1.01.01','SALÁRIOS, REMUNERAÇÕES E BENEFÍCIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1222,'2016','2.1.1.1.1.01.02','DÉCIMO TERCEIRO SALÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1223,'2016','2.1.1.1.1.01.03','FÉRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1224,'2016','2.1.1.1.1.01.04','LICENÇA- PRÊMIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1225,'2016','2.1.1.1.1.01.05','PARTICIPAÇÕES A EMPREGADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1226,'2016','2.1.1.1.1.02.00','PESSOAL A PAGAR DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1227,'2016','2.1.1.1.1.02.01','SALÁRIOS, REMUNERAÇÕES E BENEFÍCIOS DE EXERC. ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1228,'2016','2.1.1.1.1.02.02','PARTICIPAÇÕES A EMPREGADOS - EXERC. ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1229,'2016','2.1.1.1.1.03.00','PRECATORIOS DE PESSOAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1230,'2016','2.1.1.1.1.03.01','PRECATORIOS DE PESSOAL DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1231,'2016','2.1.1.1.1.03.02','PRECATÓRIOS DE PESSOAL DE EXERC. ANTERIORES - ANTES DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1232,'2016','2.1.1.1.1.03.03','PRECATÓRIOS DE PESSOAL DE EXERC. ANTERIORES - A PARTIR DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1233,'2016','2.1.1.1.1.03.04','PRECATÓRIOS DE PESSOAL VENCIDOS E NÃO PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1234,'2016','2.1.1.1.1.03.05','PRECATORIOS DE PESSOAL - REGIME ORDINÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1235,'2016','2.1.1.1.1.03.06','PRECATORIOS DE PESSOAL - REGIME ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1236,'2016','2.1.1.2.0.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1237,'2016','2.1.1.2.1.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1238,'2016','2.1.1.2.1.01.00','BENEFICIOS PREVIDENCIARIOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1239,'2016','2.1.1.2.1.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1240,'2016','2.1.1.2.1.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1241,'2016','2.1.1.2.1.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1242,'2016','2.1.1.2.1.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1243,'2016','2.1.1.2.1.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES -  A PARTIR DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1244,'2016','2.1.1.2.1.03.04','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1245,'2016','2.1.1.2.1.03.05','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1246,'2016','2.1.1.2.1.03.06','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1247,'2016','2.1.1.2.2.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1248,'2016','2.1.1.2.2.01.00','BENEFICIOS PREVIDENCIARIOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1249,'2016','2.1.1.2.2.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1250,'2016','2.1.1.2.2.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1251,'2016','2.1.1.2.2.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1252,'2016','2.1.1.2.2.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1253,'2016','2.1.1.2.2.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES -  A PARTIR DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1254,'2016','2.1.1.2.2.03.04','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1255,'2016','2.1.1.2.2.03.05','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1256,'2016','2.1.1.2.2.03.06','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1257,'2016','2.1.1.2.3.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR-INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1258,'2016','2.1.1.2.3.01.00','BENEFICIOS PREVIDENCIARIOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1259,'2016','2.1.1.2.3.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1260,'2016','2.1.1.2.3.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1261,'2016','2.1.1.2.3.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1262,'2016','2.1.1.2.3.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1263,'2016','2.1.1.2.3.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES -  A PARTIR DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1264,'2016','2.1.1.2.3.03.04','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1265,'2016','2.1.1.2.3.03.05','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1266,'2016','2.1.1.2.3.03.06','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1267,'2016','2.1.1.2.4.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1268,'2016','2.1.1.2.4.01.00','BENEFICIOS PREVIDENCIARIOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1269,'2016','2.1.1.2.4.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1270,'2016','2.1.1.2.4.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1271,'2016','2.1.1.2.4.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1272,'2016','2.1.1.2.4.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1273,'2016','2.1.1.2.4.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES -  A PARTIR DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1274,'2016','2.1.1.2.4.03.04','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1275,'2016','2.1.1.2.4.03.05','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1276,'2016','2.1.1.2.4.03.06','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1277,'2016','2.1.1.2.5.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1278,'2016','2.1.1.2.5.01.00','BENEFICIOS PREVIDENCIARIOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1279,'2016','2.1.1.2.5.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1280,'2016','2.1.1.2.5.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1281,'2016','2.1.1.2.5.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1282,'2016','2.1.1.2.5.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1283,'2016','2.1.1.2.5.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCÍCIOS ANTERIORES -  A PARTIR DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1284,'2016','2.1.1.2.5.03.04','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1285,'2016','2.1.1.2.5.03.05','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1286,'2016','2.1.1.2.5.03.06','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1287,'2016','2.1.1.3.0.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1288,'2016','2.1.1.3.1.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1289,'2016','2.1.1.3.1.01.00','BENEFICIOS ASSISTENCIAIS A PAGAR DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1290,'2016','2.1.1.3.1.02.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1291,'2016','2.1.1.4.0.00.00','ENCARGOS SOCIAIS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1292,'2016','2.1.1.4.1.00.00','ENCARGOS SOCIAIS A PAGAR-CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1293,'2016','2.1.1.4.1.01.00','CONTRIBUIÇÕES AO RGPS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1294,'2016','2.1.1.4.1.01.01','CONTRIBUIÇÕES AO RGPS SOBRE SALÁRIOS E REMUNERAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1295,'2016','2.1.1.4.1.01.02','CONTRIBUIÇÕES AO RGPS  - DEBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1296,'2016','2.1.1.4.1.01.03','CONTRIBUIÇÕES AO RGPS  -  SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1297,'2016','2.1.1.4.1.01.04','FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1298,'2016','2.1.1.4.1.02.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1299,'2016','2.1.1.4.1.03.00','CONTRIBUIÇÃO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1300,'2016','2.1.1.4.1.03.01','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA - PESSOAL REQUISITADO DE OUTROS ENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1301,'2016','2.1.1.4.1.04.00','PREVIDÊNCIA SOCIAL RURAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1302,'2016','2.1.1.4.1.05.00','FGTS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1303,'2016','2.1.1.4.1.06.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1304,'2016','2.1.1.4.1.07.00','CONTRIBUICÕES SOCIAIS  - DÉBITOS PARCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1305,'2016','2.1.1.4.1.98.00','OUTROS ENCARGOS SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1306,'2016','2.1.1.4.2.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1307,'2016','2.1.1.4.2.01.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA (RPPS)','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1308,'2016','2.1.1.4.2.99.00','OUTROS ENCARGOS SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1309,'2016','2.1.1.4.3.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1310,'2016','2.1.1.4.3.01.00','CONTRIBUIÇÕES AO RGPS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1311,'2016','2.1.1.4.3.01.01','CONTRIBUIÇÕES AO RGPS SOBRE SALÁRIOS E REMUNERAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1312,'2016','2.1.1.4.3.01.02','CONTRIBUIÇÕES AO RGPS  - DEBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1313,'2016','2.1.1.4.3.01.03','CONTRIBUIÇÕES AO RGPS  -  SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1314,'2016','2.1.1.4.3.01.04','FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1315,'2016','2.1.1.4.3.02.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1316,'2016','2.1.1.4.3.03.00','CONTRIBUIÇÃO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1317,'2016','2.1.1.4.3.03.01','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA - PESSOAL REQUISITADO DE OUTROS ENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1318,'2016','2.1.1.4.3.04.00','PREVIDÊNCIA SOCIAL RURAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1319,'2016','2.1.1.4.3.05.00','FGTS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1320,'2016','2.1.1.4.3.06.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1321,'2016','2.1.1.4.3.07.00','CONTRIBUICÕES SOCIAIS  - DÉBITOS PARCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1322,'2016','2.1.1.4.3.98.00','OUTROS ENCARGOS SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1323,'2016','2.1.1.4.4.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1324,'2016','2.1.1.4.4.01.00','INSS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1325,'2016','2.1.1.4.4.01.01','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1326,'2016','2.1.1.4.4.01.02','INSS - DEBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1327,'2016','2.1.1.4.4.01.03','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1328,'2016','2.1.1.4.4.01.04','INSS - FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1329,'2016','2.1.1.4.4.02.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1330,'2016','2.1.1.4.4.03.00','CONTRIBUIÇÃO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1331,'2016','2.1.1.4.4.03.01','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA - PESSOAL REQUISITADO DE OUTROS ENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1332,'2016','2.1.1.4.4.04.00','PREVIDÊNCIA SOCIAL RURAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1333,'2016','2.1.1.4.4.05.00','FGTS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1334,'2016','2.1.1.4.4.06.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1335,'2016','2.1.1.4.4.98.00','OUTROS ENCARGOS SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1336,'2016','2.1.1.4.5.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1337,'2016','2.1.1.4.5.01.00','INSS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1338,'2016','2.1.1.4.5.01.01','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1339,'2016','2.1.1.4.5.01.02','INSS - DEBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1340,'2016','2.1.1.4.5.01.03','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1341,'2016','2.1.1.4.5.01.04','INSS - FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1342,'2016','2.1.1.4.5.02.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1343,'2016','2.1.1.4.5.03.00','CONTRIBUIÇÃO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1344,'2016','2.1.1.4.5.03.01','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA - PESSOAL REQUISITADO DE OUTROS ENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1345,'2016','2.1.1.4.5.04.00','PREVIDÊNCIA SOCIAL RURAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1346,'2016','2.1.1.4.5.05.00','FGTS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1347,'2016','2.1.1.4.5.06.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1348,'2016','2.1.1.4.5.98.00','OUTROS ENCARGOS SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1349,'2016','2.1.2.0.0.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1350,'2016','2.1.2.1.0.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1351,'2016','2.1.2.1.1.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1352,'2016','2.1.2.1.1.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1353,'2016','2.1.2.1.1.01.01','DÍVIDA MOBILIÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1354,'2016','2.1.2.1.1.01.02','(-) DESÁGIO DE TÍTULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1355,'2016','2.1.2.1.1.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1356,'2016','2.1.2.1.1.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1357,'2016','2.1.2.1.1.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1358,'2016','2.1.2.1.1.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1359,'2016','2.1.2.1.1.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1360,'2016','2.1.2.1.1.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1361,'2016','2.1.2.1.1.04.00','FATURAS / DUPLICATAS DESCONTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1362,'2016','2.1.2.1.2.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - INTRA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1363,'2016','2.1.2.1.2.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1364,'2016','2.1.2.1.2.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1365,'2016','2.1.2.1.2.02.01','EMPRÉSTIMOS DO RPPS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1366,'2016','2.1.2.1.2.99.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1367,'2016','2.1.2.1.3.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1368,'2016','2.1.2.1.3.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1369,'2016','2.1.2.1.3.01.01','DÍVIDA MOBILIÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1370,'2016','2.1.2.1.3.01.02','(-) DESÁGIO DE TÍTULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1371,'2016','2.1.2.1.3.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1372,'2016','2.1.2.1.3.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1373,'2016','2.1.2.1.3.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1374,'2016','2.1.2.1.3.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1375,'2016','2.1.2.1.3.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1376,'2016','2.1.2.1.3.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1377,'2016','2.1.2.1.3.04.00','PROGRAMA DE APOIO À REESTRUTURAÇÃO E AO AJUSTE FISCAL DOS ESTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1378,'2016','2.1.2.1.3.04.01','PROGRAMA DE APOIO À REESTRUTURAÇÃO E AO AJUSTE FISCAL DOS ESTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1379,'2016','2.1.2.1.3.05.00','PROGRAMA DE APOIO À REESTRUTURAÇÃO E AO AJUSTE FISCAL DOS MUNICÍPIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1380,'2016','2.1.2.1.3.05.01','PROGRAMA DE APOIO À REESTRUTURAÇÃO E AO AJUSTE FISCAL DOS MUNICÍPIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1381,'2016','2.1.2.1.3.99.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1382,'2016','2.1.2.1.4.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1383,'2016','2.1.2.1.4.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1384,'2016','2.1.2.1.4.01.01','DÍVIDA MOBILIÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1385,'2016','2.1.2.1.4.01.02','(-) DESÁGIO DE TÍTULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1386,'2016','2.1.2.1.4.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1387,'2016','2.1.2.1.4.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1388,'2016','2.1.2.1.4.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1389,'2016','2.1.2.1.4.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1390,'2016','2.1.2.1.4.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1391,'2016','2.1.2.1.4.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1392,'2016','2.1.2.1.5.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1393,'2016','2.1.2.1.5.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1394,'2016','2.1.2.1.5.01.01','DÍVIDA MOBILIÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1395,'2016','2.1.2.1.5.01.02','(-) DESÁGIO DE TÍTULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1396,'2016','2.1.2.1.5.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1397,'2016','2.1.2.1.5.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1398,'2016','2.1.2.1.5.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1399,'2016','2.1.2.1.5.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1400,'2016','2.1.2.1.5.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1401,'2016','2.1.2.1.5.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1402,'2016','2.1.2.2.0.00.00','EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1403,'2016','2.1.2.2.1.00.00','EMPRÉSTIMOS A CURTO PRAZO- EXTERNO CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1404,'2016','2.1.2.2.1.01.00','EMPRÉSTIMOS EXTERNOS  - EM TÍTULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1405,'2016','2.1.2.2.1.02.00','EMPRÉSTIMOS EXTERNOS  - EM CONTRATOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1406,'2016','2.1.2.2.1.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1407,'2016','2.1.2.3.0.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1408,'2016','2.1.2.3.1.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1409,'2016','2.1.2.3.1.01.00','FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1410,'2016','2.1.2.3.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1411,'2016','2.1.2.3.1.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1412,'2016','2.1.2.3.1.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1413,'2016','2.1.2.3.1.01.98','OUTROS FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1414,'2016','2.1.2.3.1.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1415,'2016','2.1.2.3.1.03.00','FATURAS / DUPLICATAS DESCONTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1416,'2016','2.1.2.3.3.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO -INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1417,'2016','2.1.2.3.3.01.00','FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1418,'2016','2.1.2.3.3.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1419,'2016','2.1.2.3.3.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1420,'2016','2.1.2.3.3.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1421,'2016','2.1.2.3.3.01.98','OUTROS FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1422,'2016','2.1.2.3.3.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1423,'2016','2.1.2.3.4.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1424,'2016','2.1.2.3.4.01.00','FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1425,'2016','2.1.2.3.4.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1426,'2016','2.1.2.3.4.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1427,'2016','2.1.2.3.4.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1428,'2016','2.1.2.3.4.01.98','OUTROS FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1429,'2016','2.1.2.3.4.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1430,'2016','2.1.2.3.5.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1431,'2016','2.1.2.4.0.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1432,'2016','2.1.2.4.1.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1433,'2016','2.1.2.4.1.01.00','FINANCIAMENTOS EXTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1434,'2016','2.1.2.4.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1435,'2016','2.1.2.4.1.01.02','FINANCIAMENTOS DE CAPITAL DE GIRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1436,'2016','2.1.2.4.1.02.00','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1437,'2016','2.1.2.5.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1438,'2016','2.1.2.5.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1439,'2016','2.1.2.5.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1440,'2016','2.1.2.5.1.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1441,'2016','2.1.2.5.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1442,'2016','2.1.2.5.1.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1443,'2016','2.1.2.5.3.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO -INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1444,'2016','2.1.2.5.3.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1445,'2016','2.1.2.5.3.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1446,'2016','2.1.2.5.3.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1447,'2016','2.1.2.5.3.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1448,'2016','2.1.2.5.4.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO -INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1449,'2016','2.1.2.5.4.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1450,'2016','2.1.2.5.4.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1451,'2016','2.1.2.5.4.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1452,'2016','2.1.2.5.4.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1453,'2016','2.1.2.5.5.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO -INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1454,'2016','2.1.2.6.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1455,'2016','2.1.2.6.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1456,'2016','2.1.2.6.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1457,'2016','2.1.2.6.1.02.00','ENCARGOS - EMPRÉSTIMOS EXTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1458,'2016','2.1.2.6.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1459,'2016','2.1.2.6.1.04.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1460,'2016','2.1.2.8.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1461,'2016','2.1.2.8.1.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1462,'2016','2.1.2.8.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1463,'2016','2.1.2.8.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1464,'2016','2.1.2.8.3.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1465,'2016','2.1.2.8.3.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1466,'2016','2.1.2.8.3.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1467,'2016','2.1.2.8.4.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1468,'2016','2.1.2.8.4.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1469,'2016','2.1.2.8.4.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1470,'2016','2.1.2.8.5.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1471,'2016','2.1.2.9.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1472,'2016','2.1.2.9.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR- CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1473,'2016','2.1.2.9.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS EXTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1474,'2016','2.1.2.9.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS EXTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1475,'2016','2.1.3.0.0.00.00','FORNECEDORES E CONTAS A PAGAR A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1476,'2016','2.1.3.1.0.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1477,'2016','2.1.3.1.1.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1478,'2016','2.1.3.1.1.01.00','FORNECEDORES NACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1479,'2016','2.1.3.1.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1480,'2016','2.1.3.1.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1481,'2016','2.1.3.1.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1482,'2016','2.1.3.1.1.01.99','DEMAIS FORNECEDORES A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1483,'2016','2.1.3.1.1.02.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1484,'2016','2.1.3.1.1.02.01','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1485,'2016','2.1.3.1.1.02.02','PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES - ANTERIORES A 05/5/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1486,'2016','2.1.3.1.1.02.03','PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/5/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1487,'2016','2.1.3.1.1.02.04','PRECATÓRIOS DE FORNECEDORES NACIONAIS VENCIDOS E NÃO PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1488,'2016','2.1.3.1.1.02.05','PRECATORIOS DE FORNECEDORES NACIONAIS  - REGIME ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1489,'2016','2.1.3.1.1.03.00','CONTAS A PAGAR CREDORES NACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1490,'2016','2.1.3.1.1.03.01','CONTAS NÃO FINANCIADAS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1491,'2016','2.1.3.1.1.03.02','CONTAS FINANCIADAS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1492,'2016','2.1.3.1.1.03.03','PARCELAMENTO DE CONTAS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1493,'2016','2.1.3.1.1.03.99','DEMAIS CONTAS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1494,'2016','2.1.3.1.1.04.00','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1495,'2016','2.1.3.1.1.04.01','PRECATÓRIOS DE  CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1496,'2016','2.1.3.1.1.04.02','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCÍCIOS ANTERIORES - ANTERIORES A 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1497,'2016','2.1.3.1.1.04.03','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1498,'2016','2.1.3.1.1.04.04','PRECATÓRIOS DE CONTAS A PAGAR VENCIDOS E NÃO PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1499,'2016','2.1.3.2.0.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1500,'2016','2.1.3.2.1.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1501,'2016','2.1.3.2.1.01.00','FORNECEDORES ESTRANGEIROS A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1502,'2016','2.1.3.2.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1503,'2016','2.1.3.2.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1504,'2016','2.1.3.2.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1505,'2016','2.1.3.2.1.01.99','DEMAIS FORNECEDORES A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1506,'2016','2.1.3.2.1.02.00','CONTAS A PAGAR - CREDORES ESTRANGEIROS A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1507,'2016','2.1.3.2.1.02.01','CONTAS NÃO FINANCIADAS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1508,'2016','2.1.3.2.1.02.02','CONTAS FINANCIADAS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1509,'2016','2.1.3.2.1.02.03','PARCELAMENTO DE CONTAS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1510,'2016','2.1.3.2.1.02.99','DEMAIS CONTAS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1511,'2016','2.1.4.0.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1512,'2016','2.1.4.1.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1513,'2016','2.1.4.1.1.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1514,'2016','2.1.4.1.1.01.00','IPI A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1515,'2016','2.1.4.1.1.02.00','IRPJ A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1516,'2016','2.1.4.1.1.03.00','PASSIVO FISCAL DIFERIDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1517,'2016','2.1.4.1.1.04.00','IMPOSTO DE IMPORTAÇÃO A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1518,'2016','2.1.4.1.1.05.00','IOF A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1519,'2016','2.1.4.1.1.06.00','ITR A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1520,'2016','2.1.4.1.1.08.00','CIDE A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1521,'2016','2.1.4.1.1.09.00','CSSL A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1522,'2016','2.1.4.1.1.10.00','COFINS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1523,'2016','2.1.4.1.1.11.00','PIS/PASEP A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1524,'2016','2.1.4.1.1.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1525,'2016','2.1.4.1.1.13.00','RECURSOS FISCAIS - DARF A EMITIR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1526,'2016','2.1.4.1.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1527,'2016','2.1.4.1.2.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1528,'2016','2.1.4.1.2.01.00','IPI A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1529,'2016','2.1.4.1.2.02.00','IRPJ A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1530,'2016','2.1.4.1.2.03.00','PASSIVO FISCAL DIFERIDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1531,'2016','2.1.4.1.2.04.00','IMPOSTO DE IMPORTAÇÃO A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1532,'2016','2.1.4.1.2.05.00','IOF A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1533,'2016','2.1.4.1.2.06.00','ITR A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1534,'2016','2.1.4.1.2.08.00','CIDE A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1535,'2016','2.1.4.1.2.09.00','CSSL A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1536,'2016','2.1.4.1.2.10.00','COFINS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1537,'2016','2.1.4.1.2.11.00','PIS/PASEP A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1538,'2016','2.1.4.1.2.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1539,'2016','2.1.4.1.2.13.00','RECURSOS FISCAIS - DARF A EMITIR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1540,'2016','2.1.4.1.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1541,'2016','2.1.4.1.3.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1542,'2016','2.1.4.1.3.01.00','IPI A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1543,'2016','2.1.4.1.3.02.00','IRPJ A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1544,'2016','2.1.4.1.3.03.00','PASSIVO FISCAL DIFERIDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1545,'2016','2.1.4.1.3.04.00','IMPOSTO DE IMPORTAÇÃO A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1546,'2016','2.1.4.1.3.05.00','IOF A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1547,'2016','2.1.4.1.3.06.00','ITR A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1548,'2016','2.1.4.1.3.08.00','CIDE A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1549,'2016','2.1.4.1.3.09.00','CSSL A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1550,'2016','2.1.4.1.3.10.00','COFINS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1551,'2016','2.1.4.1.3.11.00','PIS/PASEP A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1552,'2016','2.1.4.1.3.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1553,'2016','2.1.4.1.3.13.00','RECURSOS FISCAIS - DARF A EMITIR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1554,'2016','2.1.4.1.3.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1555,'2016','2.1.4.2.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1556,'2016','2.1.4.2.1.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1557,'2016','2.1.4.2.1.01.00','ICMS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1558,'2016','2.1.4.2.1.01.01','ICMS A RECOLHER - SOBRE MERCADORIAS PARA REVENDA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1559,'2016','2.1.4.2.1.01.02','ICMS A RECOLHER - SOBRE MERCADORIAS DE TERCEIROS PARA DEPÓSITO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1560,'2016','2.1.4.2.1.02.00','IPVA A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1561,'2016','2.1.4.2.1.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1562,'2016','2.1.4.2.1.04.00','TAXA DE COOPERAÇÃO E DEFESA DA ORIZICULTURA - CDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1563,'2016','2.1.4.2.1.05.00','TAXA DE ATENDIMENTO CONTRA INCÊNDIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1564,'2016','2.1.4.2.1.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEÍCULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1565,'2016','2.1.4.2.1.07.00','RECURSOS FISCAIS ESTADUAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1566,'2016','2.1.4.2.1.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1567,'2016','2.1.4.2.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1568,'2016','2.1.4.2.2.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1569,'2016','2.1.4.2.2.01.00','ICMS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1570,'2016','2.1.4.2.2.01.01','ICMS A RECOLHER - SOBRE MERCADORIAS PARA REVENDA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1571,'2016','2.1.4.2.2.01.02','ICMS A RECOLHER - SOBRE MERCADORIAS DE TERCEIROS PARA DEPÓSITO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1572,'2016','2.1.4.2.2.02.00','IPVA A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1573,'2016','2.1.4.2.2.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1574,'2016','2.1.4.2.2.04.00','TAXA DE COOPERAÇÃO E DEFESA DA ORIZICULTURA - CDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1575,'2016','2.1.4.2.2.05.00','TAXA DE ATENDIMENTO CONTRA INCÊNDIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1576,'2016','2.1.4.2.2.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEÍCULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1577,'2016','2.1.4.2.2.07.00','RECURSOS FISCAIS ESTADUAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1578,'2016','2.1.4.2.2.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1579,'2016','2.1.4.2.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1580,'2016','2.1.4.2.4.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1581,'2016','2.1.4.2.4.01.00','ICMS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1582,'2016','2.1.4.2.4.01.01','ICMS A RECOLHER - SOBRE MERCADORIAS PARA REVENDA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1583,'2016','2.1.4.2.4.01.02','ICMS A RECOLHER - SOBRE MERCADORIAS DE TERCEIROS PARA DEPÓSITO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1584,'2016','2.1.4.2.4.02.00','IPVA A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1585,'2016','2.1.4.2.4.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1586,'2016','2.1.4.2.4.04.00','TAXA DE COOPERAÇÃO E DEFESA DA ORIZICULTURA - CDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1587,'2016','2.1.4.2.4.05.00','TAXA DE ATENDIMENTO CONTRA INCÊNDIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1588,'2016','2.1.4.2.4.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEÍCULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1589,'2016','2.1.4.2.4.07.00','RECURSOS FISCAIS ESTADUAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1590,'2016','2.1.4.2.4.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1591,'2016','2.1.4.2.4.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1592,'2016','2.1.4.3.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1593,'2016','2.1.4.3.1.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1594,'2016','2.1.4.3.1.01.00','ISS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1595,'2016','2.1.4.3.1.02.00','IPTU/TLP A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1596,'2016','2.1.4.3.1.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1597,'2016','2.1.4.3.1.04.00','CONTRIBUIÇÃO P/CUSTEIO DE ILUM. PUBLICA A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1598,'2016','2.1.4.3.1.06.00','RECURSOS FISCAIS MUNICIPAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1599,'2016','2.1.4.3.1.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1600,'2016','2.1.4.3.1.08.00','TAXA DE INSPEÇÃO VEICULAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1601,'2016','2.1.4.3.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1602,'2016','2.1.4.3.2.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1603,'2016','2.1.4.3.2.01.00','ISS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1604,'2016','2.1.4.3.2.02.00','IPTU/TLP A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1605,'2016','2.1.4.3.2.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1606,'2016','2.1.4.3.2.04.00','CONTRIBUIÇÃO P/CUSTEIO DE ILUM. PUBLICA A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1607,'2016','2.1.4.3.2.06.00','RECURSOS FISCAIS MUNICIPAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1608,'2016','2.1.4.3.2.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1609,'2016','2.1.4.3.2.08.00','TAXA DE INSPEÇÃO VEICULAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1610,'2016','2.1.4.3.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1611,'2016','2.1.4.3.5.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1612,'2016','2.1.4.3.5.01.00','ISS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1613,'2016','2.1.4.3.5.02.00','IPTU/TLP A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1614,'2016','2.1.4.3.5.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1615,'2016','2.1.4.3.5.04.00','CONTRIBUIÇÃO P/CUSTEIO DE ILUM. PUBLICA A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1616,'2016','2.1.4.3.5.06.00','RECURSOS FISCAIS MUNICIPAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1617,'2016','2.1.4.3.5.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1618,'2016','2.1.4.3.5.08.00','TAXA DE INSPEÇÃO VEICULAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1619,'2016','2.1.4.3.5.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1620,'2016','2.1.5.0.0.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1621,'2016','2.1.5.0.3.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1622,'2016','2.1.5.0.4.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1623,'2016','2.1.5.0.5.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1624,'2016','2.1.5.0.5.01.00','REPARTIÇÃO DA COTA DE ICMS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1625,'2016','2.1.5.0.5.02.00','REPARTIÇÃO DA COTA DE IPVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1626,'2016','2.1.5.0.5.03.00','REPARTIÇÃO DA COTA-PARTE DO IPI','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1627,'2016','2.1.5.0.5.99.00','REPARTIÇÃO DA COTA DE OUTROS TRIBUTOS/RECEITAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1628,'2016','2.1.7.0.0.00.00','PROVISÕES A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1629,'2016','2.1.7.1.0.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1630,'2016','2.1.7.1.1.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1631,'2016','2.1.7.1.1.01.00','PROVISÃO PARA INDENIZAÇÕES TRABALHISTAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1632,'2016','2.1.7.1.1.02.00','PROVISÃO PARA PAGAMENTO DE DISSÍDIOS COLETIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1633,'2016','2.1.7.3.0.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1634,'2016','2.1.7.3.1.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1635,'2016','2.1.7.3.1.01.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1636,'2016','2.1.7.3.1.01.01','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO NÃO RECORRIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1637,'2016','2.1.7.3.1.01.02','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO RECORRIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1638,'2016','2.1.7.3.1.02.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS - ESFERA JUDICIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1639,'2016','2.1.7.3.1.02.01','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1640,'2016','2.1.7.3.1.02.02','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1641,'2016','2.1.7.4.0.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1642,'2016','2.1.7.4.1.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1643,'2016','2.1.7.4.1.01.00','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1644,'2016','2.1.7.4.1.02.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1645,'2016','2.1.7.4.1.03.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1646,'2016','2.1.7.4.1.04.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS NÃO CIENTIFICADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1647,'2016','2.1.7.5.0.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1648,'2016','2.1.7.5.1.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1649,'2016','2.1.7.5.3.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1650,'2016','2.1.7.5.4.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1651,'2016','2.1.7.5.5.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1652,'2016','2.1.7.5.5.01.00','PROVISÃO PARA REPARTIÇÃO DA COTA DE ICMS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1653,'2016','2.1.7.5.5.02.00','PROVISÃO PARA REPARTIÇÃO DA COTA DE IPVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1654,'2016','2.1.7.5.5.03.00','PROVISÃO PARA REPARTIÇÃO DA COTA-PARTE DO IPI','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1655,'2016','2.1.7.5.5.99.00','PROVISÃO PARA REPARTIÇÃO DA COTA DE OUTROS TRIBUTOS/RECEITAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1656,'2016','2.1.7.6.0.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1657,'2016','2.1.7.6.1.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1658,'2016','2.1.7.9.0.00.00','OUTRAS PROVISÕES A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1659,'2016','2.1.7.9.1.00.00','OUTRAS PROVISÕES A CURTO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1660,'2016','2.1.7.9.1.01.00','PROVISÃO PARA GARANTIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1661,'2016','2.1.7.9.1.02.00','PROVISÃO PARA REESTRUTURAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1662,'2016','2.1.7.9.1.99.00','OUTRAS PROVISÕES A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1663,'2016','2.1.8.0.0.00.00','DEMAIS OBRIGAÇÕES A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1664,'2016','2.1.8.1.0.00.00','ADIANTAMENTOS DE CLIENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1665,'2016','2.1.8.1.1.00.00','ADIANTAMENTOS DE CLIENTES- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1666,'2016','2.1.8.2.0.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1667,'2016','2.1.8.2.1.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1668,'2016','2.1.8.3.0.00.00','ARRENDAMENTO OPERACIONAL A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1669,'2016','2.1.8.3.1.00.00','ARRENDAMENTO OPERACIONAL A PAGAR- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1670,'2016','2.1.8.3.1.01.00','ARRENDAMENTO OPERACIONAL A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1671,'2016','2.1.8.4.0.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DÍVIDA A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1672,'2016','2.1.8.4.1.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DÍVIDA A CURTO PRAZO- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1673,'2016','2.1.8.4.1.01.00','DEBENTURES CONVERSIVEIS EM AÇÕES NO CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1674,'2016','2.1.8.4.1.02.00','DEBENTURES NAO-CONVERSIVEIS EM AÇÕES NO CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1675,'2016','2.1.8.4.1.96.00','AGIO NA EMISSAO DE DEBENTURES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1676,'2016','2.1.8.4.1.97.00','(-) DESAGIO NA EMISSAO DE DEBENTURES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1677,'2016','2.1.8.4.1.98.00','(-) CUSTO DA TRANSAÇÃO A AMORTIZAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1678,'2016','2.1.8.4.1.99.00','OUTROS TITULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1679,'2016','2.1.8.5.0.00.00','DIVIDENDOS E JUROS SOBRE CAPITAL PRÓPRIO A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1680,'2016','2.1.8.5.1.00.00','DIVIDENDOS E JUROS SOBRE CAPITAL PRÓPRIO A PAGAR - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1681,'2016','2.1.8.5.1.01.00','DIVIDENDOS A PAGAR - TESOURO ESTADUAL/MUNICIPAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1682,'2016','2.1.8.5.1.02.00','DIVIDENDOS A PAGAR - TERCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1683,'2016','2.1.8.5.1.03.00','JUROS SOBRE CAPITAL PRÓPRIO A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1684,'2016','2.1.8.7.0.00.00','DEPÓSITOS DE INSTITUIÇÕES AUTORIZADAS A OPERAR PELO BACEN','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1685,'2016','2.1.8.7.1.00.00','DEPÓSITOS DE INSTITUIÇÕES AUTORIZADAS A OPERAR PELO BACEN - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1686,'2016','2.1.8.8.0.00.00','VALORES RESTITUÍVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1687,'2016','2.1.8.8.1.00.00','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1688,'2016','2.1.8.8.1.01.00','CONSIGNAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1689,'2016','2.1.8.8.1.01.01','RPPS - RETENÇÕES SOBRE VENCIMENTOS E VANTAGENS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1690,'2016','2.1.8.8.1.01.02','INSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1691,'2016','2.1.8.8.1.01.03','ENCARGOS SOCIAIS - OUTRAS ENTIDADES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1692,'2016','2.1.8.8.1.01.04','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1693,'2016','2.1.8.8.1.01.05','INDENIZAÇÕES E RESTITUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1694,'2016','2.1.8.8.1.01.06','IMPOSTOS E CONTRIBUIÇÕES DIVERSOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1695,'2016','2.1.8.8.1.01.07','ICMS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1696,'2016','2.1.8.8.1.01.08','ISS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1697,'2016','2.1.8.8.1.01.09','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1698,'2016','2.1.8.8.1.01.10','PENSAO ALIMENTICIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1699,'2016','2.1.8.8.1.01.11','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1700,'2016','2.1.8.8.1.01.12','ASSISTENCIA A SAUDE - ADMINISTRAÇÃO PROPRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1701,'2016','2.1.8.8.1.01.13','RETENÇÕES - ENTIDADES REPRESENTATIVAS DE CLASSES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1702,'2016','2.1.8.8.1.01.14','RETENÇÕES - PLANOS DE SEGUROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1703,'2016','2.1.8.8.1.01.15','RETENÇÕES - EMPRÉSTIMOS E FINANCIAMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1704,'2016','2.1.8.8.1.01.16','RETENÇÃO RELATIVA A VALE TRANSPORTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1705,'2016','2.1.8.8.1.01.17','RETENÇÃO RELATIVA A VALE ALIMENTAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1706,'2016','2.1.8.8.1.01.99','OUTROS CONSIGNATARIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1707,'2016','2.1.8.8.1.02.00','GARANTIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1708,'2016','2.1.8.8.1.03.00','DEPOSITOS JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1709,'2016','2.1.8.8.1.03.01','DEPOSITOS RECEBIDOS POR DETERMINAÇÃO JUDICIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1710,'2016','2.1.8.8.1.03.02','DEPOSITOS PARA RECURSOS JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1711,'2016','2.1.8.8.1.04.00','DEPOSITOS NAO JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1712,'2016','2.1.8.8.1.04.01','DEPOSITOS E CAUÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1713,'2016','2.1.8.8.1.04.02','DEPOSITOS ESPECIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1714,'2016','2.1.8.8.1.04.03','DEPOSITOS DE TERCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1715,'2016','2.1.8.8.1.04.04','DEPOSITOS DE VEICULOS ALIENAVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1716,'2016','2.1.8.8.1.04.05','DEPOSITOS A TRANSFERIR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1717,'2016','2.1.8.8.1.04.99','OUTROS DEPOSITOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1718,'2016','2.1.8.8.1.99.00','OUTROS VALORES RESTITUIVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1719,'2016','2.1.8.9.0.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1720,'2016','2.1.8.9.1.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1721,'2016','2.1.8.9.1.01.00','INDENIZAÇÕES E RESTITUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1722,'2016','2.1.8.9.1.01.01','INDENIZAÇÕES A SERVIDORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1723,'2016','2.1.8.9.1.01.02','INDENIZAÇÕES E RESTITUIÇÕES DIVERSAS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1724,'2016','2.1.8.9.1.01.03','INDENIZAÇÕES E RESTITUIÇÕES DIVERSAS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1725,'2016','2.1.8.9.1.01.04','RESTITUIÇÕES DE CONTRIBUIÇÕES PREVIDENCIÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1726,'2016','2.1.8.9.1.02.00','DIARIAS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1727,'2016','2.1.8.9.1.03.00','SUPRIMENTOS DE FUNDOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1728,'2016','2.1.8.9.1.05.00','CONVENIOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1729,'2016','2.1.8.9.1.05.01','CONVENIOS A PAGAR DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1730,'2016','2.1.8.9.1.05.02','CONVENIOS A PAGAR DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1731,'2016','2.1.8.9.1.09.00','TERMOS DE PARCERIA A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1732,'2016','2.1.8.9.1.09.01','TERMOS DE PARCERIA A PAGAR DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1733,'2016','2.1.8.9.1.09.02','TERMOS DE PARCERIA A PAGAR DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1734,'2016','2.1.8.9.1.10.00','TERMO DE COMPROMISSO A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1735,'2016','2.1.8.9.1.11.00','CONTRATOS DE GESTAO A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1736,'2016','2.1.8.9.1.12.00','SUBVENÇÕES A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1737,'2016','2.1.8.9.1.13.00','TRANSFERÊNCIAS ORCAMENTARIAS A LIBERAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1738,'2016','2.1.8.9.1.14.00','CONSÓRCIOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1739,'2016','2.1.8.9.2.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO-INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1740,'2016','2.2.0.0.0.00.00','PASSIVO NAO-CIRCULANTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1741,'2016','2.2.1.0.0.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1742,'2016','2.2.1.1.0.00.00','PESSOAL A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1743,'2016','2.2.1.1.1.00.00','PESSOAL A PAGAR- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1744,'2016','2.2.1.1.1.01.00','PESSOAL A PAGAR DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1745,'2016','2.2.1.1.1.02.00','PRECATORIOS DE PESSOAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1746,'2016','2.2.1.1.1.02.01','PRECATORIOS DE PESSOAL - REGIME ORDINÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1747,'2016','2.2.1.1.1.02.02','PRECATORIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES -  ANTERIORES  05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1748,'2016','2.2.1.1.1.02.03','PRECATORIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES -  A PARTIR DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1749,'2016','2.2.1.1.1.02.04','PRECATORIOS DE PESSOAL - REGIME ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1750,'2016','2.2.1.1.1.02.05','PRECATÓRIOS DE PESSOAL VENCIDOS E NÃO PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1751,'2016','2.2.1.2.0.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1752,'2016','2.2.1.2.1.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1753,'2016','2.2.1.2.1.01.00','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1754,'2016','2.2.1.2.1.01.01','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1755,'2016','2.2.1.2.1.01.02','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES -  ANTERIORES A 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1756,'2016','2.2.1.2.1.01.03','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS DE EXERCÍCIOS ANTERIORES -  A PARTIR DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1757,'2016','2.2.1.2.1.01.04','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1758,'2016','2.2.1.2.1.01.05','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1759,'2016','2.2.1.3.0.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1760,'2016','2.2.1.3.1.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1761,'2016','2.2.1.3.1.01.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1762,'2016','2.2.1.4.0.00.00','ENCARGOS SOCIAIS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1763,'2016','2.2.1.4.1.00.00','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1764,'2016','2.2.1.4.1.01.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1765,'2016','2.2.1.4.1.02.00','CONTRIBUICÕES SOCIAIS  - DÉBITOS PARCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1766,'2016','2.2.1.4.1.03.00','FGTS - DÉBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1767,'2016','2.2.1.4.1.99.00','OUTROS ENCARGOS SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1768,'2016','2.2.1.4.2.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1769,'2016','2.2.1.4.2.01.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA (RPPS)','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1770,'2016','2.2.1.4.2.99.00','OUTROS ENCARGOS SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1771,'2016','2.2.1.4.3.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1772,'2016','2.2.1.4.3.01.00','INSS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1773,'2016','2.2.1.4.3.01.01','INSS - DÉBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1774,'2016','2.2.1.4.3.02.00','CONTRIBUICÕES SOCIAIS  - DÉBITOS PARCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1775,'2016','2.2.1.4.3.99.00','OUTROS ENCARGOS SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1776,'2016','2.2.1.4.4.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1777,'2016','2.2.1.4.4.01.00','INSS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1778,'2016','2.2.1.4.4.01.01','INSS - DÉBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1779,'2016','2.2.1.4.4.99.00','OUTROS ENCARGOS SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1780,'2016','2.2.1.4.5.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1781,'2016','2.2.1.4.5.01.00','INSS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1782,'2016','2.2.1.4.5.01.01','INSS - DÉBITO PARCELADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1783,'2016','2.2.1.4.5.99.00','OUTROS ENCARGOS SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1784,'2016','2.2.2.0.0.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1785,'2016','2.2.2.1.0.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1786,'2016','2.2.2.1.1.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1787,'2016','2.2.2.1.1.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1788,'2016','2.2.2.1.1.01.01','DÍVIDA MOBILIÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1789,'2016','2.2.2.1.1.01.02','(-) DESÁGIO DE TÍTULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1790,'2016','2.2.2.1.1.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1791,'2016','2.2.2.1.1.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1792,'2016','2.2.2.1.1.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1793,'2016','2.2.2.1.1.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1794,'2016','2.2.2.1.2.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1795,'2016','2.2.2.1.2.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1796,'2016','2.2.2.1.2.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1797,'2016','2.2.2.1.2.02.01','EMPRÉSTIMOS DO RPPS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1798,'2016','2.2.2.1.2.99.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1799,'2016','2.2.2.1.3.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1800,'2016','2.2.2.1.3.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1801,'2016','2.2.2.1.3.01.01','DÍVIDA MOBILIÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1802,'2016','2.2.2.1.3.01.02','(-) DESÁGIO DE TÍTULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1803,'2016','2.2.2.1.3.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1804,'2016','2.2.2.1.3.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1805,'2016','2.2.2.1.3.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1806,'2016','2.2.2.1.3.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1807,'2016','2.2.2.1.3.04.00','PROGRAMA DE APOIO À REESTRUTURAÇÃO E AO AJUSTE FISCAL DOS ESTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1808,'2016','2.2.2.1.3.04.01','PROGRAMA DE APOIO À REESTRUTURAÇÃO E AO AJUSTE FISCAL DOS ESTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1809,'2016','2.2.2.1.3.05.00','PROGRAMA DE APOIO À REESTRUTURAÇÃO E AO AJUSTE FISCAL DOS MUNICÍPIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1810,'2016','2.2.2.1.3.05.01','PROGRAMA DE APOIO À REESTRUTURAÇÃO E AO AJUSTE FISCAL DOS MUNICÍPIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1811,'2016','2.2.2.1.3.99.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1812,'2016','2.2.2.1.4.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1813,'2016','2.2.2.1.4.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1814,'2016','2.2.2.1.4.01.01','DÍVIDA MOBILIÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1815,'2016','2.2.2.1.4.01.02','(-) DESÁGIO DE TÍTULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1816,'2016','2.2.2.1.4.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1817,'2016','2.2.2.1.4.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1818,'2016','2.2.2.1.4.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1819,'2016','2.2.2.1.4.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1820,'2016','2.2.2.1.5.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1821,'2016','2.2.2.1.5.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1822,'2016','2.2.2.1.5.01.01','DÍVIDA MOBILIÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1823,'2016','2.2.2.1.5.01.02','(-) DESÁGIO DE TÍTULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1824,'2016','2.2.2.1.5.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1825,'2016','2.2.2.1.5.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1826,'2016','2.2.2.1.5.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1827,'2016','2.2.2.1.5.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1828,'2016','2.2.2.2.0.00.00','EMPRÉSTIMOS A LONGO PRAZO - EXTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1829,'2016','2.2.2.2.1.00.00','EMPRÉSTIMOS A LONGO PRAZO- EXTERNO CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1830,'2016','2.2.2.2.1.01.00','EMPRÉSTIMOS EXTERNOS  - EM TÍTULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1831,'2016','2.2.2.2.1.02.00','EMPRÉSTIMOS EXTERNOS  - EM CONTRATOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1832,'2016','2.2.2.2.1.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1833,'2016','2.2.2.3.0.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1834,'2016','2.2.2.3.1.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1835,'2016','2.2.2.3.1.01.00','FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1836,'2016','2.2.2.3.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1837,'2016','2.2.2.3.1.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1838,'2016','2.2.2.3.1.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1839,'2016','2.2.2.3.1.01.98','OUTROS FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1840,'2016','2.2.2.3.1.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1841,'2016','2.2.2.3.3.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO -INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1842,'2016','2.2.2.3.4.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1843,'2016','2.2.2.3.5.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1844,'2016','2.2.2.4.0.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1845,'2016','2.2.2.4.1.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1846,'2016','2.2.2.4.1.01.00','FINANCIAMENTOS EXTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1847,'2016','2.2.2.4.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1848,'2016','2.2.2.4.1.01.02','FINANCIAMENTOS DE CAPITAL DE GIRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1849,'2016','2.2.2.4.1.02.00','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1850,'2016','2.2.2.5.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1851,'2016','2.2.2.5.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1852,'2016','2.2.2.5.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1853,'2016','2.2.2.5.1.01.01','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1854,'2016','2.2.2.5.1.01.02','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1855,'2016','2.2.2.5.1.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1856,'2016','2.2.2.5.1.02.01','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1857,'2016','2.2.2.5.1.02.02','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1858,'2016','2.2.2.5.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1859,'2016','2.2.2.5.1.03.01','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1860,'2016','2.2.2.5.1.03.02','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1861,'2016','2.2.2.5.1.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1862,'2016','2.2.2.5.1.04.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1863,'2016','2.2.2.5.1.04.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1864,'2016','2.2.2.5.3.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO -INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1865,'2016','2.2.2.5.4.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO -INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1866,'2016','2.2.2.5.5.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO -INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1867,'2016','2.2.2.6.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1868,'2016','2.2.2.6.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1869,'2016','2.2.2.6.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1870,'2016','2.2.2.6.1.01.01','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1871,'2016','2.2.2.6.1.01.02','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1872,'2016','2.2.2.6.1.02.00','ENCARGOS - EMPRÉSTIMOS EXTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1873,'2016','2.2.2.6.1.02.01','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1874,'2016','2.2.2.6.1.02.02','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1875,'2016','2.2.2.6.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1876,'2016','2.2.2.6.1.03.01','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1877,'2016','2.2.2.6.1.03.02','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1878,'2016','2.2.2.6.1.04.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1879,'2016','2.2.2.6.1.04.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1880,'2016','2.2.2.6.1.04.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCÍCIOS ANTERIORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1881,'2016','2.2.2.8.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1882,'2016','2.2.2.8.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1883,'2016','2.2.2.8.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1884,'2016','2.2.2.8.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1885,'2016','2.2.2.8.3.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1886,'2016','2.2.2.8.4.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1887,'2016','2.2.2.8.5.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1888,'2016','2.2.2.9.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1889,'2016','2.2.2.9.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1890,'2016','2.2.2.9.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS EXTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1891,'2016','2.2.2.9.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS EXTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1892,'2016','2.2.3.0.0.00.00','FORNECEDORES E CONTAS A PAGAR A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1893,'2016','2.2.3.1.0.00.00','FORNECEDORES NACIONAIS E CONTAS A PAGAR A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1894,'2016','2.2.3.1.1.00.00','FORNECEDORES NACIONAIS E CONTAS A PAGAR A LONGO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1895,'2016','2.2.3.1.1.01.00','FORNECEDORES NACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1896,'2016','2.2.3.1.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1897,'2016','2.2.3.1.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1898,'2016','2.2.3.1.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1899,'2016','2.2.3.1.1.01.99','DEMAIS FORNECEDORES A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1900,'2016','2.2.3.1.1.02.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1901,'2016','2.2.3.1.1.02.01','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO  - A PARTIR DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1902,'2016','2.2.3.1.1.02.02','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO - ANTES DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1903,'2016','2.2.3.1.1.02.03','PRECATORIOS DE FORNECEDORES NACIONAIS  - REGIME ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1904,'2016','2.2.3.1.1.02.04','PRECATÓRIOS DE FORNECEDORES NACIONAIS VENCIDOS E NÃO PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1905,'2016','2.2.3.1.1.03.00','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1906,'2016','2.2.3.1.1.03.01','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCÍCIOS ANTERIORES - ANTERIORES A 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1907,'2016','2.2.3.1.1.03.02','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1908,'2016','2.2.3.1.1.03.03','PRECATORIOS DE CONTAS A PAGAR NACIONAIS  - REGIME ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1909,'2016','2.2.3.1.1.03.04','PRECATÓRIOS DE CONTAS A PAGAR VENCIDOS E NÃO PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1910,'2016','2.2.3.2.0.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1911,'2016','2.2.3.2.1.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1912,'2016','2.2.3.2.1.01.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1913,'2016','2.2.3.2.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1914,'2016','2.2.3.2.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1915,'2016','2.2.3.2.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1916,'2016','2.2.3.2.1.01.99','DEMAIS FORNECEDORES A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1917,'2016','2.2.4.0.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1918,'2016','2.2.4.1.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1919,'2016','2.2.4.1.1.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1920,'2016','2.2.4.1.1.01.00','PASSIVO FISCAL DIFERIDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1921,'2016','2.2.4.1.1.02.00','TRIBUTOS FEDERAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1922,'2016','2.2.4.1.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1923,'2016','2.2.4.1.2.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1924,'2016','2.2.4.1.2.01.00','PASSIVO FISCAL DIFERIDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1925,'2016','2.2.4.1.2.02.00','TRIBUTOS FEDERAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1926,'2016','2.2.4.1.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1927,'2016','2.2.4.1.3.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1928,'2016','2.2.4.1.3.01.00','PASSIVO FISCAL DIFERIDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1929,'2016','2.2.4.1.3.02.00','TRIBUTOS FEDERAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1930,'2016','2.2.4.1.3.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1931,'2016','2.2.4.2.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1932,'2016','2.2.4.2.1.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1933,'2016','2.2.4.2.1.01.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1934,'2016','2.2.4.2.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1935,'2016','2.2.4.2.2.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1936,'2016','2.2.4.2.2.01.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1937,'2016','2.2.4.2.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1938,'2016','2.2.4.2.4.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1939,'2016','2.2.4.2.4.01.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1940,'2016','2.2.4.2.4.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1941,'2016','2.2.4.3.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1942,'2016','2.2.4.3.1.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1943,'2016','2.2.4.3.1.01.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1944,'2016','2.2.4.3.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1945,'2016','2.2.4.3.2.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS-INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1946,'2016','2.2.4.3.2.01.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1947,'2016','2.2.4.3.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1948,'2016','2.2.4.3.5.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS-INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1949,'2016','2.2.4.3.5.01.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1950,'2016','2.2.4.3.5.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1951,'2016','2.2.7.0.0.00.00','PROVISÕES A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1952,'2016','2.2.7.1.0.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1953,'2016','2.2.7.1.1.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1954,'2016','2.2.7.1.1.01.00','PROVISÃO PARA INDENIZAÇÕES TRABALHISTAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1955,'2016','2.2.7.1.1.02.00','PROVISÃO PARA PAGAMENTO DE DISSÍDIOS COLETIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1956,'2016','2.2.7.2.0.00.00','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1957,'2016','2.2.7.2.1.00.00','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1958,'2016','2.2.7.2.1.01.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1959,'2016','2.2.7.2.1.01.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS CONCEDIDOS DO PLANO FINANCEIRO DO RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1960,'2016','2.2.7.2.1.01.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1961,'2016','2.2.7.2.1.01.03','(-) CONTRIBUIÇÕES DO APOSENTADO PARA O PLANO FINANCEIRO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1962,'2016','2.2.7.2.1.01.04','(-) CONTRIBUIÇÕES DO PENSIONISTA PARA O PLANO FINANCEIRO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1963,'2016','2.2.7.2.1.01.05','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO FINANCEIRO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1964,'2016','2.2.7.2.1.01.06','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1965,'2016','2.2.7.2.1.01.07','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1966,'2016','2.2.7.2.1.02.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS A CONCEDER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1967,'2016','2.2.7.2.1.02.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS A CONCEDER DO PLANO FINANCEIRO DO RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1968,'2016','2.2.7.2.1.02.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1969,'2016','2.2.7.2.1.02.03','(-) CONTRIBUIÇÕES DO ATIVO PARA O PLANO FINANCEIRO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1970,'2016','2.2.7.2.1.02.04','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO FINANCEIRO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1971,'2016','2.2.7.2.1.02.05','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1972,'2016','2.2.7.2.1.02.06','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1973,'2016','2.2.7.2.1.03.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1974,'2016','2.2.7.2.1.03.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS CONCEDIDOS DO PLANO PREVIDENCIÁRIO DO RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1975,'2016','2.2.7.2.1.03.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO PREVIDENCIÁRIO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1976,'2016','2.2.7.2.1.03.03','(-) CONTRIBUIÇÕES DO APOSENTADO PARA O PLANO PREVIDENCIÁRIO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1977,'2016','2.2.7.2.1.03.04','(-) CONTRIBUIÇÕES DO PENSIONISTA PARA O PLANO PREVIDENCIÁRIO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1978,'2016','2.2.7.2.1.03.05','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO PREVIDENCIÁRIO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1979,'2016','2.2.7.2.1.03.06','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS DO PLANO PREVIDENCIÁRIO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1980,'2016','2.2.7.2.1.03.07','(-) APORTES FINANCEIROS PARA COBERTURA DO DÉFICIT ATUARIAL - PLANO DE AMORTIZAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1981,'2016','2.2.7.2.1.04.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS A CONCEDER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1982,'2016','2.2.7.2.1.04.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS A CONCEDER DO PLANO PREVIDENCIÁRIO DO RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1983,'2016','2.2.7.2.1.04.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO PREVIDENCIÁRIO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1984,'2016','2.2.7.2.1.04.03','(-) CONTRIBUIÇÕES DO ATIVO PARA O PLANO PREVIDENCIÁRIO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1985,'2016','2.2.7.2.1.04.04','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO PREVIDENCIÁRIO DO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1986,'2016','2.2.7.2.1.04.05','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1987,'2016','2.2.7.2.1.04.06','(-) APORTES PARA COBERTURA DO DÉFICIT ATUARIAL - PLANO DE AMORTIZAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1988,'2016','2.2.7.2.1.05.00','PLANO PREVIDENCIARIO - PLANO DE AMORTIZAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1989,'2016','2.2.7.2.1.05.98','(-) OUTROS CRÉDITOS DO PLANO DE AMORTIZAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1990,'2016','2.2.7.2.1.06.00','PROVISOES ATUARIAIS PARA AJUSTES DO PLANO FINANCEIRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1991,'2016','2.2.7.2.1.06.01','PROVISÃO ATUARIAL PARA OSCILAÇÃO DE RISCOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1992,'2016','2.2.7.2.1.07.00','PROVISOES ATUARIAIS PARA AJUSTES DO PLANO PREVIDENCIARIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1993,'2016','2.2.7.2.1.07.01','AJUSTE DE RESULTADO ATUARIAL SUPERAVITÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1994,'2016','2.2.7.2.1.07.02','PROVISÃO ATUARIAL PARA OSCILAÇÃO DE RISCOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1995,'2016','2.2.7.2.1.07.03','PROVISÃO ATUARIAL PARA BENEFÍCIOS A REGULARIZAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1996,'2016','2.2.7.2.1.07.04','PROVISÃO ATUARIAL PARA CONTINGÊNCIAS DE BENEFÍCIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1997,'2016','2.2.7.2.1.07.98','OUTRAS PROVISÕES ATUARIAIS PARA AJUSTES DO PLANO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1998,'2016','2.2.7.3.0.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (1999,'2016','2.2.7.3.1.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2000,'2016','2.2.7.3.1.01.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2001,'2016','2.2.7.3.1.01.01','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO NÃO RECORRIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2002,'2016','2.2.7.3.1.01.02','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO RECORRIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2003,'2016','2.2.7.3.1.02.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS - ESFERA JUDICIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2004,'2016','2.2.7.3.1.02.01','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2005,'2016','2.2.7.3.1.02.02','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2006,'2016','2.2.7.4.0.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2007,'2016','2.2.7.4.1.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2008,'2016','2.2.7.4.1.01.00','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2009,'2016','2.2.7.4.1.02.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2010,'2016','2.2.7.4.1.03.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2011,'2016','2.2.7.4.1.04.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS NÃO CIENTIFICADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2012,'2016','2.2.7.5.0.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2013,'2016','2.2.7.5.1.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2014,'2016','2.2.7.5.3.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2015,'2016','2.2.7.5.4.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2016,'2016','2.2.7.5.5.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2017,'2016','2.2.7.6.0.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2018,'2016','2.2.7.6.1.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO - CONSOLIDAÇÃO OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2019,'2016','2.2.7.9.0.00.00','OUTRAS PROVISÕES A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2020,'2016','2.2.7.9.1.00.00','OUTRAS PROVISÕES A LONGO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2021,'2016','2.2.7.9.1.01.00','PROVISÃO PARA GARANTIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2022,'2016','2.2.7.9.1.02.00','PROVISÃO PARA REESTRUTURAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2023,'2016','2.2.7.9.1.03.00','PROVISÕES DO FCVS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2024,'2016','2.2.7.9.1.03.01','PROVISÕES DO FCVS - RISCOS EXPIRADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2025,'2016','2.2.7.9.1.03.02','PROVISÕES DO FCVS - RISCOS NÃO EXPIRADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2026,'2016','2.2.7.9.1.99.00','OUTRAS PROVISÕES A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2027,'2016','2.2.8.0.0.00.00','DEMAIS OBRIGAÇÕES A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2028,'2016','2.2.8.1.0.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2029,'2016','2.2.8.1.1.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2030,'2016','2.2.8.2.0.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2031,'2016','2.2.8.2.1.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2032,'2016','2.2.8.3.0.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DÍVIDA A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2033,'2016','2.2.8.3.1.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DÍVIDA A LONGO PRAZO- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2034,'2016','2.2.8.4.0.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2035,'2016','2.2.8.4.1.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2036,'2016','2.2.8.8.0.00.00','VALORES RESTITUÍVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2037,'2016','2.2.8.8.1.00.00','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2038,'2016','2.2.8.8.1.01.00','CONSIGNAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2039,'2016','2.2.8.8.1.01.01','RPPS - RETENÇÕES SOBRE VENCIMENTOS E VANTAGENS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2040,'2016','2.2.8.8.1.01.02','INSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2041,'2016','2.2.8.8.1.01.03','ENCARGOS SOCIAIS - OUTRAS ENTIDADES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2042,'2016','2.2.8.8.1.01.04','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2043,'2016','2.2.8.8.1.01.05','INDENIZAÇÕES E RESTITUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2044,'2016','2.2.8.8.1.01.06','IMPOSTOS E CONTRIBUIÇÕES DIVERSOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2045,'2016','2.2.8.8.1.01.07','ICMS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2046,'2016','2.2.8.8.1.01.08','ISS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2047,'2016','2.2.8.8.1.01.09','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2048,'2016','2.2.8.8.1.01.10','PENSAO ALIMENTICIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2049,'2016','2.2.8.8.1.01.11','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2050,'2016','2.2.8.8.1.01.12','ASSISTENCIA A SAUDE - ADMINISTRAÇÃO PROPRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2051,'2016','2.2.8.8.1.01.13','RETENÇÕES - ENTIDADES REPRESENTATIVAS DE CLASSES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2052,'2016','2.2.8.8.1.01.14','RETENÇÕES - PLANOS DE SEGUROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2053,'2016','2.2.8.8.1.01.15','RETENÇÕES - EMPRÉSTIMOS E FINANCIAMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2054,'2016','2.2.8.8.1.01.16','RETENÇÃO RELATIVA A VALE TRANSPORTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2055,'2016','2.2.8.8.1.01.17','RETENÇÃO RELATIVA A VALE ALIMENTAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2056,'2016','2.2.8.8.1.01.99','OUTROS CONSIGNATARIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2057,'2016','2.2.8.8.1.02.00','GARANTIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2058,'2016','2.2.8.8.1.03.00','DEPOSITOS JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2059,'2016','2.2.8.8.1.03.01','DEPOSITOS RECEBIDOS POR DETERMINAÇÃO JUDICIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2060,'2016','2.2.8.8.1.03.02','DEPOSITOS PARA RECURSOS JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2061,'2016','2.2.8.8.1.04.00','DEPOSITOS NAO JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2062,'2016','2.2.8.8.1.04.01','DEPOSITOS E CAUÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2063,'2016','2.2.8.8.1.04.02','DEPOSITOS ESPECIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2064,'2016','2.2.8.8.1.04.03','DEPOSITOS DE TERCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2065,'2016','2.2.8.8.1.04.04','DEPOSITOS DE VEICULOS ALIENAVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2066,'2016','2.2.8.8.1.04.05','DEPOSITOS A TRANSFERIR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2067,'2016','2.2.8.8.1.04.99','OUTROS DEPOSITOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2068,'2016','2.2.8.8.1.99.00','OUTROS VALORES RESTITUIVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2069,'2016','2.2.8.9.0.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2070,'2016','2.2.8.9.1.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2071,'2016','2.2.9.0.0.00.00','RESULTADO DIFERIDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2072,'2016','2.2.9.1.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA (VPA) DIFERIDA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2073,'2016','2.2.9.1.1.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA DIFERIDA - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2074,'2016','2.2.9.2.0.00.00','(-) CUSTO DIFERIDO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2075,'2016','2.2.9.2.1.00.00','(-) CUSTO DIFERIDO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2076,'2016','2.3.0.0.0.00.00','PATRIMÔNIO LIQUIDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2077,'2016','2.3.1.0.0.00.00','PATRIMÔNIO SOCIAL E CAPITAL SOCIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2078,'2016','2.3.1.1.0.00.00','PATRIMÔNIO SOCIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2079,'2016','2.3.1.1.1.00.00','PATRIMÔNIO SOCIAL - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2080,'2016','2.3.1.2.0.00.00','CAPITAL SOCIAL REALIZADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2081,'2016','2.3.1.2.1.00.00','CAPITAL SOCIAL REALIZADO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2082,'2016','2.3.1.2.2.00.00','CAPITAL SOCIAL REALIZADO - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2083,'2016','2.3.1.2.3.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2084,'2016','2.3.1.2.4.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2085,'2016','2.3.1.2.5.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2086,'2016','2.3.2.0.0.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2087,'2016','2.3.2.0.1.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2088,'2016','2.3.2.0.2.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2089,'2016','2.3.2.0.3.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2090,'2016','2.3.2.0.4.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2091,'2016','2.3.2.0.5.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - MUNICÍPIO.','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2092,'2016','2.3.3.0.0.00.00','RESERVAS DE CAPITAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2093,'2016','2.3.3.1.0.00.00','ÁGIO NA EMISSÃO DE AÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2094,'2016','2.3.3.1.1.00.00','ÁGIO NA EMISSÃO DE AÇÕES - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2095,'2016','2.3.3.1.2.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2096,'2016','2.3.3.1.3.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2097,'2016','2.3.3.1.4.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2098,'2016','2.3.3.1.5.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2099,'2016','2.3.3.2.0.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2100,'2016','2.3.3.2.1.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2101,'2016','2.3.3.2.2.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2102,'2016','2.3.3.2.3.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2103,'2016','2.3.3.2.4.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2104,'2016','2.3.3.2.5.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2105,'2016','2.3.3.3.0.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2106,'2016','2.3.3.3.1.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2107,'2016','2.3.3.3.2.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2108,'2016','2.3.3.3.3.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2109,'2016','2.3.3.3.4.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2110,'2016','2.3.3.3.5.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2111,'2016','2.3.3.4.0.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2112,'2016','2.3.3.4.1.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2113,'2016','2.3.3.4.2.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2114,'2016','2.3.3.4.3.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2115,'2016','2.3.3.4.4.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2116,'2016','2.3.3.4.5.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2117,'2016','2.3.3.9.0.00.00','OUTRAS RESERVAS DE CAPITAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2118,'2016','2.3.3.9.1.00.00','OUTRAS RESERVAS DE CAPITAL - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2119,'2016','2.3.3.9.1.01.00','PRÊMIO NA EMISSÃO DE DEBÊNTURES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2120,'2016','2.3.3.9.1.02.00','RESERVAS DE DOAÇÕES E SUBVENÇÕES PARA INVESTIMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2121,'2016','2.3.3.9.1.03.00','RESERVA DE CORREÇÃO MONETÁRIA ESPECIAL DEC. LEI 1.598/77','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2122,'2016','2.3.3.9.1.99.00','DEMAIS RESERVAS DE CAPITAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2123,'2016','2.3.3.9.2.00.00','OUTRAS RESERVAS DE CAPITAL - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2124,'2016','2.3.3.9.2.01.00','PRÊMIO NA EMISSÃO DE DEBÊNTURES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2125,'2016','2.3.3.9.2.02.00','RESERVAS DE DOAÇÕES E SUBVENÇÕES PARA INVESTIMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2126,'2016','2.3.3.9.2.03.00','RESERVA DE CORREÇÃO MONETÁRIA ESPECIAL DEC. LEI 1.598/77','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2127,'2016','2.3.3.9.2.99.00','DEMAIS RESERVAS DE CAPITAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2128,'2016','2.3.3.9.3.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2129,'2016','2.3.3.9.4.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2130,'2016','2.3.3.9.5.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2131,'2016','2.3.4.0.0.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2132,'2016','2.3.4.1.0.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2133,'2016','2.3.4.1.1.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS - CONSOLIDAÇÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2134,'2016','2.3.4.2.0.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2135,'2016','2.3.4.2.1.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS - CONSOLIDAÇÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2136,'2016','2.3.5.0.0.00.00','RESERVAS DE LUCROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2137,'2016','2.3.5.1.0.00.00','RESERVA LEGAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2138,'2016','2.3.5.1.1.00.00','RESERVA LEGAL- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2139,'2016','2.3.5.1.2.00.00','RESERVA LEGAL- INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2140,'2016','2.3.5.1.3.00.00','RESERVA LEGAL- INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2141,'2016','2.3.5.1.4.00.00','RESERVA LEGAL- INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2142,'2016','2.3.5.1.5.00.00','RESERVA LEGAL- INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2143,'2016','2.3.5.2.0.00.00','RESERVAS ESTATUTÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2144,'2016','2.3.5.2.1.00.00','RESERVAS ESTATUTÁRIAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2145,'2016','2.3.5.2.2.00.00','RESERVAS ESTATUTÁRIAS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2146,'2016','2.3.5.2.3.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2147,'2016','2.3.5.2.4.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2148,'2016','2.3.5.2.5.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2149,'2016','2.3.5.3.0.00.00','RESERVA PARA CONTINGENCIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2150,'2016','2.3.5.3.1.00.00','RESERVA PARA CONTINGENCIAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2151,'2016','2.3.5.3.2.00.00','RESERVA PARA CONTINGENCIAS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2152,'2016','2.3.5.3.3.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2153,'2016','2.3.5.3.4.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2154,'2016','2.3.5.3.5.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2155,'2016','2.3.5.4.0.00.00','RESERVA DE INCENTIVOS FISCAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2156,'2016','2.3.5.4.1.00.00','RESERVA DE INCENTIVOS FISCAIS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2157,'2016','2.3.5.4.2.00.00','RESERVA DE INCENTIVOS FISCAIS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2158,'2016','2.3.5.4.3.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2159,'2016','2.3.5.4.4.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2160,'2016','2.3.5.4.5.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2161,'2016','2.3.5.5.0.00.00','RESERVAS DE LUCROS PARA EXPANSÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2162,'2016','2.3.5.5.1.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2163,'2016','2.3.5.5.2.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2164,'2016','2.3.5.5.3.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2165,'2016','2.3.5.5.4.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS -ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2166,'2016','2.3.5.5.5.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2167,'2016','2.3.5.6.0.00.00','RESERVA DE LUCROS A REALIZAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2168,'2016','2.3.5.6.1.00.00','RESERVA DE LUCROS A REALIZAR- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2169,'2016','2.3.5.6.2.00.00','RESERVA DE LUCROS A REALIZAR- INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2170,'2016','2.3.5.6.3.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2171,'2016','2.3.5.6.4.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2172,'2016','2.3.5.6.5.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2173,'2016','2.3.5.7.0.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2174,'2016','2.3.5.7.1.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2175,'2016','2.3.5.7.2.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2176,'2016','2.3.5.7.3.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2177,'2016','2.3.5.7.4.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2178,'2016','2.3.5.7.5.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2179,'2016','2.3.5.8.0.00.00','RESERVA ESPECIAL PARA DIVIDENDO OBRIGATÓRIO NÃO DISTRIBUÍDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2180,'2016','2.3.5.8.1.00.00','RESERVA ESPECIAL PARA DIVIDENDO OBRIGATÓRIO NÃO DISTRIBUÍDO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2181,'2016','2.3.5.8.2.00.00','RESERVA ESPECIAL PARA DIVIDENDO OBRIGATÓRIO NÃO DISTRIBUÍDO - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2182,'2016','2.3.5.8.3.00.00','RESERVA ESPECIAL PARA DIVIDENDO OBRIGATÓRIO NÃO DISTRIBUÍDO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2183,'2016','2.3.5.8.4.00.00','RESERVA ESPECIAL PARA DIVIDENDO OBRIGATÓRIO NÃO DISTRIBUÍDO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2184,'2016','2.3.5.8.5.00.00','RESERVA ESPECIAL PARA DIVIDENDO OBRIGATÓRIO NÃO DISTRIBUÍDO - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2185,'2016','2.3.5.9.0.00.00','OUTRAS RESERVAS DE LUCRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2186,'2016','2.3.5.9.1.00.00','OUTRAS RESERVAS DE LUCRO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2187,'2016','2.3.5.9.2.00.00','OUTRAS RESERVAS DE LUCRO - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2188,'2016','2.3.5.9.3.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2189,'2016','2.3.5.9.4.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2190,'2016','2.3.5.9.5.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2191,'2016','2.3.6.0.0.00.00','DEMAIS RESERVAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2192,'2016','2.3.6.1.0.00.00','RESERVA DE REAVALIAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2193,'2016','2.3.6.1.1.00.00','RESERVA DE REAVALIAÇÃO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2194,'2016','2.3.6.1.2.00.00','RESERVA DE REAVALIAÇÃO - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2195,'2016','2.3.6.1.3.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2196,'2016','2.3.6.1.4.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2197,'2016','2.3.6.1.5.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2198,'2016','2.3.6.9.0.00.00','OUTRAS RESERVAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2199,'2016','2.3.6.9.1.00.00','OUTRAS RESERVAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2200,'2016','2.3.6.9.2.00.00','OUTRAS RESERVAS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2201,'2016','2.3.6.9.3.00.00','OUTRAS RESERVAS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2202,'2016','2.3.6.9.4.00.00','OUTRAS RESERVAS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2203,'2016','2.3.6.9.5.00.00','OUTRAS RESERVAS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2204,'2016','2.3.7.0.0.00.00','RESULTADOS ACUMULADOS','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2205,'2016','2.3.7.1.0.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2206,'2016','2.3.7.1.1.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - CONSOLIDAÇÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2207,'2016','2.3.7.1.1.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2208,'2016','2.3.7.1.1.02.00','SUPERAVITS OU DEFICITS DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2209,'2016','2.3.7.1.1.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2210,'2016','2.3.7.1.1.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2211,'2016','2.3.7.1.2.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTRA OFSS','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2212,'2016','2.3.7.1.2.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2213,'2016','2.3.7.1.2.02.00','SUPERAVITS OU DEFICITS DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2214,'2016','2.3.7.1.2.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2215,'2016','2.3.7.1.2.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2216,'2016','2.3.7.1.3.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - UNIÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2217,'2016','2.3.7.1.3.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2218,'2016','2.3.7.1.3.02.00','SUPERAVITS OU DEFICITS DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2219,'2016','2.3.7.1.3.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2220,'2016','2.3.7.1.3.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2221,'2016','2.3.7.1.4.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - ESTADO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2222,'2016','2.3.7.1.4.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2223,'2016','2.3.7.1.4.02.00','SUPERAVITS OU DEFICITS DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2224,'2016','2.3.7.1.4.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2225,'2016','2.3.7.1.4.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2226,'2016','2.3.7.1.5.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - MUNICÍPIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2227,'2016','2.3.7.1.5.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2228,'2016','2.3.7.1.5.02.00','SUPERAVITS OU DEFICITS DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2229,'2016','2.3.7.1.5.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2230,'2016','2.3.7.1.5.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2231,'2016','2.3.7.2.0.00.00','LUCROS E PREJUÍZOS ACUMULADOS','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2232,'2016','2.3.7.2.1.00.00','LUCROS E PREJUÍZOS ACUMULADOS - CONSOLIDAÇÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2233,'2016','2.3.7.2.1.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2234,'2016','2.3.7.2.1.02.00','LUCROS E PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2235,'2016','2.3.7.2.1.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2236,'2016','2.3.7.2.1.04.00','LUCROS A DESTINAR DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2237,'2016','2.3.7.2.1.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2238,'2016','2.3.7.2.1.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2239,'2016','2.3.7.2.2.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTRA OFSS','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2240,'2016','2.3.7.2.2.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2241,'2016','2.3.7.2.2.02.00','LUCROS EPREJUIZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2242,'2016','2.3.7.2.2.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2243,'2016','2.3.7.2.2.04.00','LUCROS A DESTINAR DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2244,'2016','2.3.7.2.2.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2245,'2016','2.3.7.2.2.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2246,'2016','2.3.7.2.3.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - UNIÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2247,'2016','2.3.7.2.3.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2248,'2016','2.3.7.2.3.02.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2249,'2016','2.3.7.2.3.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2250,'2016','2.3.7.2.3.04.00','LUCROS A DESTINAR DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2251,'2016','2.3.7.2.3.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2252,'2016','2.3.7.2.3.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2253,'2016','2.3.7.2.4.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - ESTADO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2254,'2016','2.3.7.2.4.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2255,'2016','2.3.7.2.4.02.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2256,'2016','2.3.7.2.4.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2257,'2016','2.3.7.2.4.04.00','LUCROS A DESTINAR DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2258,'2016','2.3.7.2.4.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2259,'2016','2.3.7.2.4.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2260,'2016','2.3.7.2.5.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - MUNICÍPIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2261,'2016','2.3.7.2.5.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2262,'2016','2.3.7.2.5.02.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2263,'2016','2.3.7.2.5.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2264,'2016','2.3.7.2.5.04.00','LUCROS A DESTINAR DO EXERCÍCIO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2265,'2016','2.3.7.2.5.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2266,'2016','2.3.7.2.5.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2267,'2016','2.3.9.0.0.00.00','(-) AÇÕES/COTAS EM TESOURARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2268,'2016','2.3.9.1.0.00.00','(-) AÇÕES EM TESOURARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2269,'2016','2.3.9.1.1.00.00','(-) AÇÕES EM TESOURARIA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2270,'2016','2.3.9.1.2.00.00','(-) AÇÕES EM TESOURARIA - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2271,'2016','2.3.9.1.3.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2272,'2016','2.3.9.1.4.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2273,'2016','2.3.9.1.5.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2274,'2016','2.3.9.2.0.00.00','(-) COTAS EM TESOURARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2275,'2016','2.3.9.2.1.00.00','(-) COTAS EM TESOURARIA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2276,'2016','2.3.9.2.2.00.00','(-) COTAS EM TESOURARIA - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2277,'2016','2.3.9.2.3.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2278,'2016','2.3.9.2.4.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2279,'2016','2.3.9.2.5.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2280,'2016','3.0.0.0.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2281,'2016','3.1.0.0.0.00.00','PESSOAL E ENCARGOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2282,'2016','3.1.1.0.0.00.00','REMUNERAÇÃO A PESSOAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2283,'2016','3.1.1.1.0.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2284,'2016','3.1.1.1.1.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO RPPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2285,'2016','3.1.1.1.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2286,'2016','3.1.1.1.1.01.01','VENCIMENTOS E SALÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2287,'2016','3.1.1.1.1.01.02','ADICIONAL NOTURNO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2288,'2016','3.1.1.1.1.01.03','INCORPORAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2289,'2016','3.1.1.1.1.01.04','ABONO DE PERMANÊNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2290,'2016','3.1.1.1.1.01.05','ADICIONAL DE PERICULOSIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2291,'2016','3.1.1.1.1.01.06','ADICIONAL DE INSALUBRIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2292,'2016','3.1.1.1.1.01.07','ADICIONAL DE ATIVIDADES PENOSAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2293,'2016','3.1.1.1.1.01.08','INCENTIVO Á QUALIFICAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2294,'2016','3.1.1.1.1.01.09','REMUNERAÇÃO DE PESSOAL EM DISPONIBILIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2295,'2016','3.1.1.1.1.01.10','RETRIBUIÇÃO ADICIONAL VARIÁVEL E PRÓ-LABORE (LEI 7711/88)','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2296,'2016','3.1.1.1.1.01.12','VANTAGEM PECUNIÁRIA INDIVIDUAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2297,'2016','3.1.1.1.1.01.13','ABONO PROVISÓRIO - PESSOAL CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2298,'2016','3.1.1.1.1.01.14','GRATIFICAÇÃO POR EXERCÍCIO DE CARGOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2299,'2016','3.1.1.1.1.01.15','INCREMENTO PLANO DE CARGOS E SALÁRIOS DO PODER JUDICIÁRIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2300,'2016','3.1.1.1.1.01.16','GRATIFICAÇÃO POR EXERCÍCIO DE FUNÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2301,'2016','3.1.1.1.1.01.17','INDENIZAÇÃO DE LOCALIZAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2302,'2016','3.1.1.1.1.01.18','GRATIFICAÇÃO DE TEMPO DE SERVIÇO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2303,'2016','3.1.1.1.1.01.19','GRATIFICAÇÕES ESPECIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2304,'2016','3.1.1.1.1.01.20','GRATIFICAÇÃO POR ATIVIDADES EXPOSTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2305,'2016','3.1.1.1.1.01.21','FÉRIAS VENCIDAS E PROPORCIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2306,'2016','3.1.1.1.1.01.22','13. SALÁRIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2307,'2016','3.1.1.1.1.01.23','FÉRIAS - ABONO PECUNIÁRIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2308,'2016','3.1.1.1.1.01.24','FÉRIAS - ABONO CONSTITUCIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2309,'2016','3.1.1.1.1.01.25','LICENÇA-PRÊMIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2310,'2016','3.1.1.1.1.01.26','LICENÇA CAPACITAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2311,'2016','3.1.1.1.1.01.27','ADIANTAMENTO PECUNIÁRIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2312,'2016','3.1.1.1.1.01.28','REPRESENTAÇÃO MENSAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2313,'2016','3.1.1.1.1.01.29','COMPLEMENTAÇÃO SALARIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2314,'2016','3.1.1.1.1.01.30','ADICIONAL - TETO PARLAMENTAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2315,'2016','3.1.1.1.1.01.31','SUBSÍDIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2316,'2016','3.1.1.1.1.01.32','GRATIFICAÇÃO POR EXERCÍCIO DE CARGO EM COMISSÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2317,'2016','3.1.1.1.1.01.33','VENCIMENTOS E SALÁRIOS PRORROGAÇÃO SALÁRIO MATERNIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2318,'2016','3.1.1.1.1.01.35','FÉRIAS - PAGAMENTO ANTECIPADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2319,'2016','3.1.1.1.1.01.36','REMUN. PARTICIP. ÓRGÃOS DELIBERAÇÃO COLETIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2320,'2016','3.1.1.1.1.01.99','OUTROS VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2321,'2016','3.1.1.1.1.02.00','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2322,'2016','3.1.1.1.1.02.01','SUBSTITUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2323,'2016','3.1.1.1.1.02.02','ADICIONAL VARIÁVEL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2324,'2016','3.1.1.1.1.02.03','SERVIÇOS EXTRAORDINÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2325,'2016','3.1.1.1.1.02.04','GRATIFICAÇÃO POR EMBARQUE FLUVIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2326,'2016','3.1.1.1.1.02.05','GRATIFICAÇÃO ELEITORAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2327,'2016','3.1.1.1.1.02.06','LICENÇA SEM REMUNERAÇÃO INCENTIVADA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2328,'2016','3.1.1.1.1.02.07','ADICIONAL POR PLANTÃO HOSPITALAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2329,'2016','3.1.1.1.1.02.08','CONVOCAÇÃO EXTRAORDINARIA LEGISLATIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2330,'2016','3.1.1.1.1.02.09','PARTICIPAÇÃO A EMPREGADOS E ADMINISTRADORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2331,'2016','3.1.1.1.1.02.10','AUXILIO MORADIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2332,'2016','3.1.1.1.1.02.11','INDENIZAÇÕES  E RESTITUIÇÕES TRABALHISTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2333,'2016','3.1.1.1.1.02.12','INDENIZ. E RESTIT. DECORR. DE PLANOS DE DEMISSÃO VOLUNTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2334,'2016','3.1.1.1.1.02.13','RESSARCIMENTO DE DESP. DE PESSOAL REQUISITADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2335,'2016','3.1.1.1.1.02.99','OUTROS VENCIMENTOS E VANTAGENS VARIÁVEIS - PESSOAL CIVIL RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2336,'2016','3.1.1.1.1.03.00','SENTENCAS JUDICIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2337,'2016','3.1.1.2.0.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2338,'2016','3.1.1.2.1.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO RGPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2339,'2016','3.1.1.2.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2340,'2016','3.1.1.2.1.01.01','VENCIMENTOS E SALARIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2341,'2016','3.1.1.2.1.01.02','ADICIONAL NOTURNO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2342,'2016','3.1.1.2.1.01.03','INCORPORAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2343,'2016','3.1.1.2.1.01.04','ABONO DE PERMANENCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2344,'2016','3.1.1.2.1.01.05','ADICIONAL DE PERICULOSIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2345,'2016','3.1.1.2.1.01.06','ADICIONAL DE INSALUBRIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2346,'2016','3.1.1.2.1.01.07','REMUNERAÇÃO PARTICIPANTES DE ORGAO DE DELIBERAÇÃO COLETIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2347,'2016','3.1.1.2.1.01.08','INCENTIVO A QUALIFICAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2348,'2016','3.1.1.2.1.01.09','ADICIONAL DE TRANSFERÊNCIA - ART. 469/CLT','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2349,'2016','3.1.1.2.1.01.10','RETR.ADIC.VARIAVEL E PRO-LABORE(LEI 7711/88)','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2350,'2016','3.1.1.2.1.01.11','REMUNERAÇÃO DE DIRETORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2351,'2016','3.1.1.2.1.01.12','VANTAGEM PECUNIARIA INDIVIDUAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2352,'2016','3.1.1.2.1.01.13','ABONO PROVISORIO - PESSOAL CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2353,'2016','3.1.1.2.1.01.14','GRATIFICAÇÃO POR EXERCÍCIO DE CARGOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2354,'2016','3.1.1.2.1.01.15','INDENIZAÇÃO A ANISTIADO POLITICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2355,'2016','3.1.1.2.1.01.16','GRATIFICAÇÃO POR EXERCÍCIO DE FUNÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2356,'2016','3.1.1.2.1.01.17','INDENIZAÇÃO DE LOCALIZAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2357,'2016','3.1.1.2.1.01.18','GRATIFICAÇÃO DE TEMPO DE  SERVICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2358,'2016','3.1.1.2.1.01.19','GRATIFICAÇÕES ESPECIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2359,'2016','3.1.1.2.1.01.20','GRATIFICAÇÃO POR ATIVIDADES EXPOSTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2360,'2016','3.1.1.2.1.01.21','FERIAS VENCIDAS E PROPORCIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2361,'2016','3.1.1.2.1.01.22','13. SALARIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2362,'2016','3.1.1.2.1.01.23','FERIAS - ABONO PECUNIARIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2363,'2016','3.1.1.2.1.01.24','FERIAS - ABONO CONSTITUCIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2364,'2016','3.1.1.2.1.01.25','LICENCA-PREMIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2365,'2016','3.1.1.2.1.01.26','LICENCA CAPACITAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2366,'2016','3.1.1.2.1.01.27','ADIANTAMENTO  PECUNIARIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2367,'2016','3.1.1.2.1.01.28','REPRESENTAÇÃO MENSAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2368,'2016','3.1.1.2.1.01.29','COMPLEMENTAÇÃO SALARIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2369,'2016','3.1.1.2.1.01.30','ADICIONAL - TETO PARLAMENTAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2370,'2016','3.1.1.2.1.01.31','SUBSÍDIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2371,'2016','3.1.1.2.1.01.32','GRATIFICAÇÃO POR EXERCÍCIO DE CARGO EM COMISSÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2372,'2016','3.1.1.2.1.01.33','VENCIMENTOS E SALÁRIOS PRORROGAÇÃO SALÁRIO MATERNIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2373,'2016','3.1.1.2.1.01.35','FÉRIAS - PAGAMENTO ANTECIPADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2374,'2016','3.1.1.2.1.01.99','OUTROS VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2375,'2016','3.1.1.2.1.02.00','OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2376,'2016','3.1.1.2.1.02.01','SUBSTITUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2377,'2016','3.1.1.2.1.02.02','ADICIONAL VARIAVEL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2378,'2016','3.1.1.2.1.02.03','SERVICOS EXTRAORDINARIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2379,'2016','3.1.1.2.1.02.04','GRATIFICAÇÃO POR EMBARQUE FLUVIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2380,'2016','3.1.1.2.1.02.05','AVISO PREVIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2381,'2016','3.1.1.2.1.02.06','PARTICIPAÇÃO A EMPREGADOS E ADMINISTRADORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2382,'2016','3.1.1.2.1.02.07','GRATIFICAÇÃO ELEITORAL (RGPS)','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2383,'2016','3.1.1.2.1.02.08','LICENCA SEM REMUNERAÇÃO INCENTIVADA (RGPS)','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2384,'2016','3.1.1.2.1.02.09','CONVOCAÇÃO EXTRAORDINARIA LEGISLATIVA (RGPS)','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2385,'2016','3.1.1.2.1.02.10','AUXILIO MORADIA (RGPS)','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2386,'2016','3.1.1.2.1.02.99','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2387,'2016','3.1.1.2.1.03.00','SENTENCAS JUDICIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2388,'2016','3.1.1.2.1.04.00','CONTRATAÇÃO POR TEMPO DETERMINADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2389,'2016','3.1.1.2.1.04.01','SALARIO CONTRATO TEMPORARIO - LEI 8.745/93','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2390,'2016','3.1.1.2.1.04.02','ADICIONAL NOTURNO DE CONTRATO TEMPORARIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2391,'2016','3.1.1.2.1.04.03','ADICIONAL DE PERICULOSIDADE CONTR. TEMPORARIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2392,'2016','3.1.1.2.1.04.04','ADICIONAL DE INSALUBRIDADE CONTRATO TEMPORARIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2393,'2016','3.1.1.2.1.04.05','ADICIONAL DE ATIVIDADES PENOSAS - CONTR. TEMPORARIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2394,'2016','3.1.1.2.1.04.06','SERVICOS EVENTUAIS DE MEDICOS RESIDENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2395,'2016','3.1.1.2.1.04.07','RESIDENCIA MULTIPROFISSIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2396,'2016','3.1.1.2.1.04.08','ADICIONAL DE IRRADIAÇÃO IONIZANTE CONT. TEMP.','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2397,'2016','3.1.1.2.1.04.09','GRATIFICAÇÃO DE RAIO-X CONTRATO TEMPORARIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2398,'2016','3.1.1.2.1.04.10','SERVICOS EXTRAORDINARIOS CONTRATO TEMPORARIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2399,'2016','3.1.1.2.1.04.11','SERVICOS EXTRAORDINARIOS NOTURNO CONT. TEMP.','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2400,'2016','3.1.1.2.1.04.12','FERIAS VENCIDAS/PROPORCIONAIS CONT.TEMPORARIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2401,'2016','3.1.1.2.1.04.13','13º SALARIO CONTRATO TEMPORARIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2402,'2016','3.1.1.2.1.04.14','FERIAS - ABONO CONSTITUCIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2403,'2016','3.1.1.2.1.04.15','FERIAS - PAGAMENTO ANTECIPADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2404,'2016','3.1.1.2.1.04.16','SERVICOS EVENTUAIS DE AUXILIARES CIVIS NO EXT','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2405,'2016','3.1.1.2.1.04.17','SERVICOS EVENTUAIS DE PROFESSORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2406,'2016','3.1.1.2.1.04.18','SERVICOS EVENTUAIS DE ASSISTENCIA SOCIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2407,'2016','3.1.1.2.1.04.19','SERV EVENT ENFERMAG FISIOT TERAPIA OCUPAC','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2408,'2016','3.1.1.2.1.04.20','SERVICOS EVENTUAIS DE NATUREZA INDUSTRIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2409,'2016','3.1.1.2.1.04.21','SERVICOS EVENTUAIS DE AGENTES DE SAUDE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2410,'2016','3.1.1.2.1.04.22','SERVICOS EVENTUAIS DE DENTISTAS E PSICOLOGOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2411,'2016','3.1.1.2.1.04.23','SERVICOS EVENTUAIS DE MAO-DE-OBRA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2412,'2016','3.1.1.2.1.04.24','SERVIÇOS TEMPORÁRIOS DE AGENTES PRISIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2413,'2016','3.1.1.2.1.04.25','OBRIGAÇÕES PATRONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2414,'2016','3.1.1.2.1.04.26','INSS PATRONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2415,'2016','3.1.1.2.1.04.27','FGTS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2416,'2016','3.1.1.2.1.04.99','OUTRAS CONTRATAÇÕES POR TEMPO DETERMINADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2417,'2016','3.1.1.3.0.00.00','REMUNERAÇÃO A PESSOAL ATIVO MILITAR - ABRANGIDOS PELO  RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2418,'2016','3.1.1.3.1.00.00','REMUNERAÇÃO A PESSOAL  ATIVO MILITAR - ABRANGIDOS PELO RPPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2419,'2016','3.1.1.3.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PES. MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2420,'2016','3.1.1.3.1.01.01','SOLDO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2421,'2016','3.1.1.3.1.01.02','ADICIONAL DE PERMANENCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2422,'2016','3.1.1.3.1.01.03','ADICIONAL DE TEMPO DE SERVICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2423,'2016','3.1.1.3.1.01.04','ADICIONAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2424,'2016','3.1.1.3.1.01.05','ADICIONAL DE COMPENSAÇÃO ORGANICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2425,'2016','3.1.1.3.1.01.06','ADICIONAL DE HABITAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2426,'2016','3.1.1.3.1.01.07','GRATIFICAÇÃO DE LOCALIDADE ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2427,'2016','3.1.1.3.1.01.08','GRATIFICAÇÃO DE REPRESENTAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2428,'2016','3.1.1.3.1.01.09','GRATIFICAÇÃO DE FUNÇÃO DE NATUREZA ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2429,'2016','3.1.1.3.1.01.10','GRATIFICAÇÃO DE SERVICO VOLUNTARIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2430,'2016','3.1.1.3.1.01.11','VANTAGEM PECUNIARIA ESPECIAL - VPE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2431,'2016','3.1.1.3.1.01.12','INDENIZAÇÃO DE REPRESENTAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2432,'2016','3.1.1.3.1.01.13','GRATIFICAÇÃO DE EXERCÍCIOS DE CARGOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2433,'2016','3.1.1.3.1.01.14','FERIAS VENCIDAS E PROPORCIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2434,'2016','3.1.1.3.1.01.15','ADICIONAL NATALINO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2435,'2016','3.1.1.3.1.01.16','FERIAS - ABONO CONSTITUCIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2436,'2016','3.1.1.3.1.01.17','COMPLEMENTAÇÃO SALARIAL - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2437,'2016','3.1.1.3.1.01.99','OUTRAS VPD FIXAS - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2438,'2016','3.1.1.3.1.02.00','OUTRAS DESPESAS VARIAVEIS - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2439,'2016','3.1.1.3.1.02.01','INDENIZAÇÕES/MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2440,'2016','3.1.1.3.1.02.02','ADICIONAL TAREFA TEMPO CERTO(ART. 23 MP 2131)','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2441,'2016','3.1.1.3.1.02.03','ADICIONAL NOTURNO - MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2442,'2016','3.1.1.3.1.02.04','HORA-EXTRA, HORAS DE SOBREAVISO E PLANTÃO - MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2443,'2016','3.1.1.3.1.03.00','SENTENCAS JUDICIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2444,'2016','3.1.2.0.0.00.00','ENCARGOS PATRONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2445,'2016','3.1.2.1.0.00.00','ENCARGOS PATRONAIS - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2446,'2016','3.1.2.1.1.00.00','ENCARGOS PATRONAIS - RPPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2447,'2016','3.1.2.1.2.00.00','ENCARGOS PATRONAIS - RPPS - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2448,'2016','3.1.2.1.2.01.00','CONTRIBUIÇÃO PATRONAL PARA O RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2449,'2016','3.1.2.1.2.02.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2450,'2016','3.1.2.1.2.99.00','OUTROS ENCARGOS PATRONAIS - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2451,'2016','3.1.2.1.3.00.00','ENCARGOS PATRONAIS - RPPS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2452,'2016','3.1.2.1.3.02.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2453,'2016','3.1.2.1.3.99.00','OUTROS ENCARGOS PATRONAIS - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2454,'2016','3.1.2.1.4.00.00','ENCARGOS PATRONAIS - RPPS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2455,'2016','3.1.2.1.4.02.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2456,'2016','3.1.2.1.4.99.00','OUTROS ENCARGOS PATRONAIS - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2457,'2016','3.1.2.1.5.00.00','ENCARGOS PATRONAIS - RPPS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2458,'2016','3.1.2.1.5.02.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2459,'2016','3.1.2.1.5.99.00','OUTROS ENCARGOS PATRONAIS - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2460,'2016','3.1.2.2.0.00.00','ENCARGOS PATRONAIS - RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2461,'2016','3.1.2.2.1.00.00','ENCARGOS PATRONAIS - RGPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2462,'2016','3.1.2.2.1.01.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - INSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2463,'2016','3.1.2.2.1.03.00','SEGURO DE ACIDENTE NO TRABALHO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2464,'2016','3.1.2.2.1.04.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2465,'2016','3.1.2.2.1.05.00','CONTRIBUIÇÃO PREVIDENCIÁRIA INSS PRORROGAÇÃO SALÁRIO MATERNIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2466,'2016','3.1.2.2.1.06.00','CONTRIBUIÇÃO PARA O PIS SOBRE FOLHA DE PAGAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2467,'2016','3.1.2.2.1.99.00','OUTROS ENCARGOS PATRONAIS - RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2468,'2016','3.1.2.2.2.00.00','ENCARGOS PATRONAIS - RGPS - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2469,'2016','3.1.2.2.3.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2470,'2016','3.1.2.2.3.01.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - INSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2471,'2016','3.1.2.2.3.03.00','SEGURO DE ACIDENTE NO TRABALHO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2472,'2016','3.1.2.2.3.04.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2473,'2016','3.1.2.2.3.05.00','CONTRIBUIÇÃO PREVIDENCIÁRIA INSS PRORROGAÇÃO SALÁRIO MATERNIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2474,'2016','3.1.2.2.3.06.00','CONTRIBUIÇÃO PARA O PIS SOBRE FOLHA DE PAGAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2475,'2016','3.1.2.2.3.99.00','OUTROS ENCARGOS PATRONAIS - RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2476,'2016','3.1.2.2.4.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2477,'2016','3.1.2.2.5.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2478,'2016','3.1.2.3.0.00.00','ENCARGOS PATRONAIS - FGTS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2479,'2016','3.1.2.3.1.00.00','ENCARGOS PATRONAIS - FGTS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2480,'2016','3.1.2.3.1.01.00','FGTS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2481,'2016','3.1.2.3.1.02.00','FGTS - PDV','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2482,'2016','3.1.2.3.1.03.00','FGTS - PRORROGAÇÃO SALÁRIO MATERNIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2483,'2016','3.1.2.4.0.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2484,'2016','3.1.2.4.1.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2485,'2016','3.1.2.4.1.01.00','SISTEMAS SOCIAIS AUTÔNOMOS -  ATIVO CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2486,'2016','3.1.2.4.1.02.00','CONTRIBUIÇÃO DE SALÁRIO EDUCAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2487,'2016','3.1.2.4.1.03.00','CONTRIBUIÇÃO DE SALÁRIO EDUCAÇÃO REFERENTE A PRORROGAÇÃO DE SALÁRIO MATERNIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2488,'2016','3.1.2.4.1.99.00','OUTRAS CONSTRIBUIÇÕES SOCIAIS GERAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2489,'2016','3.1.2.5.0.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2490,'2016','3.1.2.5.1.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2491,'2016','3.1.2.5.1.01.00','COMPLEMENTAÇÃO DE PREVIDÊNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2492,'2016','3.1.2.5.1.02.00','SEGUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2493,'2016','3.1.2.5.1.03.00','CONTRIBUIÇÃO PATRONAL PREVIDÊNCIA PRIVADA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2494,'2016','3.1.2.5.1.04.00','COMPLEMENTAÇÃO PREVIDENCIÁRIA REFERENTE A PRORROGAÇÃO SALÁRIO MATERNIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2495,'2016','3.1.2.5.1.99.00','OUTRAS CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2496,'2016','3.1.2.9.0.00.00','OUTROS ENCARGOS PATRONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2497,'2016','3.1.2.9.1.00.00','OUTROS ENCARGOS PATRONAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2498,'2016','3.1.2.9.1.01.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2499,'2016','3.1.2.9.1.02.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2500,'2016','3.1.2.9.1.03.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2501,'2016','3.1.2.9.1.04.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2502,'2016','3.1.2.9.1.05.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2503,'2016','3.1.2.9.1.06.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2504,'2016','3.1.2.9.2.00.00','OUTROS ENCARGOS PATRONAIS - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2505,'2016','3.1.2.9.2.01.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2506,'2016','3.1.2.9.2.02.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2507,'2016','3.1.2.9.2.03.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2508,'2016','3.1.2.9.2.04.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2509,'2016','3.1.2.9.2.05.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2510,'2016','3.1.2.9.2.06.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2511,'2016','3.1.2.9.3.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2512,'2016','3.1.2.9.4.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2513,'2016','3.1.2.9.4.01.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2514,'2016','3.1.2.9.4.02.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2515,'2016','3.1.2.9.4.03.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2516,'2016','3.1.2.9.4.04.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2517,'2016','3.1.2.9.4.05.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2518,'2016','3.1.2.9.4.06.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2519,'2016','3.1.2.9.5.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2520,'2016','3.1.3.0.0.00.00','BENEFÍCIOS A PESSOAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2521,'2016','3.1.3.1.0.00.00','BENEFÍCIOS A PESSOAL - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2522,'2016','3.1.3.1.1.00.00','BENEFÍCIOS A PESSOAL - RPPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2523,'2016','3.1.3.2.0.00.00','BENEFÍCIOS A PESSOAL - RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2524,'2016','3.1.3.2.1.00.00','BENEFÍCIOS A PESSOAL - RGPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2525,'2016','3.1.3.3.0.00.00','BENEFÍCIOS A PESSOAL - MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2526,'2016','3.1.3.3.1.00.00','BENEFÍCIOS A PESSOAL - MILITAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2527,'2016','3.1.9.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL E ENCARGOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2528,'2016','3.1.9.1.0.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2529,'2016','3.1.9.1.1.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2530,'2016','3.1.9.2.0.00.00','PESSOAL REQUISITADO DE OUTROS ORGAOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2531,'2016','3.1.9.2.1.00.00','PESSOAL REQUISITADO DE OUTROS ORGAOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2532,'2016','3.1.9.9.0.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2533,'2016','3.1.9.9.1.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2534,'2016','3.1.9.9.1.01.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2535,'2016','3.1.9.9.1.02.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - ENCARGOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2536,'2016','3.2.0.0.0.00.00','BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2537,'2016','3.2.1.0.0.00.00','APOSENTADORIAS E REFORMAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2538,'2016','3.2.1.1.0.00.00','APOSENTADORIAS - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2539,'2016','3.2.1.1.1.00.00','APOSENTADORIAS - RPPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2540,'2016','3.2.1.1.1.01.00','PROVENTOS - PESSOAL CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2541,'2016','3.2.1.1.1.01.01','APOSENTADORIAS POR TEMPO DE CONTRIBUIÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2542,'2016','3.2.1.1.1.01.02','APOSENTADORIAS COMPULSÓRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2543,'2016','3.2.1.1.1.01.03','APOSENTADORIAS POR INVALIDEZ','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2544,'2016','3.2.1.1.1.01.04','APOSENTADORIAS ESPECIAIS - ATIVIDADES DE RISCO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2545,'2016','3.2.1.1.1.01.05','APOSENTADORIAS ESPECIAIS - AGENTES NOCIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2546,'2016','3.2.1.1.1.01.06','APOSENTADORIAS ESPECIAIS - DEFICIÊNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2547,'2016','3.2.1.1.1.01.07','APOSENTADORIAS PROFESSOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2548,'2016','3.2.1.1.1.01.99','OUTRAS APOSENTADORIAS ESPECIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2549,'2016','3.2.1.1.1.02.00','APOSENTADORIAS PENDENTES DE APROVAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2550,'2016','3.2.1.1.1.70.00','SENTENÇAS JUDICIAIS - APOSENTADORIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2551,'2016','3.2.1.1.1.99.00','OUTRAS APOSENTADORIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2552,'2016','3.2.1.2.0.00.00','APOSENTADORIAS - RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2553,'2016','3.2.1.2.1.00.00','APOSENTADORIAS - RGPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2554,'2016','3.2.1.3.0.00.00','RESERVA REMUNERADA - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2555,'2016','3.2.1.3.1.00.00','RESERVA REMUNERADA - PESSOAL MILITAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2556,'2016','3.2.1.3.1.01.00','PROVENTOS RESERVA- PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2557,'2016','3.2.1.3.1.01.01','RESERVA POR TEMPO DE SERVIÇO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2558,'2016','3.2.1.3.1.70.00','SENTENÇAS JUDICIAIS RESERVA PESSOAL MILITAR - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2559,'2016','3.2.1.3.1.99.00','OUTRAS RESERVAS REMUNERADAS - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2560,'2016','3.2.1.4.0.00.00','REFORMA - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2561,'2016','3.2.1.4.1.00.00','REFORMA - PESSOAL MILITAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2562,'2016','3.2.1.4.1.01.00','PROVENTOS REFORMA - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2563,'2016','3.2.1.4.1.01.01','REFORMA POR TEMPO DE SERVIÇO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2564,'2016','3.2.1.4.1.01.02','REFORMA POR INVALIDEZ','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2565,'2016','3.2.1.4.1.70.00','SENTENÇAS JUDICIAIS REFORMA PESSOAL MILITAR - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2566,'2016','3.2.1.4.1.99.00','OUTRAS REFORMAS - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2567,'2016','3.2.1.9.0.00.00','OUTRAS APOSENTADORIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2568,'2016','3.2.1.9.1.00.00','OUTRAS APOSENTADORIAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2569,'2016','3.2.2.0.0.00.00','PENSÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2570,'2016','3.2.2.1.0.00.00','PENSÕES - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2571,'2016','3.2.2.1.1.00.00','PENSÕES - RPPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2572,'2016','3.2.2.1.1.01.00','PROVENTOS DE PENSÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2573,'2016','3.2.2.1.1.70.00','SENTENÇAS JUDICIAIS - PENSÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2574,'2016','3.2.2.1.1.99.00','OUTRAS PENSÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2575,'2016','3.2.2.2.0.00.00','PENSÕES - RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2576,'2016','3.2.2.2.1.00.00','PENSÕES - RGPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2577,'2016','3.2.2.3.0.00.00','PENSÕES - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2578,'2016','3.2.2.3.1.00.00','PENSÕES - PESSOAL MILITAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2579,'2016','3.2.2.3.1.01.00','PROVENTOS DE PENSÕES - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2580,'2016','3.2.2.3.1.70.00','SENTENÇAS JUDICIAIS - PENSÕES - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2581,'2016','3.2.2.3.1.99.00','OUTRAS PENSÕES - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2582,'2016','3.2.2.9.0.00.00','OUTRAS PENSÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2583,'2016','3.2.2.9.1.00.00','OUTRAS PENSÕES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2584,'2016','3.2.3.0.0.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2585,'2016','3.2.3.1.0.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2586,'2016','3.2.3.1.1.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2587,'2016','3.2.3.1.1.01.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2588,'2016','3.2.3.2.0.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2589,'2016','3.2.3.2.1.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2590,'2016','3.2.3.2.1.01.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2591,'2016','3.2.3.9.0.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2592,'2016','3.2.3.9.1.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2593,'2016','3.2.4.0.0.00.00','BENEFÍCIOS EVENTUAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2594,'2016','3.2.4.1.0.00.00','AUXÍLIO POR NATALIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2595,'2016','3.2.4.1.1.00.00','AUXÍLIO POR NATALIDADE - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2596,'2016','3.2.4.2.0.00.00','AUXÍLIO POR MORTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2597,'2016','3.2.4.2.1.00.00','AUXÍLIO POR MORTE - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2598,'2016','3.2.4.3.0.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2599,'2016','3.2.4.3.1.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2600,'2016','3.2.4.4.0.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2601,'2016','3.2.4.4.1.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2602,'2016','3.2.4.9.0.00.00','OUTROS BENEFÍCIOS EVENTUAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2603,'2016','3.2.4.9.1.00.00','OUTROS BENEFÍCIOS EVENTUAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2604,'2016','3.2.5.0.0.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2605,'2016','3.2.5.0.1.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2606,'2016','3.2.9.0.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2607,'2016','3.2.9.1.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2608,'2016','3.2.9.1.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2609,'2016','3.2.9.1.1.01.00','AUXILIO FUNERAL ATIVO CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2610,'2016','3.2.9.1.1.02.00','AUXILIO FUNERAL INATIVO CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2611,'2016','3.2.9.1.1.03.00','AUXILIO NATALIDADE ATIVO CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2612,'2016','3.2.9.1.1.04.00','AUXILIO NATALIDADE INATIVO CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2613,'2016','3.2.9.1.1.05.00','AUXILIO RECLUSAO ATIVO CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2614,'2016','3.2.9.1.1.06.00','AUXILIO RECLUSAO INATIVO CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2615,'2016','3.2.9.1.1.07.00','AUXILIO FUNERAL PENSIONISTA CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2616,'2016','3.2.9.1.1.08.00','AUXILIO RECLUSAO PENSIONISTA CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2617,'2016','3.2.9.1.1.09.00','AUXILIO NATALIDADE PENSIONISTA CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2618,'2016','3.2.9.1.1.10.00','AUXILIO-DOENCA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2619,'2016','3.2.9.1.1.11.00','SALARIO MATERNIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2620,'2016','3.2.9.1.1.12.00','SALARIO-FAMILIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2621,'2016','3.2.9.1.1.12.01','SALARIO FAMILIA - ATIVO PESSOAL CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2622,'2016','3.2.9.1.1.12.02','SALARIO FAMILIA-INATIVO PESSOAL CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2623,'2016','3.2.9.1.1.12.03','SALARIO FAMILIA-PENSIONISTA PESSOAL CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2624,'2016','3.2.9.2.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2625,'2016','3.2.9.2.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2626,'2016','3.2.9.3.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2627,'2016','3.2.9.3.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2628,'2016','3.2.9.3.1.01.00','AUXILIO FUNERAL ATIVO MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2629,'2016','3.2.9.3.1.02.00','AUXILIO FUNERAL INATIVO MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2630,'2016','3.2.9.3.1.03.00','AUXILIO NATALIDADE ATIVO MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2631,'2016','3.2.9.3.1.04.00','AUXILIO NATALIDADE INATIVO MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2632,'2016','3.2.9.3.1.05.00','AUXILIO RECLUSAO ATIVO MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2633,'2016','3.2.9.3.1.06.00','AUXILIO RECLUSAO INATIVO MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2634,'2016','3.2.9.3.1.07.00','AUXILIO RECLUSAO PENSIONISTA MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2635,'2016','3.2.9.3.1.08.00','AUXILIO FUNERAL PENSIONISTA MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2636,'2016','3.2.9.3.1.09.00','AUXILIO NATALIDADE PENSIONISTA MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2637,'2016','3.2.9.3.1.10.00','SALARIO-FAMILIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2638,'2016','3.2.9.3.1.10.01','SALARIO FAMILIA-ATIVO PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2639,'2016','3.2.9.3.1.10.02','SALARIO FAMILIA - INATIVO PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2640,'2016','3.2.9.3.1.10.03','SALARIO FAMILIA - PENSIONIOSTA PESS. MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2641,'2016','3.2.9.9.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2642,'2016','3.2.9.9.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2643,'2016','3.3.0.0.0.00.00','USO DE BENS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2644,'2016','3.3.1.0.0.00.00','USO DE MATERIAL DE CONSUMO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2645,'2016','3.3.1.1.0.00.00','CONSUMO DE MATERIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2646,'2016','3.3.1.1.1.00.00','CONSUMO DE MATERIAL - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2647,'2016','3.3.1.1.1.01.00','COMBUSTIVEIS E LUBRIFICANTES AUTOMOTIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2648,'2016','3.3.1.1.1.03.00','GAS E OUTROS MATERIAIS ENGARRAFADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2649,'2016','3.3.1.1.1.04.00','EXPLOSIVOS E MUNISSÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2650,'2016','3.3.1.1.1.05.00','ALIMENTOS PARA ANIMAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2651,'2016','3.3.1.1.1.06.00','GENEROS ALIMENTAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2652,'2016','3.3.1.1.1.07.00','ANIMAIS PARA PESQUISA E ABATE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2653,'2016','3.3.1.1.1.08.00','MATERIAL FARMACOLÓGICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2654,'2016','3.3.1.1.1.09.00','MATERIAL ODONTOLÓGICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2655,'2016','3.3.1.1.1.10.00','MATERIAL QUIMÍCO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2656,'2016','3.3.1.1.1.11.00','MATERIAL DE COUDELARIA OU DE USO ZOOTÉCNICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2657,'2016','3.3.1.1.1.13.00','MATERIAL DE CAÇA E PESCA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2658,'2016','3.3.1.1.1.14.00','MATERIAL EDUCATIVO E ESPORTIVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2659,'2016','3.3.1.1.1.15.00','MATERIAL PARA FESTIVIDADESE HOMENAGENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2660,'2016','3.3.1.1.1.16.00','MATERIAL DE EXPEDIENTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2661,'2016','3.3.1.1.1.17.00','MATERIAL DE PROCESSAMENTO DE DADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2662,'2016','3.3.1.1.1.18.00','MATERIAIS E MEDICAMENTOS P/USO VETERINÁRIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2663,'2016','3.3.1.1.1.19.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2664,'2016','3.3.1.1.1.20.00','MATERIAL DE CAMA, MESA E BANHO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2665,'2016','3.3.1.1.1.21.00','MATERIAL DE COPA E COZINHA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2666,'2016','3.3.1.1.1.22.00','MATERIAL DE LIMPEZA E PRODUTOS DE HIGIENIZAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2667,'2016','3.3.1.1.1.23.00','UNIFORMES, TECIDOS E AVIAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2668,'2016','3.3.1.1.1.24.00','MATERIAL P/MANUT. E BENS IMÓVEIS/INSTALAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2669,'2016','3.3.1.1.1.25.00','MATERIAL PARA MANUTENÇÃO DE BENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2670,'2016','3.3.1.1.1.26.00','MATERIAL ELETRICO E ELETRONICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2671,'2016','3.3.1.1.1.27.00','MATERIAL DE MANOBRA E PATRULHAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2672,'2016','3.3.1.1.1.28.00','MATERIAL DE PROTEÇÃO E SEGURANCA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2673,'2016','3.3.1.1.1.29.00','MATERIAL PARA AUDIO, VIDEO E FOTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2674,'2016','3.3.1.1.1.30.00','MATERIAL PARA COMUNICAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2675,'2016','3.3.1.1.1.31.00','SEMENTES, MUDAS DE PLANTAS E INSUMOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2676,'2016','3.3.1.1.1.32.00','SUPRIMENTO DE AVIAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2677,'2016','3.3.1.1.1.33.00','MATERIAL PARA PRODUÇÃO INDUSTRIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2678,'2016','3.3.1.1.1.34.00','SUPRIMENTOS PARA MAQ. E MOTORES NAVIOS E EMBARCAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2679,'2016','3.3.1.1.1.35.00','MATERIAL LABORATORIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2680,'2016','3.3.1.1.1.36.00','MATERIAL HOSPITALAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2681,'2016','3.3.1.1.1.37.00','SUPRIMENTOS DE ARMAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2682,'2016','3.3.1.1.1.38.00','SUPRIMENTO DE PROTEÇÃO AO VOO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2683,'2016','3.3.1.1.1.39.00','MATERIAL PARA MANUTENÇÃO DE VEICULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2684,'2016','3.3.1.1.1.40.00','MATERIAL BIOLÓGICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2685,'2016','3.3.1.1.1.41.00','MATERIAL PARA UTILIZAÇÃO EM GRÁFICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2686,'2016','3.3.1.1.1.42.00','FERRAMENTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2687,'2016','3.3.1.1.1.43.00','MATERIAL PARA REABILITAÇÃO PROFISSIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2688,'2016','3.3.1.1.1.44.00','MATERIAL DE SINALIZAÇÃO VISUAL E OUTROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2689,'2016','3.3.1.1.1.45.00','MATERIAL TÉCNICO PARA SELEÇÃO E TREINAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2690,'2016','3.3.1.1.1.46.00','MATERIAL BIBLIOGRAFICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2691,'2016','3.3.1.1.1.48.00','BENS MÓVEIS NÃO ATIVÁVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2692,'2016','3.3.1.1.1.49.00','BILHETES DE PASSAGEM','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2693,'2016','3.3.1.1.1.50.00','BANDEIRAS, FLÂMULAS E INSIGNIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2694,'2016','3.3.1.1.1.51.00','DISCOTECAS E FILMOTECAS NÃO IMOBILIZÁVEL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2695,'2016','3.3.1.1.1.52.00','MATERIAL DE CARÁTER SECRETO OU RESERVADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2696,'2016','3.3.1.1.1.53.00','MATERIAL METEOROLÓGICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2697,'2016','3.3.1.1.1.54.00','MATERIAL P/MANUT.CON SERV.DE ESTRADAS E VIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2698,'2016','3.3.1.1.1.55.00','SELOS PARA CONTROLE FISCAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2699,'2016','3.3.1.1.1.56.00','MATERIAL DE MARCAÇÃO DA FAUNA SILVESTRE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2700,'2016','3.3.1.1.1.57.00','MATERIAL DE CONSUMO - REPARTIÇÕES NO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2701,'2016','3.3.1.1.1.58.00','SOBRESSALENTES PARA MÁQUINAS E EQUP. PARA PRODUÇÃO INDUSTRIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2702,'2016','3.3.1.1.1.70.00','AQUISIÇÃO DE SOFTWARES DE BASE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2703,'2016','3.3.1.1.1.71.00','MATERIAIS PARA CONSERVAÇÃO E MANUTENÇÃO DE BENS DE USO COMUM DO POVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2704,'2016','3.3.1.1.1.98.00','SENTENÇAS JUDICIAIS DE FORNECEDORES DE MATERIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2705,'2016','3.3.1.1.1.99.00','OUTROS MATERIAIS DE CONSUMO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2706,'2016','3.3.1.2.0.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2707,'2016','3.3.1.2.1.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2708,'2016','3.3.1.2.1.01.00','MERCADORIAS DOADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2709,'2016','3.3.1.2.1.02.00','MATERIAL DESTINADO À ASSISTÊNCIA SOCIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2710,'2016','3.3.1.2.1.03.00','MATERIAL EDUCACIONAL E CULTURAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2711,'2016','3.3.1.2.1.04.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2712,'2016','3.3.1.2.1.05.00','MATERIAL PARA CERIMONIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2713,'2016','3.3.1.2.1.06.00','MATERIAL PARA DIVULGAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2714,'2016','3.3.1.2.1.07.00','MATERIAL DESTINADO A CONTRIBUINTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2715,'2016','3.3.1.2.1.08.00','MATERIAL P/ IDENTIFICAÇÃO DE BENEFICIARIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2716,'2016','3.3.1.2.1.99.00','OUTROS MATERIAIS DE DISTRIBUIÇÃO GRATUITA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2717,'2016','3.3.2.0.0.00.00','SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2718,'2016','3.3.2.1.0.00.00','DIÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2719,'2016','3.3.2.1.1.00.00','DIÁRIAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2720,'2016','3.3.2.1.1.01.00','DIARIAS  PESSOAL CIVIL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2721,'2016','3.3.2.1.1.02.00','DIARIAS - PESSOAL MILITAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2722,'2016','3.3.2.1.1.03.00','DIARIAS - COLABORADORES EVENTUAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2723,'2016','3.3.2.1.1.04.00','DIARIAS A CONSELHEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2724,'2016','3.3.2.2.0.00.00','SERVIÇOS TERCEIROS - PF','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2725,'2016','3.3.2.2.1.00.00','SERVIÇOS TERCEIROS - PF - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2726,'2016','3.3.2.2.1.01.00','CONSULTORIA E ASSESSORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2727,'2016','3.3.2.2.1.02.00','PERICIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2728,'2016','3.3.2.2.1.03.00','AUDITORIA EXTERNA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2729,'2016','3.3.2.2.1.04.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2730,'2016','3.3.2.2.1.05.00','SERVICOS MEDICOS E ODONTOLOGICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2731,'2016','3.3.2.2.1.06.00','SELEÇÃO E TREINAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2732,'2016','3.3.2.2.1.07.00','COMUNICAÇÃO EM GERAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2733,'2016','3.3.2.2.1.08.00','LIMPEZA E CONSERVAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2734,'2016','3.3.2.2.1.09.00','SERVICOS DOMESTICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2735,'2016','3.3.2.2.1.10.00','VIGILANCIA OSTENSIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2736,'2016','3.3.2.2.1.11.00','MANUTENÇÃO E CONSERVAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2737,'2016','3.3.2.2.1.12.00','CONDOMINIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2738,'2016','3.3.2.2.1.13.00','COMISSOES E CORRETAGENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2739,'2016','3.3.2.2.1.14.00','DIREITOS AUTORAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2740,'2016','3.3.2.2.1.15.00','SERVICOS TECNICOS PROFISSIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2741,'2016','3.3.2.2.1.16.00','ESTAGIARIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2742,'2016','3.3.2.2.1.18.00','CAPATAZIA, ESTIVA E PESAGEM','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2743,'2016','3.3.2.2.1.19.00','CONFERENCIAS, EXPOSIÇÕES E ESPETACULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2744,'2016','3.3.2.2.1.20.00','ARMAZENAGEM','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2745,'2016','3.3.2.2.1.21.00','LOCAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2746,'2016','3.3.2.2.1.22.00','FORNECIMENTO DE ALIMENTAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2747,'2016','3.3.2.2.1.23.00','SERVICOS DE CARATER SECRETO OU RESERVADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2748,'2016','3.3.2.2.1.24.00','SERVICOS DE REABILITAÇÃO PROFISSIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2749,'2016','3.3.2.2.1.25.00','SERVICOS DE ASSISTENCIA SOCIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2750,'2016','3.3.2.2.1.26.00','SERV. DE APOIO ADMIN., TECNICO E OPERACIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2751,'2016','3.3.2.2.1.27.00','SERV. DE CONSERV. E REBENEFIC. DE MERCADORIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2752,'2016','3.3.2.2.1.28.00','CONFECÇÃO DE MATERIAL DE ACONDIC. E EMBALAGEM','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2753,'2016','3.3.2.2.1.29.00','CONFECÇÃO DE UNIFORMES, BANDEIRAS E FLAMULAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2754,'2016','3.3.2.2.1.30.00','FRETES E TRANSPORTES DE ENCOMENDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2755,'2016','3.3.2.2.1.31.00','JETONS E GRATIFICAÇÕES A CONSELHEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2756,'2016','3.3.2.2.1.34.00','SERVICOS DE AUDIO, VIDEO E FOTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2757,'2016','3.3.2.2.1.35.00','SERVICOS JUDICIARIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2758,'2016','3.3.2.2.1.36.00','SEGUROS EM GERAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2759,'2016','3.3.2.2.1.37.00','HOSPEDAGENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2760,'2016','3.3.2.2.1.38.00','DESPESAS COM LOCOMOÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2761,'2016','3.3.2.2.1.39.00','SERVICOS GRAFICOS E EDITORIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2762,'2016','3.3.2.2.1.99.00','OUTROS SERVICOS PRESTADOS POR PESSOA FISICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2763,'2016','3.3.2.3.0.00.00','SERVIÇOS TERCEIROS - PJ','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2764,'2016','3.3.2.3.1.00.00','SERVIÇOS TERCEIROS - PJ - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2765,'2016','3.3.2.3.1.01.00','CONSULTORIA E ASSESSORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2766,'2016','3.3.2.3.1.02.00','PERICIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2767,'2016','3.3.2.3.1.03.00','AUDITORIA EXTERNA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2768,'2016','3.3.2.3.1.04.00','COMUNICAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2769,'2016','3.3.2.3.1.05.00','PUBLICIDADE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2770,'2016','3.3.2.3.1.06.00','MANUTENÇÃO E CONSERVAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2771,'2016','3.3.2.3.1.07.00','SERVIÇOS DE APOIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2772,'2016','3.3.2.3.1.08.00','SERVIÇOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2773,'2016','3.3.2.3.1.09.00','SERVIÇOS DE ALIMENTAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2774,'2016','3.3.2.3.1.10.00','LOCAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2775,'2016','3.3.2.3.1.11.00','SERVIÇOS RELACIONADOS A TECNOLOGIA DA INFORMAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2776,'2016','3.3.2.3.1.12.00','SERVIÇOS DE TRANSPORTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2777,'2016','3.3.2.3.1.13.00','ARMAZENAGEM','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2778,'2016','3.3.2.3.1.14.00','ASSINATURAS DE PERIODICOS E ANUIDADES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2779,'2016','3.3.2.3.1.15.00','CAPATAZIA, ESTIVA E PESAGEM','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2780,'2016','3.3.2.3.1.16.00','CLASSIFICAÇÃO DE PRODUTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2781,'2016','3.3.2.3.1.17.00','COMISSOES E CORRETAGENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2782,'2016','3.3.2.3.1.18.00','CONDOMINIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2783,'2016','3.3.2.3.1.19.00','CONFECÇÃO DE MATERIAL DE ACONDIC. E EMBALAGEM','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2784,'2016','3.3.2.3.1.20.00','CONFECÇÃO DE UNIFORMES, BANDEIRAS E FLAMULAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2785,'2016','3.3.2.3.1.21.00','DIREITOS AUTORAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2786,'2016','3.3.2.3.1.22.00','EXPOSIÇÕES, CONGRESSOS, CONFERENCIAS E OUTROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2787,'2016','3.3.2.3.1.23.00','FESTIVIDADES E HOMENAGENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2788,'2016','3.3.2.3.1.24.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2789,'2016','3.3.2.3.1.25.00','HOSPEDAGENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2790,'2016','3.3.2.3.1.26.00','PATROCINIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2791,'2016','3.3.2.3.1.27.00','PRODUÇÕES JORNALISTICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2792,'2016','3.3.2.3.1.28.00','PROMOÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2793,'2016','3.3.2.3.1.29.00','SEGUROS EM GERAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2794,'2016','3.3.2.3.1.30.00','SELEÇÃO E TREINAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2795,'2016','3.3.2.3.1.31.00','SERV.MEDICO-HOSPITALAR,ODONTOL.E LABORATORIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2796,'2016','3.3.2.3.1.32.00','SERVIÇOS BANCARIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2797,'2016','3.3.2.3.1.33.00','SERVIÇOS DE ANALISES E PESQUISA CIENTIFICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2798,'2016','3.3.2.3.1.34.00','SERVIÇOS DE APOIO DO ENSINO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2799,'2016','3.3.2.3.1.35.00','SERVIÇOS DE ASSISTENCIA SOCIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2800,'2016','3.3.2.3.1.36.00','SERVIÇOS DE AUDIO VIDEO E FOTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2801,'2016','3.3.2.3.1.37.00','SERVIÇOS DE CONFECÇÃO SELOS CONTROLE FISCAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2802,'2016','3.3.2.3.1.38.00','SERVIÇOS DE CONSERV. E REBENEF. DE MERCADORIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2803,'2016','3.3.2.3.1.39.00','SERVIÇOS DE CONTROLE AMBIENTAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2804,'2016','3.3.2.3.1.40.00','SERVIÇOS DE COPIAS E REPRODUÇÃO DE DOCUMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2805,'2016','3.3.2.3.1.41.00','SERVIÇOS DE CRECHE E ASSISTENCIA PRE ESCOLAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2806,'2016','3.3.2.3.1.42.00','SERVIÇOS DE INCINERAÇÃO/DESTRUIÇÃO DE MATERIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2807,'2016','3.3.2.3.1.43.00','SERVIÇOS DE PRODUÇÃO INDUSTRIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2808,'2016','3.3.2.3.1.44.00','SERVIÇOS DE REABILITAÇÃO PROFISSIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2809,'2016','3.3.2.3.1.45.00','SERVIÇOS FUNERARIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2810,'2016','3.3.2.3.1.46.00','SERVIÇOS GRÁFICOS E EDITORIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2811,'2016','3.3.2.3.1.47.00','SERVIÇOS JUDICIARIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2812,'2016','3.3.2.3.1.51.00','SERVIÇOS TECNICOS PROFISSIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2813,'2016','3.3.2.3.1.52.00','TAXA DE ADMINISTRAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2814,'2016','3.3.2.3.1.54.00','LOCAÇÃO DE MAO-DE-OBRA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2815,'2016','3.3.2.3.1.55.00','ARRENDAMENTO MERCANTIL OPERACIONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2816,'2016','3.3.2.3.1.56.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2817,'2016','3.3.2.3.1.99.00','OUTROS SERVIÇOS TERCEIROS - PJ','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2818,'2016','3.3.2.4.0.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA - ART. 18 § 1, LC 101/00','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2819,'2016','3.3.2.4.1.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA - ART. 18 § 1, LC 101/00 - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2820,'2016','3.3.3.0.0.00.00','DEPRECIAÇÃO, AMORTIZAÇÃO E EXAUSTÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2821,'2016','3.3.3.1.0.00.00','DEPRECIAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2822,'2016','3.3.3.1.1.00.00','DEPRECIAÇÃO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2823,'2016','3.3.3.1.1.01.00','DEPRECIAÇÃO DE IMOBILIZADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2824,'2016','3.3.3.1.1.01.01','DEPRECIAÇÃO DE BENS MÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2825,'2016','3.3.3.1.1.01.02','DEPRECIAÇÃO DE BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2826,'2016','3.3.3.2.0.00.00','AMORTIZAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2827,'2016','3.3.3.2.1.00.00','AMORTIZAÇÃO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2828,'2016','3.3.3.2.1.01.00','AMORTIZAÇÃO DE IMOBILIZADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2829,'2016','3.3.3.2.1.02.00','AMORTIZAÇÃO DE INTANGÍVEL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2830,'2016','3.3.3.3.0.00.00','EXAUSTÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2831,'2016','3.3.3.3.1.00.00','EXAUSTÃO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2832,'2016','3.3.3.3.1.01.00','EXAUSTÃO DE IMOBILIZADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2833,'2016','3.4.0.0.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2834,'2016','3.4.1.0.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS OBTIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2835,'2016','3.4.1.1.0.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL INTERNA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2836,'2016','3.4.1.1.1.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2837,'2016','3.4.1.1.1.01.00','JUROS DA DÍVIDA CONTR.C/INSTIT.FINANCEIRAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2838,'2016','3.4.1.1.1.02.00','ENCARGOS DA DÍVIDA CONTR.C/INSTIT.FINANCEIRAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2839,'2016','3.4.1.1.1.99.00','JUROS E ENCARGOS DE OUTRAS  DÍVIDAS CONTRATUAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2840,'2016','3.4.1.1.3.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2841,'2016','3.4.1.1.3.01.00','JUROS DA DÍVIDA CONTR. INTERNA INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2842,'2016','3.4.1.1.3.02.00','ENCARGOS DA DÍVIDA CONTR.INTERNA INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2843,'2016','3.4.1.1.3.99.00','JUROS E ENCARGOS DE OUTRAS  DÍVIDAS CONTRATUAIS - INTERNA INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2844,'2016','3.4.1.1.4.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2845,'2016','3.4.1.1.4.01.00','JUROS DA DÍVIDA CONTR. INTERNA INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2846,'2016','3.4.1.1.4.02.00','ENCARGOS DA DÍVIDA CONTR.INTERNA INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2847,'2016','3.4.1.1.4.99.00','JUROS E ENCARGOS DE OUTRAS  DÍVIDAS CONTRATUAIS - INTERNA INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2848,'2016','3.4.1.1.5.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2849,'2016','3.4.1.1.5.01.00','JUROS DA DÍVIDA CONTR. INTERNA INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2850,'2016','3.4.1.1.5.02.00','ENCARGOS DA DÍVIDA CONTR.INTERNA INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2851,'2016','3.4.1.1.5.99.00','JUROS E ENCARGOS DE OUTRAS  DÍVIDAS CONTRATUAIS - INTERNA INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2852,'2016','3.4.1.2.0.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL EXTERNA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2853,'2016','3.4.1.2.1.00.00','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2854,'2016','3.4.1.2.1.01.00','JUROS DA DÍVIDA CONTRATADA NO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2855,'2016','3.4.1.2.1.02.00','ENCARGOS DA DÍVIDA CONTRATADA NO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2856,'2016','3.4.1.3.0.00.00','JUROS E ENCARGOS DA DÍVIDA MOBILIARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2857,'2016','3.4.1.3.1.00.00','JUROS E ENCARGOS DA DÍVIDA MOBILIARIA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2858,'2016','3.4.1.4.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2859,'2016','3.4.1.4.1.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2860,'2016','3.4.1.4.1.01.00','JUROS S/ ADIANTAMENTOS BANCARIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2861,'2016','3.4.1.8.0.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2862,'2016','3.4.1.8.1.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2863,'2016','3.4.1.8.3.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2864,'2016','3.4.1.8.4.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2865,'2016','3.4.1.8.5.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2866,'2016','3.4.1.9.0.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2867,'2016','3.4.1.9.1.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2868,'2016','3.4.2.0.0.00.00','JUROS E ENCARGOS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2869,'2016','3.4.2.1.0.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2870,'2016','3.4.2.1.1.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2871,'2016','3.4.2.1.1.01.00','JUROS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2872,'2016','3.4.2.1.1.02.00','ENCARGOS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2873,'2016','3.4.2.1.3.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2874,'2016','3.4.2.1.3.01.00','JUROS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2875,'2016','3.4.2.1.3.02.00','ENCARGOS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2876,'2016','3.4.2.1.4.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2877,'2016','3.4.2.1.4.01.00','JUROS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2878,'2016','3.4.2.1.4.02.00','ENCARGOS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2879,'2016','3.4.2.1.5.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2880,'2016','3.4.2.1.5.01.00','JUROS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2881,'2016','3.4.2.1.5.02.00','ENCARGOS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2882,'2016','3.4.2.2.0.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2883,'2016','3.4.2.2.1.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2884,'2016','3.4.2.2.1.01.00','JUROS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2885,'2016','3.4.2.2.1.02.00','ENCARGOS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2886,'2016','3.4.2.3.0.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2887,'2016','3.4.2.3.1.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2888,'2016','3.4.2.3.1.01.00','JUROS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2889,'2016','3.4.2.3.1.01.01','JUROS DE  SERVICOS TERCEIROS - PESSOA FISICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2890,'2016','3.4.2.3.1.01.02','JUROS DE SERVICOS TERCEIROS - PESSOA JURIDICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2891,'2016','3.4.2.3.1.01.03','JUROS SOBRE FORNECIMENTOS DE BENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2892,'2016','3.4.2.3.1.02.00','MULTAS DEDUTÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2893,'2016','3.4.2.3.1.02.01','MULTAS DEDUTÍVEIS SERVICOS TERCEIROS - PESSOA FISICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2894,'2016','3.4.2.3.1.02.02','MULTAS DEDUTÍVEIS  SERVICOS TERCEIROS - PESSOA JURIDICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2895,'2016','3.4.2.3.1.02.03','MULTAS DEDUTÍVEIS SOBRE FORNECIMENTOS DE BENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2896,'2016','3.4.2.3.1.03.00','MULTAS INDEDUTÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2897,'2016','3.4.2.3.1.03.01','MULTAS INDEDUTÍVEIS  SERVICOS TERCEIROS - PESSOA FISICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2898,'2016','3.4.2.3.1.03.02','MULTAS INDEDUTÍVEIS SERVICOS TERCEIROS - PESSOA JURIDICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2899,'2016','3.4.2.3.1.03.03','MULTAS INDEDUTÍVEIS SOBRE FORNECIMENTOS DE BENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2900,'2016','3.4.2.3.1.99.00','OUTROS ENCARGOS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2901,'2016','3.4.2.3.1.99.01','OUTROS ENCARGOS S/  SERVICOS TERCEIROS - PESSOA FISICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2902,'2016','3.4.2.3.1.99.02','OUTROS ENCARGOS S/ SERVICOS TERCEIROS - PESSOA JURIDICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2903,'2016','3.4.2.3.1.99.03','OUTROS ENCARGOS S/  FONECIMENTO DE BENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2904,'2016','3.4.2.4.0.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2905,'2016','3.4.2.4.1.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2906,'2016','3.4.2.4.1.01.00','JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2907,'2016','3.4.2.4.1.02.00','MULTAS DEDUTÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2908,'2016','3.4.2.4.1.03.00','MULTAS INDEDUTÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2909,'2016','3.4.2.9.0.00.00','OUTROS JUROS E ENCARGOS DE MORA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2910,'2016','3.4.2.9.1.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2911,'2016','3.4.3.0.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2912,'2016','3.4.3.1.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2913,'2016','3.4.3.1.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2914,'2016','3.4.3.1.1.01.00','VARIAÇÕES MONETARIAS DE DÍVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2915,'2016','3.4.3.1.1.02.00','VARIAÇÕES CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2916,'2016','3.4.3.1.3.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2917,'2016','3.4.3.1.3.01.00','VARIAÇÕES MONETARIAS DE DÍVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2918,'2016','3.4.3.1.4.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2919,'2016','3.4.3.1.4.01.00','VARIAÇÕES MONETARIAS DE DÍVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2920,'2016','3.4.3.1.5.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2921,'2016','3.4.3.1.5.01.00','VARIAÇÕES MONETARIAS DE DÍVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2922,'2016','3.4.3.2.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL EXTERNA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2923,'2016','3.4.3.2.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2924,'2016','3.4.3.2.1.01.00','VARIAÇÕES MONETÁRIAS DA DÍVIDA CONTRATUAL EXTERNA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2925,'2016','3.4.3.2.1.02.00','VARIAÇÕES CAMBIAIS DE DÍVIDA CONTRATUAL EXTERNA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2926,'2016','3.4.3.3.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA MOBILIARIA INTERNA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2927,'2016','3.4.3.3.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA MOBILIARIA INTERNA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2928,'2016','3.4.3.3.1.01.00','VARIAÇÕES MONETÁRIAS DE DÍVIDA MOBILIÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2929,'2016','3.4.3.4.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA MOBILIARIA EXTERNA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2930,'2016','3.4.3.4.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA MOBILIARIA EXTERNA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2931,'2016','3.4.3.4.1.01.00','VARIAÇÕES MONETARIAS DE DÍVIDA MOBILIARIA EXTERNA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2932,'2016','3.4.3.4.1.02.00','VARIAÇÕES CAMBIAIS DE DÍVIDA MOBILIARIA EXTERNA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2933,'2016','3.4.3.9.0.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2934,'2016','3.4.3.9.1.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2935,'2016','3.4.3.9.1.01.00','OUTRAS VARIAÇÕES MONETARIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2936,'2016','3.4.3.9.1.01.01','ENCARGOS FINANCEIROS DEDUTÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2937,'2016','3.4.3.9.1.01.02','ENCARGOS FINANCEIROS INDEDUTÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2938,'2016','3.4.3.9.1.01.70','ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2939,'2016','3.4.3.9.1.99.00','OUTRAS VARIAÇÕES CAMBIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2940,'2016','3.4.3.9.3.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2941,'2016','3.4.3.9.3.01.00','OUTRAS VARIAÇÕES MONETARIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2942,'2016','3.4.3.9.3.01.01','ENCARGOS FINANCEIROS DEDUTÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2943,'2016','3.4.3.9.3.01.02','ENCARGOS FINANCEIROS INDEDUTÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2944,'2016','3.4.3.9.3.01.70','ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2945,'2016','3.4.3.9.3.01.71','ATUALIZAÇÃO MONETÁRIA DE TRIBUTOS RENEGOCIADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2946,'2016','3.4.3.9.3.02.00','OUTRAS VARIAÇÕES CAMBIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2947,'2016','3.4.3.9.4.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2948,'2016','3.4.3.9.4.01.00','OUTRAS VARIAÇÕES MONETARIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2949,'2016','3.4.3.9.4.02.00','OUTRAS VARIAÇÕES CAMBIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2950,'2016','3.4.3.9.5.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2951,'2016','3.4.3.9.5.01.00','OUTRAS VARIAÇÕES MONETARIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2952,'2016','3.4.3.9.5.02.00','OUTRAS VARIAÇÕES CAMBIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2953,'2016','3.4.4.0.0.00.00','DESCONTOS FINANCEIROS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2954,'2016','3.4.4.0.1.00.00','DESCONTOS FINANCEIROS CONCEDIDOS  - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2955,'2016','3.4.8.0.0.00.00','APORTES AO BANCO CENTRAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2956,'2016','3.4.8.1.0.00.00','RESULTADO NEGATIVO DO BANCO CENTRAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2957,'2016','3.4.8.1.1.00.00','RESULTADO NEGATIVO DO BANCO CENTRAL - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2958,'2016','3.4.8.2.0.00.00','MANUTENÇÃO DA CARTEIRA DE TÍTULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2959,'2016','3.4.8.2.1.00.00','MANUTENÇÃO DA CARTEIRA DE TÍTULOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2960,'2016','3.4.9.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - FINANCEIRAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2961,'2016','3.4.9.1.0.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2962,'2016','3.4.9.1.1.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2963,'2016','3.4.9.2.0.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2964,'2016','3.4.9.2.1.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2965,'2016','3.4.9.9.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2966,'2016','3.4.9.9.1.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2967,'2016','3.5.0.0.0.00.00','TRANSFERÊNCIAS E DELEGAÇÕES CONCEDIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2968,'2016','3.5.1.0.0.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2969,'2016','3.5.1.1.0.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA A EXECUÇÃO ORCAMENTARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2970,'2016','3.5.1.1.2.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA -  INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2971,'2016','3.5.1.1.2.01.00','COTA CONCEDIDA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2972,'2016','3.5.1.1.2.02.00','REPASSE CONCEDIDO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2973,'2016','3.5.1.1.2.03.00','SUB-REPASSE CONCEDIDO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2974,'2016','3.5.1.1.2.04.00','RECURSOS ARRECADADOS - CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2975,'2016','3.5.1.1.2.05.00','VALORES DIFERIDOS - BAIXA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2976,'2016','3.5.1.1.2.08.00','VALORES DIFERIDOS - INSCRIÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2977,'2016','3.5.1.1.2.09.00','DEVOLUÇÃO DE TRANSFERÊNCIAS RECEBIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2978,'2016','3.5.1.1.2.13.00','CORRESPONDÊNCIA DE CRÉDITOS - SALDOS FINANCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2979,'2016','3.5.1.2.0.00.00','TRANSFERÊNCIAS CONCEDIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2980,'2016','3.5.1.2.2.00.00','TRANSFERÊNCIAS CONCEDIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2981,'2016','3.5.1.2.2.01.00','TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2982,'2016','3.5.1.2.2.01.01','ORDEM DE TRANSFERÊNCIAS CONCEDIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2983,'2016','3.5.1.2.2.01.02','MOVIMENTO DE FUNDOS A CRÉDITO - CORRESPONDÊNCIA DE CRÉDITOS - SALDOS NAO FINANCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2984,'2016','3.5.1.2.2.01.03','MOVIMENTO DE FUNDOS A CRÉDITO - CORRESPONDÊNCIA DE CRÉDITOS - SALDOS FINANCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2985,'2016','3.5.1.2.2.01.04','MOVIMENTO DE FUNDOS A CRÉDITOS - MOVIMENTO DE FUNDOS PRÓPRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2986,'2016','3.5.1.2.2.01.99','OUTRAS TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2987,'2016','3.5.1.2.2.02.00','TRANSFERÊNCIAS  NÃO FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2988,'2016','3.5.1.2.2.02.01','TRANSFERÊNCIAS CONCEDIDAS DE BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2989,'2016','3.5.1.2.2.02.02','DOAÇÕES CONCEDIDAS DE BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2990,'2016','3.5.1.2.2.02.03','TRANFERÊNCIAS CONCEDIDAS DE BENS MÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2991,'2016','3.5.1.2.2.02.04','DOAÇÕES CONCEDIDAS DE BENS MÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2992,'2016','3.5.1.2.2.02.05','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS E VALORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2993,'2016','3.5.1.2.2.02.06','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS DA DÍVIDA ATIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2994,'2016','3.5.1.2.2.02.99','OUTRAS TRANSFERÊNCIAS  NÃO FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2995,'2016','3.5.1.3.0.00.00','TRANSFERENCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2996,'2016','3.5.1.3.2.00.00','TRANSFERENCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RPPS - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2997,'2016','3.5.1.3.2.01.00','PLANO FINANCEIRO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2998,'2016','3.5.1.3.2.01.01','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (2999,'2016','3.5.1.3.2.01.02','RECURSOS PARA FORMAÇÃO DE RESERVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3000,'2016','3.5.1.3.2.01.99','OUTROS APORTES PARA O RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3001,'2016','3.5.1.3.2.02.00','PLANO PREVIDENCIÁRIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3002,'2016','3.5.1.3.2.02.01','RECURSOS PARA COBERTURA DE DÉFICIT FINANCEIRO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3003,'2016','3.5.1.3.2.02.02','RECURSOS PARA COBERTURA DE DÉFICIT ATUARIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3004,'2016','3.5.1.3.2.02.99','OUTROS APORTES PARA O RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3005,'2016','3.5.1.4.0.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3006,'2016','3.5.1.4.2.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RGPS  - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3007,'2016','3.5.1.4.2.01.00','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3008,'2016','3.5.1.4.2.01.01','PROVENIENTES DO ORÇAMENTO DA SEGURIDADE SOCIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3009,'2016','3.5.1.4.2.01.02','PROVENIENTES DO ORÇAMENTO FISCAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3010,'2016','3.5.1.4.2.02.00','RECURSOS PARA FORMAÇÃO DE RESERVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3011,'2016','3.5.1.4.2.99.00','OUTROS APORTES PARA O RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3012,'2016','3.5.2.0.0.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3013,'2016','3.5.2.1.0.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3014,'2016','3.5.2.1.1.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3015,'2016','3.5.2.1.3.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3016,'2016','3.5.2.1.4.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3017,'2016','3.5.2.1.5.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3018,'2016','3.5.2.1.5.01.00','ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3019,'2016','3.5.2.1.5.02.00','IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3020,'2016','3.5.2.1.5.03.00','IPI-EXPORTAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3021,'2016','3.5.2.1.5.04.00','COTA-PARTE DA CONTRIBUIÇÃO DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3022,'2016','3.5.2.1.5.05.00','TRANSFERÊNCIA DA COTA-PARTE DA COMPENSAÇÃO FINANCEIRA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3023,'2016','3.5.2.1.5.06.00','TRANSFERÊNCIA DE RECURSOS DO ESTADO PARA PROGRAMAS DE SAÚDE - REPASSE FUNDO A FUNDO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3024,'2016','3.5.2.2.0.00.00','TRANSFERÊNCIAS AO FUNDEB','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3025,'2016','3.5.2.2.4.00.00','TRANSFERÊNCIAS AO FUNDEB - INTER-OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3026,'2016','3.5.2.3.0.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3027,'2016','3.5.2.3.1.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3028,'2016','3.5.2.3.3.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3029,'2016','3.5.2.3.3.01.00','CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3030,'2016','3.5.2.3.3.02.00','AUXÍLIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3031,'2016','3.5.2.3.3.03.00','SUBVENÇÕES SOCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3032,'2016','3.5.2.3.3.04.00','SUBVENÇÕES ECONÔMICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3033,'2016','3.5.2.3.3.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3034,'2016','3.5.2.3.4.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3035,'2016','3.5.2.3.4.01.00','CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3036,'2016','3.5.2.3.4.02.00','AUXÍLIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3037,'2016','3.5.2.3.4.03.00','SUBVENÇÕES SOCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3038,'2016','3.5.2.3.4.04.00','SUBVENÇÕES ECONÔMICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3039,'2016','3.5.2.3.4.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3040,'2016','3.5.2.3.5.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3041,'2016','3.5.2.3.5.01.00','CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3042,'2016','3.5.2.3.5.02.00','AUXÍLIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3043,'2016','3.5.2.3.5.03.00','SUBVENÇÕES SOCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3044,'2016','3.5.2.3.5.04.00','SUBVENÇÕES ECONÔMICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3045,'2016','3.5.2.3.5.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3046,'2016','3.5.2.4.0.00.00','OUTRAS TRANSFERÊNCIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3047,'2016','3.5.2.4.1.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3048,'2016','3.5.2.4.3.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3049,'2016','3.5.2.4.4.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3050,'2016','3.5.2.4.5.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3051,'2016','3.5.3.0.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3052,'2016','3.5.3.1.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3053,'2016','3.5.3.1.1.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3054,'2016','3.5.3.1.1.01.00','CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3055,'2016','3.5.3.1.1.02.00','AUXÍLIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3056,'2016','3.5.3.1.1.03.00','SUBVENÇÕES SOCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3057,'2016','3.5.3.2.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3058,'2016','3.5.3.2.1.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3059,'2016','3.5.3.2.1.01.00','SUBVENÇÕES ECONÔMICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3060,'2016','3.5.4.0.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3061,'2016','3.5.4.0.1.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3062,'2016','3.5.5.0.0.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3063,'2016','3.5.5.0.1.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3064,'2016','3.5.6.0.0.00.00','TRANSFERÊNCIAS AO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3065,'2016','3.5.6.0.1.00.00','TRANSFERÊNCIAS AO EXTERIOR - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3066,'2016','3.5.7.0.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3067,'2016','3.5.7.1.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3068,'2016','3.5.7.1.3.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3069,'2016','3.5.7.1.3.01.00','DIÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3070,'2016','3.5.7.1.3.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3071,'2016','3.5.7.1.3.03.00','MATERIAL DE CONSUMO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3072,'2016','3.5.7.1.3.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3073,'2016','3.5.7.1.3.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3074,'2016','3.5.7.1.3.06.00','INDENIZAÇÕES E RESTITUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3075,'2016','3.5.7.1.3.07.00','DEMAIS VPD COM DELEGAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3076,'2016','3.5.7.1.4.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3077,'2016','3.5.7.1.4.01.00','DIÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3078,'2016','3.5.7.1.4.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3079,'2016','3.5.7.1.4.03.00','MATERIAL DE CONSUMO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3080,'2016','3.5.7.1.4.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3081,'2016','3.5.7.1.4.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3082,'2016','3.5.7.1.4.06.00','INDENIZAÇÕES E RESTITUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3083,'2016','3.5.7.1.4.07.00','DEMAIS VPD COM DELEGAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3084,'2016','3.5.7.1.5.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3085,'2016','3.5.7.1.5.01.00','DIÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3086,'2016','3.5.7.1.5.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3087,'2016','3.5.7.1.5.03.00','MATERIAL DE CONSUMO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3088,'2016','3.5.7.1.5.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3089,'2016','3.5.7.1.5.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3090,'2016','3.5.7.1.5.06.00','INDENIZAÇÕES E RESTITUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3091,'2016','3.5.7.1.5.07.00','DEMAIS VPD COM DELEGAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3092,'2016','3.5.7.2.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3093,'2016','3.5.7.2.1.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3094,'2016','3.5.7.2.1.01.00','DIÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3095,'2016','3.5.7.2.1.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3096,'2016','3.5.7.2.1.03.00','MATERIAL DE CONSUMO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3097,'2016','3.5.7.2.1.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3098,'2016','3.5.7.2.1.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3099,'2016','3.5.7.2.1.06.00','INDENIZAÇÕES E RESTITUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3100,'2016','3.5.7.2.1.07.00','DEMAIS VPD COM DELEGAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3101,'2016','3.5.9.0.0.00.00','OUTRAS TRANSFERÊNCIAS E DELEGAÇÕES CONCEDIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3102,'2016','3.5.9.0.1.00.00','OUTRAS TRANSFERÊNCIAS CONCEDIDAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3103,'2016','3.5.9.0.1.01.00','DOAÇÕES CONCEDIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3104,'2016','3.6.0.0.0.00.00','DESVALORIZAÇÃO E PERDA DE ATIVOS E INCORPORAÇÃO DE PASSIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3105,'2016','3.6.1.0.0.00.00','REAVALIAÇÃO, REDUÇÃO A VALOR RECUPERÁVEL E AJUSTE PARA PERDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3106,'2016','3.6.1.1.0.00.00','REAVALIAÇÃO DE IMOBILIZADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3107,'2016','3.6.1.1.1.00.00','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3108,'2016','3.6.1.1.1.01.00','REAVALIAÇÃO DE BENS MÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3109,'2016','3.6.1.1.1.01.01','REAVALIAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3110,'2016','3.6.1.1.1.01.02','REAVALIAÇÃO DE BENS DE INFORMÁTICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3111,'2016','3.6.1.1.1.01.03','REAVALIAÇÃO DE MÓVEIS E UTENSÍLIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3112,'2016','3.6.1.1.1.01.04','REAVALIAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3113,'2016','3.6.1.1.1.01.05','REAVALIAÇÃO DE VEÍCULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3114,'2016','3.6.1.1.1.01.06','REAVALIAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3115,'2016','3.6.1.1.1.01.07','REAVALIAÇÃO DE BENS MÓVEIS EM ANDAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3116,'2016','3.6.1.1.1.01.08','REAVALIAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3117,'2016','3.6.1.1.1.01.09','REAVALIAÇÃO DE ARMAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3118,'2016','3.6.1.1.1.01.10','REAVALIAÇÃO DE SEMOVENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3119,'2016','3.6.1.1.1.01.99','REAVALIAÇÃO DE DEMAIS BENS MÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3120,'2016','3.6.1.1.1.02.00','REAVALIAÇÃO DE BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3121,'2016','3.6.1.1.1.02.01','REAVALIAÇÃO DE BENS DE USO ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3122,'2016','3.6.1.1.1.02.02','REAVALIAÇÃO DE BENS DOMINICAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3123,'2016','3.6.1.1.1.02.03','REAVALIAÇÃO DE BENS DE USO COMUM DO POVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3124,'2016','3.6.1.1.1.02.04','REAVALIAÇÃO DE BENS IMÓVEIS EM ANDAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3125,'2016','3.6.1.1.1.02.05','REAVALIAÇÃO DE INSTALAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3126,'2016','3.6.1.1.1.02.06','REAVALIAÇÃO DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3127,'2016','3.6.1.1.1.02.99','REAVALIAÇÃO DE DEMAIS BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3128,'2016','3.6.1.2.0.00.00','REAVALIAÇÃO DE INTANGÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3129,'2016','3.6.1.2.1.00.00','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3130,'2016','3.6.1.3.0.00.00','REAVALIAÇÃO DE OUTROS ATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3131,'2016','3.6.1.3.1.00.00','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3132,'2016','3.6.1.4.0.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3133,'2016','3.6.1.4.1.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3134,'2016','3.6.1.4.1.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3135,'2016','3.6.1.4.1.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3136,'2016','3.6.1.4.1.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3137,'2016','3.6.1.4.1.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3138,'2016','3.6.1.4.2.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3139,'2016','3.6.1.4.2.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3140,'2016','3.6.1.4.2.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3141,'2016','3.6.1.4.2.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3142,'2016','3.6.1.4.2.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3143,'2016','3.6.1.4.3.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3144,'2016','3.6.1.4.3.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3145,'2016','3.6.1.4.3.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3146,'2016','3.6.1.4.3.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3147,'2016','3.6.1.4.3.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3148,'2016','3.6.1.4.4.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3149,'2016','3.6.1.4.4.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3150,'2016','3.6.1.4.4.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3151,'2016','3.6.1.4.4.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3152,'2016','3.6.1.4.4.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3153,'2016','3.6.1.4.5.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3154,'2016','3.6.1.4.5.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3155,'2016','3.6.1.4.5.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3156,'2016','3.6.1.4.5.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3157,'2016','3.6.1.4.5.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3158,'2016','3.6.1.5.0.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3159,'2016','3.6.1.5.1.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3160,'2016','3.6.1.5.1.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3161,'2016','3.6.1.5.1.01.01','REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3162,'2016','3.6.1.5.1.01.02','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE INFORMÁTICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3163,'2016','3.6.1.5.1.01.03','REDUÇÃO A VALOR RECUPERÁVEL DE MÓVEIS E UTENSÍLIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3164,'2016','3.6.1.5.1.01.04','REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3165,'2016','3.6.1.5.1.01.05','REDUÇÃO A VALOR RECUPERÁVEL DE VEÍCULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3166,'2016','3.6.1.5.1.01.06','REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3167,'2016','3.6.1.5.1.01.07','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3168,'2016','3.6.1.5.1.01.08','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ALMOXARIFADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3169,'2016','3.6.1.5.1.01.09','REDUÇÃO A VALOR RECUPERÁVEL DE ARMAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3170,'2016','3.6.1.5.1.01.10','REDUÇÃO A VALOR RECUPERÁVEL DE SEMOVENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3171,'2016','3.6.1.5.1.01.99','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3172,'2016','3.6.1.5.1.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3173,'2016','3.6.1.5.1.02.01','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3174,'2016','3.6.1.5.1.02.02','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DOMINICAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3175,'2016','3.6.1.5.1.02.03','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3176,'2016','3.6.1.5.1.02.04','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS EM ANDAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3177,'2016','3.6.1.5.1.02.05','REDUÇÃO A VALOR RECUPERÁVEL DE INSTALAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3178,'2016','3.6.1.5.1.02.06','REDUÇÃO A VALOR RECUPERÁVEL DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3179,'2016','3.6.1.5.1.02.99','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3180,'2016','3.6.1.6.0.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3181,'2016','3.6.1.6.1.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3182,'2016','3.6.1.6.1.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE SOFTWARES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3183,'2016','3.6.1.6.1.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE MARCAS, DIREITOS E PATENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3184,'2016','3.6.1.6.1.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE DIREITO DE USO DE IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3185,'2016','3.6.1.7.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3186,'2016','3.6.1.7.1.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS  E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS- CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3187,'2016','3.6.1.7.1.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3188,'2016','3.6.1.7.1.02.00','AJUSTE PARA PERDAS EM CLIENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3189,'2016','3.6.1.7.1.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3190,'2016','3.6.1.7.1.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3191,'2016','3.6.1.7.1.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3192,'2016','3.6.1.7.1.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3193,'2016','3.6.1.7.1.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3194,'2016','3.6.1.7.1.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3195,'2016','3.6.1.7.1.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3196,'2016','3.6.1.7.1.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3197,'2016','3.6.1.7.1.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3198,'2016','3.6.1.7.1.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3199,'2016','3.6.1.7.1.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3200,'2016','3.6.1.7.1.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3201,'2016','3.6.1.7.1.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3202,'2016','3.6.1.7.1.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3203,'2016','3.6.1.7.1.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3204,'2016','3.6.1.7.1.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3205,'2016','3.6.1.7.1.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3206,'2016','3.6.1.7.1.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3207,'2016','3.6.1.7.1.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3208,'2016','3.6.1.7.1.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3209,'2016','3.6.1.7.1.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3210,'2016','3.6.1.7.1.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3211,'2016','3.6.1.7.1.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE-ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3212,'2016','3.6.1.7.1.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3213,'2016','3.6.1.7.1.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3214,'2016','3.6.1.7.1.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3215,'2016','3.6.1.7.1.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3216,'2016','3.6.1.7.1.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3217,'2016','3.6.1.7.1.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3218,'2016','3.6.1.7.1.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3219,'2016','3.6.1.7.1.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3220,'2016','3.6.1.7.1.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3221,'2016','3.6.1.7.1.07.00','AJUSTE PARA PERDAS EM INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3222,'2016','3.6.1.7.1.07.01','AJUSTE PARA PERDAS EM TÍTULOS E VALORES MOBILIÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3223,'2016','3.6.1.7.1.07.02','AJUSTE PARA PERDAS EM APLICAÇÕES TEMPORÁRIAS EM METAIS PRECIOSOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3224,'2016','3.6.1.7.1.07.03','AJUSTE PARA PERDAS EM APLICAÇÕES TEMPORÁRIAS EM SEGMENTO DE IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3225,'2016','3.6.1.7.1.98.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3226,'2016','3.6.1.7.1.99.00','AJUSTE PARA PERDAS DE DEMAIS INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3227,'2016','3.6.1.7.2.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS- INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3228,'2016','3.6.1.7.2.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3229,'2016','3.6.1.7.2.02.00','AJUSTE PARA PERDAS EM CLIENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3230,'2016','3.6.1.7.2.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3231,'2016','3.6.1.7.2.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3232,'2016','3.6.1.7.2.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3233,'2016','3.6.1.7.2.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3234,'2016','3.6.1.7.2.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3235,'2016','3.6.1.7.2.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3236,'2016','3.6.1.7.2.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3237,'2016','3.6.1.7.2.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3238,'2016','3.6.1.7.2.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3239,'2016','3.6.1.7.2.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3240,'2016','3.6.1.7.2.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3241,'2016','3.6.1.7.2.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3242,'2016','3.6.1.7.2.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3243,'2016','3.6.1.7.2.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3244,'2016','3.6.1.7.2.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3245,'2016','3.6.1.7.2.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3246,'2016','3.6.1.7.2.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3247,'2016','3.6.1.7.2.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3248,'2016','3.6.1.7.2.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3249,'2016','3.6.1.7.2.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3250,'2016','3.6.1.7.2.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3251,'2016','3.6.1.7.2.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3252,'2016','3.6.1.7.2.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE-ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3253,'2016','3.6.1.7.2.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3254,'2016','3.6.1.7.2.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3255,'2016','3.6.1.7.2.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3256,'2016','3.6.1.7.2.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3257,'2016','3.6.1.7.2.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3258,'2016','3.6.1.7.2.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3259,'2016','3.6.1.7.2.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3260,'2016','3.6.1.7.2.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3261,'2016','3.6.1.7.2.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3262,'2016','3.6.1.7.2.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3263,'2016','3.6.1.7.3.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3264,'2016','3.6.1.7.3.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3265,'2016','3.6.1.7.3.02.00','AJUSTE PARA PERDAS EM CLIENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3266,'2016','3.6.1.7.3.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3267,'2016','3.6.1.7.3.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3268,'2016','3.6.1.7.3.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3269,'2016','3.6.1.7.3.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3270,'2016','3.6.1.7.3.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3271,'2016','3.6.1.7.3.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3272,'2016','3.6.1.7.3.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3273,'2016','3.6.1.7.3.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3274,'2016','3.6.1.7.3.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3275,'2016','3.6.1.7.3.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3276,'2016','3.6.1.7.3.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3277,'2016','3.6.1.7.3.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3278,'2016','3.6.1.7.3.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3279,'2016','3.6.1.7.3.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3280,'2016','3.6.1.7.3.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3281,'2016','3.6.1.7.3.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3282,'2016','3.6.1.7.3.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3283,'2016','3.6.1.7.3.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3284,'2016','3.6.1.7.3.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3285,'2016','3.6.1.7.3.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3286,'2016','3.6.1.7.3.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3287,'2016','3.6.1.7.3.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3288,'2016','3.6.1.7.3.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE-ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3289,'2016','3.6.1.7.3.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3290,'2016','3.6.1.7.3.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3291,'2016','3.6.1.7.3.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3292,'2016','3.6.1.7.3.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3293,'2016','3.6.1.7.3.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3294,'2016','3.6.1.7.3.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3295,'2016','3.6.1.7.3.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3296,'2016','3.6.1.7.3.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3297,'2016','3.6.1.7.3.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3298,'2016','3.6.1.7.3.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3299,'2016','3.6.1.7.4.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3300,'2016','3.6.1.7.4.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3301,'2016','3.6.1.7.4.02.00','AJUSTE PARA PERDAS EM CLIENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3302,'2016','3.6.1.7.4.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3303,'2016','3.6.1.7.4.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3304,'2016','3.6.1.7.4.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3305,'2016','3.6.1.7.4.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3306,'2016','3.6.1.7.4.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3307,'2016','3.6.1.7.4.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3308,'2016','3.6.1.7.4.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3309,'2016','3.6.1.7.4.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3310,'2016','3.6.1.7.4.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3311,'2016','3.6.1.7.4.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3312,'2016','3.6.1.7.4.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3313,'2016','3.6.1.7.4.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3314,'2016','3.6.1.7.4.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3315,'2016','3.6.1.7.4.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3316,'2016','3.6.1.7.4.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3317,'2016','3.6.1.7.4.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3318,'2016','3.6.1.7.4.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3319,'2016','3.6.1.7.4.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3320,'2016','3.6.1.7.4.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3321,'2016','3.6.1.7.4.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3322,'2016','3.6.1.7.4.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3323,'2016','3.6.1.7.4.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3324,'2016','3.6.1.7.4.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE-ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3325,'2016','3.6.1.7.4.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3326,'2016','3.6.1.7.4.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3327,'2016','3.6.1.7.4.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3328,'2016','3.6.1.7.4.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3329,'2016','3.6.1.7.4.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3330,'2016','3.6.1.7.4.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3331,'2016','3.6.1.7.4.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3332,'2016','3.6.1.7.4.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3333,'2016','3.6.1.7.4.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3334,'2016','3.6.1.7.4.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3335,'2016','3.6.1.7.5.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS E DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIOS- INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3336,'2016','3.6.1.7.5.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3337,'2016','3.6.1.7.5.02.00','AJUSTE PARA PERDAS EM CLIENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3338,'2016','3.6.1.7.5.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3339,'2016','3.6.1.7.5.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3340,'2016','3.6.1.7.5.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3341,'2016','3.6.1.7.5.05.01','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3342,'2016','3.6.1.7.5.05.02','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3343,'2016','3.6.1.7.5.05.03','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3344,'2016','3.6.1.7.5.05.04','DÍVIDA ATIVA TRIBUTÁRIA -CANCELAMENTO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3345,'2016','3.6.1.7.5.05.05','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3346,'2016','3.6.1.7.5.05.06','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3347,'2016','3.6.1.7.5.05.07','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3348,'2016','3.6.1.7.5.05.08','DÍVIDA ATIVA TRIBUTÁRIA -ANISTIA/REMISSAO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3349,'2016','3.6.1.7.5.05.09','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3350,'2016','3.6.1.7.5.05.10','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3351,'2016','3.6.1.7.5.05.11','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3352,'2016','3.6.1.7.5.05.12','DÍVIDA ATIVA TRIBUTÁRIA -ADJUDICAÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3353,'2016','3.6.1.7.5.05.13','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3354,'2016','3.6.1.7.5.05.14','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3355,'2016','3.6.1.7.5.05.15','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3356,'2016','3.6.1.7.5.05.16','DÍVIDA ATIVA TRIBUTÁRIA -ANULAÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3357,'2016','3.6.1.7.5.05.17','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3358,'2016','3.6.1.7.5.05.18','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3359,'2016','3.6.1.7.5.05.19','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3360,'2016','3.6.1.7.5.05.20','DÍVIDA ATIVA TRIBUTÁRIA -PRESCRIÇÃO INTERCORRENTE-ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3361,'2016','3.6.1.7.5.05.21','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3362,'2016','3.6.1.7.5.05.22','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3363,'2016','3.6.1.7.5.05.23','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3364,'2016','3.6.1.7.5.05.24','DÍVIDA ATIVA TRIBUTÁRIA -EXTINÇÃO - ATUALIZAÇÃO MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3365,'2016','3.6.1.7.5.05.25','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - PRINCIPAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3366,'2016','3.6.1.7.5.05.26','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO - MULTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3367,'2016','3.6.1.7.5.05.27','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3368,'2016','3.6.1.7.5.05.28','DÍVIDA ATIVA TRIBUTÁRIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3369,'2016','3.6.1.7.5.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3370,'2016','3.6.1.7.5.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3371,'2016','3.6.1.8.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3372,'2016','3.6.1.8.1.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3373,'2016','3.6.1.8.1.01.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MERCADORIAS PARA REVENDA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3374,'2016','3.6.1.8.1.02.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE PRODUTOS E SERVIÇOS ACABADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3375,'2016','3.6.1.8.1.03.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE PRODUTOS E SERVIÇOS EM ELABORAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3376,'2016','3.6.1.8.1.04.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MATÉRIAS-PRIMAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3377,'2016','3.6.1.8.1.05.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MATERIAIS EM TRÂNSITO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3378,'2016','3.6.1.8.1.06.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ALMOXARIFADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3379,'2016','3.6.1.8.1.07.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ADIANTAMENTOS A FORNECEDORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3380,'2016','3.6.1.8.1.08.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE OUTROS ESTOQUES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3381,'2016','3.6.2.0.0.00.00','PERDAS COM ALIENAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3382,'2016','3.6.2.1.0.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3383,'2016','3.6.2.1.1.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3384,'2016','3.6.2.1.1.01.00','PERDAS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3385,'2016','3.6.2.1.1.02.00','PERDAS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3386,'2016','3.6.2.1.1.03.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3387,'2016','3.6.2.1.1.04.00','PERDAS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3388,'2016','3.6.2.2.0.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3389,'2016','3.6.2.2.1.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3390,'2016','3.6.2.2.1.01.00','PERDAS COM ALIENAÇÃO DE BENS MOVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3391,'2016','3.6.2.2.1.01.01','PERDAS COM ALIENAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3392,'2016','3.6.2.2.1.01.02','PERDAS COM ALIENAÇÃO DE BENS DE INFORMÁTICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3393,'2016','3.6.2.2.1.01.03','PERDAS COM ALIENAÇÃO DE MÓVEIS E UTENSÍLIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3394,'2016','3.6.2.2.1.01.04','PERDAS COM ALIENAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3395,'2016','3.6.2.2.1.01.05','PERDAS COM ALIENAÇÃO DE VEÍCULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3396,'2016','3.6.2.2.1.01.06','PERDAS COM ALIENAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3397,'2016','3.6.2.2.1.01.07','PERDAS COM ALIENAÇÃO DE BENS MÓVEIS EM ANDAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3398,'2016','3.6.2.2.1.01.08','PERDAS COM ALIENAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3399,'2016','3.6.2.2.1.01.09','PERDAS COM ALIENAÇÃO DE ARMAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3400,'2016','3.6.2.2.1.01.10','PERDAS COM ALIENAÇÃO DE SEMOVENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3401,'2016','3.6.2.2.1.01.99','PERDAS COM ALIENAÇÃO DE DEMAIS BENS MÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3402,'2016','3.6.2.2.1.02.00','PERDAS COM ALIENAÇÃO DE BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3403,'2016','3.6.2.3.0.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3404,'2016','3.6.2.3.1.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3405,'2016','3.6.2.3.1.01.00','PERDAS COM ALIENAÇÃO DE SOFTWARES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3406,'2016','3.6.2.3.1.02.00','PERDAS COM ALIENAÇÃO DE MARCAS, DIREITOS E PATENTES INDUSTRIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3407,'2016','3.6.2.3.1.03.00','PERDAS COM ALIENAÇÃO DE DIREITO DE USO DE IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3408,'2016','3.6.2.9.0.00.00','PERDAS COM ALIENAÇÃO DE DEMAIS ATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3409,'2016','3.6.2.9.1.00.00','PERDAS COM ALIENAÇÃO DE DEMAIS ATIVOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3410,'2016','3.6.3.0.0.00.00','PERDAS INVOLUNTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3411,'2016','3.6.3.1.0.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3412,'2016','3.6.3.1.1.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3413,'2016','3.6.3.1.1.01.00','PERDAS INVOLUNTÁRIAS DE BENS MOVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3414,'2016','3.6.3.1.1.01.01','PERDAS INVOLUNTÁRIAS DE  MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3415,'2016','3.6.3.1.1.01.02','PERDAS INVOLUNTÁRIAS DE  BENS DE INFORMÁTICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3416,'2016','3.6.3.1.1.01.03','PERDAS INVOLUNTÁRIAS DE MÓVEIS E UTENSÍLIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3417,'2016','3.6.3.1.1.01.04','PERDAS INVOLUNTÁRIAS DE  MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3418,'2016','3.6.3.1.1.01.05','PERDAS INVOLUNTÁRIAS DE VEÍCULOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3419,'2016','3.6.3.1.1.01.06','PERDAS INVOLUNTÁRIAS DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3420,'2016','3.6.3.1.1.01.07','PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS EM ANDAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3421,'2016','3.6.3.1.1.01.08','PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS EM ALMOXARIFADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3422,'2016','3.6.3.1.1.01.09','PERDAS INVOLUNTÁRIAS DE ARMAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3423,'2016','3.6.3.1.1.01.10','PERDAS INVOLUNTÁRIAS DE SEMOVENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3424,'2016','3.6.3.1.1.01.99','PERDAS INVOLUNTÁRIAS DE DEMAIS BENS MÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3425,'2016','3.6.3.1.1.02.00','PERDAS INVOLUNTÁRIAS DE BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3426,'2016','3.6.3.2.0.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3427,'2016','3.6.3.2.1.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3428,'2016','3.6.3.2.1.01.00','PERDAS  INVOLUNTÁRIAS COM SOFTWARES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3429,'2016','3.6.3.2.1.02.00','PERDAS  INVOLUNTÁRIAS COM MARCAS, DIREITOS E PATENTES INDUSTRIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3430,'2016','3.6.3.2.1.03.00','PERDAS  INVOLUNTÁRIAS COM DIREITO DE USO DE IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3431,'2016','3.6.3.3.0.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3432,'2016','3.6.3.3.1.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3433,'2016','3.6.3.3.1.01.00','PERDAS INVOLUNTÁRIAS COM  MERCADORIAS PARA REVENDA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3434,'2016','3.6.3.3.1.02.00','PERDAS INVOLUNTÁRIAS COM  PRODUTOS E SERVIÇOS ACABADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3435,'2016','3.6.3.3.1.03.00','PERDAS INVOLUNTÁRIAS COM  PRODUTOS E SERVIÇOS EM ELABORAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3436,'2016','3.6.3.3.1.04.00','PERDAS INVOLUNTÁRIAS COM  MATÉRIAS-PRIMAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3437,'2016','3.6.3.3.1.05.00','PERDAS INVOLUNTÁRIAS COM  MATERIAIS EM TRÂNSITO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3438,'2016','3.6.3.3.1.06.00','PERDAS INVOLUNTÁRIAS COM  ALMOXARIFADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3439,'2016','3.6.3.3.1.07.00','PERDAS INVOLUNTÁRIAS COM  ADIANTAMENTOS A FORNECEDORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3440,'2016','3.6.3.3.1.99.00','PERDAS INVOLUNTÁRIAS COM  OUTROS ESTOQUES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3441,'2016','3.6.3.9.0.00.00','OUTRAS PERDAS INVOLUNTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3442,'2016','3.6.3.9.1.00.00','OUTRAS PERDAS INVOLUNTÁRIAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3443,'2016','3.6.4.0.0.00.00','INCORPORAÇÃO DE PASSIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3444,'2016','3.6.4.0.1.00.00','INCORPORAÇÃO DE PASSIVOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3445,'2016','3.6.5.0.0.00.00','DESINCORPORAÇÃO DE ATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3446,'2016','3.6.5.0.1.00.00','DESINCORPORAÇÃO DE ATIVOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3447,'2016','3.7.0.0.0.00.00','TRIBUTÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3448,'2016','3.7.1.0.0.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3449,'2016','3.7.1.1.0.00.00','IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3450,'2016','3.7.1.1.1.00.00','IMPOSTOS- CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3451,'2016','3.7.1.1.1.01.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3452,'2016','3.7.1.1.1.02.00','IPVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3453,'2016','3.7.1.1.1.03.00','ITCMD','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3454,'2016','3.7.1.1.1.04.00','ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3455,'2016','3.7.1.1.1.05.00','IPTU','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3456,'2016','3.7.1.1.1.06.00','ITBI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3457,'2016','3.7.1.1.1.07.00','ISS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3458,'2016','3.7.1.1.1.08.00','ITR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3459,'2016','3.7.1.1.1.09.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS - IPI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3460,'2016','3.7.1.1.1.10.00','IMPOSTO S/ OPERAÇÕES FINANCEIRAS - IOF','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3461,'2016','3.7.1.1.1.11.00','IMPOSTO S/ IMPORTAÇÃO - II','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3462,'2016','3.7.1.1.1.99.00','OUTROS IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3463,'2016','3.7.1.2.0.00.00','TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3464,'2016','3.7.1.2.1.00.00','TAXAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3465,'2016','3.7.1.2.1.01.00','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3466,'2016','3.7.1.2.1.02.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3467,'2016','3.7.1.3.0.00.00','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3468,'2016','3.7.1.3.1.00.00','CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3469,'2016','3.7.1.3.1.01.00','CONTRIBUIÇÕES DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3470,'2016','3.7.2.0.0.00.00','CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3471,'2016','3.7.2.1.0.00.00','CONTRIBUIÇÕES SOCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3472,'2016','3.7.2.1.1.00.00','CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3473,'2016','3.7.2.1.1.01.00','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS -','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3474,'2016','3.7.2.1.1.02.00','PIS/PASEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3475,'2016','3.7.2.1.1.03.00','CONTRIBUIÇÃO SOCIAL S/ LUCRO LIQUIDO - CSLL -','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3476,'2016','3.7.2.1.1.04.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA FISICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3477,'2016','3.7.2.1.1.05.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA JURIDICA -','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3478,'2016','3.7.2.1.1.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3479,'2016','3.7.2.1.2.00.00','CONTRIBUIÇÕES SOCIAIS - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3480,'2016','3.7.2.1.3.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3481,'2016','3.7.2.1.3.01.00','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS -','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3482,'2016','3.7.2.1.3.02.00','PIS/PASEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3483,'2016','3.7.2.1.3.03.00','CONTRIBUIÇÃO SOCIAL S/ LUCRO LIQUIDO - CSLL -','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3484,'2016','3.7.2.1.3.04.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA FISICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3485,'2016','3.7.2.1.3.05.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA JURIDICA -','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3486,'2016','3.7.2.1.3.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3487,'2016','3.7.2.1.4.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3488,'2016','3.7.2.1.5.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3489,'2016','3.7.2.2.0.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3490,'2016','3.7.2.2.1.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3491,'2016','3.7.2.3.0.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3492,'2016','3.7.2.3.1.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3493,'2016','3.7.2.9.0.00.00','OUTRAS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3494,'2016','3.7.2.9.1.00.00','OUTRAS CONTRIBUIÇÕES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3495,'2016','3.7.2.9.1.01.00','CONTRIBUIÇÃO SINDICAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3496,'2016','3.7.2.9.1.99.00','DEMAIS CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3497,'2016','3.8.0.0.0.00.00','CUSTO DAS MERCADORIAS VENDIDAS, DOS PRODUTOS VENDIDOS E DOS SERVIÇOS PRESTADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3498,'2016','3.8.1.0.0.00.00','CUSTO DE MERCADORIAS VENDIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3499,'2016','3.8.1.0.1.00.00','CUSTO DE MERCADORIAS VENDIDAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3500,'2016','3.8.1.0.2.00.00','CUSTO DE MERCADORIAS VENDIDAS - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3501,'2016','3.8.1.0.3.00.00','CUSTO DE MERCADORIAS VENDIDAS -  INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3502,'2016','3.8.1.0.4.00.00','CUSTO DE MERCADORIAS VENDIDAS -  INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3503,'2016','3.8.1.0.5.00.00','CUSTO DE MERCADORIAS VENDIDAS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3504,'2016','3.8.2.0.0.00.00','CUSTO DE PRODUTOS VENDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3505,'2016','3.8.2.0.1.00.00','CUSTO DOS PRODUTOS VENDIDOS-CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3506,'2016','3.8.2.0.2.00.00','CUSTO DOS PRODUTOS VENDIDOS-INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3507,'2016','3.8.2.0.3.00.00','CUSTO DOS PRODUTOS VENDIDOS-INTER OFSS UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3508,'2016','3.8.2.0.4.00.00','CUSTO DOS PRODUTOS VENDIDOS-INTER OFSS ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3509,'2016','3.8.2.0.5.00.00','CUSTO DOS PRODUTOS VENDIDOS-INTER OFSS MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3510,'2016','3.8.3.0.0.00.00','CUSTO DE SERVIÇOS PRESTADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3511,'2016','3.8.3.0.1.00.00','CUSTO DE SERVIÇOS PRESTADOS-CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3512,'2016','3.8.3.0.2.00.00','CUSTO DE SERVIÇOS PRESTADOS- INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3513,'2016','3.8.3.0.3.00.00','CUSTO DE SERVIÇOS PRESTADOS- INTER OFSS UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3514,'2016','3.8.3.0.4.00.00','CUSTO DE SERVIÇOS PRESTADOS- INTER OFSS ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3515,'2016','3.8.3.0.5.00.00','CUSTO DE SERVIÇOS PRESTADOS- INTER OFSS MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3516,'2016','3.9.0.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3517,'2016','3.9.1.0.0.00.00','PREMIAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3518,'2016','3.9.1.1.0.00.00','PREMIAÇÕES CULTURAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3519,'2016','3.9.1.1.1.00.00','PREMIAÇÕES CULTURAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3520,'2016','3.9.1.2.0.00.00','PREMIAÇÕES ARTÍSTICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3521,'2016','3.9.1.2.1.00.00','PREMIAÇÕES ARTÍSTICAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3522,'2016','3.9.1.3.0.00.00','PREMIAÇÕES CIENTIFICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3523,'2016','3.9.1.3.1.00.00','PREMIAÇÕES CIENTIFICAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3524,'2016','3.9.1.4.0.00.00','PREMIAÇÕES DESPORTIVAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3525,'2016','3.9.1.4.1.00.00','PREMIAÇÕES DESPORTIVAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3526,'2016','3.9.1.5.0.00.00','ORDENS HONORIFICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3527,'2016','3.9.1.5.1.00.00','ORDENS HONORIFICAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3528,'2016','3.9.1.9.0.00.00','OUTRAS PREMIAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3529,'2016','3.9.1.9.1.00.00','OUTRAS PREMIAÇÕES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3530,'2016','3.9.2.0.0.00.00','RESULTADO NEGATIVO DE PARTICIPAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3531,'2016','3.9.2.1.0.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3532,'2016','3.9.2.1.1.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3533,'2016','3.9.2.1.2.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3534,'2016','3.9.2.1.3.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3535,'2016','3.9.2.1.4.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3536,'2016','3.9.2.1.5.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3537,'2016','3.9.3.0.0.00.00','OPERAÇÕES DA AUTORIDADE MONETÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3538,'2016','3.9.3.1.0.00.00','JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3539,'2016','3.9.3.1.1.00.00','JUROS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3540,'2016','3.9.3.2.0.00.00','POSIÇÃO DE NEGOCIAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3541,'2016','3.9.3.2.1.00.00','POSIÇÃO DE NEGOCIAÇÃO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3542,'2016','3.9.3.3.0.00.00','POSIÇÃO DE INVESTIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3543,'2016','3.9.3.3.1.00.00','POSIÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3544,'2016','3.9.3.4.0.00.00','CORREÇÃO CAMBIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3545,'2016','3.9.3.4.1.00.00','CORREÇÃO CAMBIAL - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3546,'2016','3.9.3.9.0.00.00','OUTRAS VPD DE OPERAÇÕES DA AUTORIDADE MONETÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3547,'2016','3.9.3.9.1.00.00','OUTRAS VPD DE OPERAÇÕES DA AUTORIDADE MONETÁRIA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3548,'2016','3.9.4.0.0.00.00','INCENTIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3549,'2016','3.9.4.1.0.00.00','INCENTIVOS A EDUCAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3550,'2016','3.9.4.1.1.00.00','INCENTIVOS A EDUCAÇÃO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3551,'2016','3.9.4.1.1.01.00','BOLSA DE ESTUDOS NO PAÍS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3552,'2016','3.9.4.1.1.02.00','BOLSA DE ESTUDOS NO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3553,'2016','3.9.4.1.1.03.00','AUXÍLIOS PARA DESENV. DE ESTUDOS E PESQUISAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3554,'2016','3.9.4.1.1.99.00','OUTROS INCENTIVOS A EDUCAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3555,'2016','3.9.4.2.0.00.00','INCENTIVOS A CIÊNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3556,'2016','3.9.4.2.1.00.00','INCENTIVOS A CIÊNCIA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3557,'2016','3.9.4.2.1.01.00','AUXÍLIO A PESQUISADORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3558,'2016','3.9.4.2.1.02.00','AUXÍLIO AS ATIVIDADES AUXILIARES DE PESQUISA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3559,'2016','3.9.4.2.1.99.00','OUTROS INCENTIVOS A CIÊNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3560,'2016','3.9.4.3.0.00.00','INCENTIVOS A CULTURA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3561,'2016','3.9.4.3.1.00.00','INCENTIVOS A CULTURA - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3562,'2016','3.9.4.3.1.01.00','INCENTIVOS A CULTURA - PESSOAS FÍSICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3563,'2016','3.9.4.3.1.99.00','OUTROS INCENTIVOS A CULTURA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3564,'2016','3.9.4.4.0.00.00','INCENTIVOS AO ESPORTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3565,'2016','3.9.4.4.1.00.00','INCENTIVOS AO ESPORTE - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3566,'2016','3.9.4.4.1.01.00','INCENTIVOS AO ESPORTE - PESSOAS FÍSICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3567,'2016','3.9.4.4.1.99.00','OUTROS INCENTIVOS AO ESPORTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3568,'2016','3.9.4.9.0.00.00','OUTROS INCENTIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3569,'2016','3.9.4.9.1.00.00','OUTROS INCENTIVOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3570,'2016','3.9.5.0.0.00.00','SUBVENÇÕES ECONÔMICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3571,'2016','3.9.5.0.1.00.00','SUBVENÇÕES ECONÔMICAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3572,'2016','3.9.5.0.1.01.00','CORREÇÃO MONETÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3573,'2016','3.9.5.0.1.02.00','DIFERENCIAL DE JUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3574,'2016','3.9.5.0.1.03.00','PROGRAMA DE INVESTIMENTO RURAL AGROINDUSTRIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3575,'2016','3.9.5.0.1.04.00','GARANTIA E SUSTENTAÇÃO DE PREÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3576,'2016','3.9.5.0.1.05.00','CUSTOS ADMINISTRATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3577,'2016','3.9.5.0.1.06.00','CUSTEIO AGROPECUÁRIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3578,'2016','3.9.5.0.1.07.00','SUBVENÇÃO ECONOMICA AO PREMIO DE SEGURO GARANTIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3579,'2016','3.9.5.0.1.08.00','AQUISIÇÃO E PRODUÇÃO DE BENS DE CAPITAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3580,'2016','3.9.5.0.1.99.00','OUTRAS SUBVENÇÕES ECONÔMICAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3581,'2016','3.9.6.0.0.00.00','PARTICIPAÇÕES E CONTRIBUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3582,'2016','3.9.6.1.0.00.00','PARTICIPAÇÕES DE DEBÊNTURES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3583,'2016','3.9.6.1.1.00.00','PARTICIPAÇÕES DE DEBÊNTURES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3584,'2016','3.9.6.2.0.00.00','PARTICIPAÇÕES DE EMPREGADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3585,'2016','3.9.6.2.1.00.00','PARTICIPAÇÕES DE EMPREGADOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3586,'2016','3.9.6.3.0.00.00','PARTICIPAÇÕES DE ADMINISTRADORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3587,'2016','3.9.6.3.1.00.00','PARTICIPAÇÕES DE ADMINISTRADORES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3588,'2016','3.9.6.4.0.00.00','PARTICIPAÇÕES DE PARTES BENEFICIARIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3589,'2016','3.9.6.4.1.00.00','PARTICIPAÇÕES DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3590,'2016','3.9.6.5.0.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3591,'2016','3.9.6.5.1.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3592,'2016','3.9.7.0.0.00.00','VPD DE CONSTITUIÇÃO DE PROVISÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3593,'2016','3.9.7.1.0.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3594,'2016','3.9.7.1.1.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3595,'2016','3.9.7.2.0.00.00','VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3596,'2016','3.9.7.2.1.00.00','VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3597,'2016','3.9.7.3.0.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3598,'2016','3.9.7.3.1.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3599,'2016','3.9.7.4.0.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3600,'2016','3.9.7.4.1.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3601,'2016','3.9.7.5.0.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3602,'2016','3.9.7.5.5.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3603,'2016','3.9.7.6.0.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3604,'2016','3.9.7.6.1.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3605,'2016','3.9.7.9.0.00.00','VPD DE OUTRAS PROVISÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3606,'2016','3.9.7.9.1.00.00','VPD DE OUTRAS PROVISÕES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3607,'2016','3.9.9.0.0.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3608,'2016','3.9.9.1.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3609,'2016','3.9.9.1.2.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3610,'2016','3.9.9.1.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3611,'2016','3.9.9.1.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3612,'2016','3.9.9.1.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3613,'2016','3.9.9.2.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3614,'2016','3.9.9.2.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3615,'2016','3.9.9.2.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3616,'2016','3.9.9.2.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3617,'2016','3.9.9.3.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3618,'2016','3.9.9.3.1.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3619,'2016','3.9.9.4.0.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3620,'2016','3.9.9.4.1.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3621,'2016','3.9.9.4.2.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTRA OFSS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3622,'2016','3.9.9.4.3.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3623,'2016','3.9.9.4.4.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3624,'2016','3.9.9.4.5.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3625,'2016','3.9.9.5.0.00.00','MULTAS ADMINISTRATIVAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3626,'2016','3.9.9.5.1.00.00','MULTAS ADMINISTRATIVAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3627,'2016','3.9.9.6.0.00.00','INDENIZAÇÕES E RESTITUIÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3628,'2016','3.9.9.6.1.00.00','INDENIZAÇÕES E RESTITUIÇÕES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3629,'2016','3.9.9.7.0.00.00','COMPENSAÇÕES AO RGPS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3630,'2016','3.9.9.7.1.00.00','COMPENSAÇÕES AO RGPS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3631,'2016','3.9.9.7.3.00.00','COMPENSAÇÕES AO RGPS - INTER OFSS - UNIÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3632,'2016','3.9.9.9.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3633,'2016','3.9.9.9.1.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3634,'2016','3.9.9.9.1.01.00','PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3635,'2016','3.9.9.9.1.02.00','HONRA DE AVAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3636,'2016','4.0.0.0.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3637,'2016','4.1.0.0.0.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3638,'2016','4.1.1.0.0.00.00','IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3639,'2016','4.1.1.1.0.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3640,'2016','4.1.1.1.1.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3641,'2016','4.1.1.2.0.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3642,'2016','4.1.1.2.1.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3643,'2016','4.1.1.2.1.01.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3644,'2016','4.1.1.2.1.02.00','IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3645,'2016','4.1.1.2.1.03.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3646,'2016','4.1.1.2.1.03.01','IR - PESSOAS FISICAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3647,'2016','4.1.1.2.1.03.02','IR - PESSOAS JURIDICAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3648,'2016','4.1.1.2.1.04.00','ITBI','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3649,'2016','4.1.1.2.1.05.00','ITCMD','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3650,'2016','4.1.1.2.1.06.00','IPVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3651,'2016','4.1.1.2.1.97.00','(-) DEDUÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3652,'2016','4.1.1.3.0.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3653,'2016','4.1.1.3.1.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3654,'2016','4.1.1.3.1.01.00','ICMS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3655,'2016','4.1.1.3.1.02.00','ISS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3656,'2016','4.1.1.3.1.97.00','(-) DEDUÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3657,'2016','4.1.1.4.0.00.00','IMPOSTOS EXTRAORDINÁRIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3658,'2016','4.1.1.4.1.00.00','IMPOSTOS EXTRAORDINÁRIOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3659,'2016','4.1.1.9.0.00.00','OUTROS IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3660,'2016','4.1.1.9.1.00.00','OUTROS IMPOSTOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3661,'2016','4.1.2.0.0.00.00','TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3662,'2016','4.1.2.1.0.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3663,'2016','4.1.2.1.1.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3664,'2016','4.1.2.1.1.11.00','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3665,'2016','4.1.2.1.1.11.01','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA - SAÚDE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3666,'2016','4.1.2.1.1.11.02','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA - ANIMAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3667,'2016','4.1.2.1.1.14.00','TAXA DE CONTROLE E FISCALIZAÇÃO AMBIENTAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3668,'2016','4.1.2.1.1.15.00','TAXA DE SERVIÇOS ADMINISTRATIVO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3669,'2016','4.1.2.1.1.15.01','ATOS DA ADMINISTRAÇÃO EM GERAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3670,'2016','4.1.2.1.1.15.02','ATOS DA SAÚDE PÚBLICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3671,'2016','4.1.2.1.1.70.00','TAXA DE PREVENÇÃO CONTRA SINISTRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3672,'2016','4.1.2.1.1.71.00','TAXA DE FISCALIZAÇÃO SOBRE SERVIÇOS PÚBLICOS DE SANEAMENTO BÁSICO - AGESAN','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3673,'2016','4.1.2.1.1.72.00','TAXA DE REGULAÇÃO DE SERVIÇOS DE GÁS CANALIZADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3674,'2016','4.1.2.1.1.97.00','(-) DEDUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3675,'2016','4.1.2.1.1.97.11','(-) DEDUÇÃO TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3676,'2016','4.1.2.1.1.97.14','(-) DEDUÇÃO DA TAXA DE CONTROLE E FISCALIZAÇÃO AMBIENTAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3677,'2016','4.1.2.1.1.97.15','(-) DEDUÇÃO TAXA DE SERVIÇOS ADMINISTRATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3678,'2016','4.1.2.1.1.97.70','(-) DEDUÇÃO TAXA DE PREVENÇÃO CONTRA SINISTRO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3679,'2016','4.1.2.1.1.97.71','(-) DEDUÇÃO TAXA DE FISCALIZAÇÃO SOBRE SERVIÇOS PÚBLICOS DE SANEAMENTO BÁSICO - AGESAN','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3680,'2016','4.1.2.1.1.97.72','(-) DEDUÇÃO TAXA DE REGULAÇÃO DE SERVIÇOS DE GÁS CANALIZADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3681,'2016','4.1.2.1.1.97.98','(-) RENÚNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3682,'2016','4.1.2.2.0.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3683,'2016','4.1.2.2.1.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3684,'2016','4.1.2.2.1.07.00','EMOLUMENTOS E CUSTAS JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3685,'2016','4.1.2.2.1.09.00','EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRATIVAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3686,'2016','4.1.2.2.1.70.00','TAXA JUDICIÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3687,'2016','4.1.2.2.1.71.00','TAXA DE SEGURANÇA CONTRA INCÊNDIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3688,'2016','4.1.2.2.1.72.00','TAXA DE SEGURANÇA OSTENSIVA CONTRA DELITOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3689,'2016','4.1.2.2.1.73.00','TAXA DE SEGURANÇA PREVENTIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3690,'2016','4.1.2.2.1.74.00','TAXA DE APOSENTADOS E SERVENTUÁRIOS DA JUSTIÇA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3691,'2016','4.1.2.2.1.97.00','(-) DEDUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3692,'2016','4.1.2.2.1.97.07','(-) DEDUÇÃO EMOLUMENTOS E CUSTAS JUDICIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3693,'2016','4.1.2.2.1.97.09','(-) DEDUÇÃO EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRATIVAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3694,'2016','4.1.2.2.1.97.70','(-) DEDUÇÃO TAXA JUDICIÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3695,'2016','4.1.2.2.1.97.71','(-) DEDUÇÃO TAXA DE SEGURANÇA CONTRA INCÊNDIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3696,'2016','4.1.2.2.1.97.72','(-) DEDUÇÃO TAXA DE SEGURANÇA OSTENSIVA CONTRA DELITOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3697,'2016','4.1.2.2.1.97.73','(-) DEDUÇÃO TAXA DE SEGURANÇA PREVENTIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3698,'2016','4.1.2.2.1.97.74','(-) DEDUÇÃO TAXA DE APOSENTADOS E SERVENTUÁRIOS DA JUSTIÇA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3699,'2016','4.1.2.2.1.97.98','(-) RENÚNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3700,'2016','4.1.2.2.1.99.00','OUTRAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3701,'2016','4.1.3.0.0.00.00','CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3702,'2016','4.1.3.1.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3703,'2016','4.1.3.1.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3704,'2016','4.1.3.1.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3705,'2016','4.1.3.1.1.97.00','(-) DEDUÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3706,'2016','4.1.3.2.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3707,'2016','4.1.3.2.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3708,'2016','4.1.3.2.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3709,'2016','4.1.3.2.1.97.00','(-) DEDUÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3710,'2016','4.1.3.3.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3711,'2016','4.1.3.3.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3712,'2016','4.1.3.3.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3713,'2016','4.1.3.3.1.97.00','(-) DEDUÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3714,'2016','4.1.3.4.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3715,'2016','4.1.3.4.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3716,'2016','4.1.3.4.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3717,'2016','4.1.3.4.1.97.00','(-) DEDUÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3718,'2016','4.1.3.9.0.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3719,'2016','4.1.3.9.1.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3720,'2016','4.1.3.9.1.01.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3721,'2016','4.1.3.9.1.97.00','(-) DEDUÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3722,'2016','4.2.0.0.0.00.00','CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3723,'2016','4.2.1.0.0.00.00','CONTRIBUIÇÕES SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3724,'2016','4.2.1.1.0.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3725,'2016','4.2.1.1.1.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3726,'2016','4.2.1.1.1.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3727,'2016','4.2.1.1.1.01.01','CONTRIBUIÇÃO PATRONAL DE SERVIDOR ATIVO - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3728,'2016','4.2.1.1.1.01.02','CONTR.PATRONAL - PAGAMENTO DE SENTENCAS JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3729,'2016','4.2.1.1.1.02.00','CONTRIBUIÇÃO DO SEGURADO AO RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3730,'2016','4.2.1.1.1.02.01','CONTRIBUIÇÃO DO SERVIDOR - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3731,'2016','4.2.1.1.1.02.02','CONTRIBUIÇÃO DO APOSENTADO - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3732,'2016','4.2.1.1.1.02.03','CONTRIBUIÇÃO DE PENSIONISTA - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3733,'2016','4.2.1.1.1.02.04','CONTRIBUIÇÃO DO SERVIDOR -PAGTO SENT. JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3734,'2016','4.2.1.1.1.02.05','CONTRIBUIÇÃO DO APOSENTADO - PAGTO SENT. JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3735,'2016','4.2.1.1.1.02.06','CONTRIBUIÇÃO DO PENSIONISTA - PAGTO SENT. JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3736,'2016','4.2.1.1.1.03.00','CONTRIBUIÇÃO PREVIDENCIÁRIA PARA AMORTIZAÇÃO DO DÉFICIT ATUARIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3737,'2016','4.2.1.1.1.04.00','CONTRIBUIÇÕES PARA CUSTEIO DAS PENSÕES MILITARES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3738,'2016','4.2.1.1.1.97.00','(-) DEDUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3739,'2016','4.2.1.1.1.97.01','(-) RENÚNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3740,'2016','4.2.1.1.1.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3741,'2016','4.2.1.1.2.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3742,'2016','4.2.1.1.2.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3743,'2016','4.2.1.1.2.01.01','CONTRIBUIÇÃO PATRONAL DE SERVIDOR ATIVO - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3744,'2016','4.2.1.1.2.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3745,'2016','4.2.1.1.2.97.00','(-) DEDUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3746,'2016','4.2.1.1.2.97.01','(-) RENÚNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3747,'2016','4.2.1.1.2.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3748,'2016','4.2.1.1.3.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3749,'2016','4.2.1.1.3.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3750,'2016','4.2.1.1.3.01.01','CONTRIBUIÇÃO PATRONAL DE SERVIDOR ATIVO - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3751,'2016','4.2.1.1.3.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3752,'2016','4.2.1.1.3.97.00','(-) DEDUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3753,'2016','4.2.1.1.3.97.01','(-) RENÚNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3754,'2016','4.2.1.1.3.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3755,'2016','4.2.1.1.4.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3756,'2016','4.2.1.1.4.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3757,'2016','4.2.1.1.4.01.01','CONTRIBUIÇÃO PATRONAL DE SERVIDOR ATIVO - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3758,'2016','4.2.1.1.4.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3759,'2016','4.2.1.1.4.97.00','(-) DEDUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3760,'2016','4.2.1.1.4.97.01','(-) RENÚNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3761,'2016','4.2.1.1.4.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3762,'2016','4.2.1.1.5.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3763,'2016','4.2.1.1.5.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3764,'2016','4.2.1.1.5.01.01','CONTRIBUIÇÃO PATRONAL DE SERVIDOR ATIVO - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3765,'2016','4.2.1.1.5.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3766,'2016','4.2.1.1.5.97.00','(-) DEDUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3767,'2016','4.2.1.1.5.97.01','(-) RENÚNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3768,'2016','4.2.1.1.5.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3769,'2016','4.2.1.2.0.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3770,'2016','4.2.1.2.1.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3771,'2016','4.2.1.2.2.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3772,'2016','4.2.1.2.3.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3773,'2016','4.2.1.2.4.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3774,'2016','4.2.1.2.5.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3775,'2016','4.2.1.3.0.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3776,'2016','4.2.1.3.1.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3777,'2016','4.2.1.4.0.00.00','CONTRIBUIÇÃO SOBRE O LUCRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3778,'2016','4.2.1.4.1.00.00','CONTRIBUIÇÃO SOBRE O LUCRO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3779,'2016','4.2.1.5.0.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3780,'2016','4.2.1.5.1.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3781,'2016','4.2.1.6.0.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3782,'2016','4.2.1.6.1.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3783,'2016','4.2.1.9.0.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3784,'2016','4.2.1.9.1.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3785,'2016','4.2.2.0.0.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3786,'2016','4.2.2.0.1.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3787,'2016','4.2.3.0.0.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3788,'2016','4.2.3.0.1.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3789,'2016','4.2.3.0.1.01.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3790,'2016','4.2.4.0.0.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATÉGORIAS PROFISSIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3791,'2016','4.2.4.0.1.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3792,'2016','4.3.0.0.0.00.00','EXPLORAÇÃO E VENDA DE BENS, SERVIÇOS E DIREITOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3793,'2016','4.3.1.0.0.00.00','VENDA DE MERCADORIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3794,'2016','4.3.1.1.0.00.00','VENDA BRUTA DE MERCADORIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3795,'2016','4.3.1.1.1.00.00','VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3796,'2016','4.3.1.1.1.01.00','VENDA DE ESTOQUE PRÓPRIO - PAÍS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3797,'2016','4.3.1.1.1.11.00','VENDA DE ESTOQUE DE PRODUÇÃO VEGETAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3798,'2016','4.3.1.1.1.11.01','AGRICULTURA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3799,'2016','4.3.1.1.1.11.02','HORTA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3800,'2016','4.3.1.1.1.11.03','POMAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3801,'2016','4.3.1.1.1.11.99','OUTRAS VPAS DE PRODUÇÃO VEGETAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3802,'2016','4.3.1.1.1.12.00','VENDA DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3803,'2016','4.3.1.1.1.12.01','GRANJA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3804,'2016','4.3.1.1.1.12.02','PISCICULTURA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3805,'2016','4.3.1.1.1.12.03','PECUÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3806,'2016','4.3.1.1.1.12.04','APICULTURA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3807,'2016','4.3.1.1.1.12.05','SUINOCULTURA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3808,'2016','4.3.1.1.1.12.06','OVINOCULTURA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3809,'2016','4.3.1.1.1.12.07','COELHOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3810,'2016','4.3.1.1.1.12.08','GADO LEITEIRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3811,'2016','4.3.1.1.1.12.09','EQÜINOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3812,'2016','4.3.1.1.1.12.10','AVÍCOLA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3813,'2016','4.3.1.1.1.12.99','OUTRAS VPAS DE PRODUÇÃO ANIMAL E DERIVADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3814,'2016','4.3.1.1.1.13.00','VENDA DE MEDICAMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3815,'2016','4.3.1.1.1.14.00','VENDA DE LIVROS PERIOD. MAT. ESC. E PUBLICID.','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3816,'2016','4.3.1.1.1.14.01','VENDA DE LIVROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3817,'2016','4.3.1.1.1.14.02','PUBLICAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3818,'2016','4.3.1.1.1.14.03','VENDAS REVISTA RAC','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3819,'2016','4.3.1.1.1.14.04','PUBLICAÇÕES TÉCNICAS EPAGRI','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3820,'2016','4.3.1.1.1.14.05','DIVULGAÇÃO E PUBLICIDADE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3821,'2016','4.3.1.1.1.15.00','VENDA DE PRODUTOS AGROPECUÁRIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3822,'2016','4.3.1.1.1.15.99','OUTRAS VPAS AGROPECUÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3823,'2016','4.3.1.1.1.16.00','VENDA DE FARDAMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3824,'2016','4.3.1.9.0.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3825,'2016','4.3.1.9.1.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3826,'2016','4.3.1.9.1.97.00','(-) DEDUÇÕES DE VENDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3827,'2016','4.3.1.9.1.97.01','(-) VENDAS CANCELADAS E DEVOLUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3828,'2016','4.3.1.9.1.97.02','(-) ABATIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3829,'2016','4.3.1.9.1.97.03','(-) DESCONTOS INCONDICIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3830,'2016','4.3.1.9.1.97.05','(-) ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3831,'2016','4.3.1.9.1.97.06','(-) PIS/PASEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3832,'2016','4.3.1.9.1.97.07','(-) COFINS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3833,'2016','4.3.1.9.1.97.08','(-)AJUSTE A VALOR PRESENTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3834,'2016','4.3.1.9.1.99.00','(-) OUTRAS DEDUÇÕES DE VENDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3835,'2016','4.3.2.0.0.00.00','VENDA DE PRODUTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3836,'2016','4.3.2.1.0.00.00','VENDA BRUTA DE PRODUTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3837,'2016','4.3.2.1.1.00.00','VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3838,'2016','4.3.2.9.0.00.00','(-) DEDUÇÕES DE VENDA BRUTA DE PRODUTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3839,'2016','4.3.2.9.1.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3840,'2016','4.3.2.9.1.97.00','(-) DEDUÇÕES DE VENDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3841,'2016','4.3.2.9.1.97.01','(-) VENDAS CANCELADAS E DEVOLUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3842,'2016','4.3.2.9.1.97.02','(-) ABATIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3843,'2016','4.3.2.9.1.97.03','(-) DESCONTOS INCONDICIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3844,'2016','4.3.2.9.1.97.04','(-)IPI','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3845,'2016','4.3.2.9.1.97.05','(-) ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3846,'2016','4.3.2.9.1.97.06','(-) PIS/PASEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3847,'2016','4.3.2.9.1.97.07','(-) COFINS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3848,'2016','4.3.2.9.1.97.08','(-)AJUSTE A VALOR PRESENTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3849,'2016','4.3.2.9.1.99.00','(-) OUTRAS DEDUÇÕES DE VENDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3850,'2016','4.3.3.0.0.00.00','EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3851,'2016','4.3.3.1.0.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3852,'2016','4.3.3.1.1.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3853,'2016','4.3.3.1.1.01.00','PRESTAÇÃO DE SERVICOS DE TREINAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3854,'2016','4.3.3.1.1.02.00','EXPLORAÇÃO DO PATRIMONIO IMOBILIARIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3855,'2016','4.3.3.1.1.03.00','PRESTAÇÃO DE SERVICOS DE LOCAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3856,'2016','4.3.3.1.1.04.00','PRESTAÇÃO DE SERVICOS DE PESQUISAS E ANALISES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3857,'2016','4.3.3.1.1.05.00','SERVICOS DE ESTUDOS E PESQUISAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3858,'2016','4.3.3.1.1.06.00','PRESTAÇÃO DE SERVICOS DE CONSULTORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3859,'2016','4.3.3.1.1.07.00','SERVICOS CONSULT.ASSIST.TEC. ANALISE PROJETOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3860,'2016','4.3.3.1.1.08.00','PRESTAÇÃO DE SERVICOS RELACIONADOS A T.I','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3861,'2016','4.3.3.1.1.09.00','PRESTAÇÃO DE SERVICOS DE ADM. DE REDE DE COMUNIC. DE DADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3862,'2016','4.3.3.1.1.10.00','SERVICOS DE PROCESSAMENTO DE DADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3863,'2016','4.3.3.1.1.11.00','SERVICO DE INFORMAÇÕES CIENTIFICAS E TECNOLOGICAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3864,'2016','4.3.3.1.1.12.00','PRESTAÇÃO DE SERVICOS CIENTIFICOS E TECNOLOGICOS NUCLEARES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3865,'2016','4.3.3.1.1.13.00','SERVICOS DE TECNOLOGIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3866,'2016','4.3.3.1.1.14.00','SERVICOS DE COMUNICAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3867,'2016','4.3.3.1.1.15.00','PRESTAÇÃO DE SERVICOS RELACIONADOS A ARMAZENAGEM','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3868,'2016','4.3.3.1.1.16.00','PRESTAÇÃO DE SERVICOS COMPLEMENTARES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3869,'2016','4.3.3.1.1.17.00','PRESTAÇÃO DE SERVICOS RELACIONADOS AO BENEFICIAMENTO DE GRAOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3870,'2016','4.3.3.1.1.18.00','PRESTAÇÃO DE SERVICOS RECEPÇÃO E EMBARQUE DE PRODUTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3871,'2016','4.3.3.1.1.19.00','PRESTAÇÃO DE SERVICOS SERVICO DE TRANSBORDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3872,'2016','4.3.3.1.1.20.00','FORNECIMENTO DE MAO-DE-OBRA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3873,'2016','4.3.3.1.1.21.00','PRESTAÇÃO DE SERVICOS DE DISTRIB. DE GENEROS ALIMENTICIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3874,'2016','4.3.3.1.1.22.00','SERVICOS DE HOSPEDAGEM E ALIMENTAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3875,'2016','4.3.3.1.1.23.00','CONCESSAO E PERMISSAO - SERV. DE TRANSPORT','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3876,'2016','4.3.3.1.1.24.00','OUTORGA SERV. EXPL. PROD PETR. GAS NATURAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3877,'2016','4.3.3.1.1.25.00','OUTORGA DE DIREITOS DE USO DE REC. HIDR.','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3878,'2016','4.3.3.1.1.26.00','OUTORGA DIREITOS DE EXPL. E PESQ. MINER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3879,'2016','4.3.3.1.1.27.00','CONCESSAO FLORESTAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3880,'2016','4.3.3.1.1.28.00','CONCESSAO E PERMISSAO. - DIR. USO DE BENS PUB','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3881,'2016','4.3.3.1.1.29.00','COMPENSAÇÕES FINANCEIRAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3882,'2016','4.3.3.1.1.30.00','SERVICOS DE TRANSPORTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3883,'2016','4.3.3.1.1.31.00','SERVICOS PORTUARIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3884,'2016','4.3.3.1.1.32.00','SERVICOS DE SOCORRO MARITIMO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3885,'2016','4.3.3.1.1.33.00','SERVICOS DE SAUDE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3886,'2016','4.3.3.1.1.34.00','CERTIFICAÇÃO E HOMOLOGAÇÃO DE PROD. TELECOM.','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3887,'2016','4.3.3.1.1.35.00','SERVICOS DE METROLOGIA E CERTIFICAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3888,'2016','4.3.3.1.1.36.00','SERVICOS DE INSPEÇÃO E FISCALIZAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3889,'2016','4.3.3.1.1.37.00','SERVICOS ADMINISTRATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3890,'2016','4.3.3.1.1.38.00','SERVICOS DE METEOROLOGIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3891,'2016','4.3.3.1.1.39.00','SERVICOS EDUCACIONAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3892,'2016','4.3.3.1.1.40.00','SERVICOS AGROPECUARIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3893,'2016','4.3.3.1.1.41.00','SERVICOS DE REPARAÇÃO,MANUTENÇÃO E INSTALAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3894,'2016','4.3.3.1.1.42.00','SERVICOS RECREATIVOS E CULTURAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3895,'2016','4.3.3.1.1.43.00','SERVICOS REG. MARCAS,PAT.TRANSF.DE TECNOLOGIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3896,'2016','4.3.3.1.1.44.00','SERVICOS DE REGISTRO DO COMERCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3897,'2016','4.3.3.1.1.45.00','SERVICOS DE FORNECIMENTO DE AGUA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3898,'2016','4.3.3.1.1.46.00','SERVICOS DE PERFURAÇÃO E INSTALAÇÃO DE POCOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3899,'2016','4.3.3.1.1.47.00','SERVICOS DE GEOPROCESSAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3900,'2016','4.3.3.1.1.48.00','SERVICOS DE CADASTRAMENTO DE FORNECEDORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3901,'2016','4.3.3.1.1.49.00','TARIFA DE UTILIZAÇÃO DE FAROIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3902,'2016','4.3.3.1.1.50.00','TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3903,'2016','4.3.3.1.1.51.00','SERVICOS DE CADASTRO DA ATIVIDADE MINERAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3904,'2016','4.3.3.1.1.52.00','TAR.INSCR.CONCURSOS E PROCESSOS SELETIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3905,'2016','4.3.3.1.1.53.00','SERVICO DE COMPENSAÇÃO DE VARIAÇÕES SALARIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3906,'2016','4.3.3.1.1.54.00','GARANTIAS E AVAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3907,'2016','4.3.3.1.1.55.00','CREDENCIAMENTO EMP.PREST.SERVICOS DE VISTORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3908,'2016','4.3.3.1.1.56.00','SERVICOS VETERINARIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3909,'2016','4.3.3.1.1.57.00','CERTIFICAÇÃO E HOMOLOGAÇÃO ATIVIDADE MINERAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3910,'2016','4.3.3.1.1.58.00','SERV.INOV.A.PESQ.AMBIENT.PROD.-INST.CIEN.TEC.','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3911,'2016','4.3.3.1.1.59.00','SERVICOS FINANCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3912,'2016','4.3.3.1.1.60.00','SERV.COMERCIAIS DE PROD.DADOS E MAT.INFORMATI','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3913,'2016','4.3.3.1.1.61.00','SERVIÇOS DE TURISMO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3914,'2016','4.3.3.1.1.98.00','SERVIÇOS ADMINISTRATIVOS - RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3915,'2016','4.3.3.1.1.99.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTAÇÃO DE SERVICOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3916,'2016','4.3.3.9.0.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3917,'2016','4.3.3.9.1.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3918,'2016','4.3.3.9.1.01.00','(-) VENDAS CANCELADAS E DEVOLUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3919,'2016','4.3.3.9.1.02.00','(-) ABATIMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3920,'2016','4.3.3.9.1.03.00','(-) DESCONTOS INCONDICIONAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3921,'2016','4.3.3.9.1.05.00','(-) ISS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3922,'2016','4.3.3.9.1.06.00','(-) ICMS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3923,'2016','4.3.3.9.1.07.00','(-) PIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3924,'2016','4.3.3.9.1.08.00','(-) PASEP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3925,'2016','4.3.3.9.1.09.00','(-) COFINS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3926,'2016','4.3.3.9.1.10.00','(-) CONTRIBUIÇÕES PREVIDENCIARIAS - INSS PATRONAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3927,'2016','4.3.3.9.1.99.00','(-) OUTRAS DEDUÇÕES DE VENDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3928,'2016','4.4.0.0.0.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS FINANCEIRAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3929,'2016','4.4.1.0.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3930,'2016','4.4.1.1.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3931,'2016','4.4.1.1.1.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3932,'2016','4.4.1.1.3.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3933,'2016','4.4.1.1.4.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS -ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3934,'2016','4.4.1.1.5.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3935,'2016','4.4.1.2.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3936,'2016','4.4.1.2.1.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3937,'2016','4.4.1.3.0.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3938,'2016','4.4.1.3.1.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3939,'2016','4.4.1.3.3.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3940,'2016','4.4.1.3.4.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3941,'2016','4.4.1.3.5.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3942,'2016','4.4.1.4.0.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3943,'2016','4.4.1.4.1.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3944,'2016','4.4.2.0.0.00.00','JUROS E ENCARGOS DE MORA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3945,'2016','4.4.2.1.0.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3946,'2016','4.4.2.1.1.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3947,'2016','4.4.2.1.3.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3948,'2016','4.4.2.1.4.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3949,'2016','4.4.2.1.5.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3950,'2016','4.4.2.2.0.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3951,'2016','4.4.2.2.1.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3952,'2016','4.4.2.3.0.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3953,'2016','4.4.2.3.1.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3954,'2016','4.4.2.4.0.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3955,'2016','4.4.2.4.1.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3956,'2016','4.4.2.4.1.01.00','MULTAS E JUROS SOBRE IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3957,'2016','4.4.2.4.1.02.00','MULTAS E JUROS SOBRE IPVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3958,'2016','4.4.2.4.1.03.00','MULTAS E JUROS SOBRE ITCMD','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3959,'2016','4.4.2.4.1.04.00','MULTAS E JUROS SOBRE ICMS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3960,'2016','4.4.2.4.1.05.00','MULTAS E JUROS SOBRE IPTU','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3961,'2016','4.4.2.4.1.06.00','MULTAS E JUROS SOBRE ITBI','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3962,'2016','4.4.2.4.1.07.00','MULTAS E JUROS SOBRE ISS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3963,'2016','4.4.2.4.1.08.00','MULTAS E JUROS SOBRE ITR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3964,'2016','4.4.2.4.1.09.00','MULTAS E JUROS SOBRE TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3965,'2016','4.4.2.4.1.10.00','MULTAS E JUROS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3966,'2016','4.4.2.4.1.11.00','MULTAS E JUROS CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3967,'2016','4.4.2.4.1.12.00','MULTAS E JUROS CONTRIBUIÇÕES DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3968,'2016','4.4.2.4.1.13.00','MULTAS E JUROS DEMAIS CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3969,'2016','4.4.2.4.1.14.00','MULTAS E JUROS CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3970,'2016','4.4.2.4.1.15.00','MULTAS E JUROS CRÉDITOS TRIBUTARIOS PARCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3971,'2016','4.4.2.4.1.16.00','MULTAS E JUROS DE DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3972,'2016','4.4.2.4.1.97.00','(-) DEDUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3973,'2016','4.4.2.4.1.99.00','JUROS E ENCARGOS DE MORA SOBRE OUTROS CRÉDITOS TRIBUTÁRIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3974,'2016','4.4.2.9.0.00.00','OUTROS JUROS E ENCARGOS DE MORA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3975,'2016','4.4.2.9.1.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3976,'2016','4.4.3.0.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3977,'2016','4.4.3.1.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3978,'2016','4.4.3.1.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3979,'2016','4.4.3.1.3.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3980,'2016','4.4.3.1.4.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3981,'2016','4.4.3.1.5.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3982,'2016','4.4.3.2.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3983,'2016','4.4.3.2.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3984,'2016','4.4.3.3.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3985,'2016','4.4.3.3.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3986,'2016','4.4.3.3.3.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3987,'2016','4.4.3.3.4.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3988,'2016','4.4.3.3.5.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3989,'2016','4.4.3.4.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3990,'2016','4.4.3.4.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3991,'2016','4.4.3.9.0.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3992,'2016','4.4.3.9.1.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3993,'2016','4.4.3.9.3.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3994,'2016','4.4.3.9.4.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3995,'2016','4.4.3.9.5.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3996,'2016','4.4.4.0.0.00.00','DESCONTOS FINANCEIROS OBTIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3997,'2016','4.4.4.0.1.00.00','DESCONTOS FINANCEIROS OBTIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3998,'2016','4.4.5.0.0.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS E APLICAÇÕES FINANCEIRAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (3999,'2016','4.4.5.1.0.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4000,'2016','4.4.5.1.1.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4001,'2016','4.4.5.2.0.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4002,'2016','4.4.5.2.1.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4003,'2016','4.4.8.0.0.00.00','APORTES DO BANCO CENTRAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4004,'2016','4.4.8.1.0.00.00','RESULTADO POSITIVO DO BANCO CENTRAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4005,'2016','4.4.8.1.1.00.00','RESULTADO POSITIVO DO BANCO CENTRAL - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4006,'2016','4.4.9.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4007,'2016','4.4.9.0.1.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4008,'2016','4.5.0.0.0.00.00','TRANSFERÊNCIAS E DELEGAÇÕES RECEBIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4009,'2016','4.5.1.0.0.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4010,'2016','4.5.1.1.0.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4011,'2016','4.5.1.1.2.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4012,'2016','4.5.1.1.2.01.00','COTA RECEBIDA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4013,'2016','4.5.1.1.2.02.00','REPASSE RECEBIDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4014,'2016','4.5.1.1.2.03.00','SUB-REPASSE RECEBIDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4015,'2016','4.5.1.1.2.04.00','RECURSOS ARRECADADOS - RECEBIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4016,'2016','4.5.1.1.2.05.00','VALORES DIFERIDOS - BAIXA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4017,'2016','4.5.1.1.2.08.00','VALORES DIFERIDOS - INSCRIÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4018,'2016','4.5.1.1.2.09.00','DEVOLUÇÃO DE TRANSFERÊNCIAS CONCEDIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4019,'2016','4.5.1.2.0.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4020,'2016','4.5.1.2.2.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4021,'2016','4.5.1.2.2.01.00','TRANSFERÊNCIAS FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4022,'2016','4.5.1.2.2.01.01','ORDEM DE TRANSFERÊNCIAS RECEBIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4023,'2016','4.5.1.2.2.01.02','MOVIMENTO DE FUNDOS A DÉBITO - CORRESPONDÊNCIA DE DÉBITO - SALDOS NAO FINANCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4024,'2016','4.5.1.2.2.01.03','MOVIMENTO DE FUNDOS A DÉBITO - CORRESPONDÊNCIA DE DÉBITOS - SALDOS FINANCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4025,'2016','4.5.1.2.2.01.99','OUTRAS TRANSFERÊNCIAS FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4026,'2016','4.5.1.2.2.02.00','TRANSFERÊNCIAS  NÃO FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4027,'2016','4.5.1.2.2.02.01','TRANSFERÊNCIAS RECEBIDAS DE BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4028,'2016','4.5.1.2.2.02.02','DOAÇÕES RECEBIDAS DE BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4029,'2016','4.5.1.2.2.02.03','TRANFERÊNCIAS RECEBIDAS DE BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4030,'2016','4.5.1.2.2.02.04','DOAÇÕES RECEBIDAS DE BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4031,'2016','4.5.1.2.2.02.05','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS E VALORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4032,'2016','4.5.1.2.2.02.06','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS DA DÍVIDA ATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4033,'2016','4.5.1.2.2.02.99','OUTRAS TRANSFERÊNCIAS  NÃO FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4034,'2016','4.5.1.2.2.09.00','DEVOLUÇÃO DE TRANSFERÊNCIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4035,'2016','4.5.1.3.0.00.00','TRANSFERENCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4036,'2016','4.5.1.3.2.00.00','TRANSFERENCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RPPS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4037,'2016','4.5.1.3.2.01.00','PLANO FINANCEIRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4038,'2016','4.5.1.3.2.01.01','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4039,'2016','4.5.1.3.2.01.02','RECURSOS PARA FORMAÇÃO DE RESERVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4040,'2016','4.5.1.3.2.01.99','OUTROS APORTES PARA O RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4041,'2016','4.5.1.3.2.02.00','PLANO PREVIDENCIÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4042,'2016','4.5.1.3.2.02.01','RECURSOS PARA COBERTURA DE DÉFICIT FINANCEIRO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4043,'2016','4.5.1.3.2.02.02','RECURSOS PARA COBERTURA DE DÉFICIT ATUARIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4044,'2016','4.5.1.3.2.02.03','TRANSFERÊNCIA DE BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4045,'2016','4.5.1.3.2.02.04','TRANFERÊNCIAS DE BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4046,'2016','4.5.1.3.2.02.99','OUTROS APORTES PARA O RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4047,'2016','4.5.1.4.0.00.00','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RGPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4048,'2016','4.5.1.4.2.00.00','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RGPS  - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4049,'2016','4.5.1.4.2.01.00','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4050,'2016','4.5.1.4.2.01.01','PROVENIENTES DO ORÇAMENTO DA SEGURIDADE SOCIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4051,'2016','4.5.1.4.2.01.02','PROVENIENTES DO ORÇAMENTO FISCAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4052,'2016','4.5.1.4.2.02.00','RECURSOS PARA FORMAÇÃO DE RESERVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4053,'2016','4.5.1.4.2.99.00','OUTROS APORTES PARA O RGPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4054,'2016','4.5.2.0.0.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4055,'2016','4.5.2.1.0.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4056,'2016','4.5.2.1.1.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS  DE RECEITAS- CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4057,'2016','4.5.2.1.3.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4058,'2016','4.5.2.1.3.01.00','COTA-PARTE FPE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4059,'2016','4.5.2.1.3.02.00','COTA-PARTE FPM','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4060,'2016','4.5.2.1.3.03.00','COTA-PARTE ITR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4061,'2016','4.5.2.1.3.04.00','COTA-PARTE IPI','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4062,'2016','4.5.2.1.3.05.00','COTA-PARTE IMPOSTO SOBRE OPERAÇÕES DE CRÉDITO, CAMBIO E SEGURO, OU RELATIVA A TITULOS OU VALORES MOBILIARIOS - COMERCIALIZAÇÃO DO OURO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4063,'2016','4.5.2.1.3.06.00','TRANSFERENCIA DA COMPENSAÇÃO FINANCEIRA PELA EXPLORAÇÃO DE RECURSOS NATURAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4064,'2016','4.5.2.1.3.07.00','TRANSFERÊNCIAS DE RECURSOS DO SUS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4065,'2016','4.5.2.1.3.08.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDO NACIONAL DE ASSITENCIA SOCIAL - FNAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4066,'2016','4.5.2.1.3.09.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDO NACIONAL DO DESENVOLVIMENTO DA EDUCAÇÃO - FNDE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4067,'2016','4.5.2.1.3.10.00','TRANSFERENCIA FINANCEIRA DO ICMS DESONERAÇÃO - LC 87/96 (LEI KANDIR)','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4068,'2016','4.5.2.1.3.99.00','OUTRAS PARTICIPAÇÕES NA RECEITA DA UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4069,'2016','4.5.2.1.4.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4070,'2016','4.5.2.1.4.01.00','COTA-PARTE ICMS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4071,'2016','4.5.2.1.4.02.00','COTA-PARTE IPVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4072,'2016','4.5.2.1.4.03.00','COTA-PARTE IPI-EXPORTAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4073,'2016','4.5.2.1.4.04.00','COTA-PARTE DA CONTRIBUIÇÃO DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4074,'2016','4.5.2.1.4.05.00','TRANSFERÊNCIA DA  COMPENSAÇÃO FINANCEIRA PELA EXPLORAÇÃO DE RECURSOS NATURAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4075,'2016','4.5.2.1.4.06.00','TRANSFERÊNCIA DE RECURSOS DO ESTADO PARA PROGRAMAS DE SAÚDE - REPASSE FUNDO A FUNDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4076,'2016','4.5.2.1.4.99.00','OUTRAS PARTICIPAÇÕES NA RECEITA DOS ESTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4077,'2016','4.5.2.2.0.00.00','TRANSFERÊNCIAS DO FUNDEB','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4078,'2016','4.5.2.2.3.00.00','TRANSFERÊNCIAS DO FUNDEB - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4079,'2016','4.5.2.2.4.00.00','TRANSFERÊNCIAS DO FUNDEB - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4080,'2016','4.5.2.3.0.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4081,'2016','4.5.2.3.1.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4082,'2016','4.5.2.3.3.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4083,'2016','4.5.2.3.3.01.00','CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4084,'2016','4.5.2.3.3.02.00','AUXÍLIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4085,'2016','4.5.2.3.3.03.00','SUBVENÇÕES SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4086,'2016','4.5.2.3.3.04.00','SUBVENÇÕES ECONÔMICAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4087,'2016','4.5.2.3.3.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4088,'2016','4.5.2.3.4.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4089,'2016','4.5.2.3.4.01.00','CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4090,'2016','4.5.2.3.4.02.00','AUXÍLIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4091,'2016','4.5.2.3.4.03.00','SUBVENÇÕES SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4092,'2016','4.5.2.3.4.04.00','SUBVENÇÕES ECONÔMICAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4093,'2016','4.5.2.3.4.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4094,'2016','4.5.2.3.5.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4095,'2016','4.5.2.3.5.01.00','CONTRIBUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4096,'2016','4.5.2.3.5.02.00','AUXÍLIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4097,'2016','4.5.2.3.5.03.00','SUBVENÇÕES SOCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4098,'2016','4.5.2.3.5.04.00','SUBVENÇÕES ECONÔMICAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4099,'2016','4.5.2.3.5.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4100,'2016','4.5.2.4.0.00.00','OUTRAS TRANSFERÊNCIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4101,'2016','4.5.2.4.1.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4102,'2016','4.5.2.4.3.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4103,'2016','4.5.2.4.4.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4104,'2016','4.5.2.4.5.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4105,'2016','4.5.3.0.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4106,'2016','4.5.3.1.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4107,'2016','4.5.3.1.1.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4108,'2016','4.5.3.1.1.01.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA CONVÊNIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4109,'2016','4.5.3.1.1.02.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA COMBATE A FOME','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4110,'2016','4.5.3.1.1.99.00','OUTRAS TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4111,'2016','4.5.3.2.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4112,'2016','4.5.3.2.1.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4113,'2016','4.5.3.2.1.01.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA CONVÊNIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4114,'2016','4.5.3.2.1.02.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA COMBATE A FOME','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4115,'2016','4.5.3.2.1.99.00','OUTRAS TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4116,'2016','4.5.4.0.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4117,'2016','4.5.4.0.1.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4118,'2016','4.5.4.0.1.01.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDEB','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4119,'2016','4.5.4.0.1.02.00','TRANSFERÊNCIAS DE RECURSOS DA COMPLEMENTAÇÃO DO FUNDEB','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4120,'2016','4.5.4.0.1.99.00','OUTRAS TRANSFERÊNCIAS MULTIGOVERNAMENTAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4121,'2016','4.5.5.0.0.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4122,'2016','4.5.5.0.1.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4123,'2016','4.5.6.0.0.00.00','TRANSFERÊNCIAS DO EXTERIOR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4124,'2016','4.5.6.0.1.00.00','TRANSFERÊNCIAS DO EXTERIOR - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4125,'2016','4.5.7.0.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4126,'2016','4.5.7.1.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4127,'2016','4.5.7.1.3.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4128,'2016','4.5.7.1.3.01.00','DIÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4129,'2016','4.5.7.1.3.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4130,'2016','4.5.7.1.3.03.00','MATERIAL DE CONSUMO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4131,'2016','4.5.7.1.3.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4132,'2016','4.5.7.1.3.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4133,'2016','4.5.7.1.3.06.00','INDENIZAÇÕES E RESTITUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4134,'2016','4.5.7.1.3.99.00','DEMAIS VPAS COM DELEGAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4135,'2016','4.5.7.1.4.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4136,'2016','4.5.7.1.4.01.00','DIÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4137,'2016','4.5.7.1.4.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4138,'2016','4.5.7.1.4.03.00','MATERIAL DE CONSUMO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4139,'2016','4.5.7.1.4.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4140,'2016','4.5.7.1.4.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4141,'2016','4.5.7.1.4.06.00','INDENIZAÇÕES E RESTITUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4142,'2016','4.5.7.1.4.99.00','DEMAIS VPAS COM DELEGAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4143,'2016','4.5.7.1.5.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4144,'2016','4.5.7.1.5.01.00','DIÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4145,'2016','4.5.7.1.5.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4146,'2016','4.5.7.1.5.03.00','MATERIAL DE CONSUMO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4147,'2016','4.5.7.1.5.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4148,'2016','4.5.7.1.5.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4149,'2016','4.5.7.1.5.06.00','INDENIZAÇÕES E RESTITUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4150,'2016','4.5.7.1.5.99.00','DEMAIS VPAS COM DELEGAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4151,'2016','4.5.7.2.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4152,'2016','4.5.7.2.1.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4153,'2016','4.5.7.2.1.01.00','DIÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4154,'2016','4.5.7.2.1.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4155,'2016','4.5.7.2.1.03.00','MATERIAL DE CONSUMO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4156,'2016','4.5.7.2.1.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4157,'2016','4.5.7.2.1.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4158,'2016','4.5.7.2.1.06.00','INDENIZAÇÕES E RESTITUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4159,'2016','4.5.7.2.1.99.00','DEMAIS VPAS COM DELEGAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4160,'2016','4.5.8.0.0.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4161,'2016','4.5.8.0.1.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4162,'2016','4.5.9.0.0.00.00','OUTRAS TRANSFERÊNCIAS E DELEGAÇÕES RECEBIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4163,'2016','4.5.9.0.1.00.00','OUTRAS TRANSFERÊNCIAS E DELEGAÇÕES RECEBIDAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4164,'2016','4.5.9.0.1.01.00','DOAÇÕES RECEBIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4165,'2016','4.6.0.0.0.00.00','VALORIZAÇÃO E GANHOS COM ATIVOS E DESINCORPORAÇÃO DE PASSIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4166,'2016','4.6.1.0.0.00.00','REAVALIAÇÃO DE ATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4167,'2016','4.6.1.1.0.00.00','REAVALIAÇÃO DE IMOBILIZADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4168,'2016','4.6.1.1.1.00.00','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4169,'2016','4.6.1.1.1.01.00','REAVALIAÇÃO DE BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4170,'2016','4.6.1.1.1.01.01','REAVALIAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4171,'2016','4.6.1.1.1.01.02','REAVALIAÇÃO DE BENS DE INFORMÁTICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4172,'2016','4.6.1.1.1.01.03','REAVALIAÇÃO DE MÓVEIS E UTENSÍLIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4173,'2016','4.6.1.1.1.01.04','REAVALIAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4174,'2016','4.6.1.1.1.01.05','REAVALIAÇÃO DE VEÍCULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4175,'2016','4.6.1.1.1.01.06','REAVALIAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4176,'2016','4.6.1.1.1.01.07','REAVALIAÇÃO DE BENS MÓVEIS EM ANDAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4177,'2016','4.6.1.1.1.01.08','REAVALIAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4178,'2016','4.6.1.1.1.01.09','REAVALIAÇÃO DE ARMAMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4179,'2016','4.6.1.1.1.01.10','REAVALIAÇÃO DE SEMOVENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4180,'2016','4.6.1.1.1.01.99','REAVALIAÇÃO DE DEMAIS BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4181,'2016','4.6.1.1.1.02.00','REAVALIAÇÃO DE BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4182,'2016','4.6.1.1.1.02.01','REAVALIAÇÃO DE BENS DE USO ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4183,'2016','4.6.1.1.1.02.02','REAVALIAÇÃO DE BENS DOMINICAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4184,'2016','4.6.1.1.1.02.03','REAVALIAÇÃO DE BENS DE USO COMUM DO POVO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4185,'2016','4.6.1.1.1.02.04','REAVALIAÇÃO DE BENS IMÓVEIS EM ANDAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4186,'2016','4.6.1.1.1.02.05','REAVALIAÇÃO DE INSTALAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4187,'2016','4.6.1.1.1.02.06','REAVALIAÇÃO DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4188,'2016','4.6.1.1.1.02.99','REAVALIAÇÃO DE DEMAIS BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4189,'2016','4.6.1.2.0.00.00','REAVALIAÇÃO DE INTANGÍVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4190,'2016','4.6.1.2.1.00.00','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4191,'2016','4.6.1.9.0.00.00','REAVALIAÇÃO DE OUTROS ATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4192,'2016','4.6.1.9.1.00.00','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4193,'2016','4.6.2.0.0.00.00','GANHOS COM ALIENAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4194,'2016','4.6.2.1.0.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4195,'2016','4.6.2.1.1.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4196,'2016','4.6.2.1.1.01.00','GANHOS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4197,'2016','4.6.2.1.1.02.00','GANHOS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4198,'2016','4.6.2.1.1.03.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4199,'2016','4.6.2.1.1.99.00','GANHOS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4200,'2016','4.6.2.2.0.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4201,'2016','4.6.2.2.1.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4202,'2016','4.6.2.2.1.01.00','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4203,'2016','4.6.2.2.1.01.01','GANHO LÍQUIDO COM A ALIENAÇÃO DE  MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4204,'2016','4.6.2.2.1.01.02','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS DE INFORMÁTICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4205,'2016','4.6.2.2.1.01.03','GANHO LÍQUIDO COM A ALIENAÇÃO DE  MÓVEIS E UTENSÍLIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4206,'2016','4.6.2.2.1.01.04','GANHO LÍQUIDO COM A ALIENAÇÃO DE  MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4207,'2016','4.6.2.2.1.01.05','GANHO LÍQUIDO COM A ALIENAÇÃO DE  VEÍCULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4208,'2016','4.6.2.2.1.01.07','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS EM ANDAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4209,'2016','4.6.2.2.1.01.08','GANHO LÍQUIDO COM A ALIENAÇÃO DE  BENS MÓVEIS EM ALMOXARIFADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4210,'2016','4.6.2.2.1.01.09','GANHO LÍQUIDO COM A ALIENAÇÃO DE ARMAMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4211,'2016','4.6.2.2.1.01.10','GANHO LÍQUIDO COM A ALIENAÇÃO DE  SEMOVENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4212,'2016','4.6.2.2.1.01.99','GANHO LÍQUIDO COM A ALIENAÇÃO DE DEMAIS BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4213,'2016','4.6.2.2.1.02.00','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4214,'2016','4.6.2.2.1.02.01','PRODUTO DE ALIENAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4215,'2016','4.6.2.2.1.02.02','ALIENAÇÃO DE IMÓVEIS RURAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4216,'2016','4.6.2.2.1.02.03','ALIENAÇÃO DE IMÓVEIS URBANOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4217,'2016','4.6.2.2.1.02.99','ALIENAÇÃO DE OUTROS BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4218,'2016','4.6.2.2.1.97.00','(-) DEDUÇÃO DOS GANHOS COM ALIENAÇÃO DE IMOBILIZADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4219,'2016','4.6.2.2.1.97.01','(-) DEDUÇÃO ALIENAÇÃO DE BENS MÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4220,'2016','4.6.2.2.1.97.02','(-) DEDUÇÃO ALIENAÇÃO DE BENS IMÓVEIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4221,'2016','4.6.2.3.0.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4222,'2016','4.6.2.3.1.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4223,'2016','4.6.2.3.1.01.00','GANHOS COM ALIENAÇÃO DE SOFTWARES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4224,'2016','4.6.2.3.1.02.00','GANHOS COM ALIENAÇÃO DE MARCAS, DIREITOS E PATENTES INDUSTRIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4225,'2016','4.6.2.3.1.03.00','GANHOS COM ALIENAÇÃO DE DIREITO DE USO DE IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4226,'2016','4.6.2.9.0.00.00','GANHOS COM ALIENAÇÃO DE DEMAIS ATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4227,'2016','4.6.2.9.1.00.00','GANHOS COM ALIENAÇÃO DE DEMAIS ATIVOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4228,'2016','4.6.3.0.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4229,'2016','4.6.3.1.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4230,'2016','4.6.3.1.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4231,'2016','4.6.3.2.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4232,'2016','4.6.3.2.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4233,'2016','4.6.3.3.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS APREENDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4234,'2016','4.6.3.3.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS APREENDIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4235,'2016','4.6.3.4.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR PRODUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4236,'2016','4.6.3.4.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR PRODUÇÃO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4237,'2016','4.6.3.9.0.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4238,'2016','4.6.3.9.1.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4239,'2016','4.6.4.0.0.00.00','GANHOS COM DESINCORPORAÇÃO DE PASSIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4240,'2016','4.6.4.0.1.00.00','GANHOS COM DESINCORPORAÇÃO DE PASSIVOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4241,'2016','4.6.5.0.0.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4242,'2016','4.6.5.4.0.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4243,'2016','4.6.5.4.1.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4244,'2016','4.6.5.4.1.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4245,'2016','4.6.5.4.1.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4246,'2016','4.6.5.4.1.03.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4247,'2016','4.6.5.4.1.04.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4248,'2016','4.6.5.4.2.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4249,'2016','4.6.5.4.2.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4250,'2016','4.6.5.4.2.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4251,'2016','4.6.5.4.2.03.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4252,'2016','4.6.5.4.2.04.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4253,'2016','4.6.5.4.3.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4254,'2016','4.6.5.4.3.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4255,'2016','4.6.5.4.3.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4256,'2016','4.6.5.4.3.03.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4257,'2016','4.6.5.4.3.04.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4258,'2016','4.6.5.4.4.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4259,'2016','4.6.5.4.4.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4260,'2016','4.6.5.4.4.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4261,'2016','4.6.5.4.4.03.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4262,'2016','4.6.5.4.4.04.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4263,'2016','4.6.5.4.5.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4264,'2016','4.6.5.4.5.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4265,'2016','4.6.5.4.5.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4266,'2016','4.6.5.4.5.03.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4267,'2016','4.6.5.4.5.04.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4268,'2016','4.6.5.5.0.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4269,'2016','4.6.5.5.1.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4270,'2016','4.6.5.5.1.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4271,'2016','4.6.5.5.1.01.01','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4272,'2016','4.6.5.5.1.01.02','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE INFORMÁTICA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4273,'2016','4.6.5.5.1.01.03','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE MÓVEIS E UTENSÍLIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4274,'2016','4.6.5.5.1.01.04','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4275,'2016','4.6.5.5.1.01.05','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE VEÍCULOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4276,'2016','4.6.5.5.1.01.06','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4277,'2016','4.6.5.5.1.01.07','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4278,'2016','4.6.5.5.1.01.08','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ALMOXARIFADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4279,'2016','4.6.5.5.1.01.09','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE ARMAMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4280,'2016','4.6.5.5.1.01.10','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE SEMOVENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4281,'2016','4.6.5.5.1.01.99','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4282,'2016','4.6.5.5.1.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4283,'2016','4.6.5.5.1.02.01','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO ESPECIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4284,'2016','4.6.5.5.1.02.02','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS DOMINICAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4285,'2016','4.6.5.5.1.02.03','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4286,'2016','4.6.5.5.1.02.04','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS EM ANDAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4287,'2016','4.6.5.5.1.02.05','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INSTALAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4288,'2016','4.6.5.5.1.02.06','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4289,'2016','4.6.5.5.1.02.99','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4290,'2016','4.6.5.6.0.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4291,'2016','4.6.5.6.1.00.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4292,'2016','4.6.5.6.1.01.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE SOFTWARES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4293,'2016','4.6.5.6.1.02.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE MARCAS, DIREITOS E PATENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4294,'2016','4.6.5.6.1.03.00','REVERSÃO DE REDUÇÃO A VALOR RECUPERÁVEL DE DIREITO DE USO DE IMÓVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4295,'2016','4.9.0.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4296,'2016','4.9.1.0.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4297,'2016','4.9.1.0.1.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4298,'2016','4.9.1.0.1.01.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4299,'2016','4.9.1.0.1.99.00','(-) DEDUÇÕES DA VARIAÇÃO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4300,'2016','4.9.2.0.0.00.00','RESULTADO POSITIVO DE PARTICIPAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4301,'2016','4.9.2.1.0.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4302,'2016','4.9.2.1.1.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4303,'2016','4.9.2.1.2.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4304,'2016','4.9.2.1.3.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4305,'2016','4.9.2.1.4.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4306,'2016','4.9.2.1.5.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4307,'2016','4.9.2.2.0.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4308,'2016','4.9.2.2.1.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4309,'2016','4.9.3.0.0.00.00','OPERAÇÕES DA AUTORIDADE MONETÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4310,'2016','4.9.3.1.0.00.00','JUROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4311,'2016','4.9.3.1.1.00.00','JUROS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4312,'2016','4.9.3.2.0.00.00','POSIÇÃO DE NEGOCIAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4313,'2016','4.9.3.2.1.00.00','POSIÇÃO DE NEGOCIAÇÃO - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4314,'2016','4.9.3.3.0.00.00','POSIÇÃO DE INVESTIMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4315,'2016','4.9.3.3.1.00.00','POSIÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4316,'2016','4.9.3.4.0.00.00','CORREÇÃO CAMBIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4317,'2016','4.9.3.4.1.00.00','CORREÇÃO CAMBIAL - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4318,'2016','4.9.3.9.0.00.00','OUTRAS VPD DE OPERAÇÕES DA AUTORIDADE MONETÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4319,'2016','4.9.3.9.1.00.00','OUTRAS VPD DE OPERAÇÕES DA AUTORIDADE MONETÁRIA - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4320,'2016','4.9.7.0.0.00.00','REVERSÃO DE PROVISÕES E AJUSTES DE PERDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4321,'2016','4.9.7.1.0.00.00','REVERSÃO DE PROVISÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4322,'2016','4.9.7.1.1.00.00','REVERSÃO DE PROVISÕES - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4323,'2016','4.9.7.1.1.01.00','REVERSÃO DE PROVISÃO PARA RISCOS TRABALHISTAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4324,'2016','4.9.7.1.1.02.00','REVERSÃO DE PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4325,'2016','4.9.7.1.1.03.00','REVERSÃO DE PROVISÕES PARA RISCOS FISCAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4326,'2016','4.9.7.1.1.04.00','REVERSÃO DE PROVISÕES PARA RISCOS CÍVEIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4327,'2016','4.9.7.1.1.05.00','REVERSÃO DE PROVISÕES REPARTIÇÃO DE CRÉDITO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4328,'2016','4.9.7.1.1.06.00','REVERSÃO DE PROVISÕES DECORRENTES DE CONTRATOS DE PPP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4329,'2016','4.9.7.1.1.99.00','REVERSÃO DE OUTRAS PROVISÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4330,'2016','4.9.7.1.3.00.00','REVERSÃO DE PROVISÕES - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4331,'2016','4.9.7.1.4.00.00','REVERSÃO DE PROVISÕES - INTER OFSS - ESTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4332,'2016','4.9.7.1.5.00.00','REVERSÃO DE PROVISÕES - INTER OFSS - MUNICÍPIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4333,'2016','4.9.7.2.0.00.00','REVERSÃO DE AJUSTES DE PERDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4334,'2016','4.9.7.2.1.00.00','REVERSÃO DE AJUSTES DE PERDAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4335,'2016','4.9.7.2.1.01.00','REVERSÃO DE AJUSTES DE PERDAS DE CRÉDITOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4336,'2016','4.9.7.2.1.02.00','REVERSÃO DE AJUSTES DE PERDAS DE ESTOQUES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4337,'2016','4.9.7.2.1.03.00','REVERSÃO DE AJUSTES DE INVESTIMENTOS E APLICAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4338,'2016','4.9.7.2.2.00.00','REVERSÃO DE AJUSTES DE PERDAS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4339,'2016','4.9.7.2.3.00.00','REVERSÃO DE AJUSTES DE PERDAS -INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4340,'2016','4.9.7.2.4.00.00','REVERSÃO DE AJUSTES DE PERDAS -INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4341,'2016','4.9.7.2.5.00.00','REVERSÃO DE AJUSTES DE PERDAS -INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4342,'2016','4.9.9.0.0.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4343,'2016','4.9.9.1.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4344,'2016','4.9.9.1.2.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4345,'2016','4.9.9.1.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4346,'2016','4.9.9.1.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4347,'2016','4.9.9.1.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4348,'2016','4.9.9.2.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4349,'2016','4.9.9.2.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4350,'2016','4.9.9.2.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4351,'2016','4.9.9.2.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4352,'2016','4.9.9.3.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4353,'2016','4.9.9.3.1.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4354,'2016','4.9.9.4.0.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4355,'2016','4.9.9.4.1.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4356,'2016','4.9.9.4.2.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTRA OFSS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4357,'2016','4.9.9.4.3.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4358,'2016','4.9.9.4.4.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4359,'2016','4.9.9.4.5.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4360,'2016','4.9.9.5.0.00.00','MULTAS ADMINISTRATIVAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4361,'2016','4.9.9.5.1.00.00','MULTAS ADMINISTRATIVAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4362,'2016','4.9.9.6.0.00.00','INDENIZAÇÕES E RESTITUIÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4363,'2016','4.9.9.6.1.00.00','INDENIZAÇÕES E RESTITUIÇÕES - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4364,'2016','4.9.9.6.1.01.00','INDENIZ. POR DANOS CAUSADOS AO PATR. PUBLICO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4365,'2016','4.9.9.6.1.02.00','INDENIZAÇÃO POR PERDA/QUEBRA DE MERCADORIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4366,'2016','4.9.9.6.1.03.00','INDENIZ. POSSE OU OCUPAÇÃO ILIC. BENS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4367,'2016','4.9.9.6.1.04.00','REPOSIÇÃO/INDENIZAÇÃO DE SERVIDORES/AGENTES PÚBLICOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4368,'2016','4.9.9.6.1.99.00','OUTRAS INDENIZAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4369,'2016','4.9.9.7.0.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4370,'2016','4.9.9.7.1.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4371,'2016','4.9.9.7.1.01.00','VPA DE LEILOES DE MERCADORIAS APREENDIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4372,'2016','4.9.9.7.1.02.00','VPA DE ALIENAÇÃO DE BENS APREENDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4373,'2016','4.9.9.7.1.03.00','VPA DE ALIEN.BENS APREE.TRAF.ILIC.ENT.DROG.AFINS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4374,'2016','4.9.9.7.1.70.00','RECEITA DE ALIENAÇÃO DE BENS CAUCIONADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4375,'2016','4.9.9.7.1.99.00','OUTRAS VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4376,'2016','4.9.9.9.0.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4377,'2016','4.9.9.9.1.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4378,'2016','5.0.0.0.0.00.00','CONTROLES DA APROVAÇÃO DO PLANEJAMENTO E ORÇAMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4379,'2016','5.1.0.0.0.00.00','PLANEJAMENTO APROVADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4380,'2016','5.1.1.0.0.00.00','PPA - APROVADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4381,'2016','5.1.1.1.0.00.00','APROVAÇÃO INICIAL DO PPA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4382,'2016','5.1.1.2.0.00.00','REVISAO DO PPA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4383,'2016','5.1.2.0.0.00.00','PLOA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4384,'2016','5.1.2.1.0.00.00','PROJETO INICIAL DA LEI ORCAMENTARIA  - RECEITA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4385,'2016','5.1.2.1.1.00.00','PLOA INICIAL DA RECEITA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4386,'2016','5.1.2.1.2.00.00','ALTERAÇÕES  DO PROJETO INICIAL DA LOA - RECEITA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4387,'2016','5.1.2.2.0.00.00','PROJETO INICIAL DA LOA - DESPESA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4388,'2016','5.1.2.2.1.00.00','PLOA INICIAL DA DESPESA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4389,'2016','5.1.2.2.2.00.00','ALTERAÇÕES DO PROJETO INICIAL DA LOA - DESPESA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4390,'2016','5.2.0.0.0.00.00','ORÇAMENTO APROVADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4391,'2016','5.2.1.0.0.00.00','PREVISÃO DA RECEITA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4392,'2016','5.2.1.1.0.00.00','PREVISÃO INICIAL DA RECEITA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4393,'2016','5.2.1.1.1.00.00','PREVISAO INICIAL DA RECEITA  BRUTA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4394,'2016','5.2.1.1.2.00.00','(-) PREVISÃO DE DEDUÇÕES DA RECEITA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4395,'2016','5.2.1.1.2.01.00','(-) DEDUÇÕES  POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4396,'2016','5.2.1.1.2.01.01','(-) FUNDEB','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4397,'2016','5.2.1.1.2.01.02','(-) TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS A MUNICÍPIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4398,'2016','5.2.1.1.2.02.00','(-) RENÚNCIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4399,'2016','5.2.1.1.2.99.00','(-) OUTRAS DEDUÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4400,'2016','5.2.1.2.0.00.00','ALTERAÇÃO DA PREVISÃO DA RECEITA','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4401,'2016','5.2.1.2.1.00.00','PREVISÃO ADICIONAL DA RECEITA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4402,'2016','5.2.1.2.1.01.00','REESTIMATIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4403,'2016','5.2.1.2.1.02.00','CORREÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4404,'2016','5.2.1.2.9.00.00','(-) ANULAÇÃO DA PREVISÃO DA RECEITA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4405,'2016','5.2.2.0.0.00.00','FIXAÇÃO DA DESPESA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4406,'2016','5.2.2.1.0.00.00','DOTAÇÃO ORÇAMENTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4407,'2016','5.2.2.1.1.00.00','DOTAÇÃO INICIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4408,'2016','5.2.2.1.1.01.00','CREDITO INICIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4409,'2016','5.2.2.1.1.02.00','CREDITOS ANTECIPADOS - LDO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4410,'2016','5.2.2.1.1.02.01','ANTECIPAÇÃO - LDO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4411,'2016','5.2.2.1.1.02.09','(-) ANULAÇÃO DA ANTECIPAÇÃO - LDO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4412,'2016','5.2.2.1.2.00.00','DOTAÇÃO ADICIONAL POR TIPO DE CREDITO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4413,'2016','5.2.2.1.2.01.00','CREDITO ADICIONAL - SUPLEMENTAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4414,'2016','5.2.2.1.2.02.00','CREDITO ADICIONAL - ESPECIAL','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4415,'2016','5.2.2.1.2.02.01','CRÉDITOS ESPECIAIS ABERTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4416,'2016','5.2.2.1.2.02.02','CRÉDITOS ESPECIAIS REABERTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4417,'2016','5.2.2.1.2.02.03','CRÉDITOS ESPECIAIS REABERTOS - SUPLEMENTAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4418,'2016','5.2.2.1.2.03.00','CREDITO ADICIONAL - EXTRAORDINÁRIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4419,'2016','5.2.2.1.2.03.01','CRÉDITOS EXTRAORDINÁRIOS ABERTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4420,'2016','5.2.2.1.2.03.02','CRÉDITOS EXTRAORDINÁRIOS REABERTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4421,'2016','5.2.2.1.2.03.03','CRÉDITOS EXTRAORDINÁRIOS REABERTOS - SUPLEMENTAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4422,'2016','5.2.2.1.3.00.00','DOTAÇÃO ADICIONAL POR FONTE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4423,'2016','5.2.2.1.3.01.00','SUPERAVIT FINANCEIRO DE EXERCÍCIO ANTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4424,'2016','5.2.2.1.3.02.00','EXCESSO DE ARRECADAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4425,'2016','5.2.2.1.3.03.00','ANULAÇÃO DE DOTAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4426,'2016','5.2.2.1.3.04.00','OPERAÇÕES DE CREDITO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4427,'2016','5.2.2.1.3.05.00','RESERVA DE CONTINGENCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4428,'2016','5.2.2.1.3.06.00','DOTAÇÃO TRANSFERIDA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4429,'2016','5.2.2.1.3.07.00','RECURSOS SEM DESPESAS CORRESPONDENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4430,'2016','5.2.2.1.3.09.00','(-) CANCELAMENTO DE DOTAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4431,'2016','5.2.2.1.3.99.00','VALOR GLOBAL DA DOTAÇÃO ADICIONAL POR FONTE','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4432,'2016','5.2.2.1.9.00.00','CANCELAMENTO/REMANEJAMENTO DE DOTAÇÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4433,'2016','5.2.2.1.9.01.00','ALTERAÇÃO DO QUADRO DE DETALHAMENTO DA DESPESA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4434,'2016','5.2.2.1.9.01.01','ACRESCIMO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4435,'2016','5.2.2.1.9.01.09','(-)REDUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4436,'2016','5.2.2.1.9.02.00','ALTERAÇÃO DA LEI ORCAMENTARIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4437,'2016','5.2.2.1.9.02.01','ACRESCIMO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4438,'2016','5.2.2.1.9.02.09','(-)REDUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4439,'2016','5.2.2.1.9.04.00','(-)CANCELAMENTO DE DOTAÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4440,'2016','5.2.2.2.0.00.00','MOVIMENTAÇÃO DE CRÉDITOS RECEBIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4441,'2016','5.2.2.2.1.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4442,'2016','5.2.2.2.1.01.00','PROVISAO RECEBIDA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4443,'2016','5.2.2.2.1.02.00','PROVISAO RECEBIDA - BLOQUEADA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4444,'2016','5.2.2.2.1.09.00','ALTERAÇÃO DE CREDITOS MOVIMENTADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4445,'2016','5.2.2.2.1.09.01','ACRESCIMO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4446,'2016','5.2.2.2.1.09.09','(-) REDUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4447,'2016','5.2.2.2.2.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4448,'2016','5.2.2.2.2.01.00','ADMINISTRAÇÃO DIRETA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4449,'2016','5.2.2.2.2.01.01','CREDITOS RECEBIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4450,'2016','5.2.2.2.2.01.09','(-) CREDITOS TRANSFERIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4451,'2016','5.2.2.2.2.02.00','ADMINISTRAÇÃO INDIRETA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4452,'2016','5.2.2.2.2.02.01','CREDITOS RECEBIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4453,'2016','5.2.2.2.2.02.09','(-) CREDITOS TRANSFERIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4454,'2016','5.2.2.2.2.09.00','ALTERAÇÃO DE CREDITOS MOVIMENTADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4455,'2016','5.2.2.2.2.09.01','ACRESCIMO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4456,'2016','5.2.2.2.2.09.09','(-) REDUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4457,'2016','5.2.2.2.9.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4458,'2016','5.2.2.2.9.01.00','CREDITOS EXT. RECEB. POR FUSAO/CISAO/EXTINÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4459,'2016','5.2.2.2.9.02.00','CREDITOS INT. RECEB. POR FUSAO/CISAO/EXTINÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4460,'2016','5.2.2.3.0.00.00','DETALHAMENTO DE CREDITO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4461,'2016','5.2.2.3.1.00.00','CREDITOS A DETALHAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4462,'2016','5.2.2.9.0.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4463,'2016','5.2.2.9.1.00.00','PRÉ-EMPENHOS DA DESPESA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4464,'2016','5.2.2.9.1.01.00','PRÉ-EMPENHOS EMITIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4465,'2016','5.2.2.9.1.02.00','REFORÇO DE PRÉ-EMPENHO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4466,'2016','5.2.2.9.1.03.00','ANULAÇÃO DE PRÉ-EMPENHO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4467,'2016','5.2.2.9.2.00.00','EMPENHOS POR EMISSÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4468,'2016','5.2.2.9.2.01.00','EXECUÇÃO DA DESPESA POR NOTA DE EMPENHO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4469,'2016','5.2.2.9.2.01.01','EMISSAO DE EMPENHOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4470,'2016','5.2.2.9.2.01.02','REFORCO DE EMPENHOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4471,'2016','5.2.2.9.2.01.03','(-)ANULAÇÃO DE EMPENHOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4472,'2016','5.2.2.9.2.01.04','(-)CANCEL. DE EMPENHO POR FALTA DE DISPON. CAIXA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4473,'2016','5.3.0.0.0.00.00','INSCRIÇÃO DE RESTOS A PAGAR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4474,'2016','5.3.1.0.0.00.00','INSCRIÇÃO DE RP NÃO PROCESSADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4475,'2016','5.3.1.1.0.00.00','RP NÃO PROCESSADOS INSCRITOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4476,'2016','5.3.1.2.0.00.00','RP NÃO PROCESSADOS - EXERCÍCIOS ANTERIORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4477,'2016','5.3.1.3.0.00.00','RP NÃO PROCESSADOS RESTABELECIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4478,'2016','5.3.1.6.0.00.00','RP NÃO PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4479,'2016','5.3.1.7.0.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4480,'2016','5.3.2.0.0.00.00','INSCRIÇÃO DE RP PROCESSADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4481,'2016','5.3.2.1.0.00.00','RP PROCESSADOS - INSCRITOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4482,'2016','5.3.2.2.0.00.00','RP PROCESSADOS - EXERCÍCIOS ANTERIORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4483,'2016','5.3.2.6.0.00.00','RP PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4484,'2016','5.3.2.7.0.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4485,'2016','6.0.0.0.0.00.00','CONTROLES DA EXECUÇÃO DO PLANEJAMENTO E ORÇAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4486,'2016','6.1.0.0.0.00.00','EXECUÇÃO DO PLANEJAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4487,'2016','6.1.1.0.0.00.00','EXECUÇÃO DO PPA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4488,'2016','6.1.1.1.0.00.00','PPA A ALOCAR EM LEIS ORÇAMENTÁRIAS ANUAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4489,'2016','6.1.1.2.0.00.00','PPA ALOCADO  EM LEIS ORÇAMENTÁRIAS ANUAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4490,'2016','6.1.1.3.0.00.00','PPA EXECUTADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4491,'2016','6.1.2.0.0.00.00','EXECUÇÃO DO PLOA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4492,'2016','6.1.2.1.0.00.00','PROCESSAMENTO DO PLOA -RECEITA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4493,'2016','6.1.2.2.0.00.00','PROCESSAMENTO DO PLOA -DESPESA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4494,'2016','6.2.0.0.0.00.00','EXECUÇÃO DO ORÇAMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4495,'2016','6.2.1.0.0.00.00','EXECUÇÃO DA RECEITA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4496,'2016','6.2.1.1.0.00.00','RECEITA A REALIZAR','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4497,'2016','6.2.1.2.0.00.00','RECEITA REALIZADA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4498,'2016','6.2.1.3.0.00.00','(-) DEDUÇÕES DA RECEITA ORÇAMENTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4499,'2016','6.2.1.3.1.00.00','(-) DEDUÇÕES  POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4500,'2016','6.2.1.3.1.01.00','(-) FUNDEB','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4501,'2016','6.2.1.3.1.02.00','(-) TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS A MUNICÍPIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4502,'2016','6.2.1.3.2.00.00','(-) RENÚNCIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4503,'2016','6.2.1.3.9.00.00','(-) OUTRAS DEDUÇÕES DA RECEITA REALIZADA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4504,'2016','6.2.1.8.0.00.00','CORREÇÃO DE DIFERENÇAS RESULTANTES DE VARIAÇÃO CAMBIAL','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4505,'2016','6.2.2.0.0.00.00','EXECUÇÃO DA DESPESA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4506,'2016','6.2.2.1.0.00.00','DISPONIBILIDADES DE CREDITO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4507,'2016','6.2.2.1.1.00.00','CREDITO DISPONÍVEL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4508,'2016','6.2.2.1.2.00.00','CREDITO INDISPONÍVEL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4509,'2016','6.2.2.1.2.01.00','BLOQUEIO DE CREDITO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4510,'2016','6.2.2.1.2.02.00','CREDITO PRE-EMPENHADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4511,'2016','6.2.2.1.2.99.00','OUTRAS INDISPONIBILIDADES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4512,'2016','6.2.2.1.3.00.00','CREDITO UTILIZADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4513,'2016','6.2.2.1.3.01.00','CREDITO EMPENHADO A LIQUIDAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4514,'2016','6.2.2.1.3.02.00','CREDITO EMPENHADO EM LIQUIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4515,'2016','6.2.2.1.3.03.00','CREDITO EMPENHADO LIQUIDADO A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4516,'2016','6.2.2.1.3.04.00','CREDITO EMPENHADO LIQUIDADO PAGO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4517,'2016','6.2.2.1.3.05.00','EMPENHOS A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4518,'2016','6.2.2.1.3.06.00','EMPENHOS EM LIQUIDAÇÃO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4519,'2016','6.2.2.1.3.07.00','EMPENHOS LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4520,'2016','6.2.2.1.3.99.00','(-) OUTROS CRÉDITOS UTILIZADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4521,'2016','6.2.2.2.0.00.00','MOVIMENTAÇÃO DE CRÉDITOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4522,'2016','6.2.2.2.1.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4523,'2016','6.2.2.2.1.01.00','PROVISAO CONCEDIDA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4524,'2016','6.2.2.2.1.02.00','PROVISAO CONCEDIDA - BLOQUEADA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4525,'2016','6.2.2.2.1.09.00','ALTERAÇÃO DE CREDITOS MOVIMENTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4526,'2016','6.2.2.2.1.09.01','ACRESCIMO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4527,'2016','6.2.2.2.1.09.09','(-) REDUÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4528,'2016','6.2.2.2.2.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4529,'2016','6.2.2.2.2.01.00','ADMINISTRAÇÃO DIRETA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4530,'2016','6.2.2.2.2.01.01','CREDITOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4531,'2016','6.2.2.2.2.02.00','ADMINISTRAÇÃO INDIRETA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4532,'2016','6.2.2.2.2.02.01','CREDITOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4533,'2016','6.2.2.2.2.09.00','ALTERAÇÃO DE CREDITOS MOVIMENTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4534,'2016','6.2.2.2.2.09.01','ACRESCIMO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4535,'2016','6.2.2.2.2.09.09','(-) REDUÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4536,'2016','6.2.2.2.9.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4537,'2016','6.2.2.3.0.00.00','DETALHAMENTO DE CREDITO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4538,'2016','6.2.2.3.1.00.00','CREDITOS DETALHADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4539,'2016','6.2.2.8.0.00.00','CORREÇÃO DE DIFERENÇAS RESULTANTES DE VARIAÇÃO CAMBIAL','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4540,'2016','6.2.2.9.0.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4541,'2016','6.2.2.9.1.00.00','DESPESA PRE-EMPENHADA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4542,'2016','6.2.2.9.1.01.00','PRE-EMPENHOS A EMPENHAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4543,'2016','6.2.2.9.1.02.00','PRE-EMPENHOS EMPENHADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4544,'2016','6.2.2.9.2.00.00','EMISSAO DE EMPENHO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4545,'2016','6.2.2.9.2.01.00','EMPENHOS POR NOTA DE EMPENHO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4546,'2016','6.2.2.9.2.01.01','EMPENHOS A LIQUIDAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4547,'2016','6.2.2.9.2.01.02','EMPENHOS EM LIQUIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4548,'2016','6.2.2.9.2.01.03','EMPENHOS LIQUIDADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4549,'2016','6.2.2.9.2.01.04','EMPENHOS LIQUIDADOS PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4550,'2016','6.3.0.0.0.00.00','EXECUÇÃO DE RESTOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4551,'2016','6.3.1.0.0.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4552,'2016','6.3.1.1.0.00.00','RP NÃO PROCESSADOS A LIQUIDAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4553,'2016','6.3.1.2.0.00.00','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4554,'2016','6.3.1.3.0.00.00','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4555,'2016','6.3.1.4.0.00.00','RP NÃO PROCESSADOS PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4556,'2016','6.3.1.5.0.00.00','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4557,'2016','6.3.1.6.0.00.00','RP NÃO PROCESSADOS TRANSFERIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4558,'2016','6.3.1.7.0.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4559,'2016','6.3.1.7.1.00.00','RP NAO PROCESSADOS A LIQUIDAR-  INSCRIÇÃO NO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4560,'2016','6.3.1.7.2.00.00','RP NAO PROCESSADOS EM LIQUIDAÇÃO -  INSCRIÇÃO NO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4561,'2016','6.3.1.9.0.00.00','RP NÃO PROCESSADOS CANCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4562,'2016','6.3.1.9.1.00.00','CANCELAMENTOS POR INSUFICIENCIA DE RECURSOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4563,'2016','6.3.1.9.9.00.00','OUTROS CANCELAMENTOS DE RP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4564,'2016','6.3.2.0.0.00.00','EXECUÇÃO DE RP PROCESSADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4565,'2016','6.3.2.1.0.00.00','RP PROCESSADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4566,'2016','6.3.2.2.0.00.00','RP PROCESSADOS PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4567,'2016','6.3.2.6.0.00.00','RP PROCESSADOS TRANSFERIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4568,'2016','6.3.2.7.0.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4569,'2016','6.3.2.9.0.00.00','RP PROCESSADOS CANCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4570,'2016','6.3.2.9.1.00.00','POR VALORES E/OU INSCRIÇÕES INDEVIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4571,'2016','6.3.2.9.9.00.00','OUTROS CANCELAMENTOS DE RP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4572,'2016','6.3.8.0.0.00.00','CORREÇÃO DE DIFERENÇAS RESULTANTES DE VARIAÇÃO CAMBIAL','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4573,'2016','7.0.0.0.0.00.00','CONTROLES DEVEDORES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4574,'2016','7.1.0.0.0.00.00','ATOS POTENCIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4575,'2016','7.1.1.0.0.00.00','ATOS POTENCIAIS ATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4576,'2016','7.1.1.1.0.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4577,'2016','7.1.1.1.1.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4578,'2016','7.1.1.1.1.01.00','GARANTIAS RECEBIDAS NO PAÍS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4579,'2016','7.1.1.1.1.01.01','AVAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4580,'2016','7.1.1.1.1.01.02','FIANÇAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4581,'2016','7.1.1.1.1.01.03','HIPOTECAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4582,'2016','7.1.1.1.1.01.04','SEGUROS-GARANTIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4583,'2016','7.1.1.1.1.01.05','CAUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4584,'2016','7.1.1.1.1.01.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4585,'2016','7.1.1.1.1.01.07','GARANTIAS DA DÍVIDA PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4586,'2016','7.1.1.1.1.01.08','APÓLICES DE SEGUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4587,'2016','7.1.1.1.1.01.99','OUTRAS GARANTIAS  RECEBIDAS NO PAÍS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4588,'2016','7.1.1.1.1.02.00','GARANTIAS RECEBIDAS NO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4589,'2016','7.1.1.1.1.02.01','AVAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4590,'2016','7.1.1.1.1.02.02','FIANÇAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4591,'2016','7.1.1.1.1.02.03','HIPOTECAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4592,'2016','7.1.1.1.1.02.04','SEGUROS-GARANTIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4593,'2016','7.1.1.1.1.02.05','CAUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4594,'2016','7.1.1.1.1.02.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4595,'2016','7.1.1.1.1.02.07','GARANTIAS DA DÍVIDA PÚBLICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4596,'2016','7.1.1.1.1.02.08','APÓLICES DE SEGUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4597,'2016','7.1.1.1.1.02.99','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4598,'2016','7.1.1.1.1.03.00','CONTRAGARANTIAS RECEBIDAS NO PAÍS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4599,'2016','7.1.1.1.1.03.01','AVAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4600,'2016','7.1.1.1.1.03.02','FIANÇAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4601,'2016','7.1.1.1.1.03.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4602,'2016','7.1.1.1.1.03.04','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4603,'2016','7.1.1.1.1.04.00','CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4604,'2016','7.1.1.1.1.04.01','AVAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4605,'2016','7.1.1.1.1.04.02','FIANÇAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4606,'2016','7.1.1.1.1.04.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4607,'2016','7.1.1.1.1.04.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4608,'2016','7.1.1.2.0.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4609,'2016','7.1.1.2.1.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4610,'2016','7.1.1.2.1.01.00','DIREITOS CONVENIADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4611,'2016','7.1.1.2.1.02.00','TERMO DE COOPERAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4612,'2016','7.1.1.2.1.99.00','OUTROS INSTRUMENTOS CONGÊNERES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4613,'2016','7.1.1.3.0.00.00','DIREITOS CONTRATUAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4614,'2016','7.1.1.3.1.00.00','DIREITOS CONTRATUAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4615,'2016','7.1.1.3.1.01.00','CONTRATOS DE SEGUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4616,'2016','7.1.1.3.1.02.00','CONTRATOS DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4617,'2016','7.1.1.3.1.03.00','CONTRATOS DE ALUGUÉIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4618,'2016','7.1.1.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4619,'2016','7.1.1.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4620,'2016','7.1.1.3.1.06.00','CONTRATOS DE PPP - DO ENTE FEDERADO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4621,'2016','7.1.1.3.1.07.00','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4622,'2016','7.1.1.3.1.08.00','CONTRATOS DE RATEIO DE CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4623,'2016','7.1.1.3.1.99.00','OUTROS DIREITOS CONTRATUAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4624,'2016','7.1.1.9.0.00.00','OUTROS ATOS POTENCIAIS ATIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4625,'2016','7.1.2.0.0.00.00','ATOS POTENCIAIS PASSIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4626,'2016','7.1.2.1.0.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4627,'2016','7.1.2.1.1.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4628,'2016','7.1.2.1.1.01.00','GARANTIAS CONCEDIDAS NO PAÍS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4629,'2016','7.1.2.1.1.01.01','AVAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4630,'2016','7.1.2.1.1.01.02','FIANÇAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4631,'2016','7.1.2.1.1.01.03','HIPOTECAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4632,'2016','7.1.2.1.1.01.04','SEGUROS-GARANTIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4633,'2016','7.1.2.1.1.01.05','CAUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4634,'2016','7.1.2.1.1.01.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4635,'2016','7.1.2.1.1.01.99','OUTRAS GARANTIAS E CONTRAGARANTIAS CONCEDIDAS NO PAÍS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4636,'2016','7.1.2.1.1.02.00','GARANTIAS CONCEDIDAS NO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4637,'2016','7.1.2.1.1.02.01','AVAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4638,'2016','7.1.2.1.1.02.02','FIANÇAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4639,'2016','7.1.2.1.1.02.03','HIPOTECAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4640,'2016','7.1.2.1.1.02.04','SEGUROS-GARANTIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4641,'2016','7.1.2.1.1.02.05','CAUÇÕES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4642,'2016','7.1.2.1.1.02.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4643,'2016','7.1.2.1.1.02.99','OUTRAS GARANTIAS E CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4644,'2016','7.1.2.1.1.03.00','CONTRAGARANTIAS CONCEDIDAS NO PAÍS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4645,'2016','7.1.2.1.1.03.01','AVAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4646,'2016','7.1.2.1.1.03.02','FIANÇAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4647,'2016','7.1.2.1.1.03.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4648,'2016','7.1.2.1.1.03.04','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4649,'2016','7.1.2.1.1.04.00','CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4650,'2016','7.1.2.1.1.04.01','AVAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4651,'2016','7.1.2.1.1.04.02','FIANÇAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4652,'2016','7.1.2.1.1.04.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4653,'2016','7.1.2.1.1.04.99','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4654,'2016','7.1.2.2.0.00.00','OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4655,'2016','7.1.2.2.1.00.00','OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4656,'2016','7.1.2.2.1.01.00','OBRIGAÇÕES CONVENIADAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4657,'2016','7.1.2.2.1.02.00','TERMO DE COOPERAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4658,'2016','7.1.2.2.1.99.00','OUTROS INSTRUMENTOS CONGÊNERES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4659,'2016','7.1.2.3.0.00.00','OBRIGAÇÕES CONTRATUAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4660,'2016','7.1.2.3.1.00.00','OBRIGAÇÕES CONTRATUAIS - CONSOLIDAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4661,'2016','7.1.2.3.1.01.00','CONTRATOS DE SEGUROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4662,'2016','7.1.2.3.1.02.00','CONTRATOS DE SERVIÇOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4663,'2016','7.1.2.3.1.03.00','CONTRATOS DE ALUGUÉIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4664,'2016','7.1.2.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4665,'2016','7.1.2.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4666,'2016','7.1.2.3.1.06.00','CONTRATO DE GESTÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4667,'2016','7.1.2.3.1.07.00','TERMO DE PARCERIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4668,'2016','7.1.2.3.1.08.00','CONTRATOS DE PPP','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4669,'2016','7.1.2.3.1.08.01','CONTRAPRESTAÇÕES FUTURAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4670,'2016','7.1.2.3.1.08.02','RISCOS NÃO PROVISIONADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4671,'2016','7.1.2.3.1.08.03','OUTROS PASSIVOS CONTINGENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4672,'2016','7.1.2.3.1.09.00','CONTRATOS DE RATEIO DE CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4673,'2016','7.1.2.3.1.99.00','OUTROS OBRIGAÇÕES CONTRATUAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4674,'2016','7.1.2.9.0.00.00','OUTROS ATOS POTENCIAIS PASSIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4675,'2016','7.2.0.0.0.00.00','ADMINISTRAÇÃO FINANCEIRA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4676,'2016','7.2.1.0.0.00.00','DISPONIBILIDADES POR DESTINAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4677,'2016','7.2.1.1.0.00.00','CONTROLE DA DISPONIBILIDADE DE RECURSOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4678,'2016','7.2.1.1.1.00.00','RECURSOS ORDINÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4679,'2016','7.2.1.1.2.00.00','RECURSOS VINCULADOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4680,'2016','7.2.1.1.3.00.00','RECURSOS EXTRAORÇAMENTÁRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4681,'2016','7.2.1.2.0.00.00','LIMITE DE RESTOS A PAGAR POR DESTINAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4682,'2016','7.2.1.3.0.00.00','RECURSO DIFERIDO POR DESTINAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4683,'2016','7.2.2.0.0.00.00','PROGRAMAÇÃO FINANCEIRA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4684,'2016','7.2.3.0.0.00.00','INSCRIÇÃO DO LIMITE ORÇAMENTÁRIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4685,'2016','7.2.4.0.0.00.00','CONTROLES DA ARRECADAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4686,'2016','7.3.0.0.0.00.00','DÍVIDA ATIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4687,'2016','7.3.1.0.0.00.00','CONTROLE DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4688,'2016','7.3.1.1.0.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4689,'2016','7.3.1.1.1.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4690,'2016','7.3.1.1.1.01.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4691,'2016','7.3.1.1.1.02.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4692,'2016','7.3.1.1.1.03.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4693,'2016','7.3.1.1.2.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA  NÃO-TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4694,'2016','7.3.1.1.2.01.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA  NÃO-TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4695,'2016','7.3.2.0.0.00.00','CONTROLE DA INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4696,'2016','7.3.2.1.0.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4697,'2016','7.3.2.1.1.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4698,'2016','7.3.2.1.2.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4699,'2016','7.4.0.0.0.00.00','RISCOS FISCAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4700,'2016','7.4.1.0.0.00.00','CONTROLE DE PASSIVOS CONTINGENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4701,'2016','7.4.1.1.0.00.00','PASSIVOS CONTINGENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4702,'2016','7.4.1.1.1.00.00','DEMANDAS JUDICIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4703,'2016','7.4.1.1.2.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4704,'2016','7.4.1.1.3.00.00','AVAIS E GARANTIAS CONCEDIDAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4705,'2016','7.4.1.1.4.00.00','ASSUNÇÃO DE PASSIVOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4706,'2016','7.4.1.1.5.00.00','ASSISTÊNCIAS DIVERSAS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4707,'2016','7.4.1.1.9.00.00','OUTROS PASSIVOS CONTINGENTES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4708,'2016','7.4.2.0.0.00.00','CONTROLE DOS DEMAIS RISCOS FISCAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4709,'2016','7.4.2.1.0.00.00','DEMAIS RISCOS FISCAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4710,'2016','7.4.2.1.1.00.00','FRUSTRAÇÃO DE ARRECADAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4711,'2016','7.4.2.1.2.00.00','RESTITUIÇÃO DE TRIBUTOS A MAIOR','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4712,'2016','7.4.2.1.3.00.00','DISCREPÂNCIA DE PROJEÇÕES:','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4713,'2016','7.4.2.1.4.00.00','OUTROS RISCOS FISCAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4714,'2016','7.5.0.0.0.00.00','CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4715,'2016','7.5.1.0.0.00.00','CONTRATO DE RATEIO DE CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4716,'2016','7.5.2.0.0.00.00','PRESTAÇÃO DE CONTAS DE CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4717,'2016','7.5.3.0.0.00.00','CONSOLIDAÇÃO DA EXECUÇÃO  DO CONSÓRCIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4718,'2016','7.5.3.1.0.00.00','VALORES TRANSFERIDOS POR CONTRATO DE RATEIO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4719,'2016','7.5.3.2.0.00.00','DESPESAS EXECUTADAS EM CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4720,'2016','7.5.3.3.0.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS EM CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4721,'2016','7.5.3.4.0.00.00','EXECUÇÃO DE RP PROCESSADOS EM CONSÓRCIOS PÚBLICOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4722,'2016','7.5.3.5.0.00.00','INSUFICIÊNCIA DE CAIXA DO CONSÓRCIO PÚBLICO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4723,'2016','7.8.0.0.0.00.00','CUSTOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4724,'2016','7.9.0.0.0.00.00','OUTROS CONTROLES','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4725,'2016','7.9.1.0.0.00.00','RESPONSABILIDADE POR VALORES, TÍTULOS E BENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4726,'2016','7.9.1.1.0.00.00','RESPONSABILIDADE COM TERCEIROS POR VALORES, TÍTULOS E BENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4727,'2016','7.9.1.1.1.00.00','DEPÓSITOS JUDICIAIS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4728,'2016','7.9.1.1.2.00.00','DEPÓSITOS COMPULSÓRIOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4729,'2016','7.9.1.1.3.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4730,'2016','7.9.1.2.0.00.00','RESPONSABILIDADE DE TERCEIROS POR VALORES, TÍTULOS E BENS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4731,'2016','7.9.1.2.1.00.00','CONTROLE DE ADIANTAMENTOS/SUPRIMENTOS DE FUNDOS CONCEDIDOS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4732,'2016','7.9.1.2.2.00.00','ATIVOS DE PPP CONTABILIZADOS NA SPE','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4733,'2016','7.9.1.2.9.00.00','OUTRAS RESPONSABILIDADES DE TERCEIROS','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4734,'2016','7.9.2.0.0.00.00','DIVERSOS RESPONSÁVEIS EM APURAÇÃO','D');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4735,'2016','8.0.0.0.0.00.00','CONTROLES CREDORES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4736,'2016','8.1.0.0.0.00.00','EXECUÇÃO DOS ATOS POTENCIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4737,'2016','8.1.1.0.0.00.00','EXECUÇÃO DOS ATOS POTENCIAIS ATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4738,'2016','8.1.1.1.0.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4739,'2016','8.1.1.1.1.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4740,'2016','8.1.1.1.1.01.00','EXECUÇÃO DE GARANTIAS RECEBIDAS NO PAÍS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4741,'2016','8.1.1.1.1.01.01','AVAIS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4742,'2016','8.1.1.1.1.01.02','AVAIS EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4743,'2016','8.1.1.1.1.01.03','FIANÇAS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4744,'2016','8.1.1.1.1.01.04','FIANÇAS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4745,'2016','8.1.1.1.1.01.05','HIPOTECAS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4746,'2016','8.1.1.1.1.01.06','HIPOTECAS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4747,'2016','8.1.1.1.1.01.07','SEGUROS-GARANTIA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4748,'2016','8.1.1.1.1.01.08','SEGUROS-GARANTIA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4749,'2016','8.1.1.1.1.01.09','CAUÇÕES A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4750,'2016','8.1.1.1.1.01.10','CAUÇÕES EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4751,'2016','8.1.1.1.1.01.11','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4752,'2016','8.1.1.1.1.01.12','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4753,'2016','8.1.1.1.1.01.13','GARANTIAS DA DÍVIDA PUBLICA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4754,'2016','8.1.1.1.1.01.14','GARANTIAS DA DÍVIDA PUBLICA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4755,'2016','8.1.1.1.1.01.15','APÓLICES DE SEGUROS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4756,'2016','8.1.1.1.1.01.16','APÓLICES DE SEGUROS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4757,'2016','8.1.1.1.1.01.98','OUTRAS GARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4758,'2016','8.1.1.1.1.01.99','OUTRAS GARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4759,'2016','8.1.1.1.1.02.00','EXECUÇÃO DE GARANTIAS   RECEBIDAS NO EXTERIOR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4760,'2016','8.1.1.1.1.02.01','AVAIS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4761,'2016','8.1.1.1.1.02.02','AVAIS EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4762,'2016','8.1.1.1.1.02.03','FIANÇAS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4763,'2016','8.1.1.1.1.02.04','FIANÇAS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4764,'2016','8.1.1.1.1.02.05','HIPOTECAS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4765,'2016','8.1.1.1.1.02.06','HIPOTECAS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4766,'2016','8.1.1.1.1.02.07','SEGUROS-GARANTIA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4767,'2016','8.1.1.1.1.02.08','SEGUROS-GARANTIA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4768,'2016','8.1.1.1.1.02.09','CAUÇÕES A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4769,'2016','8.1.1.1.1.02.10','CAUÇÕES EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4770,'2016','8.1.1.1.1.02.11','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4771,'2016','8.1.1.1.1.02.12','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4772,'2016','8.1.1.1.1.02.13','GARANTIAS DA DÍVIDA PUBLICA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4773,'2016','8.1.1.1.1.02.14','GARANTIAS DA DÍVIDA PUBLICA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4774,'2016','8.1.1.1.1.02.15','APÓLICES DE SEGUROS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4775,'2016','8.1.1.1.1.02.16','APÓLICES DE SEGUROS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4776,'2016','8.1.1.1.1.02.98','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4777,'2016','8.1.1.1.1.02.99','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4778,'2016','8.1.1.1.1.03.00','EXECUÇÃO DE CONTRAGARANTIAS RECEBIDAS NO PAÍS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4779,'2016','8.1.1.1.1.03.01','AVAIS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4780,'2016','8.1.1.1.1.03.02','AVAIS EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4781,'2016','8.1.1.1.1.03.03','FIANÇAS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4782,'2016','8.1.1.1.1.03.04','FIANÇAS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4783,'2016','8.1.1.1.1.03.05','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4784,'2016','8.1.1.1.1.03.06','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4785,'2016','8.1.1.1.1.03.98','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4786,'2016','8.1.1.1.1.03.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4787,'2016','8.1.1.1.1.04.00','EXECUÇÃO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4788,'2016','8.1.1.1.1.04.01','AVAIS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4789,'2016','8.1.1.1.1.04.02','AVAIS EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4790,'2016','8.1.1.1.1.04.03','FIANÇAS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4791,'2016','8.1.1.1.1.04.04','FIANÇAS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4792,'2016','8.1.1.1.1.04.05','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4793,'2016','8.1.1.1.1.04.06','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4794,'2016','8.1.1.1.1.04.98','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4795,'2016','8.1.1.1.1.04.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4796,'2016','8.1.1.2.0.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4797,'2016','8.1.1.2.1.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4798,'2016','8.1.1.2.1.01.00','EXECUÇÃO DE CONVÊNIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4799,'2016','8.1.1.2.1.01.01','CONVÊNIOS A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4800,'2016','8.1.1.2.1.01.02','CONVÊNIOS A COMPROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4801,'2016','8.1.1.2.1.01.03','CONVÊNIOS A APROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4802,'2016','8.1.1.2.1.01.04','CONVÊNIOS APROVADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4803,'2016','8.1.1.2.1.01.05','CONVÊNIOS IMPUGNADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4804,'2016','8.1.1.2.1.01.06','CONVÊNIOS EM INADIMPLÊNCIA EFETIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4805,'2016','8.1.1.2.1.01.07','CONVÊNIO EM INADIMPLÊNCIA SUSPENSA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4806,'2016','8.1.1.2.1.01.08','CONVÊNIOS HOMOLOGADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4807,'2016','8.1.1.2.1.01.09','CONVÊNIOS CANCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4808,'2016','8.1.1.2.1.01.10','CONVÊNIOS NÃO RECEBIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4809,'2016','8.1.1.2.1.01.11','CONVÊNIOS ARQUIVADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4810,'2016','8.1.1.2.1.01.12','CONVÊNIOS E INSTRUMENTOS CONGÊNERES CONCLUÍDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4811,'2016','8.1.1.2.1.02.00','TERMO DE COOPERAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4812,'2016','8.1.1.2.1.02.01','TERMO DE COOPERAÇÃO A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4813,'2016','8.1.1.2.1.02.02','TERMO DE COOPERAÇÃO A COMPROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4814,'2016','8.1.1.2.1.02.03','TERMO DE COOPERAÇÃO A APROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4815,'2016','8.1.1.2.1.02.04','TERMO DE COOPERAÇÃO APROVADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4816,'2016','8.1.1.2.1.02.05','TERMO DE COOPERAÇÃO IMPUGNADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4817,'2016','8.1.1.2.1.02.06','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA EFETIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4818,'2016','8.1.1.2.1.02.07','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA SUSPENSA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4819,'2016','8.1.1.2.1.02.08','TERMO DE COOPERAÇÃO CANCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4820,'2016','8.1.1.2.1.02.09','TERMO DE COOPERAÇÃO NÃO RECEBIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4821,'2016','8.1.1.2.1.02.10','TERMO DE COOPERAÇÃO CONCLUÍDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4822,'2016','8.1.1.2.1.99.00','OUTROS INSTRUMENTOS CONGÊNERES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4823,'2016','8.1.1.2.1.99.01','OUTROS INSTRUMENTOS CONGÊNERES A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4824,'2016','8.1.1.2.1.99.02','OUTROS INSTRUMENTOS CONGÊNERES A COMPROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4825,'2016','8.1.1.2.1.99.03','OUTROS INSTRUMENTOS CONGÊNERES A APROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4826,'2016','8.1.1.2.1.99.04','OUTROS INSTRUMENTOS CONGÊNERES APROVADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4827,'2016','8.1.1.2.1.99.05','OUTROS INSTRUMENTOS CONGÊNERES IMPUGNADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4828,'2016','8.1.1.2.1.99.06','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA EFETIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4829,'2016','8.1.1.2.1.99.07','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA SUSPENSA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4830,'2016','8.1.1.2.1.99.08','OUTROS INSTRUMENTOS CONGÊNERES CANCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4831,'2016','8.1.1.2.1.99.09','OUTROS INSTRUMENTOS CONGÊNERES NÃO RECEBIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4832,'2016','8.1.1.2.1.99.10','OUTROS INSTRUMENTOS CONGÊNERES CONCLUÍDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4833,'2016','8.1.1.3.0.00.00','EXECUÇÃO DE DIREITOS CONTRATUAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4834,'2016','8.1.1.3.1.00.00','EXECUÇÃO DE DIREITOS CONTRATUAIS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4835,'2016','8.1.1.3.1.01.00','CONTRATOS DE SEGUROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4836,'2016','8.1.1.3.1.01.01','EM EXECUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4837,'2016','8.1.1.3.1.01.02','EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4838,'2016','8.1.1.3.1.02.00','CONTRATOS DE SERVIÇOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4839,'2016','8.1.1.3.1.02.01','EM EXECUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4840,'2016','8.1.1.3.1.02.02','EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4841,'2016','8.1.1.3.1.03.00','CONTRATOS DE ALUGUÉIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4842,'2016','8.1.1.3.1.03.01','EM EXECUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4843,'2016','8.1.1.3.1.03.02','EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4844,'2016','8.1.1.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4845,'2016','8.1.1.3.1.04.01','EM EXECUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4846,'2016','8.1.1.3.1.04.02','EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4847,'2016','8.1.1.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4848,'2016','8.1.1.3.1.05.01','EM EXECUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4849,'2016','8.1.1.3.1.05.02','EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4850,'2016','8.1.1.3.1.06.00','CONTRATOS DE PPP - DO ENTE FEDERADO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4851,'2016','8.1.1.3.1.06.01','CONTRATOS DE PPP - DO ENTE FEDERADO - EC','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4852,'2016','8.1.1.3.1.06.02','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 1','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4853,'2016','8.1.1.3.1.06.03','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 2','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4854,'2016','8.1.1.3.1.06.04','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 3','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4855,'2016','8.1.1.3.1.06.05','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 4','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4856,'2016','8.1.1.3.1.06.06','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 5','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4857,'2016','8.1.1.3.1.06.07','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 6','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4858,'2016','8.1.1.3.1.06.08','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 7','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4859,'2016','8.1.1.3.1.06.09','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 8','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4860,'2016','8.1.1.3.1.06.10','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 9','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4861,'2016','8.1.1.3.1.07.00','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4862,'2016','8.1.1.3.1.07.01','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4863,'2016','8.1.1.3.1.07.02','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 1','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4864,'2016','8.1.1.3.1.07.03','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 2','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4865,'2016','8.1.1.3.1.07.04','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 3','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4866,'2016','8.1.1.3.1.07.05','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 4','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4867,'2016','8.1.1.3.1.07.06','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 5','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4868,'2016','8.1.1.3.1.07.07','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 6','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4869,'2016','8.1.1.3.1.07.08','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 7','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4870,'2016','8.1.1.3.1.07.09','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 8','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4871,'2016','8.1.1.3.1.07.10','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 9','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4872,'2016','8.1.1.3.1.08.00','EXECUÇÃO DE CONTRATOS DE RATEIO DE CONSÓRCIOS PÚBLICOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4873,'2016','8.1.1.3.1.08.01','CONTRATOS DE RATEIO - A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4874,'2016','8.1.1.3.1.08.02','CONTRATOS DE RATEIO - EM EXECUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4875,'2016','8.1.1.3.1.08.03','CONTRATOS DE RATEIO - EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4876,'2016','8.1.1.3.1.99.00','OUTROS DIREITOS CONTRATUAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4877,'2016','8.1.1.3.1.99.01','OUTROS DIREITOS CONTRATUAIS - A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4878,'2016','8.1.1.3.1.99.02','OUTROS DIREITOS CONTRATUAIS - EM EXECUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4879,'2016','8.1.1.3.1.99.03','OUTROS DIREITOS CONTRATUAIS - EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4880,'2016','8.1.1.9.0.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4881,'2016','8.1.1.9.1.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4882,'2016','8.1.2.0.0.00.00','EXECUÇÃO DOS ATOS POTENCIAIS PASSIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4883,'2016','8.1.2.1.0.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4884,'2016','8.1.2.1.1.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4885,'2016','8.1.2.1.1.01.00','EXECUÇÃO DE GARANTIAS CONCEDIDAS NO PAÍS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4886,'2016','8.1.2.1.1.01.01','AVAIS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4887,'2016','8.1.2.1.1.01.03','AVAIS EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4888,'2016','8.1.2.1.1.01.04','FIANÇAS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4889,'2016','8.1.2.1.1.01.06','FIANÇAS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4890,'2016','8.1.2.1.1.01.07','HIPOTECAS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4891,'2016','8.1.2.1.1.01.09','HIPOTECAS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4892,'2016','8.1.2.1.1.01.10','SEGUROS-GARANTIA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4893,'2016','8.1.2.1.1.01.12','SEGUROS-GARANTIA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4894,'2016','8.1.2.1.1.01.13','CAUÇÕES A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4895,'2016','8.1.2.1.1.01.15','CAUÇÕES EXECUTADA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4896,'2016','8.1.2.1.1.01.16','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4897,'2016','8.1.2.1.1.01.18','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4898,'2016','8.1.2.1.1.01.19','OUTRAS GARANTIAS CONCEDIDAS NO PAÍS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4899,'2016','8.1.2.1.1.01.21','OUTRAS GARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4900,'2016','8.1.2.1.1.02.00','EXECUÇÃO DE GARANTIAS E  CONCEDIDAS NO EXTERIOR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4901,'2016','8.1.2.1.1.02.01','AVAIS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4902,'2016','8.1.2.1.1.02.03','AVAIS EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4903,'2016','8.1.2.1.1.02.04','FIANÇAS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4904,'2016','8.1.2.1.1.02.06','FIANÇAS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4905,'2016','8.1.2.1.1.02.07','HIPOTECAS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4906,'2016','8.1.2.1.1.02.09','HIPOTECAS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4907,'2016','8.1.2.1.1.02.10','SEGUROS-GARANTIA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4908,'2016','8.1.2.1.1.02.12','SEGUROS-GARANTIA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4909,'2016','8.1.2.1.1.02.13','CAUÇÕES A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4910,'2016','8.1.2.1.1.02.15','CAUÇÕES EXECUTADA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4911,'2016','8.1.2.1.1.02.16','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4912,'2016','8.1.2.1.1.02.18','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4913,'2016','8.1.2.1.1.02.19','OUTRAS GARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4914,'2016','8.1.2.1.1.02.21','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4915,'2016','8.1.2.1.1.03.00','EXECUÇÃO DE CONTRAGARANTIAS CONCEDIDAS NO PAÍS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4916,'2016','8.1.2.1.1.03.01','AVAIS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4917,'2016','8.1.2.1.1.03.03','AVAIS EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4918,'2016','8.1.2.1.1.03.04','FIANÇAS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4919,'2016','8.1.2.1.1.03.06','FIANÇAS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4920,'2016','8.1.2.1.1.03.07','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4921,'2016','8.1.2.1.1.03.09','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4922,'2016','8.1.2.1.1.03.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4923,'2016','8.1.2.1.1.03.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4924,'2016','8.1.2.1.1.04.00','EXECUÇÃO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4925,'2016','8.1.2.1.1.04.01','AVAIS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4926,'2016','8.1.2.1.1.04.03','AVAIS EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4927,'2016','8.1.2.1.1.04.04','FIANÇAS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4928,'2016','8.1.2.1.1.04.06','FIANÇAS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4929,'2016','8.1.2.1.1.04.07','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4930,'2016','8.1.2.1.1.04.09','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4931,'2016','8.1.2.1.1.04.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4932,'2016','8.1.2.1.1.04.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4933,'2016','8.1.2.2.0.00.00','EXECUÇÃO DE OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4934,'2016','8.1.2.2.1.00.00','EXECUÇÃO DE OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4935,'2016','8.1.2.2.1.01.00','EXECUÇÃO DE CONVÊNIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4936,'2016','8.1.2.2.1.01.01','CONVÊNIOS A LIBERAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4937,'2016','8.1.2.2.1.01.02','CONVÊNIOS A COMPROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4938,'2016','8.1.2.2.1.01.03','CONVÊNIOS A APROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4939,'2016','8.1.2.2.1.01.04','CONVÊNIOS APROVADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4940,'2016','8.1.2.2.1.01.05','CONVÊNIOS IMPUGNADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4941,'2016','8.1.2.2.1.01.06','CONVÊNIOS EM INADIMPLÊNCIA EFETIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4942,'2016','8.1.2.2.1.01.07','CONVÊNIOS EM INADIMPLÊNCIA SUSPENSA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4943,'2016','8.1.2.2.1.01.08','CONVÊNIOS HOMOLOGADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4944,'2016','8.1.2.2.1.01.09','CONVÊNIOS CANCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4945,'2016','8.1.2.2.1.01.10','CONVÊNIOS NÃO LIBERADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4946,'2016','8.1.2.2.1.01.11','CONVÊNIOS ARQUIVADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4947,'2016','8.1.2.2.1.01.12','CONVÊNIOS E INSTRUMENTOS CONGÊNERES CONCLUÍDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4948,'2016','8.1.2.2.1.02.00','TERMO DE COOPERAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4949,'2016','8.1.2.2.1.02.01','TERMO DE COOPERAÇÃO A LIBERAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4950,'2016','8.1.2.2.1.02.02','TERMO DE COOPERAÇÃO A COMPROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4951,'2016','8.1.2.2.1.02.03','TERMO DE COOPERAÇÃO A APROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4952,'2016','8.1.2.2.1.02.04','TERMO DE COOPERAÇÃO APROVADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4953,'2016','8.1.2.2.1.02.05','TERMO DE COOPERAÇÃO IMPUGNADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4954,'2016','8.1.2.2.1.02.06','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA EFETIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4955,'2016','8.1.2.2.1.02.07','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA SUSPENSA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4956,'2016','8.1.2.2.1.02.08','TERMO DE COOPERAÇÃO CANCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4957,'2016','8.1.2.2.1.02.09','TERMO DE COOPERAÇÃO NÃO LIBERADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4958,'2016','8.1.2.2.1.02.10','TERMO DE COOPERAÇÃO CONCLUÍDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4959,'2016','8.1.2.2.1.99.00','OUTROS INSTRUMENTOS CONGÊNERES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4960,'2016','8.1.2.2.1.99.01','OUTROS INSTRUMENTOS CONGÊNERES A LIBERAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4961,'2016','8.1.2.2.1.99.02','OUTROS INSTRUMENTOS CONGÊNERES A COMPROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4962,'2016','8.1.2.2.1.99.03','OUTROS INSTRUMENTOS CONGÊNERES A APROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4963,'2016','8.1.2.2.1.99.04','OUTROS INSTRUMENTOS CONGÊNERES APROVADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4964,'2016','8.1.2.2.1.99.05','OUTROS INSTRUMENTOS CONGÊNERES IMPUGNADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4965,'2016','8.1.2.2.1.99.06','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA EFETIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4966,'2016','8.1.2.2.1.99.07','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA SUSPENSA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4967,'2016','8.1.2.2.1.99.08','OUTROS INSTRUMENTOS CONGÊNERES CANCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4968,'2016','8.1.2.2.1.99.09','OUTROS INSTRUMENTOS CONGÊNERES NÃO LIBERADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4969,'2016','8.1.2.2.1.99.10','OUTROS INSTRUMENTOS CONGÊNERES CONCLUÍDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4970,'2016','8.1.2.3.0.00.00','EXECUÇÃO DE OBRIGAÇÕES CONTRATUAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4971,'2016','8.1.2.3.1.00.00','EXECUÇÃO DE OBRIGAÇÕES -CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4972,'2016','8.1.2.3.1.01.00','CONTRATOS DE SEGUROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4973,'2016','8.1.2.3.1.01.01','A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4974,'2016','8.1.2.3.1.01.02','EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4975,'2016','8.1.2.3.1.02.00','CONTRATOS DE SERVIÇOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4976,'2016','8.1.2.3.1.02.01','A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4977,'2016','8.1.2.3.1.02.02','EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4978,'2016','8.1.2.3.1.03.00','CONTRATOS DE ALUGUÉIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4979,'2016','8.1.2.3.1.03.01','A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4980,'2016','8.1.2.3.1.03.02','EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4981,'2016','8.1.2.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4982,'2016','8.1.2.3.1.04.01','A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4983,'2016','8.1.2.3.1.04.02','EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4984,'2016','8.1.2.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4985,'2016','8.1.2.3.1.05.01','A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4986,'2016','8.1.2.3.1.05.02','EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4987,'2016','8.1.2.3.1.06.00','CONTRATO DE GESTÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4988,'2016','8.1.2.3.1.06.01','A LIQUIDAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4989,'2016','8.1.2.3.1.06.02','LIQUIDADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4990,'2016','8.1.2.3.1.07.00','TERMO DE PARCERIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4991,'2016','8.1.2.3.1.07.01','A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4992,'2016','8.1.2.3.1.07.02','EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4993,'2016','8.1.2.3.1.08.00','CONTRATOS DE PPP','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4994,'2016','8.1.2.3.1.08.01','CONTRAPRESTAÇÕES FUTURAS - A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4995,'2016','8.1.2.3.1.08.02','CONTRAPRESTAÇÕES FUTURAS - EXECUTADAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4996,'2016','8.1.2.3.1.08.03','RISCOS NÃO PROVISIONADOS - A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4997,'2016','8.1.2.3.1.08.04','RISCOS NÃO PROVISIONADOS - EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4998,'2016','8.1.2.3.1.08.05','OUTROS PASSIVOS CONTINGENTES - A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (4999,'2016','8.1.2.3.1.08.06','OUTROS PASSIVOS CONTIGENTES - EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5000,'2016','8.1.2.3.1.09.00','EXECUÇÃO DE CONTRATOS DE RATEIO DE CONSÓRCIOS PÚBLICOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5001,'2016','8.1.2.3.1.09.01','CONTRATOS DE RATEIO - A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5002,'2016','8.1.2.3.1.09.02','CONTRATOS DE RATEIO - EM EXECUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5003,'2016','8.1.2.3.1.09.03','CONTRATOS DE RATEIO - EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5004,'2016','8.1.2.3.1.99.00','OUTRAS OBRIGAÇÕES CONTRATUAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5005,'2016','8.1.2.3.1.99.01','OUTRAS OBRIGAÇÕES CONTRATUAIS - A EXECUTAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5006,'2016','8.1.2.3.1.99.02','OUTRAS OBRIGAÇÕES CONTRATUAIS - EM EXECUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5007,'2016','8.1.2.3.1.99.03','OUTRAS OBRIGAÇÕES CONTRATUAIS - EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5008,'2016','8.1.2.9.0.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5009,'2016','8.1.2.9.1.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS - CONSOLIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5010,'2016','8.2.0.0.0.00.00','EXECUÇÃO DA ADMINISTRAÇÃO FINANCEIRA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5011,'2016','8.2.1.0.0.00.00','EXECUÇÃO DAS DISPONIBILIDADES POR DESTINAÇÃO','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5012,'2016','8.2.1.1.0.00.00','EXECUÇÃO DA DISPONIBILIDADE DE RECURSOS','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5013,'2016','8.2.1.1.1.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS','X');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5014,'2016','8.2.1.1.2.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR EMPENHO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5015,'2016','8.2.1.1.3.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR LIQUIDAÇÃO E ENTRADAS COMPENSATÓRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5016,'2016','8.2.1.1.3.01.00','COMPROMETIDA POR LIQUIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5017,'2016','8.2.1.1.3.02.00','COMPROMETIDA POR CONSIGNAÇÕES/RETENÇÕES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5018,'2016','8.2.1.1.3.03.00','COMPROMETIDA POR ENTRADAS COMPENSATÓRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5019,'2016','8.2.1.1.4.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS UTILIZADA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5020,'2016','8.2.1.1.5.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR PROGRAMAÇÃO FINANCEIRA OU ARRECADAÇÃO PRÓPRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5021,'2016','8.2.1.2.0.00.00','EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5022,'2016','8.2.1.3.0.00.00','EXECUÇÃO DO RECURSO DIFERIDO POR DESTINAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5023,'2016','8.2.2.0.0.00.00','EXECUÇÃO DA PROGRAMAÇÃO FINANCEIRA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5024,'2016','8.2.3.0.0.00.00','EXECUÇÃO DO LIMITE ORÇAMENTÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5025,'2016','8.2.4.0.0.00.00','CONTROLES DA ARRECADAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5026,'2016','8.3.0.0.0.00.00','EXECUÇÃO DA DÍVIDA ATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5027,'2016','8.3.1.0.0.00.00','EXECUÇÃO DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5028,'2016','8.3.1.1.0.00.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5029,'2016','8.3.1.1.1.00.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5030,'2016','8.3.1.1.1.01.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5031,'2016','8.3.1.1.1.02.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5032,'2016','8.3.1.1.1.03.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5033,'2016','8.3.1.1.2.00.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5034,'2016','8.3.1.1.2.01.00','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5035,'2016','8.3.1.2.0.00.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5036,'2016','8.3.1.2.1.00.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5037,'2016','8.3.1.2.1.01.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5038,'2016','8.3.1.2.1.02.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5039,'2016','8.3.1.2.1.03.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5040,'2016','8.3.1.2.2.00.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5041,'2016','8.3.1.2.2.01.00','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5042,'2016','8.3.1.3.0.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5043,'2016','8.3.1.3.1.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5044,'2016','8.3.1.3.1.01.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5045,'2016','8.3.1.3.1.02.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5046,'2016','8.3.1.3.1.03.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5047,'2016','8.3.1.3.2.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5048,'2016','8.3.1.3.2.01.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5049,'2016','8.3.1.4.0.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5050,'2016','8.3.1.4.1.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5051,'2016','8.3.1.4.1.01.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5052,'2016','8.3.1.4.1.02.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5053,'2016','8.3.1.4.1.03.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5054,'2016','8.3.1.4.2.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5055,'2016','8.3.1.4.2.01.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA NÃO-TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5056,'2016','8.3.2.0.0.00.00','EXECUÇÃO DA INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5057,'2016','8.3.2.1.0.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5058,'2016','8.3.2.1.1.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5059,'2016','8.3.2.1.2.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5060,'2016','8.3.2.2.0.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA DEVOLVIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5061,'2016','8.3.2.2.1.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA TRIBUTÁRIA DEVOLVIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5062,'2016','8.3.2.2.2.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA NÃO TRIBUTÁRIA DEVOLVIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5063,'2016','8.3.2.3.0.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5064,'2016','8.3.2.3.1.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5065,'2016','8.3.2.3.1.01.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5066,'2016','8.3.2.3.1.02.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5067,'2016','8.3.2.3.2.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5068,'2016','8.3.2.3.2.01.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5069,'2016','8.3.2.3.2.02.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5070,'2016','8.3.2.4.0.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA RECEBIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5071,'2016','8.3.2.4.1.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5072,'2016','8.3.2.4.1.01.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA EM COBRANÇA ADMINISTRATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5073,'2016','8.3.2.4.1.02.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA EM COBRANÇA JUDICIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5074,'2016','8.3.2.4.2.00.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5075,'2016','8.3.2.4.2.01.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA ADMINISTRATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5076,'2016','8.3.2.4.2.02.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA JUDICIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5077,'2016','8.3.2.5.0.00.00','BAIXA DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5078,'2016','8.3.2.5.1.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5079,'2016','8.3.2.5.1.01.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - COBRANÇA ADMINISTRATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5080,'2016','8.3.2.5.1.02.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - COBRANÇA JUDICIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5081,'2016','8.3.2.5.2.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5082,'2016','8.3.2.5.2.01.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA ADMNISTRATIVA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5083,'2016','8.3.2.5.2.02.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA JUDICIAL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5084,'2016','8.4.0.0.0.00.00','EXECUÇÃO DOS RISCOS FISCAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5085,'2016','8.4.1.0.0.00.00','EXECUÇÃO DE PASSIVOS CONTINGENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5086,'2016','8.4.1.1.0.00.00','PASSIVOS CONTINGENTES PREVISTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5087,'2016','8.4.1.1.1.00.00','DEMANDAS JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5088,'2016','8.4.1.1.2.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5089,'2016','8.4.1.1.3.00.00','AVAIS E GARANTIAS CONCEDIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5090,'2016','8.4.1.1.4.00.00','ASSUNÇÃO DE PASSIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5091,'2016','8.4.1.1.5.00.00','ASSISTÊNCIAS DIVERSAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5092,'2016','8.4.1.1.9.00.00','OUTROS PASSIVOS CONTINGENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5093,'2016','8.4.1.2.0.00.00','PASSIVOS CONTINGENTES CONFIRMADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5094,'2016','8.4.1.2.1.00.00','DEMANDAS JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5095,'2016','8.4.1.2.2.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5096,'2016','8.4.1.2.3.00.00','AVAIS E GARANTIAS CONCEDIDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5097,'2016','8.4.1.2.4.00.00','ASSUNÇÃO DE PASSIVOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5098,'2016','8.4.1.2.5.00.00','ASSISTÊNCIAS DIVERSAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5099,'2016','8.4.1.2.9.00.00','OUTROS PASSIVOS CONTINGENTES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5100,'2016','8.4.2.0.0.00.00','EXECUÇÃO DOS DEMAIS RISCOS FISCAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5101,'2016','8.4.2.1.0.00.00','DEMAIS RISCOS FISCAIS PREVISTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5102,'2016','8.4.2.1.1.00.00','FRUSTRAÇÃO DE ARRECADAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5103,'2016','8.4.2.1.2.00.00','RESTITUIÇÃO DE TRIBUTOS A MAIOR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5104,'2016','8.4.2.1.3.00.00','DISCREPÂNCIA DE PROJEÇÕES:','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5105,'2016','8.4.2.1.4.00.00','OUTROS RISCOS FISCAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5106,'2016','8.4.2.2.0.00.00','DEMAIS RISCOS FISCAIS CONFIRMADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5107,'2016','8.5.0.0.0.00.00','EXECUÇÃO DOS CONSÓRCIOS PÚBLICOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5108,'2016','8.5.1.0.0.00.00','EXECUÇÃO DO CONTRATO DE RATEIO DE CONSÓRCIO PÚBLICO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5109,'2016','8.5.1.1.0.00.00','CONTRATO DE RATEIO - EM EXECUÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5110,'2016','8.5.1.2.0.00.00','CONTRATO DE RATEIO -  EXECUTADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5111,'2016','8.5.2.0.0.00.00','EXECUÇÃO DA PRESTAÇÃO DE CONTAS DE CONSÓRCIO PÚBLICO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5112,'2016','8.5.2.1.0.00.00','A COMPROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5113,'2016','8.5.2.2.0.00.00','EM INADIMPLENCIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5114,'2016','8.5.2.3.0.00.00','A APROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5115,'2016','8.5.2.4.0.00.00','APROVADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5116,'2016','8.5.2.5.0.00.00','IMPUGNADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5117,'2016','8.5.2.6.0.00.00','CONCLUÍDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5118,'2016','8.5.3.0.0.00.00','CONSOLIDAÇÃO DA EXECUÇÃO DO CONSÓRCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5119,'2016','8.5.3.1.0.00.00','VALORES TRANSFERIDOS POR CONTRATO DE RATEIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5120,'2016','8.5.3.2.0.00.00','DESPESAS EXECUTADAS EM CONSÓRCIOS PÚBLICOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5121,'2016','8.5.3.2.1.00.00','CREDITO EMPENHADO A LIQUIDAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5122,'2016','8.5.3.2.2.00.00','CREDITO EMPENHADO EM LIQUIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5123,'2016','8.5.3.2.3.00.00','CREDITO EMPENHADO LIQUIDADO A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5124,'2016','8.5.3.2.4.00.00','CREDITO EMPENHADO LIQUIDADO PAGO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5125,'2016','8.5.3.3.0.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS EM CONSÓRCIOS PÚBLICOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5126,'2016','8.5.3.3.1.00.00','RP NÃO PROCESSADOS A LIQUIDAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5127,'2016','8.5.3.3.2.00.00','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5128,'2016','8.5.3.3.3.00.00','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5129,'2016','8.5.3.3.4.00.00','RP NÃO PROCESSADOS PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5130,'2016','8.5.3.3.5.00.00','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5131,'2016','8.5.3.3.6.00.00','RP NÃO PROCESSADOS TRANSFERIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5132,'2016','8.5.3.3.7.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5133,'2016','8.5.3.3.8.00.00','RP NÃO PROCESSADOS CANCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5134,'2016','8.5.3.4.0.00.00','EXECUÇÃO DE RP PROCESSADOS EM CONSÓRCIOS PÚBLICOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5135,'2016','8.5.3.4.1.00.00','RP PROCESSADOS A PAGAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5136,'2016','8.5.3.4.2.00.00','RP PROCESSADOS PAGOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5137,'2016','8.5.3.4.3.00.00','RP PROCESSADOS TRANSFERIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5138,'2016','8.5.3.4.4.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5139,'2016','8.5.3.4.5.00.00','RP PROCESSADOS CANCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5140,'2016','8.5.3.5.0.00.00','INSUFICIÊNCIA DE CAIXA DO CONSÓRCIO PÚBLICO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5141,'2016','8.8.0.0.0.00.00','APURAÇÃO DE CUSTOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5142,'2016','8.9.0.0.0.00.00','OUTROS CONTROLES','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5143,'2016','8.9.1.0.0.00.00','EXECUÇÃO DE RESPONSABILIDADE POR VALORES, TÍTULOS E BENS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5144,'2016','8.9.1.1.0.00.00','EXECUÇÃO DE RESPONSABILIDADE COM TERCEIROS POR VALORES, TÍTULOS E BENS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5145,'2016','8.9.1.1.1.00.00','DEPÓSITOS JUDICIAIS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5146,'2016','8.9.1.1.2.00.00','DEPÓSITOS COMPULSÓRIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5147,'2016','8.9.1.1.3.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5148,'2016','8.9.1.2.0.00.00','EXECUÇÃO DE RESPONSABILIDADE DE TERCEIROS POR VALORES, TÍTULOS E BENS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5149,'2016','8.9.1.2.1.00.00','EXECUÇÃO DE ADIANTAMENTOS/SUPRIMENTOS DE FUNDOS CONCEDIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5150,'2016','8.9.1.2.1.01.00','ADIANTAMENTOS CONCEDIDOS A COMPROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5151,'2016','8.9.1.2.1.02.00','ADIANTAMENTOS A APROVAR','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5152,'2016','8.9.1.2.1.03.00','ADIANTAMENTOS APROVADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5153,'2016','8.9.1.2.1.04.00','ADIANTAMENTOS IMPUGNADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5154,'2016','8.9.1.2.1.05.00','ADIANTAMENTOS EM INDADIMPLENCIA','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5155,'2016','8.9.1.2.1.06.00','ADIANTAMENTOS CANCELADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5156,'2016','8.9.1.2.2.00.00','EXECUÇÃO DE ATIVOS DE PPP CONTABILIZADOS NA SPE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5157,'2016','8.9.1.2.2.01.00','ATIVOS DE PPP CONTABILIZADOS NA SPE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5158,'2016','8.9.1.2.2.02.00','ATIVOS DE PPP CONTABILIZADOS NA SPE BAIXADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5159,'2016','8.9.1.2.9.00.00','EXECUÇÃO DE OUTRAS RESPONSABILIDADES DE TERCEIROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5160,'2016','8.9.2.0.0.00.00','DIVERSOS RESPONSÁVEIS EM APURAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5161,'2016','8.9.2.1.0.00.00','PAGAMENTOS INDEVIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5162,'2016','8.9.2.2.0.00.00','SALDOS NÃO RECOLHIDOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5163,'2016','8.9.2.3.0.00.00','DESFALQUES OU DESVIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5164,'2016','8.9.2.4.0.00.00','DÉBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVIÇOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5165,'2016','8.9.2.5.0.00.00','RESPONSÁVEIS POR DANOS OU PERDAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5166,'2016','8.9.2.6.0.00.00','PAGAMENTOS SEM RESPALDO ORÇAMENTÁRIO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5167,'2016','8.9.2.7.0.00.00','CRÉDITOS ANTECIPADOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5168,'2016','8.9.2.8.0.00.00','FALTA OU IRREGULARIDADE DE COMPROVAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5169,'2016','8.9.2.9.0.00.00','OUTRAS RESPONSABILIDADES EM APURAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5170,'2016','8.9.2.9.1.00.00','MULTAS E JUROS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5171,'2016','8.9.2.9.1.01.00','FALTA DE LICITAÇÃO','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5172,'2016','8.9.2.9.1.02.00','FALTA DE RECOLHIMENTO DE OBRIGAÇÕES PECUNIÁRIAS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5173,'2016','8.9.2.9.1.04.00','DÉBITOS ORIUNDOS DE USO OU ALUGUEL DE IMOVEL','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5174,'2016','8.9.2.9.1.05.00','ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5175,'2016','8.9.2.9.1.06.00','FRAUDES EM BENEFÍCIOS','C');
        INSERT INTO tcmgo.plano_contas_tcmgo (cod_plano,exercicio,estrutural,titulo,natureza) VALUES (5176,'2016','8.9.2.9.1.99.00','DEMAIS RESPONSABILIDADES EM APURAÇÃO','C');
    END IF;
END;
$$ LANGUAGE 'plpgsql';

SELECT        manutencao();
DROP FUNCTION manutencao();


----------------
-- Ticket #23523
----------------

INSERT INTO tcemg.orgao (num_orgao, exercicio, nom_orgao) VALUES (10, '2016', '10 – Entidade Estadual');


----------------
-- Ticket #23591
----------------

CREATE TABLE tcemg.teto_remuneratorio(
    cod_entidade    INTEGER         NOT NULL,
    exercicio       CHAR(4)         NOT NULL,
    vigencia        DATE            NOT NULL,
    teto            NUMERIC(14,2)   NOT NULL,
    justificativa   VARCHAR(100)            ,
    cod_evento      INTEGER                 ,
    CONSTRAINT pk_teto_remuneratorio    PRIMARY KEY            (cod_entidade, exercicio, vigencia),
    CONSTRAINT fk_teto_remuneratorio_1  FOREIGN KEY                      (cod_entidade, exercicio)
                                        REFERENCES orcamento.entidade    (cod_entidade, exercicio),
    CONSTRAINT fk_teto_remuneratorio_2  FOREIGN KEY                      (cod_evento)
                                        REFERENCES folhapagamento.evento (cod_evento)
);
GRANT ALL ON tcemg.teto_remuneratorio TO urbem;

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
VALUES
     ( 3111
     , 451
     , 'FLManterConfiguracaoTeto.php'
     , 'configuracao'
     , 53
     , ''
     , 'Configurar Teto Remuneratório'
     , TRUE
     );


----------------
-- Ticket #23592
----------------

CREATE TABLE tcemg.teto_remuneratorio_controle(
    cod_entidade    INTEGER         NOT NULL,
    exercicio       CHAR(4)         NOT NULL,
    vigencia        date            NOT NULL,
    teto            NUMERIC(14,2)   NOT NULL,
    CONSTRAINT pk_teto_remuneratorio_controle   PRIMARY KEY (cod_entidade, exercicio, vigencia),
    CONSTRAINT fk_teto_remuneratorio_controle_1 FOREIGN KEY (cod_entidade, exercicio, vigencia)
                                                REFERENCES tcemg.teto_remuneratorio (cod_entidade, exercicio, vigencia)
);
GRANT ALL ON tcemg.teto_remuneratorio_controle TO urbem;


----------------
-- Ticket #23524
----------------

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
VALUES
     ( 3102
     , 482
     , 'FLExportarFolhaPagamento.php'
     , 'exportar_filha'
     , 5
     , ''
     , 'Folha de Pagamento'
     , TRUE
     );



----------------
-- Ticket #23525
----------------

CREATE TABLE tcemg.arquivo_folha_pessoa(
    numcgm          INTEGER         NOT NULL,
    ano             CHAR(4)         NOT NULL,
    mes             INTEGER         NOT NULL,
    cpf             VARCHAR(11)     NOT NULL,
    nome            VARCHAR(200)    NOT NULL,
    sexo            CHAR(1)         NOT NULL,
    dt_nascimento   DATE            NOT NULL,
    alterado        BOOLEAN         NOT NULL DEFAULT FALSE,
    CONSTRAINT pk_arquivo_folha_pessoa     PRIMARY KEY (numcgm),
    CONSTRAINT fk_arquivo_folha_pessoa_1   FOREIGN KEY (numcgm)
                                           REFERENCES sw_cgm(numcgm)
);
GRANT ALL ON tcemg.arquivo_folha_pessoa TO urbem;


----------------
-- Ticket #23594
----------------

CREATE TABLE tcemg.tipo_cargo_servidor(
    cod_tipo        INTEGER     NOT NULL,
    descricao       VARCHAR(50) NOT NULL,
    CONSTRAINT pk_tipo_cargo_servidor   PRIMARY KEY (cod_tipo)
);
GRANT ALL ON tcemg.tipo_cargo_servidor TO urbem;

INSERT INTO tcemg.tipo_cargo_servidor VALUES (1, 'CEF - Efetivo'                              );
INSERT INTO tcemg.tipo_cargo_servidor VALUES (2, 'CRA - Comissionado de recrutamento amplo'   );
INSERT INTO tcemg.tipo_cargo_servidor VALUES (3, 'CRR - Comissionado de recrutamento restrito');
INSERT INTO tcemg.tipo_cargo_servidor VALUES (4, 'FPU - Função pública'                       );
INSERT INTO tcemg.tipo_cargo_servidor VALUES (5, 'EPU - Emprego público'                      );
INSERT INTO tcemg.tipo_cargo_servidor VALUES (6, 'APO - Agente político'                      );
INSERT INTO tcemg.tipo_cargo_servidor VALUES (7, 'STP - Servidor temporário'                  );

SELECT atualizarbanco('
CREATE TABLE folhapagamento.tcemg_entidade_cargo_servidor(
    exercicio       CHAR(4)     NOT NULL,
    cod_sub_divisao INTEGER     NOT NULL,
    cod_cargo       INTEGEr     NOT NULL,
    cod_tipo        INTEGER     NOT NULL,
    CONSTRAINT pk_entidade_cargo_servidor   PRIMARY KEY (exercicio, cod_tipo, cod_sub_divisao, cod_cargo),
    CONSTRAINT fk_entidade_cargo_servidor_1 FOREIGN KEY                                        (cod_tipo)
                                            REFERENCES tcemg.tipo_cargo_servidor               (cod_tipo),
    CONSTRAINT fk_entidade_cargo_servidor_2 FOREIGN KEY                                 (cod_sub_divisao)
                                            REFERENCES pessoal.sub_divisao              (cod_sub_divisao),
    CONSTRAINT fk_entidade_cargo_servidor_3 FOREIGN KEY                                       (cod_cargo)
                                            REFERENCES pessoal.cargo                          (cod_cargo)
);
');
SELECT atualizarbanco('GRANT ALL ON folhapagamento.tcemg_entidade_cargo_servidor TO urbem;');


CREATE TABLE tcemg.tipo_requisitos_cargo(
    cod_tipo        INTEGER         NOT NULL,
    descricao       VARCHAR(200)    NOT NULL,
    CONSTRAINT pk_tipo_requisitos_cargo     PRIMARY KEY (cod_tipo)
);
GRANT ALL ON tcemg.tipo_requisitos_cargo TO urbem;

INSERT INTO tcemg.tipo_requisitos_cargo VALUES (1, 'Nível superior completo ou nível médio com especialização, exceto quando se enquadrar nos códigos 2 ou 3 (Ex: Magistrados, Técnicos em Contabilidade, etc)');
INSERT INTO tcemg.tipo_requisitos_cargo VALUES (2, 'Profissão regulamentada privativa de profissionais de saúde (Ex: Médicos, Assistentes Sociais, Técnicos em Enfermagem etc)'                                );
INSERT INTO tcemg.tipo_requisitos_cargo VALUES (3, 'Professor'                                                                                                                                                 );
INSERT INTO tcemg.tipo_requisitos_cargo VALUES (4, 'Outras'                                                                                                                                                    );

SELECT atualizarbanco('
CREATE TABLE folhapagamento.tcemg_entidade_requisitos_cargo(
    exercicio       CHAR(4)     NOT NULL,
    cod_tipo        INTEGER     NOT NULL,
    cod_cargo       INTEGER     NOT NULL,
    CONSTRAINT pk_entidade_requisitos_cargo     PRIMARY KEY           (exercicio, cod_tipo, cod_cargo),
    CONSTRAINT fk_entidade_requisitos_cargo_1   FOREIGN KEY                                 (cod_tipo)
                                                REFERENCES tcemg.tipo_requisitos_cargo      (cod_tipo),
    CONSTRAINT fk_entidade_requisitos_cargo_2   FOREIGN KEY                                (cod_cargo)
                                                REFERENCES pessoal.cargo                   (cod_cargo)
);
');
SELECT atualizarbanco('GRANT ALL ON folhapagamento.tcemg_entidade_requisitos_cargo TO urbem;');


CREATE TABLE tcemg.tipo_remuneracao(
    cod_tipo        INTEGER     NOT NULL,
    descricao       VARCHAR(80) NOT NULL,
    CONSTRAINT pk_tipo_remuneracao      PRIMARY KEY (cod_tipo)
);
GRANT ALL ON tcemg.tipo_remuneracao TO urbem;

INSERT INTO tcemg.tipo_remuneracao VALUES( 1, 'Subsídio'                                           );
INSERT INTO tcemg.tipo_remuneracao VALUES( 2, 'Pensão'                                             );
INSERT INTO tcemg.tipo_remuneracao VALUES( 3, 'Vencimento Cargo / Função Pública / Emprego Público');
INSERT INTO tcemg.tipo_remuneracao VALUES( 4, 'Proventos de Aposentadoria'                         );
INSERT INTO tcemg.tipo_remuneracao VALUES( 5, 'Adicional por tempo de serviço'                     );
INSERT INTO tcemg.tipo_remuneracao VALUES( 6, 'Vantagens Pessoais'                                 );
INSERT INTO tcemg.tipo_remuneracao VALUES( 7, 'Função Gratificada'                                 );
INSERT INTO tcemg.tipo_remuneracao VALUES( 8, 'Vantagens Eventuais'                                );
INSERT INTO tcemg.tipo_remuneracao VALUES( 9, 'Pagamento Retroativo'                               );
INSERT INTO tcemg.tipo_remuneracao VALUES(10, 'Adicional Noturno'                                  );
INSERT INTO tcemg.tipo_remuneracao VALUES(11, 'Adicional de Insalubridade'                         );
INSERT INTO tcemg.tipo_remuneracao VALUES(12, 'Adicional de Periculosidade'                        );
INSERT INTO tcemg.tipo_remuneracao VALUES(13, 'Auxílios / Indenizações'                            );
INSERT INTO tcemg.tipo_remuneracao VALUES(14, 'Outros'                                             );

SELECT atualizarbanco('
CREATE TABLE folhapagamento.tcemg_entidade_remuneracao(
    exercicio       CHAR(4)     NOT NULL,
    cod_tipo        INTEGER     NOT NULL,
    cod_evento      INTEGER     NOT NULL,
    CONSTRAINT pk_entidade_remuneracao      PRIMARY KEY          (exercicio, cod_tipo, cod_evento),
    CONSTRAINT fk_entidade_remuneracao_1    FOREIGN KEY                                 (cod_tipo)
                                            REFERENCES tcemg.tipo_remuneracao           (cod_tipo),
    CONSTRAINT fk_entidade_remuneracao_2    FOREIGN KEY                               (cod_evento)
                                            REFERENCES folhapagamento.evento          (cod_evento)
);
');
SELECT atualizarbanco('GRANT ALL ON folhapagamento.tcemg_entidade_remuneracao TO urbem;');


INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
VALUES
     ( 3103
     , 451
     , 'FLManterConfiguracaoTipoCargoRemuneracao.php'
     , 'configurar'
     , 52
     , ''
     , 'Configurar Tipos de Cargos e Remuneração'
     , TRUE
     );


----------------
-- Ticket #23598
----------------

INSERT
  INTO administracao.funcionalidade
     ( cod_funcionalidade
     , cod_modulo
     , nom_funcionalidade
     , nom_diretorio
     , ordem
     , ativo
     )
VALUES
     ( 497
     , 62
     , 'Relatórios'
     , 'instancias/relatorios/'
     , 4
     , TRUE
     );

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo
     )
VALUES
     ( 3104
     , 497
     , 'FLRelatorioDividaFlutuante.php'
     , 'imprimir'
     , 1
     , ''
     , 'Demonstração da Dívida Flutuante'
     , TRUE
     );

INSERT
  INTO administracao.relatorio
     ( cod_gestao
     , cod_modulo
     , cod_relatorio
     , nom_relatorio
     , arquivo
     )
VALUES
     ( 6
     , 62
     , 1
     , 'Demonstração da Dívida Flutuante'
     , 'LHTCEALRelatorioDividaFlutuante.php'
     );


----------------
-- Ticket #23543
----------------

INSERT INTO tcemg.consideracao_arquivo VALUES (60, 'FLPGO');

----------------
-- Ticket #23583
----------------

ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN valor_saldo_atual_concessoes_garantia_interna        NUMERIC(14,2);
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN valor_saldo_atual_contra_concessoes_garantia_interna NUMERIC(14,2);
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN valor_saldo_atual_contra_concessoes_garantia_externa NUMERIC(14,2);
ALTER TABLE tcemg.configuracao_arquivo_dclrf ADD COLUMN medidas_corretivas TEXT;


----------------
-- Ticket #23510
----------------

UPDATE administracao.acao SET nom_acao = 'Vincular Dedutora Para RCL Anexo 8' WHERE cod_acao = 2887;
UPDATE administracao.relatorio SET arquivo = 'RREOAnexo8novo.rptdesign' WHERE cod_gestao = 6 AND cod_modulo = 36 AND cod_relatorio = 63;

